'use strict';
/**
 * 整个系统的入口，这里需要初始化系统需要的资源以及模块定义
 * @author SuperK
 * @link http://www.woaiso.com
 * @date 2015-04-30
 */
var rootModule = angular.module('hand', [
        'ionic','ionic.service.core',"ionic.service.deploy",
        'ngCordova',
        'ngResource',
        'IOS9UIWebViewPatch'
    ])
    /**
     * 系统初始化
     */
rootModule.run(function($ionicPlatform, ENV, $rootScope, $location, $ionicHistory, $cordovaNetwork,
    NetWork, Storage, $state, Log, Movies,MovieServe, $injector, $ionicLoading, $http, User, UpgradeSvc, Toast,ThirdSystemSvc,SystemSvc,NotifySvc) {
    window.param = function(obj) {
        var query = '',
            name, value, fullSubName, subName, subValue, innerObj, i;

        for (name in obj) {
            value = obj[name];

            if (value instanceof Array) {
                for (i = 0; i < value.length; ++i) {
                    subValue = value[i];
                    fullSubName = name + '[' + i + ']';
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += param(innerObj) + '&';
                }
            } else if (value instanceof Object) {
                for (subName in value) {
                    subValue = value[subName];
                    fullSubName = name + '[' + subName + ']';
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += param(innerObj) + '&';
                }
            } else if (value !== undefined && value !== null)
                query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
        }
        return query.length ? query.substr(0, query.length - 1) : query;
    };
    $ionicPlatform.ready(function() {
        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }

        //数据统计服务初始化
        if(typeof TalkingData!="undefined"){
            //初始化APPKey, Channel 渠道
            TalkingData.init("143FBCADE84207C365C36FF3BA7CEF34","http://app.handsight.cn");
        }
        //创建APPID
        SystemSvc.createAppID(function(){
            //检测软件更新
            UpgradeSvc.checkVersion(false);
            //第三方相关功能初始化
            ThirdSystemSvc.init();
            SystemSvc.initCountDown();
            NotifySvc.initNotify(); //初始化推送、以及状态栏显示内容的服务
            //获取地理位置
            MovieServe.locationInit(true);
            User.init();
            try {
                console.log('隐藏SplashScreen')
                setTimeout(function(){
                    if(navigator.splashscreen){
                         navigator.splashscreen.hide();
                    }
                },1000)
                }catch(e){

                }
        })
        window.fullPath = "";
        //这里来初始化创建缓存文件夹
        try {
            if(typeof LocalFileSystem !="undefined"){

            window.requestFileSystem = window.requestFileSystem || window.webkitRequestFileSystem;
            window.resolveLocalFileSystemURL = window.resolveLocalFileSystemURL|| window.ebkitResolveLocalFileSystemURL; //根据URL取得文件的读取权限
            //查找是否有download这个文件夹，没有则创建，然后找到这个文件夹的绝对路径
            var filesys = LocalFileSystem.PERSISTENT;
            if (device && device.platform == 'iOS') {
                filesys = LocalFileSystem.PERSISTENT;
            }
            window.requestFileSystem(filesys, 0, function(fileSystem) {
                fileSystem.root.getDirectory("handsight", {
                    create: true
                }, function() {});
                fileSystem.root.getDirectory("/handsight/tvhelper", {
                    create: true
                }, function() {});
                fileSystem.root.getDirectory("/handsight/tvhelper/cache/", {
                    create: true
                }, function(entry) {
                    //网上流传的资料中都是使用fullPath，在这里我获取到的是相对目录，在下载时使用会报错，所以换做了toURL()
                    //这是一个全局全局变量，用以保存路径
                    fullPath = entry.toURL();
                    if(device.platform=='iOS'){
                        fullPath=fullPath.replace("file://","");
                    }
                    //console.log(fullPath.toString() + '创建文件夹成功');
                    //console.log(fullPath);
                }, function() {
                    console.log('创建文件夹失败');
                });
            }, function(e) {
                console.log('创建文件夹失败', e);
            });
   
            }
        } catch (e) {
            console.log(e.name + ":" + e.message);
        }
        //这里来获取UUID登录
        Log.init();
        $ionicPlatform.registerBackButtonAction(function(e) {
            //这里将当前正在加载的框框隐藏
            $ionicLoading.hide();
            //判断处于哪个页面时双击退出
            if ($location.path() == '/tab/tv' || $location.path() == '/tab/me' ||
                $location.path() == '/tab/activity' || $location.path() == '/tab/playing' || $location.path() == '/tab/home') {
                if ($rootScope.backButtonPressedOnceToExit) {
                    ionic.Platform.exitApp();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                    Toast.show('再按一次退出系统');
                    setTimeout(function() {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
            } else if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            }
            e.preventDefault();
            return false;
        }, 101);
        //1.这里来往内存里放置用户的登录相关信息
        document.addEventListener("pause", function (event) {
            $rootScope.$broadcast('appPauseEvent');
            console.log('run() -> appPauseEvent');
        });
    });
    //电脑
    /*初始化网络监听事件*/
    window.netWorkStateInfo = {
        online: "true",
        type: "wifi",
        msg: "网络连接正常！"
    };
    window.responseError = "none";
    NetWork.isValidateNetWork();
    $rootScope.httpConfigs = []; //保存所有的网络请求配置信息
    $rootScope.setNetWork = function() {
        window.plugins.webintent.startActivity({
                action: window.plugins.webintent.ACTION_WIFI
            },
            function() {},
            function() {
                alert('Failed to open URL via Android Intent.');
                console.log("Failed to open URL via Android Intent. URL: " + theFile.fullPath)
            }
        );
    }

    $rootScope.closeNetWorkTip = function() {
        $rootScope.netWorkStateInfo.isShowTip = false;
        window.event.stopPropagation();
    }

    /*路由拦截器*/
    $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams, $rootScope) {
        //这里来监听页面的切换
        if(typeof TalkingData!="undefined"){
            TalkingData.onPage(toState.name);
        }
        $injector.get("NetWork").isValidateNetWork();
        //这里来监听路由的变化
        //判断APPID是否生成
        if(ENV.APPID==""&&toState.name!="default"){
            var tourl=toState.url;
            for(var name in toParams){
                tourl=tourl.replace(":"+name,toParams[name]);
            }
            $location.path("/default/"+encodeURIComponent(tourl));
        }
    });
    var appId = Storage.get("HANDSIGHTAPPID");
    if (appId != null) {
        ENV.APPID = appId.id;
    }
});
/**
 * 这里来初始化配置路由
 * @return {[type]}
 */
rootModule.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $locationProvider, $httpProvider, $ionicLoadingConfig) {
    $ionicConfigProvider.views.transition('none');
    $ionicConfigProvider.tabs.position("bottom");
    $ionicConfigProvider.tabs.style("standard");
    $ionicConfigProvider.navBar.alignTitle("center");
    $ionicLoadingConfig.template = '<img class="H_loading-img" src="img/load.gif">';
    $ionicLoadingConfig.duration = 10000;
    $ionicLoadingConfig.hideOnStateChange = true;
    //禁用侧滑后退功能
    $ionicConfigProvider.views.swipeBackEnabled(false);

    //$ionicConfigProvider.views.maxCache(0); //缓存
    $httpProvider.defaults.withCredentials = true;
    $httpProvider.defaults.headers.post['Content-Type'] = "application/x-www-form-urlencoded; charset=UTF-8";

    //默认的加载动画
    //$ionicLoadingConfig.template = '<ion-spinner icon="lines" class="spinner-calm"></ion-spinner>';
    //
    //
    //去除url中总是默认带有"#"
    //$locationProvider.html5Mode(true);   // 设置一下这句即可
    //配置全局错误信息拦截器
    //$httpProvider.defaults.headers.timeout = 10;
    $httpProvider.interceptors.push('HttpInterceptor');


    //设置Header信息

    //$httpProvider.defaults.headers.common['ssss'] = 'ssasdasd';
    //这里来构建页面，电信插件里面需要减少请求数量，仅配置需要的路由
    var page = location.href;
    if (page.indexOf('play.html') > -1) { //乐配页面
        $stateProvider
        .state('tab_play', {url: '/tab/play',cache: 'false',templateUrl: 'templates/tab-play.html',controller: 'PlayCtrl'})
    } else if (page.indexOf("play-detail.html") > -1) { //乐配详情页面
        $stateProvider
        .state('tab.play', {url: '/play',views: {'tab-play': {cache: 'false',templateUrl: 'templates/tab-play.html',controller: 'PlayCtrl'}}})
            .state('result-management', {
                url: '/result/management/:id',
                cache: 'false',
                templateUrl: 'templates/result-management.html',
                controller: 'ResultManagementCtrl'

            })
            .state('play-video-details', {
                url: '/play/video/detail/:id',
                cache: 'false',
                templateUrl: 'templates/play-video-detail.html',
                controller: 'PlayVideoDetailCtrl'
            })
            // .state('new-play-video-details', {
            //     url: '/new/play/video/detail/:id',
            //     cache: 'false',
            //     templateUrl: 'templates/play-videodetail.html',
            //     controller: 'newPlayVideoDetailCtrl'
            // })
            .state('play-video-edit', {
                url: '/play/video/edit/:id',
                cache: 'false',
                templateUrl: 'templates/play-video-edit.html',
                controller: 'PlayVideoEditCtrl'
            })
            .state('play-video-edit-list', {
                url: '/play/video/edit/list/:id',
                cache: 'false',
                templateUrl: 'templates/play-video-edit-list.html',
                controller: 'PlayVideoEditListCtrl'
            })
            .state('play-text-details', {
                url: '/play/text/detail/:id',
                cache: 'false',
                templateUrl: 'templates/play-text-detail.html',
                controller: 'PlayTextEditEnter'
            })
            .state('play-text-edit', {
                url: '/play/text/edit/:id',
                cache: 'false',
                templateUrl: 'templates/play-text-edit.html',
                controller: 'PlayTextEditCtrl'
            })
    } else if (page.indexOf("side.html") > -1) { //互动专区页面
        $stateProvider.state('fullScreenSide', {
            url: '/video/full/:platform/:id',
            templateUrl: 'templates/side-full-screen.html',
            controller: 'FullScreenSideCtrl',
            cache: false
        }) /********四川电信半屏三边******/
            .state('other_side', {
                url: '/video/:platform/:videoId',
                cache: 'false',
                templateUrl: 'templates/platform-side.html',
                controller: 'PlatformSideCtrl'
            })
    } else { //其他页面
        //这里来配置所有的路由信息
        $stateProvider
        /*********首页Tab页面**********/
        .state('tab', {url: "/tab",abstract: true,templateUrl: "templates/tabs.html"})
        /************首页Home**************/
        .state('tab.home', {
            url: '/home',
            cache: 'true',
            views: {
                'tab-home': {
                    templateUrl: 'templates/tab-home.html',
                    controller: 'HomeCtrl'
                }
            }
        })
            .state('play-head-details', {
                url: '/play/head/detail/:id',
                cache: 'false',
                templateUrl: 'templates/play-head-detail.html',
                controller: 'HeadPortraitDetail'
            })
            .state('red-packet', {
                url: '/red/packet/:activeId',
                cache: 'false',
                templateUrl: 'templates/red-packet.html',
                controller: 'RedPacketCtrl'
            })
            .state('play-head-edit', {
                url: '/play/head/edit/:id',
                cache: 'false',
                templateUrl: 'templates/play-head-edit.html',
                controller: 'HeadPortraitEdit'
            })
            .state('home1', {
                url: '/home1/:id',
                templateUrl: 'templates/home1.html',
                controller: 'Home1Ctrl'
            })
        /************场景连接Tab页**************/
        .state('tab.tv', {
            url: '/tv',
            views: {
                'tab-tv': {
                    templateUrl: 'templates/tab-tv.html',
                    controller: 'TVCtrl'
                }
            }
        })
        /************测试独立app三边页面**************/
        .state('platform-side', {
            url: '/platformside/app/:videoId/:senceId/:tvhelper/:moviename/:startedTime/:movieLength/:startTime',
            cache: 'false',
            templateUrl: 'templates/platform-side.html',
            controller: 'PlatformSideCtrl'
        })
            .state('movie-scene', {
                url: '/movie/scene/:videoid/',
                cache: 'true',
                templateUrl: 'templates/movie-scene.html',
                controller: 'MovieSceneCtrl'
            })
            .state('choose-city', {
                url: '/choose/city',
                cache: 'false',
                templateUrl: 'templates/choose-city.html',
                controller: 'ChooseCityCtrl'
            })

            .state('movie-scene-detail', {
                url: '/movie/scene/detail/:id/:name/:addr/:videoid',
                // cache: 'false',
                templateUrl: 'templates/movie-scene-detail.html',
                controller: 'MovieSceneDetailCtrl'
            })
            .state('movie-playing', {
                url: '/movie/playing/:id',
                cache: 'false',
                templateUrl: 'templates/movie-playing.html',
                controller: 'MoviePlayingCtrl'
            })
            .state('movie-more', {
                url: '/movie/more/:id/:textname/:versiontype/:moreid',
                cache: 'true',
                templateUrl: 'templates/movie-more.html',
                controller: 'MovieMoreCtrl'

            })
            .state('movie-detail', {
                url: '/movie/detail/:id/:starttime/:endtime/:isTv/:movieLength/:isGoBackHome/:isSystemCountdown/:sceneId',
                cache: 'true',
                templateUrl: 'templates/movie-detail.html',
                controller: 'MovieDetailCtrl'
            })
            .state('TV-detail', {
                url: '/TV/detail/:id',
                cache: 'false',
                templateUrl: 'templates/TV-detail.html',
                controller: 'TvCtrl'
            })
            .state('TV-station', {
                url: '/TV/station',
                cache: 'true',
                templateUrl: 'templates/TV-station.html',
                controller: 'TvStationCtrl'
            })
            .state('TV-station-detail', {
                url: '/TV/station/detail/:tvstationid',
                cache: 'true',
                templateUrl: 'templates/TV-station-detail.html',
                controller: 'TvStationDetailCtrl'
            })
        /***4K超高清内部使用的乐配专区**/
        .state('tab_play', {
            url: '/tab/play',
            cache: 'false',
            templateUrl: 'templates/tab-play.html',
            controller: 'PlayCtrl'
        })
            .state('tab.playing', {
                url: '/playing',
                views: {
                    'tab-playing': {
                        templateUrl: 'templates/tab-playing.html',
                        controller: 'PlayCtrl'
                    }
                }
            })
            .state('result-management', {
                url: '/result/management/:id',
                templateUrl: 'templates/result-management.html',
                controller: 'ResultManagementCtrl'

            })
            .state('play-video-details', {
                url: '/play/video/detail/:id',
                cache: 'false',
                templateUrl: 'templates/play-video-detail.html',
                controller: 'PlayVideoDetailCtrl'
            })
            .state('new-play-details', {
                url: '/new/play/detail/:id/:text',
                cache: 'true',
                templateUrl: 'templates/play-videodetail.html',
                controller: 'newPlayVideoDetailCtrl'
            })
            .state('play-video-edit', {
                url: '/play/video/edit/:id',
                templateUrl: 'templates/play-video-edit.html',
                controller: 'PlayVideoEditCtrl'
            })
            .state('play-video-edit-list', {
                url: '/play/video/edit/list/:id',
                templateUrl: 'templates/play-video-edit-list.html',
                controller: 'PlayVideoEditListCtrl'
            })
            .state('play-text-details', {
                url: '/play/text/detail/:id',
                cache: 'false',
                templateUrl: 'templates/play-text-detail.html',
                controller: 'PlayTextEditEnter'
            })
            .state('play-text-edit', {
                url: '/play/text/edit/:id',
                templateUrl: 'templates/play-text-edit.html',
                controller: 'PlayTextEditCtrl'
            })
            .state('tab.activity', {
                url: '/activity',
                views: {
                    'tab-activity': {
                        templateUrl: 'templates/tab-activity.html',
                        controller: 'ActivityCtrl'
                    }
                }
            })

        .state('tab.me', {
            url: '/me',
            views: {
                'tab-me': {
                    templateUrl: 'templates/tab-me.html',
                    controller: 'MeCtrl'
                }
            }
        })
            .state('login', {
                url: "/login",
                templateProvider: function($templateFactory) {
                    return $templateFactory.fromUrl("templates/login.html");
                },
                controller: 'LoginCtrl',
                cache: false
            })
            .state('signup', {
                url: "/signup",
                templateUrl: "templates/signup.html",
                controller: 'SignUpCtrl',
                cache: false
            })
            .state('securitycode-login', {
                url: "/securitycode/login/:type",
                templateUrl: "templates/securitycode-login.html",
                controller: 'VerifyLoginRegisterCtrl',
                cache: false

            })
            .state('full_info', {
                url: '/full_info',
                templateUrl: 'templates/full_info.html',
                controller: 'FullInfoCtrl',
                cache: false
            })
            .state('edit_user', {
                url: '/edit_user',
                templateUrl: 'templates/edit_user.html',
                controller: 'EditUserCtrl',
                cache: false
            })
            .state('update_pwd', {
                url: '/update_pwd',
                templateUrl: 'templates/update_pwd.html',
                controller: 'EditUserCtrl'
            })
            .state('about_us', {
                url: '/about_us',
                templateUrl: 'templates/about_us.html',
                controller: "AboutCtrl"
            })
            .state('introduction', {
                url: '/introduction',
                templateUrl: 'templates/introduction.html'
            })
            .state('update_version', {
                url: '/update_version',
                templateUrl: 'templates/update_version.html'
            })
            .state('help', {
                url: '/help',
                templateUrl: 'templates/help.html'
            })
            .state('suggestion', {
                url: '/suggestion',
                templateUrl: 'templates/suggestion.html',
                controller: 'CommitSuggCtrl'
            })
            .state('tiaokuan', {
                url: '/tiaokuan',
                templateProvider:function($templateFactory){
                    return $templateFactory.fromUrl("templates/tiaokuan.html");
                }
            })
            .state('side', {
                url: '/side/:type/:id',
                templateUrl: 'templates/side.html',
                controller: 'ChatCtrl',
                cache: false
            })
            .state('fullScreenSide', {
                url: '/video/full/:platform/:id',
                templateUrl: 'templates/side-full-screen.html',
                controller: 'FullScreenSideCtrl',
                cache: false
            })
            .state('manageDevice', {
                url: '/tv/manage/:deviceId',
                templateUrl: 'templates/manage-tv.html',
                controller: 'TVManageCtrl'
            })
        /***搜索**/
        .state('search', {
            url: '/search',
            templateUrl: 'templates/search.html',
            controller: 'SearchController'
        })
        /***三边搜索**/
        .state('side_search', {
            url: '/side/search',
            templateUrl: 'templates/side-search.html',
            controller: 'SideSearchCtrl'
        })

            .state('scdx_plugin', {
                url: '/scdx_plugin',
                templateUrl: 'templates/scdx_plugin.html',
                controller: 'scdxPluginCtrl'
            })
        /********四川电信半屏三边******/
        .state('other_side', {
            url: '/video/:platform/:videoId',
            templateUrl: 'templates/platform-side.html',
            controller: 'PlatformSideCtrl'
        })
        /********启动介绍页************/
        .state('introduce', {
            url: '/app/introduce',
            templateUrl: 'templates/introduce.html',
            controller: "IntroduceCtrl"
        })
        .state('default',{
            url:'/default/:tourl',
            templateUrl:'templates/default.html',
            controller:function($interval,ENV,$location,$stateParams,$ionicLoading){
                $ionicLoading.show();
                var checkAPPID=$interval(function(){
                    if(ENV.APPID!=""){
                        $ionicLoading.hide();
                        $interval.cancel(checkAPPID);
                        $location.path(decodeURIComponent($stateParams.tourl));

                    }
                },100)
            }
        })
        //这里设置一个默认页
        //var otherwise = '/login'; //默认登录页面
        var otherwise = 'tab/home'; //默认home页面

        //检查是否需要显示介绍图
        var needShowIntroduce = localStorage.getItem('need_show_introduce_v1');
        if (needShowIntroduce == null) {
            //标识没有显示过
            localStorage.setItem('need_show_introduce_v1', false);
            otherwise = "/app/introduce";
        }
        $urlRouterProvider.otherwise(otherwise);
    }
});