rootModule
    .controller('FullScreenSideCtrl', function(User, $ionicLoading, $filter, VideoStatusCore,
        $scope, Toast, $templateCache, $ionicModal, toupinLogin, ENV, InterfaceSide,
        InterfaceDotInfo, Side, $stateParams, $window, $ionicScrollDelegate, $interval, $timeout, orderDotsBy, Active) {
        var DotInfo = InterfaceDotInfo; //用于提供主题相关信息
        var videoId = $stateParams.id; //当前视频的ID，(这里的ID为电信对应的视频ID，不是系统内的)
        var watchType = 2; //当前观看类型 //2.为点播,1.为直播
        var timer = 0; //当前视频播放到的时间（默认为0）
        var shownDotId = -1; //当前展开的主题ID
        var SideConstans = {
            video: 0,
            commentRise: 1,
            vote: 2,
            topic: 3,
            repy: 4,
            channel: 5
        }


        /**
         * 用于控制当个主题的展开和隐藏
         * @param  {[type]} uuid  对应主题的序列号UUID
         * @param  {[type]} shown 是否显示，（true:强制显示，false：强制隐藏）,不填则和当前状态取反
         * @return {[type]}       [description]
         */
        function _toggleLabel(uuid, shown) {
            var dot = DotInfo.getDotByUUID(uuid);
            dot.userStatus = 1; //用户操作状态
            //当前显示的卡片ID
            var cardId = dot.uuid;
            dot.visible = shown ? shown : !dot.visible;
            shownDotId = dot.visible ? dot.uuid : -1;
            // //将所有的item关闭
            angular.forEach($scope.dots, function(item) {
                if (!dot.visible) { //如果为关闭当前Item 则将其他所有Item 设置为item-nomal 状态
                    item.status = 'item-nomal'
                } else if (item.uuid != cardId) {
                    item.visible = false;
                    item.status = 'item-hide';
                }
            })
            dot.status = dot.visible ? 'item-show' : 'item-nomal';
            var element = document.querySelector('#card-' + uuid);
            var itemTitle = element.querySelector('.label-title');
            //计算当前屏幕的高度
            var wHeight = $window.innerHeight;
            var scroll = document.querySelector('ion-scroll[delegate-handle="chat-scroll-' + uuid + '"]');
            var labelBody = angular.element(element.querySelector('.label-body'));
            if (dot.visible) { //手动修改样式,防止Angular监听不及时，出现的滚动条无法计算高度的Bug
                labelBody.addClass('show');
            } else {
                labelBody.addClass('hide');
            }
            /**
             * 这里需要计算有滚动框的内容的高度，
             * 因为在同一个手机屏幕内，每一个主题的滚动框，每次显示的高度应该是一样高的，所以这里做一个判定
             * 如果在Dot对象里面发现有一个参数则不需要计算，没有则计算一个高度出来
             ******/
            if (scroll && scroll != null && dot.visible) {
                var contentEle = document.querySelector('#content-warpper');
                var ionicContentHeight = contentEle.offsetHeight;
                if (ionicContentHeight <= 0) {
                    ionicContentHeight = contentEle.height;
                }
                var inputHeight = 0;
                var labelTitleHeight = itemTitle.offsetHeight;
                var descHeight = 0;
                //判断是否有详情介绍
                var desc = element.querySelector('.label-desc');
                if (desc != null) {
                    descHeight = desc.offsetHeight + 1;
                }
                var sheight = ionicContentHeight - labelTitleHeight - descHeight - inputHeight;
                if (dot.type == -1) {
                    sheight += 6;
                }
                //判断为商品不需要减去输入框的高度
                if (dot.type == 3 || dot.type == 2 || dot.type == 5 || dot.type == 10) {
                    sheight += inputHeight + 6;
                }
                dot.scrollHeight = sheight; //当前Scroll的高度
                dot.descHeight = descHeight;
                angular.element(scroll).css({
                    height: dot.scrollHeight + 'px'
                });
            }
            var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
            if (dot.visible) { //如果当前是显示元素不是收起元素的话，需要计算当前显示的位置
                //当前元素的位置
                var elementTop = element.offsetTop - 1;
                mainScroll.scrollTo(0, elementTop, true);
            } else {
                mainScrollResize(); //重新计算整个容器的大小
                mainScroll.scrollTop(true);
            }
        }




        /**
         * 重构方法
         * @param  {[type]} cardId [description]
         * @return {[type]}        [description]
         */
        function toggleLabel(cardId) {
            _toggleLabel(cardId, false);
        }
        $scope.toggleLabel = toggleLabel;
        $scope.toggleLabelHandler = toggleLabel;

        function mainScrollResize() {
            var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
            mainScroll.resize();
            $ionicScrollDelegate.resize();
        }

        function mainScrollTop() {
            var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
            mainScroll.scrollTop(true);
        }
        /********投票事件******/
        /**
         * 投票
         * @param  {[type]} dotId 投票ID
         * @param  {[type]} vcId  投票选项ID
         * @return {[type]}       [description]
         */

        function voteEvent(uuid, vcId) {
            if (User.getCurrentUser() != null) {
                var dot = getShowDotByUUID(uuid);
                var choice = [];
                console.log(dot);
                var canVote = false;
                for (var i = 0; i < dot.choice.length; i++) {
                    //第一步判断是否可以投票或竞猜
                    var choice = dot.choice[i];
                    if (choice.vcId == vcId && (choice.status == 1 || choice.status == 2)) {
                        $ionicLoading.show({
                            template: '您已投过，不可再投！',
                            duration: 1000,
                            noBackdrop: true
                        })
                        canVote = false;
                        break;
                    } else {
                        canVote = true;
                    }
                }
                if (canVote) { //可以投票
                    if (dot.choiceType == 1) { //单选的处理方式
                        for (var i = 0; i < dot.choice.length; i++) {
                            if (dot.choice[i].vcId == vcId) {
                                dot.choice[i].status = 1;
                                dot.choice[i].count += 1; //投票数量+1
                            } else {
                                dot.choice[i].status = 2;
                            }
                        }

                    } else if (dot.choiceType == 2) { //多选的处理方式
                        for (var i = 0; i < dot.choice.length; i++) {
                            if (dot.choice[i].vcId == vcId) {
                                dot.choice[i].count += 1; //投票数量+1
                                dot.choice[i].status = 1;
                            }
                        }
                    }
                    if (dot && dot.type == 2) {
                        sendType = 2;
                        themeType = 2;
                    }
                    if (dot && dot.type == 5) {
                        sendType = 6;
                        themeType = 5;
                    }
                    sendEvent(sendType, dot.dotId, dot.dotId, themeType, vcId, function(result) {
                        var msg = "";
                        if (result.success) {

                        } else {

                        }
                    })
                }
                //公布答案：
                //这里查找出竞猜的正确答案
                if (dot.type == 5) //竞猜
                {
                    //循环选项，找出正确答案
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (dot.choice[i].isTrue == 1) {
                            dot.trueAnswer = dot.choice[i].content;
                            break;
                        }
                        //如果为单选
                    }
                }
            } else {
                Toast.show('请登录后再来参与吧！')
            }
        }
        /**
         * 发送消息接口
         * @param  {[type]} type      对谁发表的内容，即谁的评论（0：视频；1：评论点赞；2：投票；3：话题；4：评论(回复)；5：频道
         * @param  {[type]} comentId  被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
         * @param  {[type]} rootId    评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
         * @param  {[type]} themeType 哪种主题,主题类型（1:话题2：投票3：商机-1：视频 -2：频道 ）
         * @param  {[type]} content   发送的内容
         * @return {[type]}           callback(result)
         */
        function sendEvent(type, comentId, rootId, themeType, content, callback) {
            var sendType = watchType == 1 ? SideConstans.channel : SideConstans.video;
            Side.add_theme_talk(type, comentId, rootId, themeType, content, videoId)
                .$promise.then(function(result) {
                    callback && callback(result);
                }, function(error) {
                    callback && callback({
                        success: false
                    })
                });
        }
        $scope.voteEvent = voteEvent;
        $scope.voteEventHandler = voteEvent;
        //获取打点信息
        function __init() {
            //如果为直播，或录播，需要查询的参数增多
            var id = videoId;
            var startTime, endTime;
            if (typeof DataInterface != 'undefined') {
                var obj = JSON.parse(DataInterface.getString());
                if (obj.programtype == "1") { //直播
                    //获取当前北京时间
                    var calcTime = new Date(); //北京时间到1970年1月1日秒数,模拟测试
                    calcTime.setHours(calcTime.getHours() - 5);
                    startTime = $filter('date')(calcTime, "yyyy-MM-dd HH:mm:ss"); //开始时间
                    endTime = $filter('date')(calcTime.setHours(calcTime.getHours() + 10), "yyyy-MM-dd HH:mm:ss"); //在开始时间基础上加5小时
                    //videoID为频道ID
                    id = obj.programid;
                    watchType = 1;
                } else if (obj.programtype == "2") { //回看
                    var t = DataInterface.get('video_start_time');
                    var calcTime = new Date(t.substring(0, 4), parseInt(t.substring(4, 6)) - 1, t.substring(6, 8), t.substring(8, 10), t.substring(10, 12), t.substring(12, 14));
                    calcTime.setMinutes(calcTime.getMinutes() - 1); //时间减去一分钟，防止主题时间为负值，取不到完整主题列表
                    startTime = $filter('date')(calcTime, "yyyy-MM-dd HH:mm:ss"); //开始时间
                    endTime = $filter('date')(calcTime.setHours(calcTime.getHours() + 5), "yyyy-MM-dd HH:mm:ss"); //在开始时间基础上加5小时
                    id = obj.programid;
                    watchType = 1;
                }
            }
            InterfaceDotInfo.init($scope, watchType, id, startTime, endTime, function(data) {
                angular.forEach(data, function(item) {
                    item.visible = false;
                })
                console.log($scope.setTopDots + '置顶打点信息');
                console.log($scope.othersDots + '普通打点信息');
                $scope.dots = data;
                orderDotsBy.orderdotBySomething($scope.dots);
                console.log(data);
                startTimer();
            });
            //加载活动列表
            loadActivity();
        }
        /**
         * 加载活动
         * @return {[type]} [description]
         */
        function loadActivity() {
            var type = 0;
            var page = 1;
            var starttime = new Date();
            var endtime = new Date();
            starttime.setMonth(endtime.getMonth() - 1);
            starttime = $filter('date')(starttime, 'yyyy-MM-dd HH:mm:ss');
            endtime = $filter('date')(endtime, 'yyyy-MM-dd HH:mm:ss');
            Active.getActivitys(type, page, starttime, endtime, function(list) {
                $scope.activeList = list;
            });
        }
        $scope.getClicky = function(link) {
            window.open(link, '_blank', 'location=yes');
        }

        //定义一组标识，控制显示3个内容（侧边面板、小提示、主题详情列表）
        //1.侧边面板为收起状态时，当有主题来的时候，主题详情列表隐藏，小提示显示，侧边面板展开
        //2.侧边面板为展开状态时，当有主题来的时候，主题详情列表展开（不动），小提示隐藏，侧边面板不动
        //3.用户主动点击展开按钮,主题详情列表展开，小提示隐藏，侧边栏展开
        //4.用户主动点击收起按钮，主题详情展开，小提示隐藏，侧边栏收起
        //5.用户主动点击屏幕上小提示，侧边栏不动，小提示隐藏，主题详情列表显示
        //
        $scope.warpperVisible = { //三个面板默认的显示隐藏情况
            sidePanelVisible: false,
            smallBlockVisible: false,
            themeListVisible: true
        }
        /**
         * 设置3个内容面板的显示隐藏
         * @param {[type]} sidePanelVisible  侧边栏
         * @param {[type]} smallBlockVisible 小提示
         * @param {[type]} themeListVisible  主题列表
         */
        function setWarperVisible(sidePanelVisible, smallBlockVisible, themeListVisible) {
            console.log('内容面板显示状态:', sidePanelVisible + '-' + smallBlockVisible + '-' + themeListVisible)

            //设置主题列表
            if (typeof themeListVisible == 'boolean') {
                //这里需要立即设置主题列表的状态
                var warpper = document.getElementById('full-label-list-box');
                if (themeListVisible) {
                    warpper.className = "label-list-box theme-list-show"
                } else {
                    warpper.className = "label-list-box theme-list-hide";
                }
                $scope.warpperVisible.themeListVisible = themeListVisible;
            } else {
                //默认不变
            }
            //设置小标题
            if (typeof smallBlockVisible == 'boolean') {
                $scope.warpperVisible.smallBlockVisible = smallBlockVisible;
            } else {
                //默认不变
            }
            //设置侧边栏
            if (typeof sidePanelVisible == 'boolean') {
                $scope.warpperVisible.sidePanelVisible = sidePanelVisible;
                if (typeof(SideInterface) != 'undefined') {
                    console.log('设置侧边框');
                    $timeout(function() {
                        SideInterface.scroll(sidePanelVisible, smallBlockVisible);
                    }, 50)
                }
            } else {
                //默认不变
            }
        }
        window.setWarperVisible = setWarperVisible;

        $scope.show_label = true;
        $scope.showway = false;
        var clickFlag = false;
        $scope.titlehide = true;
        /**
         * 点击屏幕上的小提示，展开主题详情
         * @return {[type]} [description]
         */
        function showDotInfo() {
            setWarperVisible(true, false, true);

            $scope.showway = false;
            $scope.spanStatus = true;
            $scope.needToShowSmallBlock = false;
            $scope.isShowPointList = true;
            clickFlag = true;
            _toggleLabel($scope.showDot.uuid, true);
        }
        $scope.showDotInfo = showDotInfo;
        var oldVideoId, needLoadPoint = true;
        var initData = {};
        var beforeData = "";

        try {
            console.log(DataInterface.getString())
            var itvId = JSON.parse(DataInterface.getString()).itvid;
            var pwd = 123456;
            var verifyCode = "-1";
            itvId = itvId != "" ? itvId : "huawei" + new Date().getTime();
            toupinLogin.check(itvId, verifyCode, pwd);
        } catch (e) {
            $scope.errMsg = e.message;
        }
        var hasUseServerTime = false;
        var useplatform = 3; //默认直接从插件获取进度
        window.getPlatformStatus = function(callback) {
            //默认使用插件获取进度
            VideoStatusCore.getStatus({
                type: useplatform
            }, function(HSData) {
                useplatform = HSData.play_screen == 3 ? 1 : 3;
                console.log(HSData.relTime)
                callback && callback(HSData);
            }, function(err) {
                console.log('err' + err);
            });
        }
        ///标识当前面板的状态（展开还是收起）
        $scope.spanStatus = false;
        $scope.switchSpan = function() {
            $scope.spanStatus = !$scope.spanStatus;
            getPanstatus($scope.spanStatus)
        }


        /**
         * 这里是用户主动点击侧边栏快捷按钮的回调函数
         * @param  {[type]} status 当前侧边栏的状态(true:显示，false:隐藏)
         * @return {[type]}        [description]
         */
        window.getPanstatus = function(status) {
            if (status) { //主动展开了，
                setWarperVisible(true, false, true);
                console.log('展开');
                $scope.showway = false;
                clickFlag = true;
                $scope.titlehide = true;
                console.log($scope.title_hide);
                $scope.needToShowSmallBlock = false;
                $scope.isShowPointList = true;
                if (shownDotId != -1) {
                    _toggleLabel(shownDotId, true);
                }
            } else {
                setWarperVisible(false, false, true);

                console.log('收起');
                $scope.showway = false;
                $scope.titlehide = true;
                $scope.isShowPointList = false;
            }
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }
        window.setTimer = function() {}
        $scope.isShowPointList = false;
        $scope.needToShowSmallBlock = false;
        var programtype = -1; //当前播放状态
        //获得当前dot信息并将title信息显示在容器中
        function startTimer() {
            var dots;
            globalTimer = $interval(function() {
                getPlatformStatus(function(data) {
                    var videoStartTime = data.video_start_time;
                    if (programtype != -1 && programtype != data.programtype + videoStartTime) {
                        programtype = data.programtype;
                        window.location.reload();
                    } else {
                        programtype = data.programtype + videoStartTime; //和时间组合起来判断
                    }
                    timer = data.relTime; //当前的时间进度
                    // var str = DataInterface.getString();
                    // var isStr = JSON.parse(str);

                    // if (isStr.play_screen == 3) {
                    //     InterfaceSide.getDeviceStatus(itvId).$promise.then(function(result) {
                    //         if (result.success) {
                    //             SideInterface.scroll(true);
                    //         }
                    //     })
                    // }
                    //1.判断当前是否正在展示

                    //2.查找需要显示的小条
                    angular.forEach($scope.dots, function(item) {
                        var timerCha = parseInt(timer) - parseInt(item.timePoint);
                        // parseInt(item.timePoint) - time < ENV.timeRange && parseInt(item.timePoint) - time > 0
                        var calc = parseInt(item.timePoint) - parseInt(timer) < ENV.timeRange && parseInt(item.timePoint) - parseInt(timer) > 0 && item.type != -1 && item.type != 1;
                        if (calc) {
                            $scope.showDot = item;
                            $scope.needToShowSmallBlock = true;
                            _toggleLabel(item.uuid, true);

                            setWarperVisible(true, true, false);
                        }

                    })

                    //这里来判断如果当前正在显示小条，则计算时间，时间到了将小条收回去
                    if ($scope.warpperVisible.smallBlockVisible) {
                        //找到对应当前正在显示的小条
                        if ($scope.showDot) {
                            //隐藏小条
                            if (timer - $scope.showDot.timePoint > 30) {
                                console.log('隐藏小条')
                                $scope.showDot = null;
                                $scope.needToShowSmallBlock = false;
                                setWarperVisible(false, false, true)
                                if (typeof(SideInterface) != 'undefined') {
                                    console.log('关闭侧边栏')
                                    SideInterface.scroll(false);
                                }
                            }
                        }
                    }
                    $scope.newVideoTime = timer;
                })

            }, 1000)


        }
        /**
         * 根据UUID查找当前显示的Point 信息
         * @param  {[type]} uuid [description]
         * @return {[type]}      [description]
         */
        function getShowDotByUUID(uuid) {
            var dot;
            angular.forEach($scope.dots, function(item, index) {
                if (uuid == item.uuid) {
                    dot = item;
                    return false;
                }
            });
            return dot;
        }

        $scope.$on('$destroy', function(event) {
            $interval.cancel(globalTimer);
        })

        __init();
    }).directive('fullLabelItem', function($compile, $templateFactory, $rootScope) {
        /**
         * 获取模板
         * @param  {[type]} contentType 主题类型
         * @return {[type]}             [description]
         */
        function getTemplate(contentType) {
            var template = '';
            switch (contentType) {
                case 1: //话题
                    template = null; //话题模板 //话题在全屏状态下不展示
                    break;
                case 2: //投票
                    template = $templateFactory.fromUrl('templates/subject/topicvote.html'); //投票模板
                    break;
                case 3: //商品
                    template = $templateFactory.fromUrl('templates/subject/shop.html'); //商机模板
                    break;
                case 4: //知识点
                    template = $templateFactory.fromUrl('templates/subject/full-knowlege.html'); //知识点模板
                    break;
                case 5: //竞猜
                    template = $templateFactory.fromUrl('templates/subject/jingcai.html'); //竞猜模板
                    break;
                case 10: //简介
                    template = $templateFactory.fromUrl('templates/subject/introduce.html'); //简介模板
                    break;
                case -1:
                    template = $templateFactory.fromUrl('templates/subject/comment.html'); //评论模板
                    break;
            }
            return template;
        }
        var linker = function(scope, element, attrs) {
            var templatePromise = getTemplate(scope.dot.type);
            if (templatePromise != null) {
                templatePromise.then(function(data) {
                    element.html(data);
                    $compile(element.contents())(scope);
                }, function(err) {
                    console.log(err);
                })
            }else{
                //如果没有模板则不处理
            }
            scope.toggleLabel = function(dotId) {
                scope.toggleLabelHandler({
                    dotId: dotId
                });
            }
            scope.linkShop = function(url) {
                window.open(url, '_blank', 'location=yes');
            }
            scope.voteEvent = function(dotId, vcId) {
                scope.voteEventHandler({
                    dotId: dotId,
                    vcId: vcId
                });
            }
            $compile(element.contents())(scope);
        }
        return {
            restrict: "E",
            link: linker,
            replace: true,
            scope: {
                dot: '=',
                toggleLabelHandler: '&',
                voteEventHandler: '&'
            }
        };
    })