'use strict';
/**
 * Created by talent on 15/12/3.
 */
rootModule
    .controller('HeadPortraitDetail', function(
        $scope, $http, ENV,$ionicPlatform,$ionicLoading,$ionicHistory, $cordovaFile, $stateParams,
         $state, PlaySvc, $timeout, Toast, $sce, User, ImageSvc) {

        //计算图片显示高宽
        ImageSvc.calcItem($scope,2,9/5,0.5);
        //计算图片高宽结束
        var disportId = "";//成果Id
        var disportDataId = "";//素材Id
        $scope.playId = -1;
        var originalImgUrl;
        $scope.playResult;
        $scope.oneDisportDataList = []; //其他作者此作品
        $scope.oneDisportDataList.loading = true;
        $scope.oneImgDataList = []; //该电影其他作品
        $scope.oneImgDataList.loading = true;
        $scope.otherImgList = []; //其他同类电影作品
        $scope.otherImgList.loading = true;
        $scope.praisetarget = $stateParams.id;//点赞数据id


        /**
         * 查询其他娱乐成果
         * @param  {[type]} type 域类型（0：所有成果；1：同素材下的成果；2：同视频下的成果；
         * 3：作者；4：作者的某个素材的成果）
         * @param  {[type]} id   ID(
         *                   type为0时：ID为0；
         *                  type为1时：素材ID；
         *                   type为2时：视频ID；
         *                  type为3或4时：作者id；)
         * @return {[type]}      [description]
         */
        function getOthers(type, id, recreationType, page, callback) {
            //id, recreationType, disportDataId, type, page, isApproved
            PlaySvc.getList(id, recreationType, -1, type, page, 4, function(result) {
                if (result.success) {
                    if (result.data && result.data.resultList) {
                        angular.forEach(result.data.resultList, function(temp) {
                            //做一个转换操作
                            switch (temp.recreationType) {
                                case "1":
                                    temp.recreationTypeText = "video";
                                    break;
                                case "2":
                                    temp.recreationTypeText = "head";
                                    break;
                                case "3":
                                    temp.recreationTypeText = "text";
                                    break;
                            }
                            try {
                                temp.content = JSON.parse(temp.content);
                            } catch (e) {
                                console.log(e);
                            }
                        })
                        callback && callback(result.data.resultList);
                        return;
                    }
                }
                callback && callback([]);
            });
        }

        /**
         * 查询当前娱乐成果信息
         * @return {[type]} [description]
         */
        function getSigleDisportInfo() {
            if ($stateParams.id) {
                $ionicLoading.show();
                PlaySvc.getSigleDisportInfo($stateParams.id, function(result) {
                    $ionicLoading.hide();
                    if (result.success) {
                        //通知开始初始化播放器
                        var cont = JSON.parse(result.data.content);
                        $scope.detailImageSrc = cont.resultImg;
                        $sce.trustAsResourceUrl(cont.resultImg);
                        if (result.data.disportId) {
                            disportId = result.data.disportId;
                        }

                        $scope.playResult = result.data;

                        $scope.playId = result.data.disportDataId;
                        disportDataId = result.data.disportDataId;
                        selectOther(result.data); //查询其他信息
                    }
                })
            }
        }

        /**
         * 查询其他娱乐
         * @param  {[type]} data 当前成果详细信息
         * @return {[type]}      [description]
         */
        function selectOther(data) {
            //1.该素材其他作者的配词——其他作者此作品
            selectSameMaterialOtherPlay(data, 1);

            //2.该电影除配词外的其他作品——该电影其他作品
            selectSameVideoOtherPlay(data, 1);

            //3.其他电影的所有乐配作品——其他同类电影作品
            selectOtherVideoAllPlay(data, 1);
        }

        //type: 1筛选出其他作者的作品 2筛选出非配词作品 0筛选出非本电影的作品
        //id: type=1 当前作者id
        //    type=2 当前成果类型id recreationType
        //    type=0 当前视频id
        //subId type=0 配头的recreationType 2
        function removeDataFromResult(type, array, id, subId){
            var tempArr = new Array();
            var index = 0;

            while(array.length > 0){
                index = Math.round(Math.random()*(array.length-1));
                if(type == 1 && array[index].authorId != id
                    || type == 2 && array[index].recreationType != id
                    || type == 0 && array[index].vid != id && array[index].recreationType != subId){

                    tempArr.push(array[index]);

                }else{}
                array.splice(index, 1);
            }

            return tempArr;
        }

        /***********第一类************/
        var sameMaterialOtherPlay = [];
        //该素材其他作者的配图——其他作者此作品
        function selectSameMaterialOtherPlay(data, page){
            getOthers(1, data.disportDataId, 2, page, function(resultData) {
                //绑定到页面上
                sameMaterialOtherPlay = sameMaterialOtherPlay.concat(removeDataFromResult(1, resultData, data.authorId));
                if(sameMaterialOtherPlay.length < 3 && resultData.length > 0){
                    selectSameMaterialOtherPlay(data, page+1);
                }else{
                    $scope.oneDisportDataList = sameMaterialOtherPlay.splice(0, 3);
                    $scope.oneDisportDataList.loading = false;
                    sameMaterialOtherPlay = [];
                }
            });
        }

        /***********第二类************/
        var sameVideoOtherPlay = [];
        //该电影除配图外的其他作品——该电影其他作品
        function selectSameVideoOtherPlay(data, page){
            getOthers(2, data.vid, 1, page, function(resultData) {
                //绑定到页面上
                sameVideoOtherPlay = sameVideoOtherPlay.concat(removeDataFromResult(2, resultData, 3));
                if(sameVideoOtherPlay.length < 3 && resultData.length > 0){
                    selectSameVideoOtherPlay(data, page+1);
                }else{
                    $scope.oneImgDataList = sameVideoOtherPlay.splice(0, 3);
                    $scope.oneImgDataList.loading = false;
                    sameVideoOtherPlay = [];
                }
            });
        }

        /***********第三类************/
        var otherVideoAllPlay = [];
        //其他电影的所有乐配作品——其他同类电影作品
        function selectOtherVideoAllPlay(data, page){
            getOthers(0, 0, 0, page, function(resultData) {
                //绑定到页面上
                otherVideoAllPlay = otherVideoAllPlay.concat(removeDataFromResult(0, resultData, data.vid, 2));
                if(otherVideoAllPlay.length < 3 && resultData.length > 0){
                    selectOtherVideoAllPlay(data, page+1);
                }else{
                    $scope.otherImgList = otherVideoAllPlay.splice(0, 3);
                    $scope.otherImgList.loading = false;
                    otherVideoAllPlay = [];
                }
            });
        }


        $scope.getoriginalImgUrl = function() {
            return originalImgUrl;
        }

        /**
         * 初始化
         * @return {[type]} [description]
         */
        function __init() {
            //查询当前配图成果信息
            getSigleDisportInfo();
        }

        //分享到第三方平台
        /*
         下面是传入的参数的格式及字段的意义：
         platform      : 分享平台，可以取值为 wxfriend(微信好友)、wxcircle(微信朋友圈)、weibo(新浪微博)、qzone(QQ空间)、qfriend(QQ好友)

         contentType   : 数据类型，可以取值为 link(网页链接)、text(文本)、img(图片)
         content       : 分享的内容对象

         contentString : 除QQ空间外分享的内容，取值可以是网页链接、文本、图片链接
         linkImgUrl    : 和网页链接一起分享的图片

         qzText        : QQ空间分享的文本
         qzLink        : QQ空间分享的网页链接
         qzImgUrl      : QQ空间分享的图片链接
         */
        $scope.shareDatas = function(){
            return {
                type: "img",
                title: $scope.playResult ? $scope.playResult.disportTitle : "",
                text: $scope.playResult ? $scope.playResult.disportTitle : "",
                link: ENV.shareApi + "?id=" + disportId,
                linkImgUrl: $scope.playResult ? JSON.parse($scope.playResult.content).resultImg : "",
                imgSrc: $scope.playResult ? JSON.parse($scope.playResult.content).resultImg : ""
            };
        };

        $scope.closeAPP = function() {
            //判断是否有backview
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                ionic.Platform.exitApp();
            }
        }
        $scope.$on("$destroy", function() {
            //通知需要停止播放
            $scope.$broadcast('stopPlay');
        });

        $timeout(function() {
            __init();
        }, 0);

        //清空缓存
        $scope.clearWholeCache = function() {
            $cordovaFile.removeRecursively(cordova.file.externalRootDirectory
                , "handsight/tvhelper/cache").then(function(success) {
                alert(success);
            }, function(error) {
                alert(error.message);
            });
        };

        //查看缓存大小
        $scope.checkFreeSpace = function() {
            $cordovaFile.checkDir(cordova.file.externalRootDirectory
                , "handsight/tvhelper/cache").then(function(success) {
                var reader = success.createReader();
                reader.readEntries(function(result2) {
                    console.log(result2);
                    var wholeSize = 0,
                        len = result2.length,
                        count = 0;
                    for (var i = 0; i < len; ++i) {
                        if (result2[i].isFile) {
                            result2[i].file(function(result3) {
                                wholeSize += result3.size;
                                ++count;
                                if (count === len) {
                                    alert(wholeSize);
                                }

                                console.log(wholeSize);
                                console.log(result3);
                            }, function(error3) {
                                alert(error3.message);
                            });
                        }
                    }
                }, function(error2) {
                    alert(error2.message);
                });
            }, function(error) {
                alert(error.message);
            });
        };

        $scope.userPlayHead = function(title) {
            //识别用户是否登录
            if (User.getCurrentUser() != null) {
                //跳转页面
                if (disportId != "") {
                    $state.go('play-head-edit', {
                        id: disportDataId
                    });
                }
            } else {
                //打开电信登录页面
                if (typeof LaunchMode != 'undefined') {
                    LaunchMode.log();
                }
                Toast.show('您还未登录')
            }
        };

        // 评论功能，通过滚动控制输入框是否显示<mark3>
        // $timeout(function(){
        //     var commentheigth = document.getElementById('playheaddetail').offsetTop - window.screen.height+105;

        //     if(commentheigth<0){
        //           $scope.$broadcast("playheaddetail",{"status":true})
        //     }else{
        //         $scope.$broadcast("playheaddetail",{"status":false})
        //     }
        // },100)
        //显示评论框
        // function showInputBox(scrollTop, scrollLeft) {
        //     var commentheigth = document.getElementById('playheaddetail').offsetTop - window.screen.height+105;
        //     if(commentheigth<0){
        //         $scope.$broadcast("playheaddetail",{"status":true})
        //     }else{
        //         if (scrollTop >= commentheigth) {
        //             $scope.$broadcast("playheaddetail",{"status":true})
        //         } else {
        //             $scope.$broadcast("playheaddetail",{"status":false})
        //         }
        //     }

        // }
        // $scope.showInputBox = showInputBox;
        // $scope.scrollTop = function() {
        //     $ionicScrollDelegate.scrollTop();
        // }

        // 监听滚动事件
        var lastvalue=0;
        $timeout(function(){
          var commentheigth = document.getElementById('playheaddetail').offsetTop - window.screen.height+105;
          if(commentheigth<=0){
            $scope.$broadcast("playheaddetail",{"status":true})
          }
          document.querySelector("#content-scroll").onscroll=function(){
            var commentheigth = document.getElementById('playheaddetail').offsetTop - window.screen.height+105; //comment的高度
              var currentvalue = this.scrollTop;
              var sl = Math.abs(currentvalue-lastvalue)
              if(sl>15){
                if (this.scrollTop >= commentheigth) {
                    $scope.$broadcast("playheaddetail",{"status":true})
                } else {
                    $scope.$broadcast("playheaddetail",{"status":false})
                }
                if (this.scrollTop >= commentheigth+window.screen.height) {
                    $scope.$broadcast("playheaddetailback",{"status":true})
                } else {
                    $scope.$broadcast("playheaddetailback",{"status":false})
                }
                lastvalue = currentvalue;
              }
          }
        },100)


            //打开其它乐配电影详情页
        $scope.openDisportDetail = function(playhead) {
             var id,text;
             id=playhead.disportId;  //跳转到哪里去?
             text=playhead.recreationTypeText;
             $state.go('play-'+text+'-details', {
                id: id
              });
           }
           //打开配图其他作品详情页
        $scope.openheadDisportDetail = function(playhead) {
             var id;
             id=playhead.disportId;  //跳转到哪里去?
             $state.go('play-'+'head'+'-details', {
                id: id
            });
        }
    });