/**
 * Created by talent on 15/12/2.
 */
rootModule
    .controller('HeadPortraitEdit', function ($scope, $ionicPlatform, upload, $http, ENV, $ionicScrollDelegate,
                                              $stateParams, $ionicLoading, $state, $sce, PlaySvc, User, $timeout,
                                              $interval, photoService, Toast, $ionicPopup) {
        //素材ID
        var materialId = $stateParams.id;
        //显示隐藏乐配背景
        $scope.showplayhead = true;
        $scope.playResult = {};

        //素材图片或已配图片信息
        var srcImgInfo = {
            srcImageFile: "", //图片的url
            srcIndex: "", //指定头的索引
            srcInfo: null //指定头的空间属性
        };

        //用户自拍图片信息
        var descImgInfo = {
            targetImageFile: "", //图片的url
            targetIndex: "", //指定头的索引
            targetInfo: null //指定头的空间属性
        };

        //用户最终成果数据结构(即content字段)
        var headConfs = {
            srcImg: "", //素材图片url
            resultImg: "", //成果图片url
            headsIndex: [], //已替换的头的索引(如,[1,2,3])
        };

        //素材内容数据结果(即content字段)
        var materialConfs = {
            type: "", //类型
            data: "", //素材图片url
            faceInfo: [{ //素材中脸的信息数组
                index: 1, //脸的索引
                info: "" //脸的信息(矩形值)
            }]
        }

        function findMaterialInfo(tag) {
            for (var i = 0; i < materialConfs.faceInfo.length; ++i) {
                if (materialConfs.faceInfo[i].index == tag) {
                    return materialConfs.faceInfo[i].info;
                }
            }

            return null;
        }

        //取消当前编辑信息
        $scope.cancelPlayEvent = function () {
            //delete conf data
            getAuthorResultList();
            showListHidePanel();
        };

        //完成并保存编辑信息
        $scope.writePicWordsName = function () {
            $scope.data = {
                name: $scope.displayInfo.title
            };
            var myPopup = $ionicPopup.show({
                title: '请输入乐配名称',
                template: '<input type="text" placeholder="请输入乐配名称" class="popup-text" ng-model="data.name">',
                scope: $scope,
                buttons: [{
                    text: '取消',
                    onTap: function(e){
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                            cordova.plugins.Keyboard.disableScroll(true);
                        }
                    }
                }, {
                    text: '完成',
                    onTap: function (e) {
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                            cordova.plugins.Keyboard.disableScroll(true);
                        }
                        if (!$scope.data.name) {
                            e.preventDefault();
                        } else {
                            return $scope.data.name;
                        }
                    }
                }]
            });
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(false);
            }
            myPopup.then(function (res) {
                if (res && res != "") {
                    $scope.displayInfo.title = res;
                    if (!headConfs.resultImg || headConfs.resultImg == "") {
                        Toast.show("没有可上传的新成果!");
                        return;
                    }
                    $ionicLoading.show();
                    if (lastChangeIndex < 0) {
                        httpAddResult(function () {
                            lastChangeIndex = 1;

                            $ionicLoading.hide();
                            $scope.cancelPlayEvent();
                        });
                    }
                    else {
                        httpModifyResult(function (res) {
                            lastChangeIndex = 1;

                            $ionicLoading.hide();
                            $scope.cancelPlayEvent();
                        });
                    }
                } else {

                }
            });
            return false;
        };

        //显示成果展示列表，隐藏字幕编辑界面
        function showListHidePanel() {
            $scope.resultListStyle = {
                display: "block"
            };
            // $scope.editPanelStyle = {
            //     display: "none"
            // };
            $scope.showplayhead = false;
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }

        //隐藏成果展示列表，显示字幕编辑界面
        function hideListShowPanel() {
            $scope.resultListStyle = {
                display: "none"
            };
            // $scope.editPanelStyle = {
            //     display: "block"
            // };
            $scope.showplayhead = true;
            $ionicScrollDelegate.$getByHandle('mainScrnWordsScroll').scrollTop();
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }

        hideListShowPanel();

        //页面成果信息展示
        $scope.displayInfo = {
            resultImg: "", //成果url, 没有成果之前为最初的素材图片
            title: "大家一起来配一下标题", //成果标题
            video: "未知来源", //素材来源
            mHeads: null //素材中所有头的空间属性
        };

        $scope.displayInfo.title = "配图" + (new Date()).getTime();

        var contentFaceInfo = null;

        //根据$stateParams中的头像素材信息加载背景素材图片
        (function httpLoadBgPic() {
            $ionicLoading.show();
            $http.post(ENV.api + "/recreation/material/get", param({disportDataId: materialId}))
                .success(function (responce) {
                    $ionicLoading.hide();
                    if (!responce.success) {
                        Toast.show(responce.msg);
                        return;
                    }

                    if (!responce.data) {
                        Toast.show("素材数据不存在");
                        return;
                    }

                    $scope.displayInfo.video = responce.data.disportDataName || "";

                    var content = JSON.parse(responce.data.content);


                    /**********************test data*****************************/

                    //var content = {
                    //    type: "1",
                    //    data: "http://resource.handsight.com.cn/TVHelp01/base/704_1735082_458143.jpg",
                    //    faceInfo: [
                    //        {
                    //            index: 1,
                    //            info: "{x:311,y:59,width:126,height:126,lex:338,ley:92,lew:27,leh:27,rex:381,rey:86,rew:27,reh:27,sc0:0,sc1:0,sc2:0,sc3:0,sc4:0,sc5:0}"
                    //        }
                    //    ]
                    //};

                    /**********************test data*****************************/

                        //将素材内容拷贝一份
                    materialConfs = deepCopy(content);
                    if (!materialConfs) {
                        Toast.show("拷贝出错!");
                        return;
                    }

                    srcImgInfo.srcImageFile = content.data;
                    headConfs.srcImg = content.data;

                    var img = new Image(), originW = 0, originH = 0;
                    img.src = content.data;
                    img.onload = function () {
                        originW = this.width;
                        originH = this.height;

                        var real2origin = screen.width / originW;

                        for (var i = 0; i < content.faceInfo.length; ++i) {
                            eval('var ss=' + content.faceInfo[i].info);
                            content.faceInfo[i].info = ss;
                            content.faceInfo[i].info.width *= real2origin;
                            content.faceInfo[i].info.height *= real2origin;
                            content.faceInfo[i].info.x *= real2origin;
                            content.faceInfo[i].info.y *= real2origin;
                        }

                        contentFaceInfo = content.faceInfo;

                        $timeout(function () {
                            $scope.displayInfo.resultImg = content.data;
                            $sce.trustAsResourceUrl(content.data);
                            $scope.createNewResult();
                            //计算透明层距离顶部的距离
                            var offsetTop = document.querySelector('#play-head').offsetTop;
                            if (device.platform == 'iOS') {
                                $scope.editPanelStyle = {
                                    top: offsetTop+59 > screen.availHeight*0.7 ? "80%" : offsetTop+59 + "px"
                                }
                            } else {
                                $scope.editPanelStyle = {
                                    top: offsetTop+39 > screen.availHeight*0.7 ? "80%" : offsetTop+39 + "px"
                                }
                            }
                        }, 0);
                    };

                    img.onerror = function () {
                        Toast.show('图片加载失败!');
                    };

                });
        })();

        function generateHeadsBox() {
            if (contentFaceInfo) {
                //根据素材图片中头像的位置和大小信息生成标记头像的透明按钮
                $scope.displayInfo.mHeads = contentFaceInfo;
                contentFaceInfo = null;
            }
        }

        //深度复制素材内容函数
        function deepCopy(srcObj) {
            if (!srcObj) {
                return null;
            }

            var descObj = {
                type: srcObj.type,
                data: srcObj.data,
                faceInfo: []
            };

            for (var i = 0; i < srcObj.faceInfo.length; ++i) {
                descObj.faceInfo[i] = {
                    index: srcObj.faceInfo[i].index,
                    info: srcObj.faceInfo[i].info
                };
            }

            return descObj;
        }

        var needStop = false, procInterv = 0, TmObj = 0;
        var timeTick = 0, interTm = 1000;
        $ionicPlatform.registerBackButtonAction(function(){
            $interval.cancel(procInterv);
            $interval.cancel(TmObj);
            $ionicLoading.hide();
        }, 600);

        //点击头像调起拍照功能事件函数
        $scope.callCamera = function (head) {
            try {
                hideListShowPanel();
                photoService.takePhotoForHead(function (imageURI) {
                    $scope.procPercentage = 0;
                    timeTick = 0;
                    interTm = 1000;

                    TmObj = $interval(function(){
                        interTm = Math.round(Math.random()*1950 + 50);
                        if(timeTick < 99){
                            $scope.procPercentage = ++timeTick;
                        }
                    }, interTm);

                    $ionicLoading.show({template: "正在处理中{{procPercentage}}%", scope: $scope, duration: 60000});
                    var lastTime = (new Date()).getTime();
                    upload.uploadEvent(imageURI, {type: '3', fileType: 'img'}, function (res) {
                        console.log("uploadEvent: " + ((new Date()).getTime() - lastTime));
                        if (!res.success) {
                            $ionicLoading.hide();
                            needStop = true;
                            Toast.show(res.msg);
                            return;
                        }

                        if (!res.data || res.data == "") {
                            $ionicLoading.hide();
                            needStop = true;
                            Toast.show("数据为空!");
                            return;
                        }

                        for (var i = 0; i < headConfs.headsIndex.length; ++i) {
                            if (headConfs.headsIndex[i] == head.index) {
                                break;
                            }
                        }
                        if (i >= headConfs.headsIndex.length) {
                            headConfs.headsIndex[headConfs.headsIndex.length] = head.index;
                        }

                        srcImgInfo.srcIndex = head.index;
                        srcImgInfo.srcInfo = findMaterialInfo(head.index);

                        //获取图片url
                        descImgInfo.targetImageFile = res.data;
                        descImgInfo.targetIndex = 1;//暂定为用户照片中第一个头
                        httpUploadUserPic(res.data, function (url) {
                            $interval.cancel(TmObj);
                            $interval.cancel(procInterv);
                            procInterv = $interval(function(){
                                if(!url || url == "")
                                {
                                    $interval.cancel(procInterv);
                                    $ionicLoading.hide();
                                    return;
                                }

                                if(timeTick < 100){
                                    $scope.procPercentage = ++timeTick;
                                }else{
                                    updateBackgroundPic(url);

                                    $interval.cancel(procInterv);
                                    $ionicLoading.hide();
                                }
                            }, 10);

                        });
                    }, function (err) {
                        $ionicLoading.hide();
                        Toast.show(err);
                    }/*, function (proc) {
                        if (proc < 90) {
                            $scope.procPercentage = proc;
                        }
                    }*/);
                }, function (err) {
                    //处理错误信息
                    Toast.show(err);
                });
            } catch (e) {
                Toast.show(e);
            }
        }

        //上传用户当前拍照结果函数
        //返回照片中头像的位置信息
        function httpUploadUserPic(url, callback) {
            if(!url){
                Toast.show("程序出错!");
                callback();
                return;
            }
            //去掉url中的"http://"或其他头部信息
            //if(url.indexOf("http://") >= 0){
            //    url = url.replace("http://", "");
            //}
            var lastTime = (new Date()).getTime();
            $http.get(ENV.api + "/common/find_face_alg?srcImageFile=" + url)
                .success(function (res) {
                    console.log("find_face_alg: " + ((new Date()).getTime() - lastTime));
                    if (!res.success) {
                        Toast.show(res.msg);
                        callback();
                        return;
                    }
                    if (!res.data || res.data.count <= 0) {
                        Toast.show("没有识别出你的头像,请重拍!");
                        callback();
                        return;
                    }
                    procUserHeadInfo(res.data, function (res) {
                        if (res) {
                            callback(res);
                        } else {
                            callback();
                        }
                    });
                })
                .error(function (err) {
                    Toast.show(err);
                    callback();
                });
        }

        //处理用户头像信息
        function procUserHeadInfo(data, callback) {
            if (data) {
                var faceInfo = data.faceInfo;
                for (var i = 0; i < faceInfo.length; ++i) {
                    if (faceInfo[i].index == "1") {
                        descImgInfo.targetInfo = faceInfo[i].info;
                        break;
                    }
                }

                //开始合成头像图片
                httpCombinePortrait(function (url) {
                    if (url) {
                        callback(url);
                    } else {
                        callback();
                    }
                });
            } else {
                Toast.show("程序出错!");
                callback();
            }
        }

        //合成配图结果函数
        function httpCombinePortrait(callback) {
            var lastTime = (new Date()).getTime();
            $http.post(ENV.api + "/common/replace_face_alg", param({
                targetImageFile: descImgInfo.targetImageFile,
                targetIndex: descImgInfo.targetIndex,
                targetInfo: descImgInfo.targetInfo,
                srcImageFile: srcImgInfo.srcImageFile,
                srcIndex: srcImgInfo.srcIndex,
                srcInfo: srcImgInfo.srcInfo
            })).success(function (res) {
                console.log("replace_face_alg: " + ((new Date()).getTime() - lastTime));
                if (!res.success) {
                    Toast.show(res.msg);
                    callback();
                    return;
                }

                if (!res.data || res.data == "") {
                    Toast.show("数据为空!");
                    callback();
                    return;
                }

                callback(res.data);
            }).error(function (err) {
                Toast.show(err);
                callback();
            });
        }


        var lastChangeIndex = -1;
        //更新背景图片函数
        function updateBackgroundPic(url) {
            times = 0;
            (function() {
                var call = arguments.callee;
                var img = new Image();
                img.src = url;
                img.onload = function () {
                    $timeout(function () {
                        $scope.displayInfo.resultImg = url;
                        $sce.trustAsResourceUrl(url);
                    }, 0);
                };

                img.onerror = function (err) {
                    if (times++ <= 5) {
                        call();
                    } else {
                        Toast.show(err);
                    }
                };
            })();
            srcImgInfo.srcImageFile = url;
            headConfs.resultImg = url;
        }

        //当前编辑的成果ID
        var curDisportId = "";
        //添加成果到服务端
        function httpAddResult(callback) {
            $ionicLoading.show();
            $http.post(ENV.api + "/recreation/add", param({
                disportDataId: materialId,
                disportTitle: $scope.displayInfo.title,
                content: JSON.stringify(headConfs)
            })).success(function (response) {
                $ionicLoading.hide();
                if (!response.success) {
                    if (response.code == "50005") {
                        Toast.show("名字重复!");
                        return;
                    }
                    Toast.show(response.msg);
                    return;
                }

                if (!response.data) {
                    Toast.show("数据为空!");
                    return;
                }

                curDisportId = response.data.disportId;

                callback();
            });
        }

        //修改当前成果
        function httpModifyResult(callback, disportId) {
            $ionicLoading.show();
            $http.post(ENV.api + "/recreation/update", param({
                json: JSON.stringify({
                    disportId: disportId || curDisportId,
                    disportTitle: $scope.displayInfo.title,
                    content: JSON.stringify(headConfs)
                })
            })).success(function (response) {
                $ionicLoading.hide();
                if (!response.success) {
                    if (response.code == "50005") {
                        Toast.show("名字重复!");
                        return;
                    }
                    Toast.show(response.msg);
                    callback(false);
                    return;
                }


                callback(true);
            });
        }

        //新建成果事件
        $scope.createNewResult = function () {
            generateHeadsBox();
            //计算透明层距离顶部的距离
            var offsetTop = document.querySelector('#play-head').offsetTop;
            if (device.platform == 'iOS') {
                $scope.editPanelStyle = {
                    top: offsetTop+59 > screen.availHeight*0.7 ? "80%" : offsetTop+59 + "px"
                }
            } else {
                $scope.editPanelStyle = {
                    top: offsetTop+39 > screen.availHeight*0.7 ? "80%" : offsetTop+39 + "px"
                }
            }
            //初始化数据
            srcImgInfo.srcImageFile = materialConfs.data;
            srcImgInfo.srcIndex = "";
            srcImgInfo.srcInfo = null;

            headConfs.resultImg = "";
            headConfs.headsIndex = [];

            lastChangeIndex = -1;

            $timeout(function () {
                $scope.displayInfo.resultImg = headConfs.srcImg;

                $scope.displayInfo.title = "配图" + (new Date()).getTime();
            }, 0);

            hideListShowPanel();
        };
        getAuthorResultList();

        //分享到第三方平台
        /*
         下面是传入的参数的格式及字段的意义：
         platform      : 分享平台，可以取值为 wxfriend(微信好友)、wxcircle(微信朋友圈)、weibo(新浪微博)、qzone(QQ空间)、qfriend(QQ好友)

         contentType   : 数据类型，可以取值为 link(网页链接)、text(文本)、img(图片)
         content       : 分享的内容对象

         contentString : 除QQ空间外分享的内容，取值可以是网页链接、文本、图片链接
         linkImgUrl    : 和网页链接一起分享的图片

         qzText        : QQ空间分享的文本
         qzLink        : QQ空间分享的网页链接
         qzImgUrl      : QQ空间分享的图片链接
         */
        $scope.shareDatas = function(play){
            if(play) {
                play = angular.fromJson(play);
                return {
                    type: "img",
                    title: play ? play.disportTitle : "",
                    text: play ? play.disportTitle : "",
                    link: ENV.shareApi + "?id=" + play.disportId,
                    linkImgUrl: play ? play.content.resultImg : "",
                    imgSrc: play ? play.content.resultImg : ""
                };
            }
        };


        //当前正在编辑的成果ID
        var curEditDisportId = "";

        //获取作者此素材的成果列表
        function getAuthorResultList() {
            //*********管理历史成果。。。。***************/
            var disportDataId = materialId;
            $scope.disportDataId = disportDataId;
            var originalImgUrl;
            var textResultImg = "";
            $scope.resultPlayList = [];
            /**
             * 获取成果列表
             * @return {[type]} [description]
             */
            function getDisoportDataList(page, callback) {
                //识别用户是否登录
                if (User.getCurrentUser() != null) {
                    var userId = User.getCurrentUser().userId;
                } else {
                    Toast.show('您还未登录');
                    return;
                }
                PlaySvc.getList(userId, 2, materialId, 4, page, 0, function (result) {
                    if (result.success) {
                        if (result.data && result.data.resultList) {
                            if(parseInt(result.data.totalCount) <= $scope.resultPlayList.length+parseInt(result.data.pageSize)){
                                $scope.isShowLoadMore = false;
                                 if(parseInt(result.data.totalCount)>10){
                                    $scope.isShowNoData = true; 
                                   }
                                $timeout(function() {
                                    Toast.show('没有更多数据了');
                                 }, 500);
                            }else{
                                $scope.isShowLoadMore = true;
                            }
                            //这里做循环添加数据
                            angular.forEach(result.data.resultList, function (item) {
                                item.isPlay = false;
                                item.content = JSON.parse(item.content);
                            })

                            callback && callback(result.data.resultList);


                            //处理刚才编辑的成果背景显示
                            // 添加背景色
                            angular.forEach($scope.resultPlayList, function (item) {
                                item.isActive = false;
                                if (item.disportId == curEditDisportId) {
                                    item.isActive = true;
                                    curEditDisportId = "";
                                }
                            });

                            return;
                        } else {
                            Toast.show('查询成果列表失败')
                        }
                    }
                    callback && callback([]);
                });
            }

            /**
             * 根据成果ID查询成果
             * @param  {[type]} disportId [description]
             * @return {[type]}           [description]
             */

            function getDisportById(disportId) {
                var itemResult;
                angular.forEach($scope.resultPlayList, function (item) {
                    if (item.disportId == disportId) {
                        itemResult = item;
                        return false;
                    }
                })
                return itemResult;
            }

            var page = 1;

            /**
             * 初始化当前页面
             * @return {[type]} [description]
             */
            function __init() {
                $scope.resultPlayList = [];
                $scope.noMoreData = false;
                //查询成果列表
                getDisoportDataList(page, function (resultList) {
                    //初始化成果列表
                    if (resultList.length == 0) { //暂时没有数据则需要提示
                        $scope.noMoreData = true;
                        Toast.show('没有更多数据了！')
                    } else {
                        $scope.noMoreData = false;
                        $scope.resultPlayList = $scope.resultPlayList.concat(resultList);
                        $timeout(function () {
                            $ionicScrollDelegate.resize();
                        }, 100);
                    }
                })
            }

            $scope.isShowLoadMore = false;
            //加载更多成果
            $scope.loadMoreDisport = function () {
                page++;
                $scope.isShowLoadMore = false;
                getDisoportDataList(page, function (resultList) {
                    //初始化成果列表
                    $scope.resultPlayList = $scope.resultPlayList.concat(resultList);
                    if (resultList.length <= 0) {
                        isShowLoadMore = false;
                    }
                })
            }
            //删除事件
            $scope.deleteEvent = function (disportId) {
                //添加背景色
                angular.forEach($scope.resultPlayList, function (item) {
                    item.isActive = false;
                    if (item.disportId == disportId) {
                        item.isActive = true;
                    }
                });
                $ionicPopup.show({
                    title: '确认删除？',
                    buttons: [{
                        text: '取消'
                    }, {
                        text: '确定',
                        onTap: function () {
                            //开始执行删除
                            PlaySvc.deleteRecreation(disportId, function (result) {
                                if (result.success) {
                                    /*如果删除的成果为当前正在编辑的成果,则自动新建一个成果*/
                                    Toast.show('删除成功')
                                    //重新加载列表
                                    page = 1;
                                    $scope.resultPlayList.noData = false;
                                    getDisoportDataList(page, function (resultList) {
                                        $scope.resultPlayList = resultList;
                                    })
                                } else {
                                    Toast.show('删除失败')
                                }
                            })
                        }
                    }]
                })
            }
            //发布事件
            $scope.publishEvent = function (disportItem) {
                //添加背景色
                angular.forEach($scope.resultPlayList, function (item) {
                    item.isActive = false;
                    if (item.disportId == disportItem.disportId) {
                        item.isActive = true;
                    }
                });
                if (disportItem.isRelease == 0) {
                    $ionicPopup.show({
                        title: '立即发布？',
                        buttons: [{
                            text: '取消'
                        }, {
                            text: '确定',
                            onTap: function () {
                                //开始执行发布
                                PlaySvc.releaseRecreation(disportItem.disportId, 1, function (result) {
                                    if (result.success) {
                                        Toast.show('发布成功');
                                        //重新加载列表
                                        page = 1;
                                        //$scope.isShowLoadMore = true;
                                        $scope.resultPlayList.noData = false;
                                        getDisoportDataList(page, function (resultList) {
                                            $scope.resultPlayList = resultList;
                                        })
                                    } else {
                                        Toast.show('发布失败！')
                                    }
                                })
                            }
                        }]
                    })
                } else {
                    Toast.show('已经发布了哟~');
                }
            }
            //分享样式
            $scope.shareEvent = function (disport) {
                //添加背景色
                angular.forEach($scope.resultPlayList, function (item) {
                    item.isActive = false;
                    if (item.disportId == disport.disportId) {
                        item.isActive = true;
                    }
                });
            }
            $scope.preview = {};
            //预览
            $scope.previewEvent = function (disport) {
                //添加背景色
                angular.forEach($scope.resultPlayList, function (item) {
                    item.isActive = false;
                    if (item.disportId == disport.disportId) {
                        item.isActive = true;
                    }
                });
                //预览我的字幕成果
                $ionicLoading.show();
                var img = new Image();
                img.src = disport.content.resultImg;
                img.onload = function () {
                    $ionicLoading.hide();
                    $timeout(function () {
                        $scope.preview.contentPic = disport.content.resultImg;
                        $scope.preview.popupcontentStyle = {left: 200, visibility: "visible"};
                        $ionicScrollDelegate.$getByHandle('mainScrnWordsScroll').scrollTop();
                    }, 0);
                };

                img.onerror = function () {
                    $ionicLoading.hide();
                    Toast.show("图片加载失败!");
                };
            }
            //hide the modified picture
            $scope.popupcontentClick = function () {
                return $scope.preview.popupcontentStyle = {visibility: "hidden"};
            };

            //修改名字
            $scope.changeName = function (disport) {
                //添加背景色
                angular.forEach($scope.resultPlayList, function (item) {
                    item.isActive = false;
                    if (item.disportId == disport.disportId) {
                        item.isActive = true;
                    }
                });
                //修改我的成果名字
                if (disport.isRelease == "1") {
                    Toast.show('已发布的成果不能编辑');
                    return;
                }
                if($scope.displayInfo){
                    $scope.displayInfo.title = disport.disportTitle;
                }else{
                    $scope.displayInfo = {
                        title: disport.disportTitle
                    }
                }
                var myPopup = $ionicPopup.show({
                    template: '<input type="text" class="popup-text" ng-model="displayInfo.title">',
                    title: '请输入乐配名称',
                    scope: $scope,
                    buttons: [{
                        text: '取消',
                        onTap: function(e){
                            if (window.cordova && window.cordova.plugins.Keyboard) {
                                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                cordova.plugins.Keyboard.disableScroll(true);
                            }
                        }
                    }, {
                        text: '完成',
                        //type: 'button-positive',
                        onTap: function (e) {
                            if (window.cordova && window.cordova.plugins.Keyboard) {
                                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                cordova.plugins.Keyboard.disableScroll(true);
                            }
                            if (!$scope.displayInfo.title) {
                                e.preventDefault();
                            } else {
                                return $scope.displayInfo.title;
                            }
                        }
                    }]
                });
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(false);
                }
                myPopup.then(function (res) {
                    if (res) {
                        $ionicLoading.show();
                        httpModifyResult(function () {
                            $ionicLoading.hide();
                            getAuthorResultList();
                        }, disport.disportId);
                    } else {

                    }
                });
            }

            //编辑当前成果
            $scope.modifyEvent = function (disport) {
                curEditDisportId = disport.disportId;
                //添加背景色
                angular.forEach($scope.resultPlayList, function (item) {
                    item.isActive = false;
                    if (item.disportId == disport.disportId) {
                        item.isActive = true;
                    }
                });
                if (disport.isRelease == "1") {
                    Toast.show('已发布的成果不能编辑');
                    return;
                }

                curDisportId = disport.disportId;
                $scope.displayInfo.title = disport.disportTitle;
                headConfs = disport.content;
                lastChangeIndex = 1;
                $timeout(function () {
                    $scope.displayInfo.resultImg = headConfs.resultImg;
                    $sce.trustAsResourceUrl(headConfs.resultImg);
                }, 0);
                hideListShowPanel();
            }

            __init();
        }

    });