/**
 * 首页电影，more电影列表，电影二级页面的内容查询
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
/**
 * 首页列表相关
 */
.controller('HomePageCtrl', function($scope,Movies,Toast) {
    var status = "NEW";
    var homePage = 1; //怎样设定请求参数
    $scope.homeVideoList = [];

    Movies.getHomeMovies(status,homePage,function(result){ //查询首页显示视频
        if (result.data && result.data.length > 0) {
            $scope.homeVideoList = result.data;
        } else{
            Toast.show("没有跟多数据了")
        }
    })

})
.controller('MovieMoreCtrl',function($scope,$timeout,$ionicLoading,$state,Movies,Toast){
    $scope.moreMovies = [];
    var noMoreData = false;
    var isLoading = false;
    var index = 0;
    var listcolumn = 3; //排列每行个数
    $scope.moreMovies = []; //页面显示
    var currentPageNo = 1; //当前的页码
    var disportType = 0; //查询电影列表参数
    var area = 0; //查询电影列表参数
    var type = 0; //查询电影列表参数
    var year = 0; //查询电影列表参数
    $scope.movieClassLabel = [[
        {"a":"全部","disportid":"0"},
        {"a":"乐配词","disportid":"1"},
        {"a":"乐配音","disportid":"2"}
    ],[
        {"a":"全部","areaid":"0"},
        {"a":"内地","areaid":"1"},
        {"a":"港台","areaid":"2"},
        {"a":"日韩","areaid":"3"},
        {"a":"欧美","areaid":"4"},
        {"a":"其他","areaid":"5"}
    ],[
        {"a":"全部","typeid":"0"},
        {"a":"爱情","typeid":"1"},
        {"a":"战争","typeid":"2"},
        {"a":"喜剧","typeid":"3"},
        {"a":"科幻","typeid":"4"},
        {"a":"恐怖","typeid":"5"},
        {"a":"动画","typeid":"6"},
        {"a":"恐怖","typeid":"7"}
    ],[
        {"a":"全部","yearid":"0"},
        {"a":"2015","yearid":"2015"},
        {"a":"2014","yearid":"2014"},
        {"a":"2013","yearid":"2013"},
        {"a":"2012","yearid":"2012"},
        {"a":"2011","yearid":"2011"},
        {"a":"2010","yearid":"2010"}
    ]]
    $scope.isScroll = "false"
    console.log($scope.movieClassLabel)

    //控制页面每行显示视频个数
    var filterData = function(data, column) {
            var tempData = [];
            for (var i = 0; i < data.length; i++) {
                var index = parseInt(i / column);
                if (i % column == 0) {
                    tempData[index] = [];
                }
                var temp = data[i];
                temp.SplashImg = "img/loading.png"
                //做一个转换操作
                tempData[index].push(temp);
            }
            return tempData;
        }

    //获取$scope.moreMovie中的每个item；
    function getItem() {
     if (index == $scope.moreMovies.length*listcolumn) {
       return null;
     }
     var firstIndex = parseInt(index/listcolumn);
     var secondIndex = index%listcolumn;
     if ($scope.moreMovies[firstIndex][secondIndex] == undefined){
       return null;
     }
     var item = $scope.moreMovies[firstIndex][secondIndex];
     index++;
     return item;
    }

    //延迟加载，将item.content.SplashImg设置真实路径
    function loadImg(item) {
        if (item != null) {
            var realurl = item.image;
            var img = new Image();
            img.src = realurl;
            img.onload = function() {
                item.SplashImg = realurl;
                $timeout(function() {
                    loadImg(getItem());
                }, 10);
            }
        }
    }

    function getList() {
        $ionicLoading.show();
        if (!noMoreData && !isLoading) {
           isLoading = true;
            Movies.getMoviesList(disportType,area,type,year,currentPageNo,function(result){ //查询视频列表
                if (result.data && result.data.length > 0) {
                    if($scope.moreMovies.length>0){
                    var calc = listcolumn-$scope.moreMovies[$scope.moreMovies.length-1].length;
                    if(calc>0){
                        for(var i = 0;i < calc;i++){
                            $scope.moreMovies[$scope.moreMovies.length-1].push(result.data.shift());
                        }
                    }}
                    var temp = filterData(result.data,listcolumn);
                    console.log(temp)
                    $scope.moreMovies = $scope.moreMovies.concat(temp);
                    console.log($scope.moreMovies)
                    loadImg(getItem());//延迟加载

                    noMoreData = false;
                } else{
                    noMoreData = true;
                    Toast.show("没有跟多数据了")
                }
                currentPageNo++;
                $ionicLoading.hide();
                isLoading = false;
                if (!$scope.$$phase) {
                    $scope.$apply();
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicLoading.hide();
            })
        }else{
            console.log("hao")
        }
    }

    $scope.loadMore = function() {
       getList();
    }

    //页面点击调用查询电影分类函数
    $scope.fiterMovies = function(e){
        // 判断是否改变查询参数
        if(e.path[0].attributes.areaid.value != ""){
            area = e.path[0].attributes.areaid.value;
        }else{
            //不改变参数
        }
        if(e.path[0].attributes.typeid.value != ""){
            type = e.path[0].attributes.typeid.value;
        }else{
            //不改变参数
        }
        if(e.path[0].attributes.yearid.value != ""){
            year = e.path[0].attributes.yearid.value;
        }else{
            //不改变参数
        }
        if(e.path[0].attributes.disportid.value != ""){
            disportType = e.path[0].attributes.disportid.value;
        }else{
            //不改变参数
        }
        currentPageNo = 1;
        $scope.moreMovies = [];
        index = 0;
        getList();

    }
    //打开电影详情页面
    $scope.openDetail = function(movieitem){
        var id = movieitem.disportId;
        $state.go('movie-'+'detail', {
            id: id
        });
    }


})
.controller("MovieDetailCtrl",function($scope,$state,Movies,Toast){
    var vId = 1;//$stateParams.id;
    var disportDataId = 1; //素材ID ？
    var typeh = 7 //脑补主题
    var typet = 10 //简介
    $scope.themeList = [];
    $scope.threeList = [];
    $scope.entertainmentOther = [];
    $scope.entertainmentOthervideo = [];

    Movies.getHeadTheme(typeh,vId,function(result){ //查询视频二级显示的主题
        if(result.data && result.data.content.length > 0){
            $scope.themeList = result.data.content;
        } else{
            Toast.show("没有跟多数据了");
        }
    });
    Movies.getHeadTheme(typet,vId,function(result){ //查询视频二级显示的主题
        if(result.data && result.data.content.length > 0){
            $scope.synopsis = result.data.content;
        } else{
            Toast.show("没有跟多数据了");
        }
    });
    //评论功能，通过滚动控制输入框是否显示<mark3>
    function showInputBox(scrollTop, scrollLeft) {
        var commentheigth = document.getElementById('commetposition').offsetTop - window.screen.height+105; //comment的高度
        if (scrollTop >= commentheigth) {
            document.getElementById("inputbox").className = "sb-input-warpper inputboxshow"
        } else {
            document.getElementById("commenttext").value = "";//清空input里面的内容
            document.getElementById("inputbox").className = "sb-input-warpper inputboxhide";
        }
    }
    $scope.showInputBox = showInputBox;
    $scope.input = {
        comment: ""
    };
    $scope.scrollTop = function() {
        $ionicScrollDelegate.scrollTop();
    }



    Movies.getThree(vId,disportDataId,function(result){ //查询影片下的三配
        if(result.data && result.data.resultList.length > 0){
            $scope.threeList = result.data.resultList;
        } else{
            Toast.show("没有跟多数据了")
        }
    });
    Movies.getEntertainmentOther(vId,disportDataId,function(result){ //查询影片的其他娱乐推荐
        if(result.data && result.data.resultList.length > 0){
            $scope.entertainmentOther = result.data.resultList;
        } else{
            Toast.show("没有跟多数据了")
        }
    });
    Movies.getEntertainmentOthervideo(vId,function(result){ //查询其他影片的娱乐推荐
        if(result.data && result.data.length > 0){
            $scope.entertainmentOthervideo = result.data;
        } else{
            Toast.show("没有跟多数据了")
        }
    });
    Movies.getMovieFeature(vId,function(result){
        if(result.data && result.data.length > 0){
            $scope.movieFeature = result.data;
        } else{
            Toast.show("没有跟多数据了")
        }
    })
    $scope.likeNumber = 330;
    $scope.like = function(e){
        e.path[0].className +=" button-positive";
        e.path[1].children[0].className +=" disabled";
        e.path[1].children[0].style.opacity ="1";
        e.path[1].children[1].style.opacity ="1";
        e.path[1].children[1].className +=" disabled";
        $scope.likeNumber++
    }
    $scope.praiseNumber = 30;
    $scope.praise = function(e){
        e.path[0].className +=" button-positive";
        e.path[1].children[0].className +=" disabled";
        e.path[1].children[0].style.opacity ="1";
        e.path[1].children[1].style.opacity ="1";
        e.path[1].children[1].className +=" disabled";
        $scope.praiseNumber++
    };

    //打开电影详情页面
    $scope.openDetail = function(movieitem){
        var id = movieitem.disportId;
        $state.go('movie-'+'detail', {
            id: id
        });
    }

})
