/**
 *电影场景相关操作
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
/**
 * 电影场景相关
 */
.controller('MovieSceneCtrl', function($scope,$state,$ionicPlatform,$ionicHistory,$ionicScrollDelegate,$timeout,$stateParams,$ionicModal,$rootScope,$ionicLoading,Movies,Toast){
  var longitude;
  var latitude;
  var videoid = $stateParams.videoid;

  $ionicLoading.show({'duration':4000,'delay':0,'noBackdrop':false});
  var getCinema = function(longitude,latitude,searchdistance){
    $scope.senceList = [];
    $scope.senceList.loading=true; //正在加载数据状态
    $scope.senceList.nodate=false;  //没有数据状态
    var reg = /^\d+(\.\d)?/;
    // 查询附近电影院
    Movies.getAroundCinema(longitude,latitude,searchdistance,function(result){
        // console.log(result)
        if (result.data && result.data.length > 0) {
            $ionicLoading.hide();
            angular.forEach(result.data,function(item){
              if(reg.test(item.distance)){
                item.distance=reg.exec(item.distance)[0]
                item.distance = item.distance + "公里"
              }
            })
            $scope.senceList = result.data;
            $scope.senceList.loading=false;

        } else{
            Movies.getAroundCinema(longitude,latitude,30,function(result){
                // console.log(result)
                if (result.data && result.data.length > 0) {
                    $ionicLoading.hide();
                    angular.forEach(result.data,function(item){
                      if(reg.test(item.distance)){
                        item.distance=reg.exec(item.distance)[0]
                      }
                    })
                    $scope.senceList = result.data;
                    $scope.senceList.loading=false;

                } else{
                    console.log("没有更多数据了")
                    $ionicLoading.hide();
                    $scope.senceList.nodate=true;
                    $scope.senceList.loading=false;
                }
            })
        }
    })
  }

  //打开定位页面
  $scope.gochoosecity = function(){
     $state.go('choose-city');
  }


  //打开电影详情页面
  $scope.openDetail = function(movieitem){
      var id = movieitem.cinemaId;
      var name = encodeURIComponent(movieitem.cinemaName);
      var addr = encodeURIComponent(movieitem.cinemaAddress);
      $state.go('movie-scene-detail', {
          id: id,
          name:name,
          addr:addr,
          videoid:videoid
      });
  }
  var locationTime = 1;
  var freshLocation = function(){
    $scope.currentLocation = [];
    locationTime++
    if(locationTime==7){
      locationTime =0;
      $ionicLoading.hide()
      $scope.currentLocation.city = "选择城市";
      $scope.currentLocation.addr = "未获取到地理位置";
      Toast.show("未获得地理位置信息");
    }else{
        if($rootScope.userlocation.locations.length>0){

          $scope.currentLocation = $rootScope.userlocation.locations[$rootScope.userlocation.locations.length-1];
          $scope.locationCity = $rootScope.userlocation.locations[$rootScope.userlocation.locations.length-1];
          //无网络情况下获取到的定位无位置信息，只有经纬度
          if($scope.currentLocation.addr==undefined){
            var isAddr = false
            angular.forEach($rootScope.userlocation,function(item){
              if(item.addr!=undefined){
                $scope.currentLocation = item;
                isAddr = true;
              }
            })
            if(!isAddr){
              $scope.currentLocation.city = "选择城市";
              $scope.currentLocation.addr = "未获取到地理位置";
            }
          }else{
            // $scope.currentLocation = $rootScope.userlocation.locations[i-1];
          }
          longitude = $scope.currentLocation.longitude;
          latitude = $scope.currentLocation.latitude;
          getCinema(longitude,latitude,5);//获取附近电影院
          locationTime = 0
          $ionicLoading.hide()
        }else{
          setTimeout(function(){freshLocation()},1000)
        }
    }
  }

  freshLocation();//进入电影院页面查询一次
  $scope.freshLocationAgain = function(){
    $ionicLoading.show({'duration':5000,'delay':0,'noBackdrop':false});
    if($rootScope.userlocation){
      Movies.searchLocation(function(result){
          $rootScope.userlocation.locations.push(result);
          freshLocation();
      });
    }else{
      $scope.currentLocation.city = "选择城市"
      $scope.currentLocation.addr = "未获取到地理位置";
      console.log("未获取到地理位置")
      $ionicLoading.hide;
    }
  };


  function pySegSort(arr) {
    var letters ="abcdefghjklmnopqrstwxyz".split('');
    var segs = [];
    var curr;
    angular.forEach(letters, function(item){
      curr = {letter: item.toUpperCase(), data:[]};
      angular.forEach(arr, function(itemdata) {
        if(itemdata.pinyin.split("")[0]==item || itemdata.pinyin.split("")[0]==item.toUpperCase()){
          curr.data.push(itemdata)
        }
      });
      if(curr.data.length) {
        segs.push(curr);
      }
    });
    return segs;
  }
  $scope.cityList = []
  $scope.lastChooseCity = [];
  var cityList = []
  $scope.hotcitylist = [];
  //控制页面每行显示视频个数
  var filterData = function(data, column) {
          var tempData = [];
          for (var i = 0; i < data.length; i++) {
              var index = parseInt(i / column);
              if (i % column == 0) {
                  tempData[index] = [];
              }
              var temp = data[i];
              temp.SplashImg = "img/loading.png"
              //做一个转换操作
              tempData[index].push(temp);
          }
          return tempData;
      }


  //获取城市列表
  Movies.getCityList(function(result){
      angular.forEach(result.cityList,function(item){
        // item.notFind = false;
        if(item.areaVOs&&item.areaVOs.length>0){
          $scope.cityList=$scope.cityList.concat(item.areaVOs)
        }
      })
      angular.forEach($scope.cityList,function(item){
        //JSON数据为String类型
        if(parseInt(item.isHot)==1){
          $scope.hotcitylist.push(item)
        }
      })
      cityList = $scope.cityList
      $scope.cityList=pySegSort($scope.cityList)
      // console.log($scope.cityList)
      // console.log($scope.hotcitylist)
      if($scope.hotcitylist.length>0){
        $scope.hotcitylist=filterData($scope.hotcitylist,3)
      }
  })
  $scope.selectAcity = function(city){
    if(city.notFind){

    }else{
       var isNew = true;
       var oldIndex;
       angular.forEach($scope.lastChooseCity,function(item,index){
         if(city.id==item.id){
           isNew = false;
           oldIndex = index;
         }
       })
       if(isNew){
         $scope.lastChooseCity.unshift(city)
       }else{
         $scope.lastChooseCity.splice(oldIndex,1)
         $scope.lastChooseCity.unshift(city);
       }

       $scope.modal.remove();
       $scope.showresult = false;
       Movies.selectAcity(city.id,function(result){
         $scope.currentLocation={}
         $scope.currentLocation.city = city.areaname;
         $scope.currentLocation.addr = city.areaname;
         if(result.success){
           $scope.senceList = result.cinemaList;
           $ionicLoading.hide()
           $ionicScrollDelegate.resize();
           // $scope.modal.remove();
         }else{
           Toast.show("未获取到该城市的电影院");
           // $scope.currentLocation={}
           $scope.senceList=[]
           // freshLocation();//进入电影院页面查询一次
           // $scope.modal.remove();
         }
       })
    }

  }
  $scope.getLocationCinema = function(longitude,latitude,distance,cityInfor){
      $ionicLoading.show({'duration':5000,'delay':0,'noBackdrop':false});
      getCinema(longitude,latitude,distance);
      $scope.modal.remove();
      $scope.currentLocation = cityInfor;

  }
  /**
   * 显示选择城市信息
   * @param  {[type]} dotId [description]
   * @return {[type]}       [description]
   */
  var descEvent = function(cityId) {
      //var dot = getShowDotByid(dotId);
      // console.log(themeItem)
      // themeItem.allContent = InterfaceDotInfo.createAllContent(cityId);
      $scope.tempInfo = cityId;
      $ionicModal.fromTemplateUrl('templates/subjectme/choose-city.html', {
          scope: $scope,
          animation: 'slide-in-up'
      }).then(function(modal) {
          $scope.modal = modal;
          modal.show();
          // $scope.inputContent = document.getElementById("cityInput").value;
          $scope.inputContent={
             "value":""
          };

      });
    }
  $scope.showcitydescEvent = descEvent;
  //关闭模板
  $scope.removeModal = function(){
    $scope.modal.remove();
    $scope.showresult = false;//设初始页面
  }
  $scope.inputContent={
     "value":""
  };
  $scope.searchAcity = function(){
    $scope.beSearchCity = [];
    var inputContent = $scope.inputContent.value;
    var inputItems = inputContent.split("");
    var regstring = inputItems.join(".*")//正则匹配字符串
    if(inputContent==""){
      // Toast.show("输入不能为空!")
      $scope.showresult = false;//设初始页面
    }else if(cityList.length!=0){
      var reg = new RegExp(regstring,"i");
      $scope.showresult = true;
      var beSearch = false
      angular.forEach(cityList,function(item){
        if(item.areaname.indexOf(inputContent)>=0){//匹配中文
          $scope.beSearchCity.push(item);
          beSearch = true
        }else if(reg.test(item.pinyin)){ //正则匹配拼音
          $scope.beSearchCity.push(item);
          beSearch = true
        }
      })
      $ionicScrollDelegate.resize();
      if(!beSearch){
        $scope.beSearchCity.push({"areaname":"抱歉,暂时未找到相关城市","notFind":true})
      }
    }
  }
  $scope.$watch('inputContent.value', function(newValue, oldValue) {
      $scope.searchAcity()
  })

/*
  城市列表字母选择
 */
 // var ul=document.getElementsByTagName('ul');
 //    ul.addEventListener('touchstart', function(event){
 //    var touch = event.targetTouches[0];
 //         Scroll=0;
 //          startPos = {
 //            x:touch.pageX,
 //            y:touch.pageY,
 //            time:+new Date
 //          };
 //               event.stopPropagation();
 //               return false;
 //        },false);
 //    ul.addEventListener('touchmove', function(event){
 //        // 如果这个元素的位置内只有一个手指的话
 //        if (event.targetTouches.length == 1) {
 //           var touch = event.targetTouches[0];
 //        // 把元素放在手指所在的位置
 //        　endPos = {
 //          x:touch.pageX - startPos.x,
 //          y:touch.pageY - startPos.y,
 //          time:+new Date
 //            };
 //            y=endPos.y ;
 //          }
 //               event.stopPropagation();
 //               return false;

 //        },false);
     $scope.linkfixedposition = function(e){
          $scope.beSearchCity = [];
          $scope.showletterresult = true;
          var reg = e.target.innerHTML//正则匹配字符串
          $scope.lettertitle=e.target.innerHTML;
          angular.forEach($scope.cityList,function(item){
            if(reg.toLowerCase().test(item.pinyin)){ //正则匹配拼音
               $scope.beSearchCity.push(item);
               beSearch = true
             }
           })
     }


})

