

rootModule
.controller('ResultManagementCtrl', function($scope, Toast, $rootScope, PlaySvc, User, $ionicLoading, $location, $state,$timeout) {
    /**
     * 筛选类型{全部、配音、配词}
     * @type {[type]}
     */
    $scope.filterTypes = PlaySvc.getFilterTypes();
    //列表
    $scope.playList = [];
    var currentTypeId = 1; //当前筛选的类型
    var currentPageNo = 1; //当前的页码
    var playListData = [];
    /**
     * 用于添加数据
     * @param {[type]} arry [description]
     */
    var filterData = function(data, column) {
            var tempData = [];
            for (var i = 0; i < data.length; i++) {
                var index = parseInt(i / column);
                if (i % column == 0) {
                    tempData[index] = [];
                }
                var temp = data[i];
                //做一个转换操作
                switchDesign(temp);
                tempData[index].push(temp);
            }
            return tempData;
        }
    var switchDesign = function(temp){
        //做一个转换操作
        switch (temp.recreationType) {
            case "1":
                temp.recreationTypeText = "video";
                break;
            case "2":
                temp.recreationTypeText = "head";
                break;
            case "3":
                temp.recreationTypeText = "text";
                break;
        }
        try {
            temp.content = JSON.parse(temp.content);

            //temp.content.videoSplashImg = "http://192.168.8.105/download/videoSplash.png"
            temp.content.SplashImg = "img/black.png"
            //设置默认图片，延迟加载
        } catch (e) {
            console.log(e);
        }
    }
    /**
     * 筛选娱乐内容
     * @return {[type]} [description]
     */
    $scope.filterTypeEvent = function(typeId) {
        $scope.playList = [];
        currentTypeId = typeId;
        currentPageNo = 1;
        getList();
    }
    var noMoreData = false;
    var isLoading = false;
    var index = 0;
    var listcolumn = 2;

//<mark>
    //获取$scope.playList中的每个item；
    function getItem() {
      if (index == $scope.playList.length*listcolumn) {
        return null;
      }
      var firstIndex = parseInt(index/listcolumn);
      var secondIndex = index%listcolumn;
      if ($scope.playList[firstIndex][secondIndex] == undefined){
        return null;
      }
      var item = $scope.playList[firstIndex][secondIndex];
      index++;
      console.log(index);
      return item;
    }
    var style = "full-image"
    //延迟加载，将item.content.SplashImg设置真实路径
    function loadImg(item) {
        if (item != null) {
            var realurl;
            if (item.recreationType == 1){
                //1为配音
                realurl = item.content.videoSplashImg;
            }else if(item.recreationType == 3){
                //3配词
                realurl = item.content.resImgSrc
            }
            var img = new Image();
            img.src = realurl;
            img.onload = function() {
                item.content.loaded = true; //控制img的css属性
                item.content.SplashImg = realurl;
                $timeout(function() {
                    loadImg(getItem());
                }, 10);
            };
            img.onerror = function(){
                $timeout(function() {
                    loadImg(getItem());
                }, 10);
            };
        }
    }
    //延迟加载
    function getList() {
        $ionicLoading.show();
        if (!noMoreData && !isLoading) {
            isLoading = true;
            var user = User.getCurrentUser();
            var userId=user.userId;
            if(null!=userId){
                console.log(userId)
                PlaySvc.getList(userId,0,-1,3,currentPageNo,0, function(result) {
                    if (result.data && result.data.resultList && result.data.resultList.length > 0) {
                        if($scope.playList.length>0){

                        var calc = listcolumn-$scope.playList[$scope.playList.length-1].length;
                        if(calc>0){
                            for(var i = 0;i < calc;i++){

                                switchDesign(result.data.resultList[0]);

                                $scope.playList[$scope.playList.length-1].push(result.data.resultList.shift());
                            }
                        }}
                        var temp = filterData(result.data.resultList, listcolumn);
                        console.log(temp);
                        $scope.playList = $scope.playList.concat(temp);
                        console.log($scope.playList)
                        loadImg(getItem());//延迟加载
                        noMoreData = false;
                    } else {
                        //没有更多数据了
                        noMoreData = true;
                        Toast.show('没有更多数据了');
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicLoading.hide();
                    currentPageNo++;
                    isLoading = false;
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                });
            }else{
                //user not login
            }
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $ionicLoading.hide();
    }
    $scope.loadMore = function() {
        getList();
    }
    $rootScope.shoudHideTab = true;
    //打开详情页
    $scope.openDetails = function(id, text) {
        if (window.plugins && typeof window.plugins.webintent != 'undefined') {
            window.plugins.webintent.startActivity({
                    action: "com.handsight.tvhelper.PopoutActivity",
                    extras: {
                        url: "/play/" + text + "/detail/" + id
                    }
                },
                function() {},
                function() {}
            );
        } else {
            $state.go('play-'+text+'-details', {
                id: id
            });
        }
        // $state.go('play-'+text+'-details', {
        //     id: id
        // });
    }
})
/**
 * 乐配音查看详情
 * @param  {[type]} $scope){                 } [description]
 * @return {[type]}           [description]
 */