var scrnWordsCanvas = (function() {
	var tests = [{
		effect: "posterize",
		options: {
			levels: 5
		}
	}, {
		effect: "solarize"
	}, {
		effect: "colorfilter",
		options: {
			r: 0,
			g: 194 / 255,
			b: 177 / 255,
			luminosity: 0
		}
	}, {
		effect: "findedges"
	}, {
		effect: "emboss",
		options: {
			amount: 0.5,
			angle: 135 / 180 * Math.PI
		}
	}, {
		effect: "edgeenhance3x3"
	}, {
		effect: "edgeenhance5x5"
	}, {
		effect: "sharpen3x3",
		options: {
			strength: 0.5
		}
	}, {
		effect: "sharpen5x5",
		options: {
			strength: 0.1
		}
	}, {
		effect: "soften3x3"
	}, {
		effect: "soften5x5"
	}, {
		effect: "laplace3x3"
	}, {
		effect: "laplace5x5"
	}, {
		effect: "crossedges",
		options: {
			strength: 0.5
		}
	}, {
		effect: "coloradjust",
		options: {
			r: 0,
			g: 0.3,
			b: 0
		}
	}, {
		effect: "blur",
		options: {
			kernelSize: 5
		}
	}, {
		effect: "glow",
		options: {
			kernelSize: 5,
			amount: 1.0
		}
	}, {
		effect: "hsl",
		options: {
			hue: -0.8,
			saturation: 0.5,
			lightness: -0.3
		}
	}, {
		effect: "fliph"
	}, {
		effect: "flipv"
	}, {
		effect: "desaturate"
	}, {
		effect: "brightness",
		options: {
			brightness: -1.00,
			contrast: -0.1
		}
	}, {
		effect: "sepia",
	}, {
		effect: "invert",
	}, {
		effect: "noise",
		options: {
			amount: 0.5,
			strength: 0.5,
			mono: true
		}
	}, {
		effect: "removenoise"
	}, {
		effect: "lighten",
		options: {
			amount: 0.5
		}
	}, {
		effect: 'mosaic',
		options: {
			blockSize: 8
		}
	}, {
		effect: 'equalize',
		options: {}
	}];

	var canvas = null,
		image = null,
		style = null,
		context = null,
		w = 0,
		h = 0; //一张干净画布， 一张原图片， 一个变化样式
	function CIS(c, i, s) {
		canvas = c;
		image = i;
		style = s;
		context = canvas.getContext("2d");
		w = canvas.width;
		h = canvas.height;
	}

	function changeFilter(callback) {
		var index = parseInt(style.imgMod);
		if(index <= 0){
			callback();
			return;
		}
		--index;
		canvas.title = tests[index].effect;
		var P = new Pixastic(context);
		P[tests[index].effect](tests[index].options).done(function() {
			canvas.style.display = "block";
			callback();
		});
	}

	function addWords() {
		var fontSize = parseInt(style.fontSize);
		context.shadowColor = "black";
		context.shadowBlur = 8;
		context.shadowOffsetX = 3;
		context.shadowOffsetY = 3;
		context.fillStyle = "white";
		context.font = fontSize + "px Arial";

		var textWidth = context.measureText(style.originContent).width;
		var realWordSum, realWords;
		//if(textWidth > w){
		//	realWordSum = parseInt(w / (textWidth / style.originContent.length))-1;
		//	realWords = style.originContent.substr(0,realWordSum);
		//	textWidth = context.measureText(realWords).width;
		//	context.fillText(realWords, (w - textWidth) / 2, h - fontSize*3);
        //
		//	realWords = style.originContent.substr(realWordSum);
		//	textWidth = context.measureText(realWords).width;
		//	context.fillText(realWords, (w - textWidth) / 2, h - fontSize);
		//}else{
			context.fillText(style.originContent, (w - textWidth) / 2, h - fontSize);
		//}
		context.font = fontSize * 2 / 3 + "px Arial";
		textWidth = context.measureText(style[style.targetLang]).width;
		/*if(textWidth > w){
			realWordSum = parseInt(w / (textWidth / style[style.targetLang].length))-1;
			realWords = style[style.targetLang].substr(0,realWordSum);
			textWidth = context.measureText(realWords).width;
			context.fillText(realWords, (w - textWidth) / 2, h - fontSize * 2);

			realWords = style[style.targetLang].substr(realWordSum);
			textWidth = context.measureText(realWords).width;
			context.fillText(realWords, (w - textWidth) / 2, h - fontSize / 5);
		}else {*/
			context.fillText(style[style.targetLang], (w - textWidth) / 2, h - fontSize / 5);
		//}
		if(wordsCallback){
			wordsCallback(style.imgMod);
		}
	}

	var wordsCallback=null;

	function Refresh() {
		var HWRate = image.height/image.width;
		var realH=0,realW=0;
		/*if(HWRate >= h/w){
			realH = h;
			realW = h / HWRate;
		}else{*/
			realW = w;
			realH = w * HWRate;
		//}
		context.clearRect(0,0,w,h);
		context.fillStyle = "#000000";
		context.fillRect(0,0,w,h);
		//context.drawImage(image, (w-realW)/2, (h-realH)/2, realW, realH);
		context.drawImage(image, 0, 0, w, h);
		changeFilter(addWords);
	}

	/*
	* 匿名函数说明:
	* Canvas,	<canvas>对象
	* Image,	要绘制到canvas上的Image对象
	* Style,	要写到canvas上的样式对象
	* {
	* 		imgSrc: "",		//素材图片url
	* 		imgMod: "0",	//滤镜样式(0, 3, 15, 18, 21, 23, 25, 27, 28, 29)
	* 		originContent: "",		//中文字幕内容
	* 		en: "",		//英文字幕内容
	* 		jp: "",		//日文字幕内容
	* 		kor: "",	//韩文字幕内容
	* 		fontSize: 30,		//字幕文字大小(单位: px)
	* 		targetLang: "en",	//当前外文类型(en, jp, kor)
	* 		resImgSrc: "",		//成果图片url
	*  };
	*  cb,		回调函数
	* */
	return function(Canvas, Image, Style, cb) {
		if(cb){
			wordsCallback = cb;
		}
		else{
			wordsCallback = null;
		}
		CIS(Canvas, Image, Style);
		Refresh();
	};
})();