rootModule
    .controller('PlayTextEditCtrl', function ($scope, PlaySvc, Toast, $ionicPopup,
                                              $ionicScrollDelegate, $http, ENV, $stateParams, $state, User, $sce, $timeout, $ionicLoading) {


        /*window.Keyboard.hideKeyboardAccessoryBar(true);*/
        window.addEventListener('native.keyboardshow',function(){
            document.body.classList.add('keyboard-open');
        });
        $scope.imgEnv = {
            api: "http://playTextImg.handsight.cn/"
        };
        $scope.imgSrcArr = [
            {
                name: "原色派",
                title: "0",
                src: "origin.png"
            },
            {
                name: "电影派",
                title: "3",
                src: "one.png"
            },
            {
                name: "绿色派",
                title: "15",
                src: "two.png"
            },
            {
                name: "浩克派",
                title: "18",
                src: "three.png"
            },
            {
                name: "黑白派",
                title: "21",
                src: "four.png"
            },
            {
                name: "旧照派",
                title: "23",
                src: "five.png"
            },
            {
                name: "木画派",
                title: "25",
                src: "six.png"
            },
            {
                name: "曝光派",
                title: "27",
                src: "seven.png"
            },
            {
                name: "像素派",
                title: "28",
                src: "eight.png"
            },
            {
                name: "油画派",
                title: "29",
                src: "nine.png"
            }
        ]

        function createNewConf(old) {
            var newConf = {};
            for (var p in old) {
                newConf[p] = old[p];
            }
            return newConf;
        }

        var originEffect = {
            imgSrc: "",
            imgMod: "0",
            originContent: "",
            en: "",
            jp: "",
            kor: "",
            fontSize: 30,
            targetLang: "en",
            resImgSrc: "",
        };
        var wordsOptionList = document.getElementById("wordsOptionList");
        var myCanvas = document.getElementById("myCanvas");
        var context = myCanvas.getContext("2d");
        var scrnWords = document.getElementById("scrnWords");
        var otherWords = document.getElementById("otherWords");
        var fontsizeChange = document.getElementById("fontsizeChange");
        var langSelect = document.getElementById("selectLang");


        var editPanelHeight = 0;
        (function(){
            $timeout(function(){
                var height = document.querySelector("ion-content").offsetHeight;
                editPanelHeight = height - document.body.offsetWidth * 720 / 1280 + "px";
                $scope.editPanelStyle = {
                    height: editPanelHeight,
                    border:"none"
                };
                $scope.editBgStyle = {
                    backgroundColor: "#262626"
                }
            }, 0);
        })();

        $scope.gotoResultManag = function () {
            $state.go('result-management');
        };

        //显示成果展示列表，隐藏字幕编辑界面
        function showListHidePanel() {
            $scope.editBgStyle = {
                backgroundColor: "#FFFFFF"
            }
            $scope.editPanelStyle = {
                display: "none",
                height: editPanelHeight,
                border: "none"
            };
            $scope.resultListStyle = {
                display: "block"
            };
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }

        //隐藏成果展示列表，显示字幕编辑界面
        function hideListShowPanel() {
            $scope.resultListStyle = {
                display: "none"
            };
            $scope.editPanelStyle = {
                display: "block",
                height: editPanelHeight,
                border:"none"
            };
            $scope.editBgStyle = {
                backgroundColor: "#262626"
            }
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }

        //修改当前成果
        function httpModifyResult(callback, disport) {
            $ionicLoading.show();
            $http.post(ENV.api + "/recreation/update", param({
                json: JSON.stringify({
                    disportId: disport.disportId,
                    disportTitle: $scope.displayInfo.title,
                    content: JSON.stringify(disport.content)
                })
            })).success(function (response) {
                $ionicLoading.hide();
                if (!response.success) {
                    if (response.code == "50005") {
                        Toast.show("名字重复!");
                        return;
                    }
                    Toast.show(response.msg);
                    callback(false);
                    return;
                }


                callback(true);
            });
        }

        hideListShowPanel();
        //获取单个指定成果
        $http.post(ENV.api + "/recreation/material/get", param({
                disportDataId: $stateParams.id
            }))
            .success(function (response) {
                if (!response.success) {
                    return;
                }
                var resultData = response.data;
                $scope.disportData=response.data;
                var originDataId = resultData.disportDataId;
                var content = JSON.parse(resultData.content);
                var originPic = new Image();
                var wordsOnScreen = createNewConf(originEffect); //当前图片的当前配置信息
                wordsOnScreen.imgSrc = content.data;
                originPic.src = wordsOnScreen.imgSrc;

                originPic.onload = function () {

                    myCanvas.height = 1280 * this.height / this.width;

                    //编辑页首次刷新画布
                    scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                    /*, function() {

                     //生成滤镜用例图片
                     var divArr = document.getElementsByClassName("filterGlass");
                     var len = divArr.length;
                     if (window.filterGlassCollection) {
                     for (var i = 0; i < len; ++i) {
                     divArr[i].children[0].src = window.filterGlassCollection[divArr[i].title];
                     }
                     return;
                     }
                     window.filterGlassCollection = {};
                     var img = new Image();
                     img.src = "img/youhua.png";
                     img.onload = function() {
                     var canvas = document.createElement("canvas");
                     canvas.width = img.width;
                     canvas.height = img.height;
                     var style = createNewConf(originEffect);

                     function rollcaller(index, cb) {
                     if (index < len) {
                     style.imgMod = divArr[index].title;
                     scrnWordsCanvas(canvas, img, style, function(mod) {
                     window.filterGlassCollection[mod] = canvas.toDataURL();
                     cb(index + 1, cb);
                     });
                     } else {
                     for (var i = 0; i < len; ++i) {
                     divArr[i].children[0].src = window.filterGlassCollection[divArr[i].title];
                     }
                     }
                     }
                     rollcaller(0, rollcaller);
                     };
                     });*/

                    //取消当前编辑信息
                    $scope.cancelPlayEvent = function () {
                        //delete conf data
                        getAuthorResultList();
                        wordsOnScreen = createNewConf(originEffect);
                        scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                        showListHidePanel();
                        fontsizeChange.value = "33";
                    };

                    //回到配词
                    $scope.backtoWords = function () {
                        wordsOnScreen = createNewConf(originEffect);
                        scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                        hideListShowPanel();
                        $scope.eraseScrnWordsInput();
                    };

                    //完成并保存编辑信息
                    $scope.writePicWordsName = function () {
                        if(!scrnWords.value || scrnWords.value == ""){
                            Toast.show("你还没有配词哦!");
                            return;
                        }
                        $scope.data = {
                            name: "配词"+(new Date()).getTime()
                        };
                        var myPopup = $ionicPopup.show({
                            template: '<input type="text" placeholder="请输入乐配名称" class="popup-text" ng-model="data.name">',
                            title: '请输入乐配名称',
                            scope: $scope,
                            buttons: [{
                                text: '取消',
                                onTap: function (e){
                                      if (window.cordova && window.cordova.plugins.Keyboard) {
                                          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                          cordova.plugins.Keyboard.disableScroll(true);
                                      }
                                }
                            }, {
                                text: '完成',
                                //type: 'button-positive',
                                onTap: function (e) {
                                    if (window.cordova && window.cordova.plugins.Keyboard) {
                                        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                        cordova.plugins.Keyboard.disableScroll(true);
                                    }
                                    if (!$scope.data.name) {
                                        e.preventDefault();
                                    } else {
                                        return $scope.data.name;
                                    }
                                }
                            }]
                        });
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                            cordova.plugins.Keyboard.disableScroll(false);
                        }
                        myPopup.then(function (res) {
                            if (res) {
                                $ionicLoading.show({
                                    duration: 60000
                                });
                                $timeout(function(){
                                    saveCurPic(res, function () {
                                        $ionicLoading.hide();
                                        $scope.cancelPlayEvent();
                                    });
                                },300);
                            } else {

                            }
                        });
                        return false;
                    };

                    otherWords.value = "";
                    scrnWords.value = "";

                    $scope.eraseScrnWordsInput = function () {
                        otherWords.value = "";
                        scrnWords.value = "";
                        wordsOnScreen = createNewConf(originEffect);
                        scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                    };

                    function translateWords(lang) {
                        if (wordsOnScreen.originContent === "") {
                            return;
                        }
                        var url = "http://openapi.baidu.com/public/2.0/bmt/translate?client_id=" + "P1Z8nmmTUwhfrST6tOHFLWaB" + "&q=" + wordsOnScreen.originContent + "&from=zh&to=" + lang;
                        $http.get(url).success(function (response) {
                            if (response.trans_result[0]) {
                                wordsOnScreen[lang] = response.trans_result[0].dst;
                                otherWords.value = wordsOnScreen[wordsOnScreen.targetLang];
                            } else {
                            }
                        });
                    }

                    //pop up the modified picture
                    function saveCurPic(title, callback) {
                        //保存当前图片配置信息
                        var base64Data = myCanvas.toDataURL();
                        base64Data = base64Data.substr(22, base64Data.length - 22);
                        var urrl = ENV.uploadApi + "/common/upload";
                        $http.post(urrl, param({
                            type: "4",
                            imgBase64: base64Data,
                        })).success(function (response) {
                            try {
                                if(!response.success)
                                {
                                    Toast.show(response.msg);
                                    return;
                                }

                                if(!response.data || response.data == ""){
                                    Toast.show("程序出错");
                                    return;
                                }

                                var newConf = createNewConf(wordsOnScreen);
                                newConf.imgSrc = originPic.getAttribute("src");
                                newConf.imgMod = wordsOnScreen.imgMod;
                                newConf.resImgSrc = response.data;
                                var pictureConfs = JSON.stringify(newConf);
                                var url = ENV.api + "/recreation/add";
                                $http.post(url, param({
                                    disportDataId: originDataId,
                                    disportTitle: title,
                                    content: pictureConfs
                                })).success(function (response) {
                                    callback(response);
                                });
                            } catch (e) {
                                //TODO handle the exception
                                callback(null);
                            }
                        });
                    };

                    //输入框聚焦后间隔等待翻译
                    var waitTransInterv;
                    scrnWords.onfocus = function () {
                        waitTransInterv = setInterval(function () {
                            translateAndShow();
                        }, 1000);
                    };
                    scrnWords.onblur = function () {
                        clearInterval(waitTransInterv);
                    };

                    //手动输入翻译内容
                    var waitOtherInterv;
                    otherWords.onfocus = function () {
                        waitOtherInterv = setInterval(function () {
                            if (wordsOnScreen[wordsOnScreen.targetLang] != otherWords.value) {
                                wordsOnScreen[wordsOnScreen.targetLang] = otherWords.value;
                                scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                            }
                        }, 1000);
                    };
                    otherWords.onblur = function () {
                        clearInterval(waitOtherInterv);
                    };


                    //翻译并刷新字幕
                    function translateAndShow() {
                        if (wordsOnScreen.originContent == scrnWords.value) {
                            return;
                        }
                        wordsOnScreen.originContent = scrnWords.value;
                        translateWords("en");
                        translateWords("jp");
                        translateWords("kor");

                        setTimeout(function () {
                            context.clearRect(0, 0, myCanvas.width, myCanvas.height);
                            //refresh(originPic, myCanvas.width, myCanvas.height);
                            scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                        }, 500);
                    };

                    //change font size of native words
                    fontsizeChange.onchange = function () {
                        scrnWords.blur();
                        otherWords.blur();
                        wordsOnScreen.fontSize = this.value;
                        //refresh(originPic, myCanvas.width, myCanvas.height);
                        scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                    };

                    //change foreign language kind
                    (function () {
                        var btnClassStr = langSelect.children[0].className;
                        var btnClassStrAct = btnClassStr + "activated";
                        langSelect.children[0].setAttribute("class", btnClassStrAct);
                        var selLang = function () {
                            for (i = 0; i < len; ++i) {
                                langSelect.children[i].setAttribute("class", btnClassStr);
                            }
                            switch (this.name) {
                                case "en":
                                    langSelect.children[0].setAttribute("class", btnClassStrAct);
                                    break;
                                case "jp":
                                    langSelect.children[1].setAttribute("class", btnClassStrAct);
                                    break;
                                case "kor":
                                    langSelect.children[2].setAttribute("class", btnClassStrAct);
                                    break;
                                default:
                                    break;
                            }
                            wordsOnScreen.targetLang = this.name;
                            otherWords.value = wordsOnScreen[wordsOnScreen.targetLang];
                            scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                        };
                        for (var i = 0, len = langSelect.children.length; i < len; ++i) {
                            langSelect.children[i].onclick = selLang;
                        }
                    })();

                    (function () {
                        var divArr = document.getElementsByClassName("filterGlass");
                        for (var i = 0, len = divArr.length; i < len; ++i) {
                            divArr[i].onclick = function () {
                                wordsOnScreen.imgMod = this.title;
                                scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                            };
                        }
                    })();
                };

                //分享到第三方平台
                /*
                 下面是传入的参数的格式及字段的意义：
                 platform      : 分享平台，可以取值为 wxfriend(微信好友)、wxcircle(微信朋友圈)、weibo(新浪微博)、qzone(QQ空间)、qfriend(QQ好友)

                 contentType   : 数据类型，可以取值为 link(网页链接)、text(文本)、img(图片)
                 content       : 分享的内容对象

                 contentString : 除QQ空间外分享的内容，取值可以是网页链接、文本、图片链接
                 linkImgUrl    : 和网页链接一起分享的图片

                 qzText        : QQ空间分享的文本
                 qzLink        : QQ空间分享的网页链接
                 qzImgUrl      : QQ空间分享的图片链接
                 */
                $scope.shareDatas = function(play){
                    if(play) {
                        play = angular.fromJson(play);
                        return {
                            type: "img",
                            title: play ? play.disportTitle : "",
                            text: play ? play.disportTitle : "",
                            link: ENV.shareApi + "?id=" + play.disportId,
                            linkImgUrl: play ? play.content.resImgSrc : "",
                            imgSrc: play ? play.content.resImgSrc : ""
                        };
                    }
                };


                //当前正在编辑的成果ID
                //var curEditDisportId = "";
                //获取作者此素材的成果列表
                function getAuthorResultList() {
                    //*********管理历史成果。。。。***************/
                    var disportDataId = originDataId;
                    $scope.disportDataId = disportDataId;
                    var originalImgUrl;
                    var textResultImg = "";
                    $scope.resultPlayList = [];
                    /**
                     * 获取成果列表
                     * @return {[type]} [description]
                     */
                    function getDisoportDataList(page, callback) {
                        //识别用户是否登录
                        if (User.getCurrentUser() != null) {
                            var userId = User.getCurrentUser().userId;
                        } else {
                            Toast.show('您还未登录');
                            return;
                        }
                        PlaySvc.getList(userId, 3, disportDataId, 4, page, 0, function (result) {
                            if (result.success) {
                                if (result.data && result.data.resultList && result.data.resultList.length > 0) {
                                    //这里做循环添加数据
                                    
                                    if(parseInt(result.data.totalCount) <= $scope.resultPlayList.length+parseInt(result.data.pageSize)){
                                        $scope.isShowLoadMore = false;
                                        if(parseInt(result.data.totalCount)>10){
                                            $scope.isShowNoData = true; 
                                        }
                                       
                                       $timeout(function() {
                                            Toast.show('没有更多数据了');
                                        }, 500); 
                                    }else{
                                        $scope.isShowLoadMore = true;
                                         $scope.isShowNoData = false;
                                    }
                                    angular.forEach(result.data.resultList, function (item) {
                                        item.isPlay = false;
                                        item.content = JSON.parse(item.content);
                                    })
                                    callback && callback(result.data.resultList);

                                    //处理刚才编辑的成果背景显示
                                    // 添加背景色
                                   /* angular.forEach($scope.resultPlayList, function (item) {
                                        item.isActive = false;
                                        if (item.disportId == curEditDisportId) {
                                            item.isActive = true;
                                            curEditDisportId = "";
                                        }
                                    });*/

                                    return;
                                } else {
                                    Toast.show('查询成果列表失败')
                                }
                            }
                            callback && callback([]);
                        });
                    }

                    /**
                     * 根据成果ID查询成果
                     * @param  {[type]} disportId [description]
                     * @return {[type]}           [description]
                     */

                    function getDisportById(disportId) {
                        var itemResult;
                        angular.forEach($scope.resultPlayList, function (item) {
                            if (item.disportId == disportId) {
                                itemResult = item;
                                return false;
                            }
                        })
                        return itemResult;
                    }

                    var page = 1;

                    /**
                     * 初始化当前页面
                     * @return {[type]} [description]
                     */
                    function __init() {
                        $scope.resultPlayList = [];
                        $scope.noMoreData = false;
                        //查询成果列表
                        getDisoportDataList(page, function (resultList) {
                            //初始化成果列表
                            if (resultList.length == 0) { //暂时没有数据则需要提示
                                $scope.noMoreData = true;
                                Toast.show('没有更多数据了！')
                            } else {
                                $scope.noMoreData = false;
                                $scope.resultPlayList = $scope.resultPlayList.concat(resultList);
                                $timeout(function () {
                                    $ionicScrollDelegate.resize();
                                }, 100);
                            }
                        })
                    }

                    $scope.isShowLoadMore = false;
                    //加载更多成果
                    $scope.loadMoreDisport = function () {
                        page++;
                        $scope.isShowLoadMore = false;
                        getDisoportDataList(page, function (resultList) {
                            //初始化成果列表
                            $scope.resultPlayList = $scope.resultPlayList.concat(resultList);
                            if (resultList.length <= 0) {
                                isShowLoadMore = false;
                            }
                        })
                    }

                    //修改名字
                    $scope.changeName = function (disport) {
                        //添加背景色
                        angular.forEach($scope.resultPlayList, function (item) {
                            item.isActive = false;
                            if (item.disportId == disport.disportId) {
                                item.isActive = true;
                            }
                        });
                        //修改我的成果名字
                        if (disport.isRelease == "1") {
                            Toast.show('已发布的成果不能编辑');
                            return;
                        }
                        if($scope.displayInfo){
                            $scope.displayInfo.title = disport.disportTitle;
                        }else{
                            $scope.displayInfo = {
                                title: disport.disportTitle
                            }
                        }
                        var myPopup = $ionicPopup.show({
                            template: '<input type="text" class="popup-text" ng-model="displayInfo.title">',
                            title: '确定要修改吗？',
                            scope: $scope,
                            buttons: [{
                                text: '取消',
                                onTap: function (e){
                                    if (window.cordova && window.cordova.plugins.Keyboard) {
                                        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                        cordova.plugins.Keyboard.disableScroll(true);
                                    }
                                }
                            }, {
                                text: '<b>确定</b>',
                                type: 'button-positive',
                                onTap: function (e) {
                                    if (window.cordova && window.cordova.plugins.Keyboard) {
                                        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                        cordova.plugins.Keyboard.disableScroll(true);
                                    }
                                    if (!$scope.displayInfo.title) {
                                        e.preventDefault();
                                    } else {
                                        return $scope.displayInfo.title;
                                    }
                                }
                            }]
                        });
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                            cordova.plugins.Keyboard.disableScroll(false);
                        }
                        myPopup.then(function (res) {
                            if (res && res != "") {
                                $ionicLoading.show();
                                httpModifyResult(function (data) {
                                    $ionicLoading.hide();
                                    if(data) {
                                        getAuthorResultList();
                                    }
                                }, disport);
                            } else {

                            }
                        });
                    }
         
                    //删除事件
                    $scope.deleteEvent = function (disportId) {
                        //添加背景色
                        angular.forEach($scope.resultPlayList, function (item) {
                            item.isActive = false;
                            if (item.disportId == disportId) {
                                item.isActive = true;
                            }
                        });
                        $ionicPopup.show({
                            title: '确认删除？',
                            buttons: [{
                                text: '取消'
                            }, {
                                text: '确定',
                                onTap: function () {
                                    //开始执行删除
                                    PlaySvc.deleteRecreation(disportId, function (result) {
                                        if (result.success) {
                                            Toast.show('删除成功')
                                            //重新加载列表
                                            page = 1;
                                            $scope.resultPlayList.noData = false;
                                            getDisoportDataList(page, function (resultList) {
                                                $scope.resultPlayList = resultList;
                                            })
                                        } else {
                                            Toast.show('删除失败')
                                        }
                                    })
                                }
                            }]
                        })
                    }
                    //发布事件或分享
                    $scope.publishEvent = function (disport) {
                        //添加背景色
                        angular.forEach($scope.resultPlayList, function (item) {
                            item.isActive = false;
                            if (item.disportId == disport.disportId) {
                                item.isActive = true;
                            }
                        });
                        if (disport.isRelease == 0) {
                            $ionicPopup.show({
                                title: '立即发布？',
                                buttons: [{
                                    text: '取消'
                                }, {
                                    text: '确定',
                                    onTap: function () {
                                        //开始执行发布
                                        PlaySvc.releaseRecreation(disport.disportId, 1, function (result) {
                                            if (result.success) {
                                                Toast.show('发布成功');
                                                //重新加载列表
                                                page = 1;
                                                //$scope.isShowLoadMore = true;
                                                $scope.resultPlayList.noData = false;
                                                getDisoportDataList(page, function (resultList) {
                                                    $scope.resultPlayList = resultList;
                                                })
                                            } else {
                                                Toast.show('发布失败！')
                                            }
                                        })
                                    }
                                }]
                            })
                        } else {
                            //Toast.show('已经发布了哟~');
                        }
                    }

                    //分享样式
                    $scope.shareEvent = function (disport) {
                        //添加背景色
                        angular.forEach($scope.resultPlayList, function (item) {
                            item.isActive = false;
                            if (item.disportId == disport.disportId) {
                                item.isActive = true;
                            }
                        });
                    }
                    $scope.getOriginalVideoUrl = function () {
                        return originalVideoUrl;
                    }
                    var nowPlayItem;
                    //预览
                    $scope.previewEvent = function (disportId) {
                        //添加背景色
                        angular.forEach($scope.resultPlayList, function (item) {
                            item.isActive = false;
                            if (item.disportId == disportId) {
                                item.isActive = true;
                            }
                        });
                        //预览我的字幕成果
                        var disportItem = getDisportById(disportId);
                        wordsOnScreen = createNewConf(disportItem.content);
                        scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
                        $ionicScrollDelegate.$getByHandle('mainScrnWordsScroll').scrollTop();
                    }
                    $scope.$on('videoEnd', function () {
                        //修改预览状态。
                        if (typeof nowPlayItem != 'undefined') {
                            nowPlayItem.isPlay = false;
                        }
                    })
                    $scope.$on("$destroy", function () {
                        //通知需要停止播放
                        $scope.$broadcast('stopPlay');
                    });

                    __init();
                }

            });
    });