/**
 * @description 三边功能页面
 * @author SuperK
 * @date 2015/04/07
 */
rootModule
    .controller('ChatCtrl', function(ENV, $log, $scope,
        $http, $compile, $templateCache, $timeout, $interval,
        $rootScope, $stateParams, TV, User, Live, Side, ThumbImage,
        $ionicScrollDelegate, $ionicLoading, $ionicModal, $ionicPopup,
        Toast,
        $window, Storage, $state, DotInfo, barCodeScannerUtil, MediaSvc, UUID, dateTime, $ionicPlatform, orderDotsBy) {
        /*********整个函数的开始********/
        var chatContent = document.querySelector('#chat-content'),
            labelList = document.querySelector('#label-list'),
            thumbContainer = document.querySelector('#thumb-scroll'),
            thumbScroll = $ionicScrollDelegate.$getByHandle('thumb-image-scroll'),
            SideConstans = {
                video: 0,
                commentRise: 1,
                vote: 2,
                topic: 3,
                repy: 4,
                channel: 5
            },
            bigThumbContainer = document.querySelector('#big-thumb'),
            watchType = $stateParams.type == 'live' ? 1 : 2, //观看类型及ID，直播为1，点播为2
            commonId = $stateParams.id,
            time = 0, //当前视频进度
            imagesCache = [], //本地缓存，存放图片
            deviceId = watchType == 1 ? -1 : $stateParams.id, //终端ID
            channelId = -1, //频道ID
            videoId = -1, //视频ID
            localDots = [],
            hasDialog = false,
            pullStatusRespones = true,
            oldPlayTime = 0,
            globalCommentData = [],
            shownDotId = -1,
            globalThumbPath = '';

        /****主要用来自定义，是否显示快照和Header****/
        $scope.hasHeader = $stateParams.hasHeader;
        $scope.hasThumb = $stateParams.hasThumb;
        /****主要用来自定义，是否显示快照和Header****/


        $scope.handShow;
        var shouldToInitDots = [];
        $scope.dots = [];
        $scope.dot = {
            dotId: '001',
            inputMode: 0
        }
        var hasShowThumbList = [];
        var hasThumbImagePath = false;
        $scope.isShow = true;

        //切换影片的时候清空所有数据
        function resetUpData() {
            //重置数据，
            console.log('加载影片清空数据。。')
            $scope.thumbImgs = [];
            shouldToInitDots = [];
            hasShowThumbList = []; //清空快照的保存列表，防止更新影片的时候，不显示快照
            $scope.dots = [];
            globalCommentData = []; //存储的评论库
            shownDotId = -1;
            $scope.time = 0;
            time = 0;
            isPlay = false;
            time = 0;
            $scope.inputToolVisible = false;
            $scope.newPointNum = 0;
            if (!$scope.$$phase) {
                $scope.$apply();
            }
            mainScrollResize(); //重新计算输入框
            mainScrollTop();
            //清空数据应放在之前
        }

        function hasShowThumb(time) {
            hasShow = false;
            if (hasShowThumbList.length > 0) {
                angular.forEach(hasShowThumbList, function(item) {
                    if (item == time) {
                        hasShow = true;
                        return false;
                    }
                })
            }
            return hasShow;
        }
        //存放数据
        $scope.comments = [];
        $scope.thumbImgs = [];
        $scope.commentText = {
            text: '',
            type: 0, //0:评论，1:回复
            commentId: -1, //回复用ID,
            placeholder: '戳我添加评论'
        }; //存放视频或频道评论列表
        $scope.inputToolVisible = false; //是否显示输入框
        $scope.sbText = {
            text: ''
        }

        $scope.videoInfo = {}; //存储节目、视频相关信息
        var isPlay = false; //是否在播放
        var index = 0;
        var globalTimer;

        //排重方法
        function joinWithUUIDFilter(toJoin, fromJoin) {
            var nowList = [];
            //判断DotInfo里面是否有对应主题
            angular.forEach(fromJoin, function(dot) {
                var nowhasDump = false;
                angular.forEach($scope.dots, function(item) {
                    if (item.uuid == dot.uuid) {
                        nowhasDump = true;
                        return false;
                    }
                })
                if (!nowhasDump) {
                    var waithasDump = false;
                    angular.forEach(toJoin, function(item) {
                        if (item.uuid == dot.uuid) {
                            waithasDump = true;
                            return false;
                        }
                    })
                    if (!nowhasDump && !waithasDump) {
                        toJoin.push(dot);
                    }
                }

            })
            return toJoin;
        }

        function Log(name, desc) {
            try {
                //
                //window.localStorage.setItem("log-"+new Date().getTime(), name+","+window.JSON.stringify(desc));
                //console.log(name, desc);
            } catch (e) {
                console.log(e);
            }
        }



        //这里来记录日志
        function startTimmer() {

            //定时器，定时显示节目或视频快照，如果为频道则不动态加载，直接显示一个频道图片
            globalTimer = $interval(function() {
                //进入timer了
                Log('开始Timer', {
                    index: index
                });
                if (index % 5 == 0) { //隔5s获取一次设备状态
                    Log('开始获取设备状态', {
                        index: index
                    })
                    getDeviceStatus(function(data) {
                        Log('获取设备状态成功', data);
                    }, true)
                }
                shoudLoadDotInfo();
                $scope.time = time;
                //测试数据
                //测试数据
                //显示打点信息
                var dot = DotInfo.getShownDotsByTime(time, videoId);
                if (dot && dot.length > 0) {
                    //到点开始推送
                    if (shownDotId == -1) {
                        //置顶
                        // dot = orderDotsBy.orderdotBySomething($scope.dots)
                        Log('加载需要显示的主题列表', dot);
                        initDot(dot);
                    } else {
                        Log('主题有展开的项，加入等待列表', dot);

                        //这里需要排重，现在的方式为每次都将所有的需要显示的都取出来了的，
                        shouldToInitDots = joinWithUUIDFilter(shouldToInitDots, dot);
                        $scope.newPointNum = shouldToInitDots.length;
                    }

                }
                //显示评论信息
                var comts = getShownCommentsByTime(time);
                if (comts && comts.length > 0) {
                    $timeout(function() {
                        Log('加载需要显示的评论信息', comts);
                        initNeedShowComments(comts);
                    })
                }
                time++;
                if (hasThumbImagePath && time % 10 == 0 && isPlay && !hasShowThumb(time)) {
                    Log('加载节目快照', time);
                    //判断是否有节目快照丢失
                    //这里判断如果当前显示的点的时间和上一次相差大于15秒，则认为有一张快照丢失了，应补齐
                    if (hasShowThumbList.length > 0) {
                        var tAbs = Math.abs(time - hasShowThumbList[hasShowThumbList.length - 1]);
                        if (tAbs > 15 && tAbs < 20) {
                            //丢了一张
                            Log('丢失节目快照，自动补齐', time);
                            addThumbImage(time - 10);
                            hasShowThumbList.push(time - 10);
                        }
                    }
                    hasShowThumbList.push(time);
                    addThumbImage(time);
                }
                Log('结束Timer', {
                    index: index
                });
                index++;
            }, 1000);

        }

        function addThumbImage(time) {
            var thumb = {
                thumbImg: globalThumbPath + '' + time + '.jpg',
                time: time
            }; //ThumbImage.getThumb(time);
            if (typeof thumb == 'undefined') {

            }
            if (thumb && typeof thumb != 'undefined') {
                //判断数组中是否有这个数
                function in_array(search, arr) {
                    for (var i = 0; i < arr.length; i++) {
                        if (arr[i] == search) {
                            return true;
                        }
                    }
                    return false;
                }
                var hasFlag = in_array(thumb, $scope.thumbImgs)
                if ($scope.thumbImgs.length > 0 && hasFlag) {

                } else {
                    $scope.thumbImgs.push(thumb);
                    var imgLength = $scope.thumbImgs.length;
                    if (thumbContainer && thumbContainer != null) {
                        thumbContainer.style.width = 90 * imgLength + 'px';
                        thumbScroll.scrollTo(90 * imgLength, 0, true);
                    }
                }

            }
        }
        /*******页面效果及DOM操作*******/
        var ChatEvent = {
                /**
                 * 话题聊天窗口滚动到最下端
                 * @param  {[type]} dotId [description]
                 * @return {[type]}       [description]
                 */
                scrollBottom: function(uuid) {
                    if (shownDotId && shownDotId == uuid) {
                        var scroll = $ionicScrollDelegate
                            .$getByHandle('chat-scroll-' + uuid);
                        scroll.resize();
                        scroll.scrollBottom(true);
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        // $timeout(function() {
                        //     scroll.resize();
                        //     scroll.scrollBottom(true);
                        // }, 1000)
                    }
                }
            }
            /**
             * 负责显示和隐藏卡片，点击标题显示隐藏
             * @param  {[type]} cardId 卡片ID
             * @param  {[type]} shown  是否显示
             * @return {[type]}        [description]
             */

        function _toggleLabel(uuid, shown) {
            var dot = DotInfo.getDotByUUID(uuid);
            //判断当前元素是否被显示过了
            dot.userStatus = 1; //用户操作状态

            //当前显示的卡片ID
            var cardId = dot.uuid;
            dot.visible = shown ? shown : !dot.visible;
            shownDotId = dot.visible ? dot.uuid : -1;
            //这里来加载评论数据,仅开启的时候加
            if (dot.visible && !dot.hasInitCommentData) {
                initAllCommentData(dot)
            }
            if (!dot.visible) { //关闭的时候，
                if (shouldToInitDots.length > 0) {
                    initDot(shouldToInitDots);
                    //判断一下把最后一个商品展开
                    if (shouldToInitDots && shouldToInitDots.length > 0) {
                        var needOpenCardId = -1;
                        for (var i = 0; i < shouldToInitDots.length; i++) {
                            var item = shouldToInitDots[shouldToInitDots.length - 1 - i];
                            if (item.type == 3) {
                                needOpenCardId = item.uuid;
                                break;
                            }
                        }
                    }
                    shouldToInitDots = [];
                    $scope.newPointNum = 0;
                    if (needOpenCardId != -1) {
                        $timeout(function() {
                            _toggleLabel(needOpenCardId, true);
                        }, 10)
                    }

                }
            }
            // //将所有的item关闭
            angular.forEach($scope.dots, function(item) {
                if (!dot.visible) { //如果为关闭当前Item 则将其他所有Item 设置为item-nomal 状态
                    item.status = 'item-nomal'
                } else if (item.uuid != cardId && item.type == 6) { //简介默认不关闭
                    item.visible = false;
                    item.status = 'item-hide';
                }
            })
            dot.status = dot.visible ? 'item-show' : 'item-nomal';
            var element = document.querySelector('#card-' + uuid);
            var itemTitle = element.querySelector('.label-title');
            //计算当前屏幕的高度
            var wHeight = $window.innerHeight;
            var scroll = document.querySelector('ion-scroll[delegate-handle="chat-scroll-' + uuid + '"]');
            var labelBody = angular.element(element.querySelector('.label-body'));
            if (dot.visible) { //手动修改样式,防止Angular监听不及时，出现的滚动条无法计算高度的Bug
                labelBody.addClass('show');
            } else {
                labelBody.addClass('hide');
            }
            /**
             * 这里需要计算有滚动框的内容的高度，
             * 因为在同一个手机屏幕内，每一个主题的滚动框，每次显示的高度应该是一样高的，所以这里做一个判定
             * 如果在Dot对象里面发现有一个参数则不需要计算，没有则计算一个高度出来
             ******/
            if (scroll && scroll != null && dot.visible) {
                var contentEle = document.querySelector('#chat-content');
                var ionicContentHeight = contentEle.offsetHeight;
                console.log(ionicContentHeight);
                if (ionicContentHeight <= 0) {
                    ionicContentHeight = contentEle.height;
                }
                var inputHeight = 42;
                var labelTitleHeight = itemTitle.offsetHeight;
                var descHeight = 0;
                //判断是否有详情介绍
                var desc = element.querySelector('.label-desc');
                if (desc != null) {
                    descHeight = desc.offsetHeight + 1;
                }
                //判断是否为第一个Item,如果为第一个Item 则不需要*2
                /*if (dot.uuid == getLastShownDot().uuid) {
                    labelTitleHeight;
                } else {
                    labelTitleHeight = labelTitleHeight * 2 - 15;
                }
                */
                var sheight = ionicContentHeight - labelTitleHeight - descHeight - inputHeight;

                if (dot.type == -1) {
                    sheight += 6;
                }
                //判断为商品不需要减去输入框的高度
                if (dot.type == 3 || dot.type == 2 || dot.type == 5 || dot.type == 6) {
                    sheight += inputHeight + 6;
                }
                dot.scrollHeight = sheight; //当前Scroll的高度
                dot.descHeight = descHeight;
                angular.element(scroll).css({
                    height: dot.scrollHeight + 'px'
                });
                /*
                 * 商品不需要滚动到底部
                 */
                if (dot.type != 3 && dot.type != 5 && dot.type != 2 && dot.type != 6) {
                    ChatEvent.scrollBottom(uuid);
                }
            }
            var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
            if (dot.visible) { //如果当前是显示元素不是收起元素的话，需要计算当前显示的位置
                //当前元素的位置
                var elementTop = element.offsetTop - 1;
                mainScroll.scrollTo(0, elementTop, true);
            } else {
                mainScrollResize(); //重新计算整个容器的大小
                mainScroll.scrollTop(true);
            }
            /**
             * 投票、竞猜、商品不显示输入框
             * @type {[type]}
             */
            $scope.inputToolVisible = (dot.type != 3 && dot.type != 5 && dot.type != 2 && dot.type != 6) ? dot.visible : false;
            // if (!$scope.$$phase) {
            //                 $scope.$apply();
            //             }
            console.log("是否显示" + dot.visible);
        }
        var getLastShownDot = function() {
            var dot = null;
            if ($scope.dots && $scope.dots.length > 0) {
                dot = $scope.dots[$scope.dots.length - 1];
            }
            return dot;
        }

        function mainScrollResize() {
            var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
            mainScroll.resize();
            $ionicScrollDelegate.resize();
        }

        function mainScrollTop() {
            var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
            mainScroll.scrollTop(true);
        }

        var keyboarShowTime, keyboarHideTime, messageSendTime = 0;
        //显示键盘事件
        window.addEventListener('native.keyboardshow', keyboardShowHandler);

        function getCurrentTime() {
            return new Date().getTime().valueOf();
        }

        function keyboardShowHandler(e) {
            console.log('keyboardshow')
            var cla = getCurrentTime() - messageSendTime;
            var keyboardHeight = e.keyboardHeight; //键盘高度
            if (cla > 300) {
                if (typeof device != 'undefined' && device.platform == 'iOS') {
                    //修复IOS平台使用键盘后，scroll位置不对的问题
                    document.querySelector('#fix-ios-keyboard-ele').style.height = keyboardHeight + 'px';
                    //判断如果为IOS平台，则需要手动将输入框设置到键盘高度
                    document.querySelector('.input-tools').style.bottom = keyboardHeight + 'px';
                }
                var dot = DotInfo.getDotByUUID(shownDotId);
                //这里存储一个当前滚动的高度
                if (typeof dot.keyboardShownScrollTop == 'undefined' || dot.keyboardShownScrollTop == null) {
                    //这里将标题栏，简介条向上滚动
                    var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
                    var scrollTop = mainScroll.getScrollPosition().top;

                    //当前滚动框的高度
                    var scroll = document.querySelector('ion-scroll[delegate-handle="chat-scroll-' + shownDotId + '"]');
                    var titleheight = 55; //标题栏高度
                    var scrollHeight = dot.scrollHeight - keyboardHeight + dot.descHeight + titleheight; //原本滚动框高度－键盘高度＋描述的高度+标题
                    if (typeof device != 'undefined' && device.platform == 'Android') { //修复Android打开键盘底下出现的空白
                        scrollHeight += 24;
                    }
                    dot.keyboardShowScrollHeight = scrollHeight;
                    dot.keyboardShownScrollTop = scrollTop + dot.descHeight + titleheight;
                }
                angular.element(scroll).css({
                    height: dot.keyboardShowScrollHeight + 'px'
                });
                mainScroll.scrollTo(0, dot.keyboardShownScrollTop, false);
                ChatEvent.scrollBottom(shownDotId);
            }
        }
        //隐藏键盘事件
        window.addEventListener('native.keyboardhide', keyboardHideHandler);

        function keyboardHideHandler(e) {
            var cla = getCurrentTime() - messageSendTime;
            if (cla > 300) {
                console.log('keyboardhide')
                //判断如果为IOS平台，则需要手动将输入框设置到0
                if (typeof device != 'undefined' && device.platform == 'iOS') {
                    document.querySelector('.input-tools').style.bottom = '0px';
                    document.querySelector('#fix-ios-keyboard-ele').style.height = '0px';
                }
                var dot = DotInfo.getDotByUUID(shownDotId);
                dot.keyboardShowScrollHeight = null;
                dot.keyboardShownScrollTop = null;
                _toggleLabel(shownDotId, true);
            }
        }
        /**
         * 重构方法
         * @param  {[type]} cardId [description]
         * @return {[type]}        [description]
         */
        function toggleLabel(cardId) {
            _toggleLabel(cardId, false);
        }

        $scope.toggleLabel = toggleLabel;
        $scope.toggleLabelHandler = toggleLabel;
        $scope.newDotClickEvent = function() {
            _toggleLabel(shownDotId, false);
        }

        /****************用户界面相关位置计算开始****************/
        $scope.contentOnScroll = function(scrollTop) {
            var quick = document.querySelector('#quick-warpper');
            if (quick && quick != null) {
                quick.style['-webkit-transform'] = "translateY(" + (scrollTop) + "px)";
                quick.style['transform'] = "translateY(" + (scrollTop) + "px)";
            }
            return false;
        }

        function initUserIntrface() {
            /**
             * 监控全局滚动，将快捷键设置为固定位置
             * @param  {[type]} ){                         $ionicScrollDelegate.getScrollView().onScroll [description]
             * @param  {[type]} 500 [description]
             * @return {[type]}     [description]
             */
            var quick = document.querySelector('#quick-warpper');
            if (quick && quick != null) {
                quick.style.top = GlobalParam.contentHeight - 140 + 'px';
            }
        }
        /**
         * 存储当前设备对应的一些变量值，如Header 高度，Content高度
         *
         */
        var GlobalParam = {
            contentHeight: chatContent.offsetHeight, //主题框的总高度
            inputHeight: 42, //输入栏的高度
            labelTitleHeight: 50, //主题标签高度,
            currentScrollHeight: 0 //
        }

        $scope.moreFun = function() {
            $ionicPopup.alert({
                title: '更多功能，敬请期待...'
            })
        }
        /**
         * 快捷键处理事件
         * @return {[type]} [description]
         */
        function quickEvent(uuid) {
            //这里需要判断，如果当前有展开的项目，需要先收起再展开
            if (uuid != shownDotId) {
                if (shownDotId != -1) {
                    _toggleLabel(shownDotId, false);
                }
                $timeout(function() {
                    console.log("打开ID" + uuid);
                    _toggleLabel(uuid, true);
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                }, 10)
            }

            event.stopPropagation();
            return false;
        }
        $scope.quickEvent = quickEvent;

        /**
         * 增加功能，按住快捷键可自由定制按钮的位置
         */
        var Quick = {
            element: '',
            pos: {
                left: 3,
                top: 485
            },
            init: function() {
                this.element = angular.element(document.querySelector('#quick-warpper'));
                var pos = null; //Storage.get('quickPos');
                if (typeof pos != 'undefined' && pos != null) {
                    this.setPos(pos.left, pos.top);
                } else {
                    this.setPos(this.pos.left, this.pos.top);
                }
            },
            setPos: function(left, top) {
                //这里需要做一些对应的校正，如果拖拽的位置超过了指定的区域，需要将位置调整到可见的区域
                if (top < 0) {
                    top = 0;
                }
                if (left < 0) {
                    left = 0;
                }
                if (left > $window.innerWidth - 42) {
                    left = $window.innerWidth - 42;
                }
                if (top > $window.innerHeight - 202) {
                    top = $window.innerHeight - 202;
                }
                Quick.pos = {
                    left: left,
                    top: top
                }
                Storage.set('quickPos', Quick.pos);
                Quick.element.css({
                    left: Quick.pos.left + 'px',
                    top: Quick.pos.top + 'px'
                })
            },
            move: function() {
                if (event.targetTouches.length == 1) {
                    var touch = event.targetTouches[0];
                    // 把元素放在手指所在的位置
                    Quick.setPos(touch.pageX - 24, touch.pageY - 108);
                }
                event.stopPropagation();
            }
        }
        $scope.quickMove = Quick.move;





        /**
         * 检测全局滚动事件
         */
        function onContentScroll() {

            console.log(view);
        }
        /**
         * 显示话题详细信息
         * @param  {[type]} dotId [description]
         * @return {[type]}       [description]
         */
        var descEvent = function(dotId) {
            var dot = getShowDotByid(dotId);
            $scope.tempInfo = dot;
            $ionicModal.fromTemplateUrl('templates/subject/knowlege-details.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
                modal.show();
            });
        }
        $scope.descEvent = descEvent;
        $scope.descEventHandler = descEvent;
        /**
         * 点赞事件
         * @param  {[type]} cid 评论ID
         * @param  {[type]} type 对谁发表的内容，即谁的评论（0：视频；1：评论点赞；2：投票；3：话题；4：评论(回复)；5：频道
         * @return {[type]}     [description]
         */
        var likeEvent = function(cid, type) {
            //通过CID获取评论信息
            var comment = getLocalCommentByCid(cid);
            if (comment) {
                comment.isLike = true;
            }
            Side.add_theme_talk(SideConstans.commentRise, cid, watchType == 1 ? channelId : videoId, -1, -2, deviceId).$promise.then(function(result) {
                var msg = "";
                if (result.success) {
                    msg = "点赞成功";
                } else {
                    msg = '点赞失败 ' + result.msg
                }
                $ionicLoading.show({
                    template: msg,
                    duration: 1000,
                    noBackdrop: true
                })
            })
        }
        $scope.likeEvent = likeEvent;
        /******************发表评论事件***************/
        /**
         * 评论或回复
         * @param  {[type]} doType 评论还是回复  0评论，1回复
         * @return {[type]}        [description]
         */
        var sendCommentEvent = function() {
            var value = $scope.commentText.text,
                doType = $scope.commentText.type;
            if (value && "" != value) {
                var sendType = -1;
                var commentId = -1;
                var rootId = watchType == 1 ? channelId : videoId;
                var themeType = watchType == 1 ? -2 : -1;
                switch (doType) {
                    case 0:
                        sendType = watchType == 1 ? SideConstans.channel : SideConstans.video;
                        commentId = watchType == 1 ? channelId : videoId;
                        break;
                    case 1:
                        sendType = 4;
                        commentId = $scope.commentText.commentId;
                        break;
                }
                sendEvent(sendType, commentId, rootId, themeType, value, function(result) {
                    var msg = "";
                    if (result.success) {
                        $scope.commentText = {
                            text: Debug.getRandomMsg(),
                            placeholder: '戳我添加评论',
                            type: 0,
                            commentId: -1
                        };
                        document.querySelector('#commentText').value = "";
                        document.querySelector('#commentText').value = Debug.getRandomMsg();
                    } else {
                        $ionicLoading.show({
                            template: '发表失败 ' + result.msg,
                            duration: 1000,
                            noBackdrop: true
                        })
                    }

                });
            }
        }
        $scope.sendCommentEvent = sendCommentEvent;

        /********投票事件******/
        /**
         * 投票
         * @param  {[type]} dotId 投票ID
         * @param  {[type]} vcId  投票选项ID
         * @return {[type]}       [description]
         */

        function voteEvent(uuid, vcId) {
            var dot = getShowDotByUUID(uuid);
            var choice = [];
            var canVote = false;
            for (var i = 0; i < dot.choice.length; i++) {
                //第一步判断是否可以投票或竞猜
                var choice = dot.choice[i];
                if (choice.vcId == vcId && (choice.status == 1 || choice.status == 2)) {
                    $ionicLoading.show({
                        template: '您已投过，不可再投！',
                        duration: 1000,
                        noBackdrop: true
                    })
                    canVote = false;
                    break;
                } else {
                    canVote = true;
                }
            }
            if (canVote) { //可以投票
                if (dot.choiceType == 1) { //单选的处理方式
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (dot.choice[i].vcId == vcId) {
                            dot.choice[i].status = 1;
                        } else {
                            dot.choice[i].status = 2;
                        }
                    }

                } else if (dot.choiceType == 2) { //多选的处理方式
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (dot.choice[i].vcId == vcId) {
                            dot.choice[i].status = 1;
                        }
                    }
                }
                sendCommentData(dot.dotId, {
                    content: vcId,
                    inputMode: 0
                });
                //公布答案：
                //这里查找出竞猜的正确答案
                if (dot.type == 5) //竞猜
                {
                    //循环选项，找出正确答案
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (dot.choice[i].isTrue == 1) {
                            dot.trueAnswer = dot.choice[i].content;
                            break;
                        }
                    }
                }
            }
        }
        $scope.voteEvent = voteEvent;
        $scope.voteEventHandler = voteEvent;


        /******************发送消息、点赞、评论、投票事件*********************/
        /**
         * 发送消息接口
         * @param  {[type]} type      对谁发表的内容，即谁的评论（0：视频；1：评论点赞；2：投票；3：话题；4：评论(回复)；5：频道
         * @param  {[type]} comentId  被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
         * @param  {[type]} rootId    评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
         * @param  {[type]} themeType 哪种主题,主题类型（1:话题2：投票3：商机-1：视频 -2：频道 ）
         * @param  {[type]} content   发送的内容
         * @return {[type]}           callback(result)
         */
        function sendEvent(type, comentId, rootId, themeType, content, callback) {
            var sendType = watchType == 1 ? SideConstans.channel : SideConstans.video;
            Side.add_theme_talk(type, comentId, rootId, themeType, content, deviceId)
                .$promise.then(function(result) {
                    callback && callback(result);
                }, function(error) {
                    callback && callback({
                        success: false
                    })
                });
        }

        function sendCommentData(dotId, data) {
            //发送消息的时候记录一个时间用于处理IOS键盘失去焦点，出现的位置计算错误问题。
            messageSendTime = getCurrentTime();
            var content = data.content;
            var inputMode = data.mode;
            if (inputMode == 1) { //语音输入
                content = '{"voice":"' + content + '"}';
            }
            var dot = getShowDotByid(dotId);

            var sendType = 3; //话题
            var themeType = 1;
            var commentId = dotId;
            var rootId = dotId;

            if (dot && dot.type == -1) { //为评论信息(1.直播，2.点播)
                sendType = watchType == 1 ? 5 : 0;
                themeType = watchType == 1 ? -2 : -1;
            }
            if (dot && dot.type == 2) {
                sendType = 2;
                themeType = 2;
            }
            if (dot && dot.type == 5) {
                sendType = 6;
                themeType = 5;
            }
            if (dot && dot.type == 4) { //知识点
                themeType = 4;
                sendType = 7;
            }
            //这里直接把自己发送的内容显示出来
            var user = User.getCurrentUser();
            addCommentData({
                "cid": UUID.newuuid(),
                "userId": user.userId,
                "nickname": user.nickname,
                "headImg": user.headImg,
                "rootId": dotId,
                "themeType": themeType,
                "content": content,
                "type": sendType,
                "commentTime": dateTime.getDateTime(),
                "targetId": rootId,
                "playTime": $scope.time
            }, false)
            sendEvent(sendType, commentId, rootId, themeType, content, function(result) {
                var msg = "";
                if (result.success) {

                } else {

                }

            })
        }

        /**
         * 界面系统初始化
         * @return {[type]} [description]
         */
        function init() {
            console.info('开始初始化框架')
            resetData();
            Side.resetData(); //重置数据
            if (watchType == 2) { //当前为点播状态
                setOffset();
                startTimmer();
            } else {
                getDotInfo();
            }
            initUserIntrface();
            Quick.init();
            getWatchInfo();
            bindBackButton();
        }
        /**
         * 重置所有数据
         * @return {[type]} [description]
         */
        $rootScope.$on('reset_side_data', function() {
            $scope.dots = [];
            globalCommentData = [];
        })

        function resetData() {
            $rootScope.$broadcast('reset_side_data');
        }

        /**
         * @author SuperK
         * @param themeType - 主题类型
         * @param rootId  - 主题ID
         * @param type - 类型
         */
        function initAllCommentData(dot) {
            var rootId = dot.dotId;
            var type = 1; //
            if (dot && dot.type == -1) { //为评论信息(1.直播，2.点播)
                rootId = videoId;
                type = watchType == 1 ? -2 : -1;
            }
            if (dot.type == 2) {
                type = 2;
            }
            if (dot.type == 5) {
                type = 5;
            }
            if (dot.type == 4) {
                type = 4;
            }
            var themeType = dot.type;
            //使用新版拉取话题聊天信息，与评论一样
            //这里不加载数据，
            Side.getAllHistoryComments(rootId, themeType, function(result) {
                if (result.success) {
                    if (result.data && result.data.length > 0) {
                        //批量查询
                        var ids = [];
                        angular.forEach(result.data, function(item, index) {
                            if (parseInt(item.playTime) < time || themeType == 2 || themeType == 5) {
                                ids.push(item.cid);
                            } else {
                                globalCommentData.push(angular.extend({
                                    hasShow: false
                                }, item));
                            }
                        })
                        getCommentById(ids.join(','));
                    }
                }
                dot.hasInitCommentData = true;
            });
        }

        function shoudLoadDotInfo() {
            //这里读取rootScope里面是否有主题列表信息，如果没有，则拉取，如果有，则不拉取
            var dotInfoList = $rootScope.dotInfoList;
            if (videoId != -1 && (typeof dotInfoList == 'undefined' || dotInfoList == null || dotInfoList.videoId != videoId || $rootScope.hasChangePage)) {
                //这里需要拉取评论
                getDotInfo();
                $rootScope.hasChangePage = false;
            }
        }

        /**
         * 初始化显示打点信息
         * @param  {[type]} dot 打点信息,数组
         * @return {[type]}     [description]
         */
        function initDot(dots) {
            /**
             * 这里做一次排重
             */
            angular.forEach(dots, function(dot) {
                var hasDump = false;
                angular.forEach($scope.dots, function(item) {
                    if (item.uuid == dot.uuid) {
                        hasDump = true;
                        return false;
                    }
                })
                if (!hasDump) {
                    dot.msgs = [];
                    dot.inputMode = 0;
                    //这里存储一个标志，是否加载主题评论信息
                    dot.hasInitCommentData = false;
                    $scope.dots.push(dot);
                    //设置置顶
                    $scope.dots = orderDotsBy.orderdotBySomething($scope.dots);
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                }
            })


        }
        var shouldExsist = false;
        /**
         * 获取当前节目或视频的相关信息、获取推送消息的相关接口
         * @return {[type]} [description]
         */
        function getWatchInfo() {
            Log('建立长连接');
            Side.longPoll(commonId, watchType).$promise.then(function(result) {
                if (result.status == 200 || typeof result.status == 'undefined') {
                    Log('长连接返回数据', result);
                    if (result.data && result.data.length > 0) {
                        angular.forEach(result.data, function(item) {
                            addCommentData(JSON.parse(item), true);
                        })
                    }
                    if (!shouldExsist) {
                        getWatchInfo();
                    }
                } else {
                    $timeout(function() {
                        getWatchInfo();
                    }, 5000)
                }

            }, function() {
                if (!shouldExsist) {
                    getWatchInfo();
                }
            })
        }

        /**
         * 设置位置以及大小
         */
        function setOffset() {
            var scroll = document.querySelector("#img-scroll");
            if (scroll && scroll != null) {
                scroll.style.width = window.innerWidth + 'px';
                window.onresize = function() {
                    scroll.style.width = window.innerWidth + 'px';
                }
            }

        }



        /**
         * 通过视频评论ID获取评论信息
         * @param  {[type]} commentId [description]
         * @return {[type]}           [description]
         */
        function getCommentById(commentId, isNew) {
            Side.getCommentById(commentId).$promise.then(function(result) {
                if (result.success && result.data && typeof result.data != 'undefined') {
                    angular.forEach(result.data, function(item) {
                        item.playTime = parseInt(item.playTime);
                        addCommentData(item, isNew);
                    })

                } else {

                }
            })
        }
        /***语音的重复播放**/
        var currentPlayComment;
        /**
         * 语音播放功能
         * @param  {[type]} dotId     主题ID
         * @param  {[type]} commentId 评论ID、聊天信息ID
         * @return {[type]}           [description]
         */
        function playAudio(dotId, commentId) {
            if (currentPlayComment) {
                currentPlayComment.playing = false;
            }
            //判断URL是否存在
            var comment = getCommentByDotAndId(dotId, commentId);
            if (comment && comment.voice) {
                var url = comment.voice;
                if (url && url.indexOf('mp3') > -1) {
                    comment.playing = true; //修改当前状态
                    MediaSvc.play(url, function() {
                        comment.playing = false;
                    }, function(err) {
                        comment.playing = false;
                    })
                }
            }
            currentPlayComment = comment;

        }
        window.playAudio = playAudio;
        $scope.playAudio = playAudio;

        /**
         * 添加数据到页面中
         * @param {[type]} data [description]
         * @param {[type]} isNew 是否为新消息,
         */
        function addCommentData(data, isNew) {
            //解析数据
            if (data.playTime && data.playTime == 'null') {
                data.playTime = 0;
            }
            var user = User.getCurrentUser();
            if (user.userId == data.userId) {
                data.me = true;
            } else {
                data.me = false;
            }
            data.playTime = parseInt(data.playTime);
            //识别语音消息
            if ((typeof(data.content)) == 'string') {
                if (data.content.indexOf("voice") > -1) {
                    //播放语音
                    var url = JSON.parse(data.content).voice;
                    data.voice = url;
                    data.playing = false;
                }
            }

            if (user.userId == data.userId && isNew == true) { //当收到的为即时消息并且消息是自己的时，更新数据
                return;
            }
            var dot = getShowDotByIdAndType(data.rootId, data.themeType);
            if (dot != null && typeof dot != 'undefined') {
                switch (parseInt(data.type)) {
                    case 0: //视频；
                        if (filterCommentDump(dot.msgs, data)) {
                            dot.msgs.push(angular.extend({}, data));
                        }
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        ChatEvent.scrollBottom(dot.uuid);
                        break;
                    case 1: //评论点赞；
                        //获取到Root

                        break;
                    case 2: //投票；
                        if (filterCommentDump(dot.msgs, data)) {
                            for (var i = 0; i < dot.choice.length; i++) {
                                if (data.content == dot.choice[i].vcId) { //当前选中的项
                                    dot.choice[i].count++;

                                    if (user.userId == data.userId) {
                                        if (dot.choiceType == 1) { //单选类型
                                            dot.choice[i].status = 1;
                                            for (var j = 0; j < dot.choice.length; j++) {
                                                if (i != j) {
                                                    dot.choice[j].status = 2;
                                                }
                                            }
                                        } else if (dot.choiceType == 2) { //多选类型
                                            dot.choice[i].status = 1;
                                        }
                                    }
                                }

                            }
                            if (!$scope.$$phase) {
                                $scope.$apply();
                            }
                        }

                        break;

                    case 3: //话题；
                        if (filterCommentDump(dot.msgs, data)) {
                            dot.msgs.push(angular.extend({}, data));
                        }
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        ChatEvent.scrollBottom(dot.uuid);
                        break;
                    case 4: //评论(回复)；
                        if (data.themeType) {

                        }
                        break;
                    case 5: //频道
                        if (filterCommentDump(dot.msgs, data)) {
                            dot.msgs.push(angular.extend({}, data));
                        }
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        ChatEvent.scrollBottom(dot.uuid);
                        break;

                    case 6: //竞猜
                        if (filterCommentDump(dot.msgs, data)) {
                            for (var i = 0; i < dot.choice.length; i++) {
                                if (data.content == dot.choice[i].vcId) { //当前选中的项
                                    dot.choice[i].count++;
                                    if (user.userId == data.userId) {
                                        if (dot.choiceType == 1) { //单选类型
                                            dot.choice[i].status = 1;
                                            for (var j = 0; j < dot.choice.length; j++) {
                                                if (i != j) {
                                                    dot.choice[j].status = 2;
                                                }
                                            }
                                        } else if (dot.choiceType == 2) { //多选类型
                                            dot.choice[i].status = 1;
                                        }
                                    }
                                }

                            }
                            if (!$scope.$$phase) {
                                $scope.$apply();
                            }
                        }
                        break;
                    case 7: //知识点
                        if (filterCommentDump(dot.msgs, data)) {
                            dot.msgs.push(angular.extend({}, data));
                        }
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        ChatEvent.scrollBottom(dot.uuid);
                        break;
                }
            }
        }
        /**
         * 对评论数据排重
         * @param  {[type]} datas [description]
         * @param  {[type]} data  [description]
         * @return {[type]}       [description]
         */
        function filterCommentDump(datas, data) {
            var insertStatus = true;
            if (datas && data) {
                angular.forEach(datas, function(item) {
                    if (item.cid == data.cid) {
                        insertStatus = false;
                    }
                })
            }
            return insertStatus;
        }


        /**
         * 解析出评论中的点赞与评论
         * @param  {[type]} data [description]
         * @return {[type]}      [description]
         */
        function filterCommentData(data) {
            var user = User.getCurrentUser();
            var likeList = [],
                repyList = [];
            if (data && data.sunList) {
                angular.forEach(data.sunList, function(item) {
                    switch (parseInt(item.type)) {
                        case 0: //视频；
                            break;
                        case 1: //评论点赞；
                            //判断是否点赞
                            if (user && item.userId == user.userId) {
                                data.isLike = true;
                            }
                            likeList.push(item);
                            break;
                        case 2: //投票；

                            break;
                        case 3: //话题；

                            break;
                        case 4: //评论(回复)；
                            repyList.push(item);
                            if (user && item.userId == user.userId) {
                                data.isRepy = true;
                            }
                            break;
                        case 5: //频道

                            break;
                    }
                })
            }
            data.likeList = likeList;
            data.repyList = repyList;
        }

        /**
         * 获取需要显示的评论信息
         * @param  {[type]} currentTime [description]
         * @return {[type]}             [description]
         */
        function getShownCommentsByTime(currentTime) {
            var tempComments = [];
            if (globalCommentData && globalCommentData.length > 0) {
                if (globalCommentData && globalCommentData.length > 0) {
                    angular.forEach(globalCommentData, function(item, index) {
                        //将之前未显示的内容直接显示
                        if (!item.hasShow && time > parseInt(item.playTime)) { //表示视频已经播放过了。
                            tempComments.push(item);
                            item.hasShow = true;
                        }
                    });
                }
            }
            return tempComments;
        }
        /**
         * 初始化需要显示的信息
         * @param  {[type]} comments [description]
         * @return {[type]}          [description]
         */
        function initNeedShowComments(comments) {
            if (comments && comments.length > 0) {
                var ids = [];
                angular.forEach(comments, function(item) {
                    ids.push(item.cid)
                })
                getCommentById(ids.join(','), true);
            }
        }


        /**
         * 本地获取评论信息
         * @return {[type]} [description]
         */
        function getLocalCommentByCid(cid) {
            var comment;
            if ($scope.comments && $scope.comments.length > 0) {
                angular.forEach($scope.comments, function(item) {
                    if (cid == item.cid) {
                        comment = item;
                        return false;
                    }
                })
            }
            return comment;
        }
        /**
         * 根据打点ID获取打点信息
         * @param  {[type]} dotId [description]
         * @return {[type]}       [description]
         */
        function getShowDotByid(dotId) {
            var dot;
            angular.forEach($scope.dots, function(item, index) {
                if (dotId == item.dotId) {
                    dot = item;
                    return false;
                }
            });
            return dot;
        }
        /**
         * 根据UUID查找当前显示的Point 信息
         * @param  {[type]} uuid [description]
         * @return {[type]}      [description]
         */
        function getShowDotByUUID(uuid) {
            var dot;
            angular.forEach($scope.dots, function(item, index) {
                if (uuid == item.uuid) {
                    dot = item;
                    return false;
                }
            });
            return dot;
        }


        /**
         * [getShowDotByIdAndType description]
         * @param  {[type]} dotId [description]
         * @param  {[type]} type  [description]
         * @return {[type]}       [description]
         */
        function getShowDotByIdAndType(dotId, type) {
            var dot;
            angular.forEach($scope.dots, function(item, index) {
                if (dotId == item.dotId && type == item.type) {
                    dot = item;
                    return false;
                }
            });
            return dot;
        }
        /**
         * 获取打点信息CommentID
         * @param  {[type]} dotId     [description]
         * @param  {[type]} commentId [description]
         * @return {[type]}           [description]
         */
        function getCommentByDotAndId(dotId, commentId) {
            var dot = getShowDotByid(dotId);
            var comment;
            if (dot && dot.msgs && dot.msgs.length > 0) {
                angular.forEach(dot.msgs, function(item, index) {
                    if (commentId == item.cid) {
                        comment = item;
                        return false;
                    }
                });
            }
            return comment;
        }
        var oldVideoId, needLoadPoint = true;
        var beforeLoadStatusTime = 0;
        /**
         * 获取设备当前状态信息
         * @param {[type]} [background] [是否显示正在加载]
         * @return {[type]} [description]
         */
        function getDeviceStatus(callback, background) {
            var loadStatusTime = new Date().getTime() - beforeLoadStatusTime;
            if (pullStatusRespones || loadStatusTime > 10000) { //是否上一次发送的请求返回了
                pullStatusRespones = false;
                if (watchType = 2) { //点播才具有设备状态信息
                    if (background && background == true) {} else {
                        $ionicLoading.show();
                    }
                    Side.getDeviceStatus(commonId).$promise.then(function(result) {
                        $ionicLoading.hide();
                        if (result.success) { //获取数据成功
                            if (typeof oldVideoId != 'undefined' && result.data.videoId != oldVideoId) {
                                needLoadPoint = true;
                            }
                            $scope.deviceStatus = result.data;
                            videoId = result.data.videoId;
                            oldVideoId = videoId;
                            $scope.videoInfo = result.data;
                            $scope.time = parseInt(result.data.relTime);
                            time = $scope.time;
                            oldPlayTime = time;
                            globalThumbPath = result.data.videoImgPath;
                            if (globalThumbPath != "") {
                                hasThumbImagePath = true;
                                $scope.hasThumbImagePath = true;
                            } else {
                                $scope.hasThumbImagePath = false;
                            }
                            //这里来判断是否需要加载打点信息
                            if (needLoadPoint) {
                                shoudLoadDotInfo();
                                needLoadPoint = false;
                            }
                            pullStatusRespones = true;
                            try {
                                var status = parseInt(result.data.status);
                                if (status == 1 || status == 2 || status == 3) { //暂停
                                    isPlay = false;
                                } else if (status == 0) {
                                    isPlay = true;
                                }
                            } catch (e) {
                                console.log(e);
                            }
                            callback && callback(result.data);
                        } else {
                            pullStatusRespones = true;
                            //获取失败后重新初始化
                            //statusError();
                        }
                    }, function(err) {
                        pullStatusRespones = true;
                    });
                }
            }
        }
        var statusError = function() {
            if (!hasDialog) {
                var alertPopup = $ionicPopup.alert({
                    title: '设备未开机？？',
                    template: '请尝试打开电视播放视频',
                    buttons: [{
                        text: '<b>重试</b>',
                        type: 'button-positive',
                        onTap: function(e) {

                        }
                    }, {
                        text: '取消',
                        onTap: function(e) {
                            $rootScope.$broadcast('reload_devices');
                            $state.go('tab.tv');
                        }
                    }]
                });
                hasDialog = true;
            }
        };
        $scope.statusErrorEvent = statusError;



        /**
         * 1.从后台获取打点信息列表
         * @return {[type]} [description]
         */
        function getDotInfo() {
            resetUpData();
            $ionicLoading.show();
            DotInfo.init($scope, watchType, watchType == 1 ? channelId : videoId, function() {
                resetUpData();
                getDeviceStatus();
                $ionicLoading.hide();
            });
        }


        //消息显示方法
        function showMsg(msg) {
            $ionicLoading.hide();
            $ionicLoading.show({
                template: msg,
                duration: 1000,
                noBackdrop: true
            });
        }
        $scope.$on('$destroy', function(event) {
            $rootScope.hasChangePage = true;
            $interval.cancel(globalTimer);
            shouldExsist = true;
            resetUpData();
        })
        //增加扫码功能
        $scope.openSysCamera = function() {
            barCodeScannerUtil.openSysCamera();
        }
        $scope.$on('side.msg', function(e, data) {
            //这里来发送消息
            sendCommentData(data.itemId, data);
        })
        $scope.$on('send.data', function(e, data) {
            sendCommentData(getShowDotByUUID(shownDotId).dotId, data);
        })

        function bindBackButton() {
            $ionicPlatform.onHardwareBackButton(function(event) {
                if ($state.current.name == 'side') {
                    if (shownDotId != -1) {
                        _toggleLabel(shownDotId);
                    } else {
                        $state.go('tab.tv');
                    }
                }
                event && (event.preventDefault() || event.stopPropagation())
            });
        }


        init();
    })
    .filter('watchTime', function($filter) {

        /**
         * 创建一个时分秒的字符
         * @return {[type]} [description]
         */
        function createTimeText(theTime) {
            var theTime1 = 0; // 分
            var theTime2 = 0; // 小时
            if (theTime > 60) {
                theTime1 = parseInt(theTime / 60);
                theTime = parseInt(theTime % 60);
                if (theTime1 > 60) {
                    theTime2 = parseInt(theTime1 / 60);
                    theTime1 = parseInt(theTime1 % 60);
                }
            }
            var result = "" + parseInt(theTime) + "秒";
            if (theTime1 > 0) {
                result = "" + parseInt(theTime1) + "分" + result;
            }
            if (theTime2 > 0) {
                result = "" + parseInt(theTime2) + "小时" + result;
            }
            return result;
        }
        return function(value) {
            var theTime = parseInt(value); // 秒
            if (theTime <= 0 || isNaN(theTime)) {
                return "0秒"
            }
            //这里需要来单独处理直播的点播的数据，直播和点播需要显示不同的格式
            if (typeof DataInterface != 'undefined') {
                //获取到当前观看的影片类型0：点播，1:直播，2：录播(回看)
                var programeType = parseInt(DataInterface.get('programtype'));
                switch (programeType) {
                    case 0: //点播，显示时分秒
                        return createTimeText(theTime);
                        break;
                    case 1: //直播,显示年月日
                        return $filter('date')(new Date(theTime * 1000), 'HH:mm:ss');
                        break;
                    case 2: //回看，减去开始时间，显示时分秒
                        var t=DataInterface.get('video_start_time');
                        //得到毫秒数
                        var calcMs = new Date(t.substring(0, 4), parseInt(t.substring(4, 6)) - 1, t.substring(6, 8), t.substring(8, 10), t.substring(10, 12), t.substring(12, 14)).getTime();
                        var time=parseInt(theTime-calcMs/1000);
                        return createTimeText(time);
                        break;
                }
            }else{
                return createTimeText(theTime);
            }

        }
    })
    .filter('br', function($filter) {
        return function(value) {
            return value.replace(ag, "");
        }
    })
    .filter('showTime', function($filter) {
        function dateFromString(str) {
            var a = str.split(/[^0-9]/);
            return new Date(a[0], a[1] - 1 || 0, a[2] || 1, a[3] || 0, a[4] || 0, a[5] || 0, a[6] || 0);
        }
        return function(value) {
            var dateFilter = $filter('date');
            value = dateFromString(value);
            return dateFilter(value, 'MM-dd HH:mm:ss');
        }

    })
