'use strict';
/**
 * @description 用户相关Controller
 * @author SuperK
 * @date 2015-04-01
 * @{@link http://www.woaiso.com}
 */
rootModule
/**
 * 个人信息页面
 * @param  {[type]} $scope) [description]
 * @return {[type]}         [description]
 */
/*登录前后页面*/
.controller('MeCtrl', function($ionicPlatform, $ionicHistory, ENV, $scope, User, $rootScope, $ionicPopup, $ionicLoading, Storage, $location, TV, $timeout) {
    /**
     * 进入后就需要重新查新
     * @param  {[type]} )
     * @return {[type]}   [description]
     */
    $scope.$on('$ionicView.enter', function() {
        //1.第一步识别用户是否登录
        if (User.userIsLogin()) { //登录了
            //展示登录的界面
            $scope.isLogin = true;
            //这里去查询用户信息
            get_user_info(function() {
                $scope.$broadcast('pageLoading.hide');
            })
        } else { //未登录
            $scope.isLogin = false;
            $scope.$broadcast('pageLoading.hide');
        }
        $scope.loginType=$rootScope.loginType;
    })

    /*
     *切换用户刷新个人信息显示
     *
     */
    function get_user_info(callback) {
        User.get_user_info().$promise.then(function(respones) {
            if (respones.success) {
                $scope.user = respones.data;
            }
            callback && callback();
        });
    }
    /**
     * 用户退出登录操作
     * @return {[type]} [description]
     */
    $scope.logout = function() {
        var myPopup = $ionicPopup.show({
            title: '是否要退出当前帐户？',
            scope: $scope,
            buttons: [{
                text: '取消'
            }, {
                text: '确定',
                onTap: function(e) {
                    $ionicLoading.show({
                        template: "正在退出"
                    });
                    User.logout(function(result) {
                        //成功退出
                        $ionicLoading.hide();
                        $location.path('login');
                    });
                }
            }]
        });
    }
})
/**
 * 修改用户资料相关接口
 * @return {[type]}                   [description]
 */
.controller('EditUserCtrl', function($scope, User,$filter,$state, $ionicLoading, Toast, $ionicHistory, $rootScope, $ionicPopup, ENV, photoService, Storage, $ionicActionSheet, $location, $timeout) {
    $scope.$on('$ionicView.enter',function(){
        //判断用户状态是否正确
        if($rootScope.globalUserIsLogin){
            $scope.userinfo = User.getCurrentUser();
            setSexChoice();
            if( $scope.userinfo.birthDay==""){
                 $scope.userinfo.birthDay=new Date();
            }else{
                $scope.userinfo.birthDay = $scope.userinfo.birthDay.replace(/-/g, "/")
                $scope.userinfo.birthDay = new Date(Date.parse($scope.userinfo.birthDay))
            }
            $scope.$watch('userinfo.birthDay', function(newValue, oldValue) {
                //根据生日信息填写星座
                if(/-/g.test($scope.userinfo.birthDay)){
                    $scope.userinfo.birthDay = $scope.userinfo.birthDay.replace(/-/g, "/")
                    $scope.userinfo.birthDay = new Date(Date.parse($scope.userinfo.birthDay))
                }
                var month = $scope.userinfo.birthDay.getMonth()+1;
                var date = $scope.userinfo.birthDay.getDate();
                if (month == 1 && date >=20 || month == 2 && date <=18) {$scope.userinfo.constellation = "水瓶座";}
                if (month == 1 && date > 31) {$scope.userinfo.constellation = "Huh?";}
                if (month == 2 && date >=19 || month == 3 && date <=20) {$scope.userinfo.constellation = "双鱼座";}
                if (month == 2 && date > 29) {$scope.userinfo.constellation = "Say what?";}
                if (month == 3 && date >=21 || month == 4 && date <=19) {$scope.userinfo.constellation = "白羊座";}
                if (month == 3 && date > 31) {$scope.userinfo.constellation = "OK. Whatever.";}
                if (month == 4 && date >=20 || month == 5 && date <=20) {$scope.userinfo.constellation = "金牛座";}
                if (month == 4 && date > 30) {$scope.userinfo.constellation = "I'm soooo sorry!";}
                if (month == 5 && date >=21 || month == 6 && date <=21) {$scope.userinfo.constellation = "双子座";}
                if (month == 5 && date > 31) {$scope.userinfo.constellation = "Umm ... no.";}
                if (month == 6 && date >=22 || month == 7 && date <=22) {$scope.userinfo.constellation = "巨蟹座";}
                if (month == 6 && date > 30) {$scope.userinfo.constellation = "Sorry.";}
                if (month == 7 && date >=23 || month == 8 && date <=22) {$scope.userinfo.constellation = "狮子座";}
                if (month == 7 && date > 31) {$scope.userinfo.constellation = "Excuse me?";}
                if (month == 8 && date >=23 || month == 9 && date <=22) {$scope.userinfo.constellation = "处女座";}
                if (month == 8 && date > 31) {$scope.userinfo.constellation = "Yeah. Right.";}
                if (month == 9 && date >=23 || month == 10 && date <=22) {$scope.userinfo.constellation = "天秤座";}
                if (month == 9 && date > 30) {$scope.userinfo.constellation = "Try Again.";}
                if (month == 10 && date >=23 || month == 11 && date <=21) {$scope.userinfo.constellation = "天蝎座";}
                if (month == 10 && date > 31) {$scope.userinfo.constellation = "Forget it!";}
                if (month == 11 && date >=22 || month == 12 && date <=21) {$scope.userinfo.constellation = "射手座";}
                if (month == 11 && date > 30) {$scope.userinfo.constellation = "Invalid Date";}
                if (month == 12 && date >=22 || month == 1 && date <=19) {$scope.userinfo.constellation = "摩羯座";}
                if (month == 12 && date > 31) {$scope.userinfo.constellation = "No way!";}
            })
        }else{
            //未登录状态，非法操作
            if($ionicHistory.backView()){
                $ionicHistory.goBack();
            }else{
                $state.go('tab.me');
            }
            Toast.show('登录状态异常,请重新登录');
        }
    })


    $scope.flag = 1;
    var update = $scope.update = {};
    /*
     *修改头像
     */
    $scope.showChoice = function() {
        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
            buttons: [{
                text: '拍照上传'
            }, {
                text: '选择本地图片'
            }],
            titleText: '上传头像',
            cancelText: '关闭',
            cancel: function() {
                // add cancel code..
            },
            buttonClicked: function(index) {
                switch (index) {
                    case 0:
                        photoService.takePhoto(imageSuccessCallback, imageErrorCallback);
                        break;
                    case 1:
                        photoService.choiceImg(imageSuccessCallback, imageErrorCallback);
                        break;
                    default:
                        break;
                }
                return true;
            }
        });
    };
    /**
     * 处理用户拍照或者选择图片
     * @param  {[type]} result 上传服务器返回的数据
     * @return {[type]}          [description]
     */
    function imageSuccessCallback(result) {
        //设置用户的
        if (result.success) {
            var imageUrl = result.data;
            var user = User.getCurrentUser();
            user.headImg = imageUrl;
            $ionicLoading.show();
            User.update_user_info(user, function(userinfo) {
                $scope.userinfo = userinfo;
                Toast.show('头像修改成功');
                $ionicLoading.hide();
            })
        } else {
            Toast.show('图片上传异常');
        }
    }

    function imageErrorCallback(err) {
        $ionicLoading.hide();
    }
    /*修改密码*/
    $scope.update_pwd = function() {
        //1.校验用户输入的数据是否满足密码条件
        if (update.oldpwd != '') {
            if (update.newpwd != '') {
                var user = User.getCurrentUser();
                if (user != null) {
                    var username = user.userName;
                    $ionicLoading.show();
                    User.update_password(username, update.oldpwd, update.newpwd).$promise.then(function(result) {
                        $ionicLoading.hide();
                        if (result.success) {
                            Toast.show("修改成功");
                            //返回上一级页面
                            $ionicHistory.goBack();
                        } else {
                            Toast.show(result.msg);
                        }
                    })
                } else {
                    Toast.show("用户信息异常");
                }
            } else {
                Toast.show('新密码不能为空')
            }
        } else {
            Toast.show('原密码不能为空');
        }
    }
    var sexs=[];
    /**
     * 设置选择用户性别的功能
     */
    function setSexChoice(){
        sexs = $scope.sexs = [{
            id: 1,
            text: '男',
            isActive: true,
            active: 'assertive icon ion-male',
            not: 'icon ion-male'
        }, {
            id: 3,
            text: '女',
            isActive: false,
            active: 'assertive icon ion-female',
            not: 'icon ion-female'
        }, {
            id: 2,
            text: '保密',
            isActive: false,
            active: 'assertive icon ion-secret',
            not: 'icon ion-secret'
        }, ]
        for (var i = 0; i < sexs.length; i++) {
            if ($scope.userinfo&&$scope.userinfo.sex == sexs[i].id) {
                sexs[i].isActive = true;
            } else {
                sexs[i].isActive = false;
            }
        }
    }
    /**
     * 用户选择进入
     * @param  {[type]} id [description]
     * @return {[type]}    [description]
     */
    $scope.choice = function(id) {
        $scope.userinfo.sex = id;
        for (var i = 0; i < sexs.length; i++) {
            if (id == sexs[i].id) {
                sexs[i].isActive = true;
            } else if (id != sexs[i].id) {
                sexs[i].isActive = false;
            }
        }
    }
    /**
     * 保存用户资料
     * @return {[type]} [description]
     */
    var save = function() {
        $ionicLoading.show();
        var regEmail = /^(\w-*\.*)+@(\w-?)+(\.\w{2,})+$/;
        console.log($scope.userinfo.email);
            if(regEmail.test($scope.userinfo.email)){
               if (typeof($scope.userinfo.email) == 'undefined' || $scope.userinfo.email == '' || regEmail.test($scope.userinfo.email)) {
                   $scope.userinfo.birthDay=$filter('date')($scope.userinfo.birthDay,"yyyy-MM-dd HH:mm:ss");
                   User.update_user_info($scope.userinfo).$promise.then(function(result) {
                       $ionicLoading.hide();
                       if (result.success) {
                           //返回上一级页面
                           Toast.show('保存成功');
                           $ionicHistory.goBack();
                       } else {
                           Toast.show('保存失败')
                       }
                   });
               } else {
                   $ionicLoading.hide();
                   Toast.show('邮箱格式不正确')
               }
           }else{
                $ionicLoading.hide();
                Toast.show('邮箱格式不正确')
           }

    }
    $scope.save = save;
})
/**
 * 注册页面Controller
 * @param  {[type]} $scope      [description]
 * @param  {[type]} $ionicPopup [description]
 * @param  {[type]} $location   [description]
 * @param  {[type]} User)       {                   var sign [description]
 * @return {[type]}             [description]
 */
.controller('SignUpCtrl', function($scope, $ionicPopup, $location, User, $ionicLoading, Storage, $rootScope) {
    var sign = $scope.sign = {};
    //debugData
    sign.phone = '';
    sign.verifyCode = "-1";
    var phoneValidate = function() {
        var msg = "";
        if (sign.phone) {
            var phonestatus = /[\S]/.test(sign.phone);
            if (phonestatus && sign.phone.length >= 6 && sign.phone.length <= 11) {
                if (sign.password) {
                    phonestatus = /[\S]/.test(sign.password);
                    if (phonestatus && sign.password.length >= 6 && sign.password.length <= 16) {
                        return true;
                    } else {
                        msg = "密码为6-16位数字字母组合"
                    }
                } else {
                    msg = "密码不能为空"
                }
            } else {
                msg = "用户名为6-12位的数字字母组合，推荐用手机号";
            }
        } else {
            msg = "帐户不能为空"
        }
        $ionicLoading.show({
            template: msg,
            duration: 1000,
            noBackdrop: true
        });
        return false;
    }


    //点击显示明文密码
    $scope.pwd_status = "password";
    $scope.showPassword = function() {
        if ($scope.pwd_status == "password") {
            $scope.pwd_status = "text";
        } else if ($scope.pwd_status == "text") {
            $scope.pwd_status = "password";
        }

    }
    $scope.getVerifyCode = function() {
        if (phoneValidate()) {
            var resource = User.get_verifycode(sign.phone);
            console.log(resource);
            // An elaborate, custom popup
            var myPopup = $ionicPopup.show({
                title: '校验码已发送',
                subTitle: '<h3>+86 ' + sign.phone.replace(/(\d{3})(\d{4})/, "$1-$2-") + '</h3>',
                scope: $scope,
                buttons: [{
                    text: '确定'
                }]
            });
        }
    };
    $scope.signUp = function() {
        if (sign.phone && phoneValidate() && sign.verifyCode && sign.password) {
            $ionicLoading.show();
            User.signup(sign.phone, sign.verifyCode, sign.password).$promise.then(function(result) {
                var msg = "";
                if (result.success) {
                    console.log(result);
                    msg = "注册成功！";
                    User.login(sign.phone, sign.password,function(result) {
                        User.get_user_info(function() {
                            //$location.path('full_info');
                        });
                    })
                } else {
                    msg = "注册失败 " + result.msg;
                }
                $ionicLoading.hide();
                $ionicLoading.show({
                    template: msg,
                    duration: 1000,
                    noBackdrop: true
                });
            })
        }
    }

})
/**
 * 登录页面相关操作
 * @param  {[type]} $scope     [description]
 * @param  {Object} $location) {                   $scope.user [description]
 * @return {[type]}            [description]
 */
.controller('LoginCtrl', function($scope,$timeout, $location, Toast, $state, $interval, User, $ionicLoading, $log, $rootScope, Storage, ENV, $ionicHistory,ThirdSystemSvc) {
    /**
     * 跳过登录页
     * @return {[type]} [description]
     */
    $scope.closeLogin=function(){
        if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
        }else{
            $state.go("tab.home")
        }
    }
    //判断用户是否登录
    if(User.userIsLogin()){
        if ($ionicHistory.backView()) {
            $ionicHistory.goBack();
        }else{
            $state.go("tab.home")
        }
    }
    /**
     * 登录按钮绑定的事件
     * @param  {[type]} user 用户账号密码
     * @return {[type]}      [description]
     */
    $scope.signIn = function(user) {
        if (user && user.username != '' && user.password != '') {
            $ionicLoading.show();
            User.login(user.username, user.password,function(result) {
                $ionicLoading.hide();
                if (result) { //含有登录信息
                    if (result.success) { //登录成功
                        var resultMsg = result.msg;
                        //登录成功
                        Toast.show(resultMsg);
                        User.get_user_info();
                        if ($ionicHistory.backView()) {
                            $ionicHistory.goBack();
                        }else{
                            $state.go("tab.home")
                        }
                    } else {
                        var resultMsg = result.msg;
                        Toast.show(resultMsg);
                    }
                } else {

                }
            })
        }

    };


    /**
     * 以下是第三方登录的代码
     */
    /**
     * QQ登录
     */
    function QQLogin() {
        $ionicLoading.show();
        ThirdSystemSvc.hsqq.login(function(result) {
                if(typeof device!='undefined'&&device.platform=="Android"){
                    result=JSON.parse(result)[0];
                }
                doThirdLogin('qq', result);
            }, function(err) {
                $ionicLoading.hide();
                //Toast.show('QQ登录出现错误' + err);
        })
        // if (typeof HSPlugin != 'undefined') {
        //     $ionicLoading.show();
        //     window.HSPlugin.execFunc('thirdPartLogin', ['qq'], function(data) {
        //         data = JSON.parse(data);
        //         //解析资料单独处理QQ的结果
        //         var result = {
        //             access_token: data[0].access_token,
        //             tokenInfo: data[0],
        //             userInfo: data[1]
        //         };
        //         doThirdLogin('qq', result);
        //     }, function(err) {
        //         $ionicLoading.hide();
        //         Toast.show('QQ登录出现错误' + err);
        //     });
        // } else {
        //     Toast.show('QQ登录组件不存在')
        // }
    }
    /**
     * 微信登录
     */
    function WeiXinLogin() {
        $ionicLoading.show();
        ThirdSystemSvc.hswechat.login(function(result) {
                doThirdLogin('wx', result);
            }, function(err) {
                $ionicLoading.hide();
                //Toast.show('微博登录出现错误' + err);
        })
    }
    /**
     * 微信登录
     */
    function WeiBoLogin() {
        $ionicLoading.show();
        ThirdSystemSvc.hsweibo.login(function(result) {
                doThirdLogin('wb', result);
            }, function(err) {
                $ionicLoading.hide();
                //Toast.show('微博登录出现错误' + err);
        })
    }
    /**
     * 识别登录的结果
     * @param  {[type]} platform [description]
     * @param  {[type]} result   [description]
     * @return {[type]}          [description]
     */
    function doThirdLogin(platform, result) {
        console.log(result);
        //这里来识别结果
        if (result) {
            var token;
            // if (platform == 'qq') {
            //     token = JSON.stringify(result.tokenInfo);
            // } else {
                token = JSON.stringify(result);
            // }
            //2.调用服务器接口登录用户
            User.thirdLogin(platform, token, function() {
                //这里需要单独处理QQ的结果
                // if (platform == 'qq') {
                //     var userInfo = result.userInfo;
                //     User.get_user_info(function() {
                //         var user = $rootScope.globalUserInfo;
                //         user.nickName = userInfo.nickname;
                //         user.headImg = userInfo.figureurl_qq_1;
                //         //这里设置用户资料
                //         User.update_user_info(user, function() {
                //             $ionicLoading.hide();
                //             if ($ionicHistory.backView()) {
                //                 $ionicHistory.goBack();
                //             }
                //         });
                //     })
                // } else {
                    //其他不需要单独处理
                    //登录成功，
                    if ($ionicHistory.backView()) {
                        $ionicHistory.goBack();
                    }else{
                        $state.go("tab.home")
                    }
                    $ionicLoading.hide();
                    User.get_user_info();
                // }
                $rootScope.globalUserIsLogin = true;

            }, function(err) {
                Toast.show('授权失败');
                $ionicLoading.hide();
            })
        } else {
            $ionicLoading.hide();
            Toast.show('授权失败')
        }
    }

    $scope.QQLogin = QQLogin;
    $scope.WeiXinLogin = WeiXinLogin;
    $scope.WeiBoLogin = WeiBoLogin;

})
    .controller('FullInfoCtrl', function($scope, $ionicLoading, User, $location, $rootScope) {
        $scope.userinfo = User.getCurrentUser();
        $scope.fullEnterEvent = function() {
            if ($scope.userinfo.nickname != undefined) {
                $ionicLoading.show();
                User.update_user_info($scope.userinfo).$promise.then(function(result) {
                    if (result.success) {
                        //登录成功
                        $ionicLoading.hide();
                        $ionicLoading.show({
                            template: '更新成功',
                            noBackdrop: true,
                            duration: 1000
                        });
                        $rootScope.$broadcast('reload_devices');
                        $rootScope.$broadcast('reload_userInfo');
                        $location.path('tab/tv');
                    } else {
                        $ionicLoading.hide();
                        $ionicLoading.show({
                            template: '更新失败',
                            noBackdrop: true,
                            duration: 1500
                        })
                    }
                });
            }


        }
        var sexs = $scope.sexs = [{
            id: 1,
            text: '男',
            isActive: true,
            active: 'assertive icon ion-male',
            not: 'icon ion-male'
        }, {
            id: 3,
            text: '女',
            isActive: false,
            active: 'assertive icon ion-female',
            not: 'icon ion-female'
        }, {
            id: 2,
            text: '保密',
            isActive: false,
            active: 'assertive icon ion-secret',
            not: 'icon ion-secret'
        }, ]
        $scope.choice = function(id) {
            $scope.userinfo.sex = id;
            for (var i = 0; i < sexs.length; i++) {
                if (id == sexs[i].id) {
                    sexs[i].isActive = true;
                } else if (id != sexs[i].id) {
                    sexs[i].isActive = false;
                }
            }
        }
    })
/*反馈意见*/
.controller('CommitSuggCtrl', function($scope, $ionicLoading, User, $location, $rootScope,Toast) {
    var sugg = $scope.sugg = {};
    $scope.tijiao = function() {
        User.commit_suggestion(sugg.content).$promise.then(function(result) {
            if (result.success) {
                Toast.show("感谢您对我们的建议");
                $location.path('tab/me');
            } else {

            }
        })
    }
})
/********关于我们******/
.controller('AboutCtrl', function(UpgradeSvc, $scope) {
    $scope.checkVersion = function() {
        UpgradeSvc.checkVersion(true);
    }
    if(typeof device!='undefined'&&device.platform != 'iOS'){
        $scope.showCheckVersion=true;
    }
});