rootModule
    .controller('VerifyLoginRegisterCtrl', function($scope, $http, ENV, $stateParams, $state, $ionicPopup, $ionicHistory,
                                                    $ionicLoading, $timeout, User,$rootScope, Toast) {

        //类型: controlType=0,  验证码登录
        //     controlType=1,  注册
        var controlType = $stateParams.type;
        $scope.user = {};
        //手机号码输入页面
        var TelephonePage = (function(){
            //电话号码页面隐藏
            $scope.telePageHide = true;

            //电话号码输入框
            $scope.user.telephone = "";

            //禁用按钮
            $scope.clickNextDisabled = true;

            //下一步按钮
            $scope.clickNext = function(){
                if($scope.user.telephone==""){
                    $ionicPopup.alert({
                        title: '系统提示',
                        template: '电话号码不能为空！',
                        okText: "确定"
                    });
                    return;
                }
                var pattern = /[^0-9]/g;
                if(pattern.test($scope.user.telephone) || $scope.user.telephone[0] != "1" || $scope.user.telephone.length != 11){
                    //"电话号码格式错误！"
                    $ionicPopup.alert({
                        title: '系统提示',
                        template: '电话号码格式错误！',
                        okText: "确定"
                    });
                    return;
                }

                $ionicLoading.show();
                //请求验证手机号是否已被注册
                httpCheckRegistered($scope.user.telephone, 1, function(res){
                    if(!res){
                        Toast.show("验证请求错误!");
                        $ionicLoading.hide();
                        return;
                    } else if(res == "true"){
                        //验证码登录
                        if(controlType == 0){
                            //请求发送验证码
                            verifyCodePage.httpRequestSendCode(function(res){
                                $ionicLoading.hide();
                                if(res){
                                    //进入验证码页面
                                    hide();
                                    verifyCodePage.show();
                                    verifyCodePage.enter();
                                }else{
                                    Toast.show("发送验证码失败!");
                                }
                            })
                        }else{//验证码注册
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: '该账号已被注册！',
                                okText: "确定"
                            });
                            $ionicLoading.hide();
                        }
                    } else if(res == "false"){
                        //验证码登录
                        //验证码注册

                        //请求发送验证码
                        controlType = 1;
                        verifyCodePage.httpRequestSendCode(function (res) {
                            $ionicLoading.hide();
                            if (res) {
                                //进入验证码页面
                                hide();
                                verifyCodePage.show();
                                verifyCodePage.enter();
                            }else{
                                Toast.show("发送验证码失败!");
                            }
                        })
                    }
                });
            };

            function show(){
                $scope.title = (controlType == "0" ? "用短信验证码登录" : "注册");
                $scope.goback = function(){
                    $state.go('login', {});//返回登录首页
                };
                $scope.telePageHide = false;
                $scope.clickNextDisabled = false;
            }
            function hide(){
                $scope.telePageHide = true;
                $scope.clickNextDisabled = true;
            }

            /*
            * 函数名: httpCheckRegistered
            * 函数功能: 请求服务器验证当前手机号或其他注册账号是否已被注册
            * 参数: account, 注册账号(如, 手机号)
            *      type, 账号类型(type=1, 手机号;
            *                    type=2, 邮箱)
            *      callback, 回调函数
            * 返回值: 无
            * 创建者: 寇才华
            * 创建时间: 2015-12-22
            * */
            function httpCheckRegistered(account, type, callback){
                $http.get(ENV.api + "/user/check_register?account=" + account + "&type=" + type)
                    .success(function(responce){
                        try{
                            if(!responce.success || !responce.data){
                                $ionicPopup.alert({
                                    title: '系统提示',
                                    template: responce.msg,
                                    okText: "确定"
                                });
                                callback();
                                return;
                            }

                            callback(responce.data == 1 ? "true" : "false");
                        }catch(e){
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: '程序出错',
                                okText: "确定"
                            });
                            callback();
                        }
                    });
            }

            return {
                show: show,
                hide: hide
            }
        })();

        //首次显示电话号码页面
        TelephonePage.show();

        //验证码获取页面
        var verifyCodePage = (function(){
            //验证码页面隐藏
            $scope.verfPageHide = true;

            //验证码输入框
            $scope.user.verCodeInput = "";

            $scope.user.restTime = 0;

            //获取验证码按钮
            $scope.getCodeBtnDisable = true;

            $scope.getVerCode = function(){
                httpRequestSendCode(function(res){
                    if(res){
                        enter();
                    }
                });
            };

            //下一步按钮
            $scope.nextBtn = function(){
                if($scope.user.verCodeInput == "" || $scope.user.verCodeInput.length != 6){
                    Toast.show("请输入验证码!");
                    return;
                }
                if(controlType == 0){
                    httpVerifyCodeLogin(function(res){
                        if(res){
                            // 进入密码输入界面
                            hide();
                            passwordPage.show();
                        }
                    });
                }else {
                    httpCheckVerifyCode(function(res){
                        if(res){
                            // 进入密码输入界面
                            hide();
                            passwordPage.show();
                        }
                    });
                }
            };

            function httpRequestSendCode(callback){
                $http.get(ENV.api + "/user/access/get_verifycode?phone=" + $scope.user.telephone)
                    .success(function(responce){
                        try{
                            if(!responce.success){
                                $ionicPopup.alert({
                                    title: '系统提示',
                                    template: responce.msg,
                                    okText: "确定"
                                });
                                callback(false);
                                return;
                            }

                            callback(true);
                        }catch(e){
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: '程序出错',
                                okText: "确定"
                            });
                            callback(false);
                        }
                    });
            }

            function countdown(count, callback){
                var timeSum = count;
                function timeDecay(){
                    $timeout(function(){
                        $scope.user.restTime = timeSum;
                    },0);

                    if(timeSum > 0){
                        --timeSum;
                        setTimeout(arguments.callee, 1000);
                    }else{
                        callback();
                    }
                }

                timeDecay();
            }

            function enter(){
                $scope.getCodeBtnDisable = true;
                countdown(60, function(){
                    $scope.getCodeBtnDisable = false;
                });
            }

            //核对验证码
            function httpCheckVerifyCode(callback){
                $ionicLoading.show();
                $http.get(ENV.api + "/user/access/valid_verifycode?phone=" + $scope.user.telephone
                    + "&verifyCode=" + $scope.user.verCodeInput)
                    .success(function(responce){
                        $ionicLoading.hide();
                        try{
                            if(!responce.success){
                                $ionicPopup.alert({
                                    title: '系统提示',
                                    template: responce.msg,
                                    okText: "确定"
                                });
                                callback(false);
                                return;
                            }

                            callback(true);
                        }catch(e){
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: '程序出错',
                                okText: "确定"
                            });
                            callback(false);
                        }
                    });
            }

            //验证码登录
            function httpVerifyCodeLogin(callback){
                $ionicLoading.show();
                $http.post(ENV.api + "/user/login", param({
                    userName: $scope.user.telephone,
                    password: $scope.user.verCodeInput,
                    type: "1"
                })).success(function(responce){
                        $ionicLoading.hide();
                        try{
                            if(!responce.success){
                                $ionicPopup.alert({
                                    title: '系统提示',
                                    template: responce.msg,
                                    okText: "确定"
                                });
                                callback(false);
                                return;
                            }

                            callback(true);
                        }catch(e){
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: '程序出错',
                                okText: "确定"
                            });
                            callback(false);
                        }
                    });
            }


            function show(){
                $scope.title = "填写验证码";
                $scope.goback = function(){
                    hide();
                    TelephonePage.show();//返回登录首页
                };
                $scope.getCodeBtnDisable = false;
                $scope.verfPageHide = false;
            }

            function hide(){
                $scope.verfPageHide = true;
                $scope.getCodeBtnDisable = true;
            }

            return {
                httpRequestSendCode: httpRequestSendCode,
                enter: enter,
                show: show,
                hide: hide
            };
        })();
        //
        ////密码输入页面
        var passwordPage = (function(){
            //密码页面隐藏
            $scope.pwdPageHide = true;

            $scope.password = "";

            $scope.commit = function(){
                if($scope.user.password.length < 6){
                    $ionicPopup.alert({
                        title: '系统提示',
                        template: '密码至少6位',
                        okText: "确定"
                    });
                    return;
                }

                var pattern = /[^0-9a-zA-Z]/g;
                if(pattern.test($scope.user.password)){
                    $ionicPopup.alert({
                        title: '系统提示',
                        template: '密码必须为字母或数字',
                        okText: "确定"
                    });
                    return;
                }

                if(controlType == "0"){
                    httpVerfModifyPwd(function(res){
                        if(res){
                            /*var ui = User.get_user_info(function(){
                                gotoNextPage();
                            });
                            if(!ui){*/
                                User.login($scope.user.telephone, $scope.user.password,
                                    function(responce){
                                        console.log(responce);
                                        gotoNextPage();
                                        Toast.show("登录成功!");
                                    }, false)
                            /*}else{
                                $rootScope.globalUserIsLogin = true;
                            }*/
                           // $state.go('tab.home', {});//返回登录首页
                        }
                    });
                }
                else{
                    httpRegister(function(state){
                        if(state){
                            //result.userId;
                            /*var ui = User.get_user_info(function(){
                                gotoNextPage();
                            });
                            if(!ui){*/
                                User.login($scope.user.telephone, $scope.user.password,
                                function(responce){
                                    console.log(responce);
                                    Toast.show("登录成功!");
                                    gotoNextPage();
                                }, false)
                            /*}else{
                                $rootScope.globalUserIsLogin = true;
                            }*/
                            //$state.go('tab.home', {});//返回登录首页
                        }
                    });
                }
            };

            /*
            * 函数名: gotoNextPage
            * 函数功能: 判断是跳转到登录前的页面,还是主页
            * 函数参数: 无
            * 返回值: 无
            * 创建时间: 2015-12-18
            * 创建者: 寇才华
            * */
            function gotoNextPage(){
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                }else{
                    $state.go("tab.home")
                }
            }

            //验证码注册
            function httpRegister(callback){
                $ionicLoading.show();
                //注册
                $http.post(ENV.api + "/user/register", param({
                    userName: $scope.user.telephone,
                    verifyCode: $scope.user.verCodeInput,
                    password: User.encodePassword($scope.user.password),
                    type: "1"
                })).success(function (responce) {
                    $ionicLoading.hide();
                    try {
                        if (!responce.success) {
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: responce.msg,
                                okText: "确定"
                            });
                            callback(false);
                            return;
                        }

                        callback(true);
                    } catch (e) {
                        $ionicPopup.alert({
                            title: '系统提示',
                            template: '程序出错',
                            okText: "确定"
                        });
                        callback(false);
                    }
                });
            }

            //验证码修改密码
            function httpVerfModifyPwd(callback){
                $ionicLoading.show();
                $http.post(ENV.api + "/user/update_password", param({
                    userName: $scope.user.telephone,
                    password: $scope.user.verCodeInput,
                    newPwd: User.encodePassword($scope.user.password),
                    type: "1"
                })).success(function (responce) {
                    $ionicLoading.hide();
                    try {
                        if (!responce.success) {
                            $ionicPopup.alert({
                                title: '系统提示',
                                template: responce.msg,
                                okText: "确定"
                            });
                            callback(false);
                            return;
                        }

                        callback(true);
                    } catch (e) {
                        $ionicPopup.alert({
                            title: '系统提示',
                            template: '程序出错',
                            okText: "确定"
                        });
                        callback(false);
                    }
                });
            }

            function show(){
                $scope.title = "设置密码";
                $scope.goback = function(){
                    hide();
                    verifyCodePage.show();//返回登录首页
                };
                $scope.pwdPageHide = false;
            }
            function hide(){
                $scope.pwdPageHide = true;
            }

            return {
                show: show,
                hide: hide
            };
        })();
    });