'use strict';
/**
 * 评论功能内容
 */
rootModule
    .directive('commentList',function($compile,Toast,Movies,$timeout,$rootScope,$stateParams,MediaSvc, User, $state, $ionicPopup, $ionicScrollDelegate, InterfaceSide){
      var linker = function(scope,element,attrs){
        /***语音的重复播放**/
        var currentPlayComment;
        var histeryIds = [];
        var mediaPlayer=null;
        scope.commentLength = 0;
        /**
         * 语音播放功能
         * @param  {[type]} dotId     主题ID
         * @param  {[type]} commentId 评论ID、聊天信息ID
         * @return {[type]}           [description]
         */
        function playAudioVoice(url) {
            if (currentPlayComment) {
                currentPlayComment.playing = false;
            }
            if(mediaPlayer!=null){
                mediaPlayer.pause();
            }
            //判断URL是否存在
            var comment = url;
            if (comment && comment.voice) {
                var url = comment.voice;
                if (url && url.indexOf('m4a') > -1) {
                    comment.playing = true; //修改当前状态
                    MediaSvc.play(url, function() {
                      //开始播放
                      console.log('play success end')
                      $timeout(function(){comment.playing = false});
                    }, function(err) {
                        $timeout(function(){comment.playing = false});
                    },function(player){
                      mediaPlayer=player;
                    },function(status){
                      if(status==4){
                        $timeout(function(){comment.playing = false});
                      }
                    })
                }
            }
            currentPlayComment = comment;
        }
        scope.playAudioVoice = playAudioVoice;
        scope.playCommentList = []; // 保存评论数据
        scope.playCommentList.loading = false; //当前是否正在加载
        var contentheight = window.screen.height - 105;//可用分辨率，即content高度
        var themeType = attrs.themetype;  //（1:话题2：投票3：商机4:知识点5:竞猜-1：视频 -2：频道 -3：乐配成果）
       if(attrs.videoid){
          var rootId = attrs.videoid; //评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
        }else{
          var rootId = $stateParams.id; //评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
        }
        function getCommentById(commentId){
          InterfaceSide.getCommentById(commentId).$promise.then(function(result) {
              angular.forEach(result.data,function(item){
                // console.log(item.content)
              try{
                   //语音评论
                 item.content= JSON.parse(item.content);
                 if(item.content.voice){
                  item.voice = item.content.voice;
                 }
              }catch(e){

              }
              })
              if (result.success) {
                  for (var i = 0; i < result.data.length; i++) {
                      var commenttime = result.data[i].commentTime.replace(/-/g, "/")
                      if(/\.\d/.test(commenttime)){
                          result.data[i].commentTime = new Date(Date.parse(commenttime.replace(/\.\d/g,"")))
                      }else{
                          result.data[i].commentTime = new Date(Date.parse(commenttime))
                      }

                  } //将字符串转换为data对象；
                  scope.playCommentList = scope.playCommentList.concat(result.data); // 将数据保存到Scope里面，颠倒顺序
                  $ionicScrollDelegate.resize();
                  // element[0].querySelector("[idname='nextPageComment']").style.display="block";

              } else {
                  console.log('查询评论实体数据失败！')
              }
              scope.playCommentList.loading = false;
          }, function(err) {
              scope.playCommentList.loading = false;
              console.log(err);
          })
        }
        // var pageIndex = 1;
        // var pageSize = 10;
        // //分页查询评论
        // Movies.getCommentbyPage(themeType,rootId,pageIndex,pageSize,function(result){
        //   if(result.success){
        //     if(result.data.totalNo<=pageSize){
        //       element[0].querySelector("[idname='nextPageComment']").innerHTML = "无更多数据";
        //       element[0].querySelector("[idname='nextPageComment']").disabled = true;
        //     }else{
        //       pageIndex++
        //     }
        //   }else{
        //     element[0].querySelector("[idname='nextPageComment']").style.display="none";
        //     scope.playCommentList.loading = false;
        //   }
        //   debugger
        // })
        /**
         * 获取乐配评论数据
         * @return {[type]} [description]
         */
        function getPlayCommentList() {
            histeryIds = [];
            scope.playCommentList = [];
            element[0].querySelector("[idname='nextPageComment']").innerHTML = "加载更多";
            element[0].querySelector("[idname='nextPageComment']").disabled = false;

            //1.查询出当前乐配作品的历史评论数据,rootId,乐配ID，主题类型：8，themeType,-3：娱乐成果
            InterfaceSide.getAllHistoryComments(rootId, themeType, function(result) {
                //2.将所有评论ID拼接起来，
                if (result.success) {
                    var ids = [];
                    if (result.data && result.data.length > 0) {
                        for (var i = 0; i < result.data.length; i++) {
                            ids.push(result.data[i].cid);
                        }
                        //2.获取到所有评论ID，发起查询实体内容
                        histeryIds = ids.reverse();

                        if(histeryIds.length<=10){
                             element[0].querySelector("[idname='nextPageComment']").innerHTML = "无更多数据";
                             element[0].querySelector("[idname='nextPageComment']").disabled = true;
                             element[0].querySelector("[idname='nextPageComment']").style.display="none";
                             // debugger
                        }else{
                             element[0].querySelector("[idname='nextPageComment']").style.display="block";
                        }
                        getCommentById(histeryIds.slice(0, 9).join(','));
                        histeryIds = histeryIds.slice(10);
                        scope.commentLength = ids.length
                    } else {
                        //mark,当前没有人评论
                        scope.loading = false;
                    }
                } else {
                    element[0].querySelector("[idname='nextPageComment']").style.display="none";
                    scope.playCommentList.loading = false;
                    // Toast.show("加载评论失败")
                }
            })
        }
        var loadMore = function(){
            var ids = [];
            if(histeryIds.length>9){
                ids = histeryIds.slice(0, 9)
                histeryIds = histeryIds.slice(10)
                if(histeryIds.length<9){
                  element[0].querySelector("[idname='nextPageComment']").innerHTML = "无更多数据";
                  element[0].querySelector("[idname='nextPageComment']").disabled = true;
                }
            }else if(histeryIds.length==0){
                element[0].querySelector("[idname='nextPageComment']").innerHTML = "无更多数据";
                element[0].querySelector("[idname='nextPageComment']").disabled = true;
            }else{
                ids = histeryIds;
                histeryIds = []
                element[0].querySelector("[idname='nextPageComment']").innerHTML = "无更多数据";
                element[0].querySelector("[idname='nextPageComment']").disabled = true;
            }

            getCommentById(ids.join(','));
            $timeout(function() {
                $ionicScrollDelegate.resize();
            }, 100);
        }
        //查询评论数据
        // getPlayCommentList();
        $rootScope.$on(attrs.id,function(e,data){  //监听发送评论事件，将自己发表的最新评论append到页面上
          scope.commentLength++
          var result=data;
          try{
               //语音评论
              result.comment.content= JSON.parse(result.comment.content)
              if(result.comment.content.voice){
               result.comment.voice = result.comment.content.voice;
              }
          }catch(e){

          }
          scope.playCommentList.unshift(result.comment);  //将该条数据设置到页面上
          var allCommentHeigth = element[0].querySelector("#commentainer").clientHeight
          // debugger
          if(allCommentHeigth<contentheight){
              //判断评论是否填满整个屏幕
              var commentheigth = element[0].querySelector(".comment-top").offsetTop-(contentheight-allCommentHeigth-70);
              //使评论刚好在底部显示，不留白
          }
          else{
              var commentheigth = element[0].querySelector(".comment-top").offsetTop ; //comment到顶部的高度
          }

          $ionicScrollDelegate.resize();
          // console.log(attrs.iscoll)
          if(attrs.iscoll=="true"){
            //ionid scroll

              if(attrs.isinmedol&&attrs.isinmedol!=""){//在一个medol里面
                  $ionicScrollDelegate.$getByHandle(attrs.isinmedol).scrollTo(0, commentheigth);//

              }else{
                $ionicScrollDelegate.$getByHandle('').scrollTo(0, commentheigth);//
              }
              // debugger

          }else{
            //原生 scroll
            if(element[0].offsetParent!=null){
              element[0].offsetParent.scrollTop = commentheigth-5;
            }
          }
        })
        var isShowLoadMore = function(length){
          if (length>10) {
            element[0].querySelector("[idname='nextPageComment']").innerHTML = "加载更多";
            element[0].querySelector("[idname='nextPageComment']").disabled = false;
            element[0].querySelector("[idname='nextPageComment']").style.display="block";
          }else{
            element[0].querySelector("[idname='nextPageComment']").innerHTML = "无更多数据";
            element[0].querySelector("[idname='nextPageComment']").disabled = true;
            element[0].querySelector("[idname='nextPageComment']").style.display="block";
          };
        }
        scope.$parent.$on('$ionicView.leave',function(){
            if(mediaPlayer!=null){
                mediaPlayer.pause();
                currentPlayComment.playing = false;
            }
        })
        scope.$on('$destroy',function(){
            if(mediaPlayer!=null){
                mediaPlayer.pause();
                currentPlayComment.playing = false;
            }
        })
        scope.$on("pushDownMoreData",function(e,data){
          if(attrs.dotmsgs){

          }else if(data.data){
            getPlayCommentList()
          }
        })
        if(attrs.dotmsgs){
          scope.commentLength = scope.dotmsgs.length;
          scope.isInSide = true;
          // scope.playCommentList = [];
          // debugger
          scope.playCommentList = scope.dotmsgs;
          // console.log(scope.dotmsgs)
          // isShowLoadMore(allCommentList.length)
          // if(allCommentList.length>10){
          //   scope.playCommentList = allCommentList.slice(0, 9);
          //   allCommentList = allCommentList.slice(10)

          // }else{
          //   scope.playCommentList = allCommentList;
          // }
          //点击加载更多评论
          // scope.loadMore = function(){
          //   if(allCommentList.length>10){
          //     scope.playCommentList = scope.playCommentList.concat(allCommentList.slice(0, 9));
          //     allCommentList = allCommentList.slice(10)
          //   }else{
          //     scope.playCommentList = scope.playCommentList.concat(allCommentList);
          //   }
          //   isShowLoadMore(allCommentList.length)
          //   $ionicScrollDelegate.resize();
          // }

        }else{
          scope.loadMore = loadMore;
          getPlayCommentList();
          scope.isInSide = false;
        }
      }


      return{
        restrict:"AE",
        link:linker,
        replace:true,
        templateUrl:"templates/directives/comment-list.html",
        scope: {
           dotmsgs: '='
        }
      }

    })