rootModule
	.directive('labelItem', function($compile, $rootScope,$templateFactory,ImageSvc) {
        function getTemplate(contentType) {
            var template = '';
            switch (contentType) {

                case 1: //话题
                    template = $templateFactory.fromUrl('templates/subjectme/topichat.html'); //话题模板
                    break;
                case 2: //投票
                    template = $templateFactory.fromUrl('templates/subjectme/topicvote.html'); //投票模板
                    break;
                case 3: //商品
                    template = $templateFactory.fromUrl('templates/subjectme/shop.html'); //商机模板
                    break;
                case 4: //知识点
                    template = $templateFactory.fromUrl('templates/subjectme/knowlege.html'); //知识点模板
                    break;
                case 5: //竞猜
                    template = $templateFactory.fromUrl('templates/subjectme/jingcai.html'); //竞猜模板
                    break;
                case 10: //简介
                    template = $templateFactory.fromUrl('templates/subjectme/introduce.html'); //简介模板
                    break;
                // case -1:
                //     template = $templateFactory.fromUrl('templates/subjectme/comment.html'); //评论模板
                //     break;
                default:
                    template=null;
                    break;
            }
            return template;
        }
        var linker = function(scope, element, attrs) {
            var templatePromise = getTemplate(scope.dot.type);
            if (templatePromise != null) {
                templatePromise.then(function(data) {
                    element.html(data);
                    $compile(element.contents())(scope);
                }, function(err) {
                    console.log(err);
                })
            }else{
                //如果没有模板则不处理
            }
               //这里来获取页面可以显示的图片宽度
               var poster=ImageSvc.calcItem(scope,3,1/1,0);
                   scope.Imgwidth=poster.itemWidth;
                   scope.Imgheight=poster.itemHeight;

            scope.toggleLabel = function(dotId) {
                scope.toggleLabelHandler({
                    dotId: dotId
                });
            }
            scope.sendChatEvent = function(dotId) {
                scope.sendChatEventHandler({
                    dotId: dotId
                });
            }
            scope.voteEvent = function(dotId, vcId) {
                scope.voteEventHandler({
                    dotId: dotId,
                    vcId: vcId
                });
            }
            scope.descEvent = function(dotId,isGoComment) {
                scope.descEventHandler({
                    dotId: dotId,
                    isGoComment: isGoComment
                })
            }
             /*添加话题的详情页*/
              scope.showtopicEvent = function(dotId) {
                scope.showtopicEventHandler({
                    dotId: dotId
                })
            }
            /*添加简介的详情页*/
              scope.showintroduceEvent = function(dotId) {
                scope.showintroduceEventHandler({
                    dotId: dotId
                })
            }
            scope.showMicEvent = function(dotId) {
                scope.showMicEventHandler({
                    dotId: dotId
                })
            }
            scope.playAudioEvent = function(dotId, commentId) {
                playAudio(dotId, commentId);
            }


            scope.linkShop = function(url) {
                window.open(url, '_blank', 'location=yes');
            }
            scope.$on('send.data', function(e, data) {
                scope.$emit('side.msg', angular.extend({
                    itemId: scope.dot.dotId
                }, data));
            })
        }
        return {
            restrict: "E",
            link: linker,
            replace: true,
            transclude: true,
            scope: {
                dot: '=',
                time: '=',
                toggleLabelHandler: '&',
                sendChatEventHandler: '&',
                descEventHandler: '&',
                voteEventHandler: '&',
                showMicEventHandler: '&',
                playAudioEvent: '&',
                showtopicEventHandler:'&',
                showintroduceEventHandler:'&'
            }
        };
    });