'use strict';
/**
 * 电影场次选择模块，图片滑动功能
 */
rootModule
    .directive('hscroll', function($timeout) {
        var linker = function(scope, element, attr) {
            var imagesUl = element.find('ul');
            imagesUl.css({
                'left': "0px"
            });
            //这里来计算UL的宽度
            //var windowWidth = window.screen.width;
            var windowWidth = document.body.clientWidth;
            //计算出图片的宽度
            var imageWidth = windowWidth / 3 - 20; //每张图片的宽度
            scope.imageWidth = imageWidth;
            //2.计算外框的高度
            var boxHeight = imageWidth * 1.3;
            scope.imageHeight = boxHeight;
            //计算所有图片外框的总宽度

            //计算最外层Box showtime-movies高度
            element.css({
                'height': (boxHeight + 20) + 'px'
            });
            //1.绑定触摸事件
            var lastX = 0;
            //开始触摸
            element.bind('touchstart', function(e) {
                var touch = e.touches[0];
                lastX = touch.pageX;
            })
            //触摸移动
            element.bind('touchmove', function(e) {
                var touch = e.touches[0];
                var calcX = touch.pageX - lastX;
                var nowleft = parseInt(imagesUl[0].style.left.replace('px', ''));
                imagesUl.css({
                    left: nowleft + calcX + 'px'
                })
                lastX = touch.pageX;
                e.preventDefault();
            })
            //结束触摸
            element.bind('touchend', function(e) {
                restorePosition();
            })
            /**
             * 超出的部分归位
             * @return {[type]} [description]
             */
            function restorePosition(){
                var nowleft = parseInt(imagesUl[0].style.left.replace('px', ''));
                if (nowleft > 0) {
                    imagesUl[0].style.left = 0 + 'px';
                } else if (imagesUl[0].offsetWidth + nowleft < document.body.clientWidth) {
                    imagesUl[0].style.left = -(imagesUl[0].offsetWidth - document.body.clientWidth) + 'px';
                }
            }


            /*************以下是点击的函数*******************/
            var index = 1;
            /**
             * 用来设置某个影片获得焦点
             * @param  {[type]} nowImg   当前操作的影片
             * @param  {[type]} nowindex 当前影片的下标
             * @return {[type]}          [description]
             */
            function focusImg(nowImg, nowindex) {
                //1.将当前影片标记为激活状态
                angular.forEach(scope.scenemovielist, function(imgitem) {
                    imgitem.activated = false;
                })
                nowImg.activated = true;
                //2.计算应该偏移的位置
                //当前下标+1,偏移8个像素
                var offset = (imageWidth+8) * (nowindex-1)-windowWidth%(imageWidth+8)/2;
                translationmovie(offset);
             }

            var ScaleImg = function(nowImg, nowindex) {
                focusImg(nowImg,nowindex);
                scope.$emit('videoChanged',{video:nowImg})
            };
            function translationmovie(offset) {
                imagesUl[0].style.left = -offset+'px';
                restorePosition(); //超出了重新计算
            }
            scope.ScaleImg = ScaleImg;
            /**
             * 切换当前焦点视频
             */
            scope.$on('changeFocus',function(e,data){
                var video=data.video;
                $timeout(function(){
                  angular.forEach(scope.scenemovielist,function(item,index){
                    if(item.videoId==video.videoId){
                        focusImg(item,index);
                    }
                  })
                },1)

            })

        }
        return {
            restrict: "E",
            templateUrl: 'templates/hs-scroll.html',
            link: linker,
            replace: true,
            scope: {
                scenemovielist: '='
            }
        }

    })