'use strict';
/**
 * 分享功能
 */
rootModule

    .directive("sharepage",function($ionicActionSheet,ThirdSystemSvc,ImageSvc,Toast){
      var linker=function($scope,element,attr){
          element.bind('click',function(e){
           // 显示操作表
           $ionicActionSheet.show({
             titleText: '分享给好友',
             cancelText: '取消',
             buttonClicked: function(index) {
                 switch (index){
                     case 0:
                         shareWeixinFriendCircle();
                         break;
                     case 1:
                         shareWeixinFriend();
                         break;
                     case 2:
                         shareXinlangWeibo();
                         break;
                     case 3:
                         shareQQZone();
                         break;
                     case 4:
                         shareQQFriend();
                         break;
                 }
               return true;
             },
               buttons: [
                   {text: '<i class="ion-circle-of-friends-share share-icon"></i><p>微信朋友圈</p>'},
                   {text: '<i class="ion-wechat-share share-icon"></i><p>微信好友</p>'},
                   {text: '<i class="ion-sina-share share-icon"></i><p>新浪微博</p>'},
                   {text: '<i class="ion-qq-space-share share-icon"></i><p>QQ空间</p>'},
                   {text: '<i class="ion-qq-share share-icon"></i><p>QQ好友</p>'}
               ],
               cssClass: "shareBtnsClass"
   });
        })
          /**
           * 分享成功的回调函数
           * @return {[type]} [description]
           */
          function shareSuccessCallback(){
              Toast.show('分享成功');
          }
          /**
           * 分享失败的回调函数
           */
          function shareErrorCallabck(){
              Toast.show('分享失败');
          }
          var shareWeixinFriendCircle = function(){
              var data=$scope.$parent.shareDatas(attr["disportClicked"]);
              if(data){
                  var jsonStr = [{
                      "platform": "wxcircle",
                      "contentType": "link",
                      "content":{
                          "title": data.title ,
                          "contentString":data.link ,
                          "linkImgUrl": ImageSvc.getShareThumb(data.linkImgUrl),
                          "qzText":data.text,
                          "qzLink":data.link,
                          "qzImgUrl":ImageSvc.getShareThumb(data.linkImgUrl),
                          "description":"来自视动无限（APP下载地址：http://app.handsight.cn ）"
                      }
                  }];
                  //分享
                  ThirdSystemSvc.hswechat.shareToFriendCircle(jsonStr,shareSuccessCallback,shareErrorCallabck);
              }
          };

          var shareWeixinFriend = function(){
              var data=$scope.$parent.shareDatas(attr["disportClicked"]);
              if(data){
                  var jsonStr = [{
                      "platform": "wxfriend",
                      "contentType": "link",
                      "content":{
                          "title": data.title ,
                          "contentString":data.link ,
                          "linkImgUrl": ImageSvc.getShareThumb(data.linkImgUrl),
                          "qzText":data.text,
                          "qzLink":data.link,
                          "qzImgUrl":ImageSvc.getShareThumb(data.linkImgUrl),
                          "description":"来自视动无限（APP下载地址：http://app.handsight.cn ）"
                      }
                  }];

                  //分享
                  ThirdSystemSvc.hswechat.shareToFriend(jsonStr,shareSuccessCallback,shareErrorCallabck);
              }
          };

          var shareXinlangWeibo = function(){
              var data=$scope.$parent.shareDatas(attr["disportClicked"]);
              if(data){
                  var jsonStr = [{
                      "platform": "weibo",
                      "contentType": "img",
                      "content":{
                          "title": data.title+"来自视动无限"+data.link+"（APP下载地址：http://app.handsight.cn ）" ,
                          "contentString":data.imgSrc ,
                          "linkImgUrl": ImageSvc.getPlayThumb(data.imgSrc),
                          "qzText":data.text,
                          "qzLink":data.link,
                          "qzImgUrl":ImageSvc.getPlayThumb(data.imgSrc)
                      }
                  }];
                  //分享
                  ThirdSystemSvc.hsweibo.share(jsonStr,shareSuccessCallback,shareErrorCallabck);
              }
          };

          var shareQQZone = function(){
              var data=$scope.$parent.shareDatas(attr["disportClicked"]);
              if(data){
                  var jsonStr = [{
                      "platform": "qzone",
                      "contentType": "link",
                      "content":{
                          "title": data.title ,
                          "contentString":data.link ,
                          "linkImgUrl": ImageSvc.getPlayThumb(data.linkImgUrl),
                          "qzText":"来自视动无限（APP下载地址：http://app.handsight.cn ）",
                          "qzLink":data.link,
                          "qzImgUrl":ImageSvc.getPlayThumb(data.imgSrc),
                          "description":"来自视动无限（APP下载地址：http://app.handsight.cn ）"
                      }
                  }];
                  //分享
                  ThirdSystemSvc.hsqq.shareToQzone(jsonStr,shareSuccessCallback,shareErrorCallabck);
              }
          };
          var shareQQFriend = function(){
              var data=$scope.$parent.shareDatas(attr["disportClicked"]);
              if(data){
                  var jsonStr = [{
                      "platform": "qfriend",
                      "contentType": "link",
                      "content":{
                          "title": data.title ,
                          "contentString":data.link ,
                          "linkImgUrl": ImageSvc.getPlayThumb(data.linkImgUrl),
                          "qzText":"来自视动无限"+"（APP下载地址：http://app.handsight.cn ）",
                          "qzLink":data.link,
                          "qzImgUrl":ImageSvc.getPlayThumb(data.imgSrc),
                          "description":"来自视动无限（APP下载地址：http://app.handsight.cn ）"
                      }
                  }];
                  //分享
                  ThirdSystemSvc.hsqq.shareToQQ(jsonStr,shareSuccessCallback,shareErrorCallabck);
              }
          };


      }

      return{
        restrict:"AE",
        link:linker,
        replace:true,
        scope:{
          getShareData:'&'
        }
      }

    })