/**
 * @description  系统内使用的视频播放器
 * @author SuperK
 * @date 2015/10/11
 * @email liaoyf@handsight.cn
 */
rootModule
    .directive('videoPlayer', function($compile, MediaSvc, $interval, $timeout, Toast,ImageSvc) {
        //初始化Linker
        var linker = function(scope, element, attrs) {
            scope.currentTime = 0;
            scope.videoFullTime = 0;
            scope.videoPlayStatus = 3; //1.播放，2.暂停，3.播放完成停止
            scope.isControllsVisible = false; //是否显示时间进度条,相关组件
            scope.showPosterImg = true;
            scope.statusText="";
            scope.previewStatus = 1; //1.还未开始预览 2.正在预览， 原音预览文字
            scope.isedit = false; //当前是否为编辑页面
            scope.processPercent = "0%";
            var userPlayAudio;
            var playVideourl;
            var playMedia; //语音播放器
            scope.showPreview = true;
            scope.isShowPlayButton = false; //是否显示播放按钮
            var video = element.find('video')[0];
            var range = element.find('input')[0];
            //设置初始化的一些参数
            var videoProcess = 0; //当前缓冲的大小0-1;
            var realAudioUrl = "";
            var useLocalBuffered=false;
            /***********************播放器相关事件处理**************************/
            /*video.addEventListener('loadeddata',function(e){
                console.log('loadeddata');   
            })
            video.addEventListener('loadedmetadata',function(e){
                console.log('loadedmetadata');   
            })
            video.addEventListener('loadstart',function(e){
                console.log('loadstart');   
            })
            video.addEventListener('readystatechange',function(e){
                console.log('readystatechange');   
            })
            video.addEventListener('waiting',function(e){
                console.log('waiting');
            })*/


            /*var eventList = {
                "loadstart": 0,
                "progress": 0,
                "suspend": 0,
                "abort": 0,
                "error": 0,
                "emptied": 0,
                "stalled": 0,
                "loadedmetadata": 0,
                "loadeddata": 0,
                "canplay": 0,
                "canplaythrough": 0,
                "playing": 0,
                "waiting": 0,
                "seeking": 0,
                "seeked": 0,
                "ended": 0,
                "durationchange": 0,
                "timeupdate": 0,
                "play": 0,
                "pause": 0,
                "ratechange": 0,
                "resize": 0,
                "volumechange": 0
            };
            for (var p in eventList) {
                (function (prop) {
                    video.addEventListener(prop, function (event) {
                        eventList[event.type] += 1;
                        console.log(event.type + "----->" + eventList[event.type] + "??" + video.networkState + "--->" +
                            (new Date().getTime()));
                    })
                })(p);
            }*/

            //获取总时长
            video.addEventListener('durationchange', function(e) {
                //console.log('durationchange');
                var time = parseInt(video.duration);
                scope.videoFullTime = time;
                //设置Range的长度
                range.min = 0;
                range.max = time;
                range.value = 0;
            })
            video.addEventListener('timeupdate', function(event) {
                //console.log('timeupdate');
                scope.currentTime = parseInt(video.currentTime);
                //这里需要来修改进度条
                range.value = scope.currentTime;
                if (!scope.$$phase) {
                    scope.$apply();
                }
            })
            video.addEventListener('canplaythrough', function() {
                //console.log('....oncanplaythrough');
                scope.statusText = "";


            })
            video.addEventListener('canplay', function() {
              //  console.log('....oncanplay');
                scope.statusText = "";
            })
            video.addEventListener('ended', function(event) {
               // console.log('......onended');
                scope.$emit('videoEnd');
                Player.stop();
                if (!scope.$$phase) {
                    scope.$apply();
                }
            })

            //加载动画
            video.addEventListener('progress', function(e) {
                var
                    t = this,
                    target = (e !== undefined) ? e.target : t.media,
                    percent = null;
                // newest HTML5 spec has buffered array (FF4, Webkit)
                if (target && target.buffered && target.buffered.length > 0 && target.buffered.end && target.duration) {
                    // account for a real array with multiple values - always read the end of the last buffer
                    percent = target.buffered.end(target.buffered.length - 1) / target.duration;
                }
                // Some browsers (e.g., FF3.6 and Safari 5) cannot calculate target.bufferered.end()
                // to be anything other than 0. If the byte count is available we use this instead.
                // Browsers that support the else if do not seem to have the bufferedBytes value and
                // should skip to there. Tested in Safari 5, Webkit head, FF3.6, Chrome 6, IE 7/8.
                else if (target && target.bytesTotal !== undefined && target.bytesTotal > 0 && target.bufferedBytes !== undefined) {
                    percent = target.bufferedBytes / target.bytesTotal;
                }
                // Firefox 3 with an Ogg file seems to go this way
                else if (e && e.lengthComputable && e.total !== 0) {
                    percent = e.loaded / e.total;
                }
                if (percent !== null) {
                    percent = Math.min(1, Math.max(0, percent));
                    videoProcess = percent;
                }

                console.log('缓冲数量...', (percent * 100).toFixed(1) + "%");
                if (percent > 0.1) {
                    
                }
                // scope.processPercent = (percent * 100).toFixed(2) + "%";
            })
            video.addEventListener('playing', function(e) {
               // console.log('onplaying', e);
            })

            /**
             * 开始缓冲数据，在Android平台上即开始播放立即暂停
             * @param  {[type]} e       [description]
             * @param  {[type]} data){                         } [description]
             * @return {[type]}         [description]
             */
            scope.$on('startToBuffer', function(e, data) {
                Player.bufferData();
            })
            scope.$on('setPreview', function(e, data) {
                scope.showPreview = data.show;
                Player.stop();
            })

            //进度条相关操作
            range.oninput = function() {
                video.currentTime = this.value;
                if (Player.audioPlayer != null) {
                    //这里需要判断语音总时长，看是否播放
                    if (Player.audioPlayer.getDuration() < this.value) { //如果音频时间小于当前拖动的时间，则不播放了
                        Player.audioPlayer.stop();
                    } else {
                        Player.audioPlayer.seekTo(this.value * 1000);
                        //判断视频播放状态
                        if (!video.paused) { //当前视频是否暂停
                            Player.audioPlayer.play();
                        } else {

                        }
                    }
                }
                //声音也需要设置位置
            }
            scope.$on('startPlay', function() {
                Player.play(false);
            });
            //预览用户的配音
            scope.$on('previewUserAudio', function() {
                Player.play(true);
                if (video.readyState == 4) {
                    video.currentTime = 0;
                }
                scope.previewStatus = 1; //恢复成原音预览
                scope.showPreview = false;
            });
            scope.$on('previewUserAudioStop', function() {
                Player.stop();
                scope.showPreview = true;
            });

            function resetPlayer() {
                if (video.readyState == 4) {
                    video.currentTime = 0;
                }
                if (typeof playMedia != 'undefined' && playMedia != null) {
                    playMedia.seekTo(0)
                }
                scope.previewStatus = 1;
            }
            scope.$on('resetPlayer', function() {
                resetPlayer();
            })
            scope.$on('stopPlay', function() {
                Player.stop();
            });
            /**
             * 视频准备好播放的事件
             * @return {[type]} [description]
             */
            function videoReady(){
                scope.$emit('videoReady');
                //改变Video大小
                video.width=document.body.offsetWidth;
                video.height="200";

                Media.getVideo().status=Constant.bufferComplete;
            }

            /**
             * 原音预览功能
             * @return {[type]} [description]
             */
            scope.previewRealAudioEvent = function() {
                if (scope.previewStatus == 1) { //播放
                    resetPlayer(); //重置播放器
                    scope.previewStatus = 2;
                    __initPlayer({
                        userPlayAudio: realAudioUrl,
                        videoSplashImg: scope.posterImg,
                        url: video.src,
                        buffer:true
                    })
                    Player.play(true); //需要缓存数据
                } else {
                    Player.stop();
                    video.currentTime = 0;
                    scope.previewStatus = 1;
                }
                event.stopPropagation();
                return false;
            }
            /**
             * 初始化播放器，将用户的语音，封面、原视频加载进来
             * @param  {[type]} e     [description]
             * @param  {[type]} data) {                           video.poster [description]
             * @return {[type]}       [description]
             */
            scope.$on('__initVideoPlayer', function(e, data) {
                realAudioUrl = data.realAudioUrl;
                __initPlayer(data);
            });

            function __initPlayer(data) {
                data.url = encodeURI(data.url);
                //1.封面
                if (scope.posterImg != data.videoSplashImg) {
                    scope.posterImg = ImageSvc.getPlayThumb(data.videoSplashImg);
                }
                //2.设置语音文件
                if (Media.getAudio().url != data.userPlayAudio) {
                    Media.resetAudio(); //重置状态
                    Player.releaseResource();
                    Media.setAudioUrl(data.userPlayAudio);
                } else {
                    //播放的语音文件未改变
                }
                //3.视频地址
                /**
                 * 如果视频地址相同，则不需要重新加载
                 * @param  {[type]} video.src [description]
                 * @return {[type]}           [description]
                 */
                if (Media.getVideo().url == data.url) {
                    video.currentTime = 0;
                } else {
                    Media.resetVideo();
                    Media.setVideoUrl(data.url);
                    videoProcess = 0;
                }
                //开始缓存数据
                if(typeof data.buffer!='undefined'&&!data.buffer){ //判断是否使用本地缓存
                    video.src = data.url;
                    video.localPath=data.url;
                    video.load();
                }else{
                    useLocalBuffered=true;
                    Player.bufferData();
                }
            }

            var Constant = {
                notBuffer: 1, //还未开始缓冲数据
                buffering: 2, //正在缓冲数据
                bufferComplete: 3, //缓冲完成,
                bufferError: 4
            }
            var Media = {
                //定义的内部使用的数据
                __data: {
                    video: {
                        url: null,
                        status: Constant.notBuffer
                    },
                    audio: {
                        url: null,
                        status: Constant.notBuffer
                    }
                },
                /**
                 * 获取视频状态数据
                 * @return {[type]} [description]
                 */
                getVideo: function() {
                    return this.__data.video;
                },
                /**
                 * 设置当前的视频状态
                 * @param Constant status 当前的状态
                 */
                setVideoStatus: function(status) {
                    this.__data.video.status = status;
                    return this.__data.video.status;
                },
                /**
                 * 重置视频的状态
                 * @return {[type]} [description]
                 */
                resetVideo: function() {
                    this.__data.video = {
                        url: null,
                        status: Constant.notBuffer
                    }
                },
                /**
                 * 设置视频地址
                 * @param String url 视频文件地址
                 */
                setVideoUrl: function(url) {
                    this.__data.video.url = url;
                },
                /**
                 * 获取语音状态数据
                 * @return {[type]} [description]
                 */
                getAudio: function() {
                    return this.__data.audio;
                },
                /**
                 * 设置当前的语音状态
                 * @param Constant status 当前的状态
                 */
                setAudioStatus: function(status) {
                    this.__data.audio.status = status;
                    return this.__data.audio.status;
                },
                /**
                 * 设置音频地址
                 * @param String url 语音文件地址
                 */
                setAudioUrl: function(url) {
                    this.__data.audio.url = url;
                },
                /**
                 * 重置音频的状态
                 * @return {[type]} [description]
                 */
                resetAudio: function() {
                    this.__data.audio = {
                        url: null,
                        status: Constant.notBuffer
                    }
                },
                /**
                 * 缓存文件功能
                 * @return {[type]} [description]
                 */
                buffer: function(data, callback, processEventCallback) {
                    var $this = this;
                    if (data && null != data.url) {
                        data.status = Constant.buffering;
                        MediaSvc.bufferFile(data.url, function(path) {
                            callback && callback(path);
                        }, processEventCallback)
                    } else {
                        data.status = Constant.bufferError; //缓存过程出现错误
                        //视频地址不存在
                        callback(data.status);
                    }
                },
                /**
                 * 缓存视频文件
                 * @param  {Function} callback [description]
                 * @return {[type]}            [description]
                 */
                bufferVideo: function(callback) {
                    var data = this.__data.video;
                    this.buffer(data, function(path) {
                        data.status = Constant.bufferComplete;
                        data.localPath = path;
                        videoReady();
                        callback && callback(path);
                    }, function(percent,path) {
                        scope.processPercent = (percent * 100).toFixed(1) + "%";
                        if (percent > 0.2&&!data.status!=Constant.bufferComplete) { //大于20%即可以开始播放
                            data.status = Constant.bufferComplete;
                            data.localPath = path;
                            videoReady();
                            callback && callback(path);
                        }

                    });
                },
                /**
                 * 缓存音频文件
                 * @param  {Function} callback [description]
                 * @return {[type]}            [description]
                 */
                bufferAudio: function(callback) {
                    var data = this.__data.audio;
                    this.buffer(data, function(path) {
                        data.status = Constant.bufferComplete;
                        data.localPath = path;
                        callback && callback(path);
                    });
                }
            }

            /**
             * 播放器相关操作
             * @type {Object}
             */
            var Player = {
                status: 0, //当前播放状态，0.未操作过，1.播放，2.暂停，3停止
                audioPlayer: null,
                videoPlayer: null,
                checkStatusInterval: null, //用于检测音视频是否准备完成的定时器
                //创建播放器
                createPlayer: function(audioUrl, videoUrl) {
                    function playSuccessCallback() {
                        console.log('播放成功')
                    }

                    function playErrorCallback(error) {
                        console.log('audio player error', error)
                    }

                    function playStatusCallback(status) {
                        console.log('当前播放器的状态' + status)
                    }
                    if (audioUrl != null) {
                        //创建音频播放器
                        this.audioPlayer = MediaSvc.createAudioPlayer(audioUrl,
                            playSuccessCallback,
                            playErrorCallback,
                            playStatusCallback);
                    } else {
                        //无需创建音频播放器
                    }
                    //视频播放器
                    if (video.src != videoUrl) {
                        video.src = videoUrl;
                    } else {
                        //当前播放视频和传入的URL一致
                    }
                    this.videoPlayer = video;
                },
                play: function(withAudio) {
                    //这里需要来判断文件是否都下载完成了
                    var video = Media.getVideo();
                    var audio = Media.getAudio();
                    var _this = this;
                    scope.loading = true;

                    //1.识别是否有语音需要播放
                    if (withAudio) { //判断是否需要播放语音
                        //1.1判断是否已经有语音播放器了
                        if (_this.audioPlayer != null) {
                            //时间进度同步
                            if (_this.audioPlayer.getDuration() < _this.videoPlayer.currentTime) {
                                //这里不播放了

                            } else {
                                _this.audioPlayer.seekTo(_this.videoPlayer.currentTime * 1000)
                                _this.audioPlayer.play();
                            }
                            _this.videoPlayer.play();
                            scope.loading = false;
                            this.status = 1;
                            scope.videoPlayStatus = Player.status;
                        } else {
                            _this.checkStatusInterval = $interval(function() {
                                //判断是否视频、语音文件已经缓存完毕
                                if (video.status == Constant.bufferComplete &&
                                    audio.status == Constant.bufferComplete) {
                                    //取消循环定时器
                                    $interval.cancel(_this.checkStatusInterval);
                                    //创建播放器
                                    _this.createPlayer(audio.localPath, video.localPath); //创建播放器
                                    //开始播放

                                    _this.status = 1;
                                    scope.videoPlayStatus = _this.status;
                                    _this.videoPlayer.play();
                                    _this.audioPlayer.play();
                                    //取消Loading
                                    $timeout(function() {
                                        scope.showPosterImg = false;
                                        scope.loading = false;
                                    }, 100)
                                } else {
                                    //继续循环检测
                                }
                            }, 100)
                        }
                    } else { //无需播放语音
                        scope.processPercent="加载中";
                        // video.play();
                        //这里需要做一些处理，如果是使用本地缓存技术，则应该判断本地是否已经缓存完毕
                        //如果不是使用本地缓存技术，则需要判断是否加载完毕
                        if(useLocalBuffered){ //使用本地缓存
                            _this.checkStatusInterval = $interval(function() {
                                if (video.status == Constant.bufferComplete) {
                                 // if (true) {
                                    //取消循环定时器
                                    $interval.cancel(_this.checkStatusInterval);
                                    //创建播放器
                                    _this.createPlayer(null, video.url); //创建播放器
                                    _this.videoPlayer.play();
                                    _this.status = 1;
                                    scope.videoPlayStatus = _this.status;
                                    scope.showPosterImg = false;
                                    scope.loading = false;
                                }
                            })
                        }else{ //不使用本地缓存
                            _this.createPlayer(null, video.url); //创建播放器
                            _this.videoPlayer.play();

                            _this.checkCurTmInterval = $interval(function() {
                                console.log("_this.checkCurTmInterval");
                                if(_this.videoPlayer.currentTime > 0) {
                                    videoReady();
                                    scope.loading = false;
                                    $interval.cancel(_this.checkCurTmInterval);
                                }
                            });

                            //开始检测是否已经准备好开始播放了
                            _this.checkStatusInterval = $interval(function() {
                                console.log("_this.checkStatusInterval");
                                console.log(status);
                                if (video.status == Constant.bufferComplete) {
                                    $interval.cancel(_this.checkStatusInterval);
                                    _this.status = 1;
                                    scope.videoPlayStatus = _this.status;
                                    scope.showPosterImg = false;
                                }
                            });
                        }
                    }

                    scope.isShowPlayButton = false;
                },
                pause: function() {
                    video.pause();
                    if (this.audioPlayer != null) {
                        this.audioPlayer.pause();
                    }
                    this.status = 2;
                    scope.videoPlayStatus = Player.status;
                },
                stop: function() {
                    console.log('停止播放。')
                    video.pause();
                    if (this.audioPlayer != null) {
                        this.audioPlayer.pause();
                        this.audioPlayer.seekTo(0);
                        this.audioPlayer.release(); //释放资源
                        this.audioPlayer = null;
                    }
                    this.status = 3;
                    scope.videoPlayStatus = Player.status;
                    scope.previewStatus = 1; //恢复成原音预览
                    scope.isShowPlayButton = true;
                },
                bufferData: function() {
                    //开始缓冲数据
                    //1.缓冲视频文件
                    Media.bufferVideo(function(path) {
                        //得到缓存完成的本地磁盘绝对路径
                        if (video.src != path) {
                            video.src = path;
                            video.load();
                        } else {
                            //当前播放视频和传入的URL一致
                        }
                        video.play();
                        $timeout(function() {
                            if (Player.status != 1) {
                                video.pause();
                                if (video.readyState == 4) {
                                    video.currentTime = 0;
                                } else {
                                    //视频还没有准备好
                                }

                            }
                        }, 100)
                        //2.开始缓存音频文件
                        Media.bufferAudio();
                    });
                },
                /**
                 * 释放资源
                 * @return {[type]} [description]
                 */
                releaseResource: function() {
                    if (this.checkStatusInterval) {
                        $interval.cancel(this.checkStatusInterval);
                        $interval.cancel(this.checkCurTmInterval);
                    }
                    if (this.audioPlayer != null) {
                        this.audioPlayer.stop();
                        this.audioPlayer.release(); //释放资源
                    }
                    // if (this.videoPlayer != null) {
                    //     this.videoPlayer.stop();
                    // }
                }
            }
            var isDetailsPreview = false;
            var audioReady = false;
            //改变播放状态
            scope.changePlayStatusEvent = function() {
                var withAudio;
                if (Media.getAudio().url != null) {
                    withAudio = true;
                } else {
                    withAudio = false;
                }
                switch (Player.status) {
                    case 0:
                        Player.play(withAudio);
                        //需要隐藏正中播放按钮
                        scope.isShowPlayButton = false;
                        break;
                    case 1:
                        Player.pause();
                        break;
                    case 2:
                        Player.play(withAudio);
                        scope.isShowPlayButton = false;
                        break;
                    case 3: //暂未设计停止功能
                        Player.play(withAudio);
                        scope.isShowPlayButton = false;
                        break;
                }
                event.stopPropagation();
                return false;
            }
            /**
             * 播放器触摸事件
             * @return {[type]} [description]
             */
            scope.touchPlayerEvent = function() {
                if (Player.status == 1) {
                    scope.isControllsVisible = !scope.isControllsVisible;
                }
                if (scope.isControllsVisible) { //如果当前是显示的，则默认1S后隐藏
                    $timeout(function() {
                        if (Player.status == 1) {
                            scope.isControllsVisible = false;
                        }
                    }, 5000)
                }
                event.stopPropagation();
                return false;
            }
            scope.rangeTouchEvent = function() {
                event.stopPropagation();
            }
            scope.$on('$destroy', function() {
                console.log('destroy resource');
                Player.releaseResource();
            })
            //读取参数，确认是否显示preview
            if (attrs.isshowpreview && attrs.isshowpreview == 'false') {
                scope.showPreview = false;
                scope.isShowPlayButton = true;
            }
            if (attrs.isedit && attrs.isedit == 'true') { //当前为编辑页面
                scope.isedit = true;
            }
            if(attrs.videoUrl&&attrs.videoUrl!=""){
                __initPlayer({
                    url:attrs.videoUrl,
                    buffer:false,
                    videoSplashImg:attrs.posterUrl
                })
            }
        }

        return {
            restrict: "E",
            link: linker,
            replace: true,
            templateUrl:"templates/directives/video-player.html"
        };

    });