'use strict';
/**
 * 语音相关处理，录音，上传
 * @author  SuperK
 * @link http://www.woaiso.com
 * @date 2015/05/06
 */
rootModule
    .directive('voiceItem', function($compile, $state,Toast,$templateCache, $rootScope, User, $ionicPopup, $interval, $timeout, ENV, $ionicScrollDelegate, UploadSvc) {
        var linker = function(scope, element, attrs) {
            //初始化输入框相关信息
            scope.input = {
                inputMode: 0, //输入模式，0为文字输入，1.为语音输入
                text: '', //
                btnValue: '发送',
                textState: 'nomal', //当前输入的状态，{nomal:'文字未输入状态',focus:'获取焦点',}
                voiceState: ''
            }
            if (attrs.hideVoice) {
                scope.input.hideVoice = true;
            }
            var keyboardVisible = false;
            /**
             * 发送信息
             * @return {[type]}   [description]
             */
            scope.sendEvent = function() {
                var user =  User.userIsLogin();//判断用户是否登录
                if($rootScope.globalUserIsLogin){
                    keyboardVisible = true;
                    $timeout(function() {
                        if (scope.input.text != '') {
                            scope.$emit('send.data', {
                                content: scope.input.text,
                                dotidno: attrs.dotidno,
                                mode: scope.input.inputMode
                            });
                            scope.input.text = '';
                        }
                    }, 2);
                    return false;
                }

            }
            var ele = element[0].querySelector('.sb-input');
            // ele.addEventListener('blur', function(e) {
            //     if (keyboardVisible) {
            //         ele.focus();
            //     }
            // });
            document.body.addEventListener('touchstart', function(e) {
                if (e.srcElement.className.indexOf('sb-send-btn') < 0) {
                    keyboardVisible = false;
                } else {
                    keyboardVisible = true;
                }
            })
            document.body.addEventListener('click', function(e) {
                if (e.srcElement.className.indexOf('sb-send-btn') < 0) {
                    keyboardVisible = false;
                } else {
                    keyboardVisible = true;
                }
            })
            scope.inputMode = 1; //0为文字输入，1.为语音输入
            scope.changeMode = function() {
                //判断输入框是否有内容
                if (scope.sbText && scope.sbText.text != '') {
                    console.log('发送消息', scope.sbText)
                } else {
                    var sbInput = document.querySelector('#sb-input');
                    if (scope.inputMode == 0) {
                        scope.inputMode = 1;
                        angular.element(sbInput).css({
                            top: sbInput.offsetTop - 150 + 'px'
                        })
                    } else {
                        scope.inputMode = 0;
                        angular.element(sbInput).css({
                            top: sbInput.offsetTop + 150 + 'px'
                        })
                    }
                }
            }
            scope.test = function(str, event) {
                console.log(str);
                event.preventDefault();
                return false;
            }
            /********************录音上传开始********************/
            var started = false;
            scope.btnValue = "开始录音";
            scope.sec = 0;
            var media;
            var shouldStop = false;
            var src = "";
            var dotId = -1;
            /**
             * 开始录音方法
             * @return {[type]} [description]
             */
            function recordAudio() {
                var devicePlatform = device.platform;
                console.log(devicePlatform);
                try {
                    src = fullPath + "voicemessage" + new Date().getTime() + ".m4a"; // 定义录音文件
                    media = new Media(src, function() { //初始化录音Media
                        console.log('录音成功!');
                    }, function(err) {
                        console.log('录音失败:' + JSON.stringify(err));
                    });
                    // 开始录音
                    media.startRecord();
                    var intv = $interval(function() {
                        scope.sec += 100;
                        if (shouldStop) {
                            console.log('Stop Record')
                            media.stopRecord();
                            $interval.cancel(intv);
                            //media.release();
                            console.log('释放资源...')
                            //判断是否是有效的录音
                            if(isValidateVoice){
                                UploadSvc.upload(src, {
                                type: '2'
                                }, function(result) {
                                    if (result.success) {
                                        scope.$emit('send.data', {
                                            content: result.data,
                                            dotidno: attrs.dotidno,
                                            mode: scope.input.inputMode,
                                            voiceLength:misls
                                        });
                                    }
                                });
                            }else{
                                //本次录音时间太短了
                            }
                        }
                    }, 100);
                } catch (e) {
                    console.log(e);
                }
            }
            /*******************测试上传功能*******************/
            var uploadEvent = function(filename) {}


            
            scope.startRecord = function() {
                startTime=new Date().getTime(); //开始计时
                isValidateVoice=false; //默认设置本次录音无效
                console.log('touch start ......');
                if (started) {
                    stopRecord();
                } else {
                    scope.sec = 0;
                    shouldStop = false;
                    started = true;
                    recordAudio();
                }
                scope.voiceText="松开 发送";
                scope.input.voiceState="touch";
                scope.showvoicebox = true; //显示录音提示框
                event.preventDefault();
                event.stopPropagation();
                return false;
            }
            scope.holdRecord = function() {
                console.log('drag')
                event.preventDefault();
                event.stopPropagation();
                return false;
            }
            //记录按下了抬起的时间，小于某个值则不发送语音评论
            var startTime=new Date().getTime();
            var isValidateVoice=false;
            var misls=0 //录音时长
            scope.stopRecord = function(dId) {
                misls=parseInt((new Date().getTime()-startTime)/1000);
                if(misls>1){ //大于1S才能发布
                    isValidateVoice=true;
                }else{
                    isValidateVoice=false;
                    Toast.show('多说几个字吧');
                }
                console.log('touch end ......end');
                scope.btnValue = "开始录音";
                dotId = dId;
                setTimeout(function() {
                    shouldStop = true;
                }, 500);
                started = false;
                scope.voiceText="按住 说话";
                scope.input.voiceState="touchend";
                scope.showvoicebox = false;  //隐藏录音提示框
                event.stopPropagation();
                return false;
            }
            scope.moreFun = function() {
                $ionicPopup.alert({
                    title: '更多功能，敬请期待...'
                })
            }
            scope.$watch('input.voiceState', function(newValue, oldValue) {
                scope.voiceText = newValue == 'touch' ? '松开 发送' : '按住 说话';
            })
            /**
             * 打开电信登录页面
             * @return {[type]} [description]
             */
            scope.openLoginPageEvent = function() {
                $state.go('login');//跳转登录页面
                if (typeof LaunchMode != 'undefined') {
                    LaunchMode.log();
                }
            }


        }
        return {
            restrict: "EA",
            link: linker,
            replace: true,
            templateUrl: 'templates/voice-item.html'
        };
    });