'use strict';
/**
 * 语音相关处理，录音，上传
 * @author  SuperK
 * @link http://www.woaiso.com
 * @date 2015/05/06
 */
rootModule
    .directive('voicecommentItem', function($compile,$stateParams,$location, $state,$templateCache,InterfaceSide,Toast,$rootScope, User, $ionicPopup, $interval, $timeout, ENV, $ionicScrollDelegate, UploadSvc) {
        var linker = function(scope, element, attrs) {
            //初始化输入框相关信息
            scope.inputtext = {
                inputMode: 0, //输入模式，0为文字输入，1.为语音输入
                text: '', //
                btnValue: '发送',
                textState: 'nomal', //当前输入的状态，{nomal:'文字未输入状态',focus:'获取焦点',}
                voiceState: '',
            }
            if(attrs.videoid){
              var commentId = attrs.videoid; //被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
              var rootId = attrs.videoid; //评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)

            }else{
              var commentId = $stateParams.id; //被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
              var rootId = $stateParams.id; //评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
            }
            if (attrs.hideVoice) {
                scope.inputtext.hideVoice = true;
            }
            var keyboardVisible = false;
            /**
             * 发送信息
             * @return {[type]}   [description]
             */
            scope.sendEvent = function() {
                var user = User.getCurrentUser();//获取用户信息
                // debugger
                if ($rootScope.globalUserIsLogin) {
                    keyboardVisible = true;
                    if(attrs.dotidno){
                        $timeout(function() {
                            if (scope.inputtext.text != '') {
                                scope.$emit('send.data', {
                                    content: scope.inputtext.text,
                                    dotidno: attrs.dotidno,
                                    mode: scope.input.inputMode
                                });
                                scope.inputtext.text = '';
                            }
                        }, 2);
                    }


                    //2.判断用户是否输入了内容
                    if (scope.inputtext.text != "") {

                        //3.组织数据type, commentId, rootId, themeType, content, deviceId, playTime
                        var type = attrs.typeno; //8标识为乐配评论 0视屏 对谁发表的内容，即谁的评论


                        var themeType = attrs.themetype; //乐配类型
                        var content = scope.inputtext.text; //发送的内容
                        var deviceId = -1; //设备ID，仅在三边观看情况有
                        var playTime = 0; //当前视频播放的时间
                        // console.log(type)
                        // console.log(attrs.typeno)
                        // console.log(commentId+"kjdfjsdkdkjfdfskjdf")
                        //4.将数据发送到服务器
                        if(attrs.isaddcomment=="true"){
                            InterfaceSide.add_theme_talk(type, commentId, rootId, themeType, content, deviceId, playTime).$promise.then(function(result) {
                                if (result.success) {

                                    //4.发送评论数据成功，发送消息
                                    $rootScope.$broadcast(attrs.elementid,{
                                      comment:{
                                        type: type,
                                        comentId: commentId,
                                        rootId: rootId,
                                        content: content,
                                        deviceId: -1,
                                        themeType: type,
                                        playTime: 0,
                                        userId: user.userId,
                                        nickname: user.nickName,
                                        headImg: user.headImg,
                                        commentTime: new Date()
                                    }
                                    })
                                    scope.inputtext.text = ""; //清空输入框
                                    $ionicScrollDelegate.resize();
                                } else {
                                    Toast.show('发送评论失败')
                                }
                            }, function(err) {
                                Toast.show('发送评论失败')
                            })
                        }else{
                        }

                    } else {
                        Toast.show('发送的内容不能为空')
                    }
                } else {
                    Toast.show('请登录后再来吐槽吧！');
                }
            }
            var ele = element[0].querySelector('.sb-input');
            // ele.addEventListener('blur', function(e) {
            //     if (keyboardVisible) {
            //         ele.focus();
            //     }
            // });
            document.body.addEventListener('touchstart', function(e) {
                if (e.srcElement.className.indexOf('sb-send-btn') < 0) {
                    keyboardVisible = false;
                } else {
                    keyboardVisible = true;
                }
            })
            document.body.addEventListener('click', function(e) {
                if (e.srcElement.className.indexOf('sb-send-btn') < 0) {
                    keyboardVisible = false;
                } else {
                    keyboardVisible = true;
                }
            })
            scope.inputMode = 1; //0为文字输入，1.为语音输入
            scope.changeMode = function() {
                //判断输入框是否有内容
                if (scope.sbText && scope.sbText.text != '') {
                    // console.log('发送消息', scope.sbText)
                } else {
                    var sbInput = document.querySelector('#sb-input');
                    if (scope.inputMode == 0) {
                        scope.inputMode = 1;
                        angular.element(sbInput).css({
                            top: sbInput.offsetTop - 150 + 'px'
                        })
                    } else {
                        scope.inputMode = 0;
                        angular.element(sbInput).css({
                            top: sbInput.offsetTop + 150 + 'px'
                        })
                    }
                }
            }
            scope.test = function(str, event) {
                // console.log(str);
                event.preventDefault();
                return false;
            }
            /********************录音上传开始********************/
            var started = false;
            scope.btnValue = "开始录音";
            scope.sec = 0;
            var media;
            var shouldStop = false;
            var src = "";
            var dotId = -1;
            /**
             * 开始录音方法
             * @return {[type]} [description]
             */
            function recordAudio() {
                var devicePlatform = device.platform;
                // console.log(devicePlatform);
                try {
                    src = fullPath + "voicemessage" + new Date().getTime() + ".m4a"; // 定义录音文件
                    // if (devicePlatform == 'Android') {
                    //     src = fullPath + "voicemessage" + new Date().getTime() + ".m4a"; // 定义录音文件
                    // } else if (devicePlatform == 'iOS') {
                    //     src = "voicemessage" + new Date().getTime() + '.m4a';
                    // }
                    media = new Media(src, function() { //初始化录音Media
                        console.log('录音成功!');
                    }, function(err) {
                        console.log('录音失败:' + JSON.stringify(err));
                    });
                    // 开始录音
                    media.startRecord();

                    var intv = $interval(function() {
                        scope.sec += 100;
                        if (shouldStop) {
                            console.log('Stop Record')
                            media.stopRecord();
                            $interval.cancel(intv);
                            //media.release();
                            console.log('释放资源...')
                            if(isValidateVoice){
                                UploadSvc.upload(src, {
                                    type: '2'
                                }, function(result) {
                                    if (result.success) {
                                        if(attrs.dotidno){
                                            scope.$emit('send.data', {
                                                content: result.data,
                                                dotidno: attrs.dotidno,
                                                mode: scope.inputtext.inputMode,
                                                voiceLength:misls
                                            });
                                        }

                                        var user = User.getCurrentUser();//判断用户是否登录
                                        if ($rootScope.globalUserIsLogin ) {
                                            //2.判断用户是否输入了内容
                                            if (result.data != "") {

                                                //3.组织数据type, commentId, rootId, themeType, content, deviceId, playTime
                                                var type = attrs.typeno; //8标识为乐配评论 0视屏 对谁发表的内容，即谁的评论


                                                var themeType = attrs.themetype; //乐配类型
                                                var content = '{"voice":"' + result.data + '","voiceLength":"'+misls+'"}'; //发送的内容
                                                var deviceId = -1; //设备ID，仅在三边观看情况有
                                                var playTime = 0; //当前视频播放的时间
                                                // console.log(type)
                                                // console.log(attrs.typeno)
                                                // console.log(commentId+"kjdfjsdkdkjfdfskjdf")
                                                //4.将数据发送到服务器
                                                if(attrs.isaddcomment=="true"){
                                                    InterfaceSide.add_theme_talk(type, commentId, rootId, themeType, content, deviceId, playTime).$promise.then(function(result) {
                                                        if (result.success) {
                                                            //4.发送评论数据成功，发送消息
                                                            $rootScope.$broadcast(attrs.elementid,{
                                                              comment:{
                                                                type: type,
                                                                comentId: commentId,
                                                                rootId: rootId,
                                                                content: content,
                                                                deviceId: -1,
                                                                themeType: type,
                                                                playTime: 0,
                                                                userId: user.userId,
                                                                nickname: user.nickName,
                                                                headImg: user.headImg,
                                                                commentTime: new Date()
                                                            }
                                                            })
                                                            scope.inputtext.text = ""; //清空输入框
                                                            $ionicScrollDelegate.resize();
                                                        } else {
                                                            Toast.show('发送评论失败')
                                                        }
                                                    }, function(err) {
                                                        Toast.show('发送评论失败')
                                                    })
                                                }else{

                                                }
                                            } else {
                                                Toast.show('发送的内容不能为空')
                                            }
                                        } else {
                                            Toast.show('请登录后再来吐槽吧！');
                                        }
                                    }
                                });
                            }
                            //停止录音
                        }
                    }, 100);
                } catch (e) {
                    console.log(e);
                }
            }
            /*******************测试上传功能*******************/
            var uploadEvent = function(filename) {}
            scope.startRecord = function() {
                startTime=new Date().getTime(); //开始计时
                isValidateVoice=false; //默认设置本次录音无效
                console.log('touch start ......');
                if (started) {
                    stopRecord();
                } else {
                    scope.sec = 0;
                    shouldStop = false;
                    scope.btnValue = "停止录音";
                    started = true;
                    recordAudio();
                }
                scope.voiceText="松开 发送";
                scope.inputtext.voiceState="touch";
                scope.showvoicebox = true;   //录音提示框
                event.preventDefault();
                event.stopPropagation();
                return false;
            }
            scope.holdRecord = function() {
                console.log('drag')
                event.preventDefault();
                event.stopPropagation();
                return false;
            }
            //记录按下了抬起的时间，小于某个值则不发送语音评论
            var startTime=new Date().getTime();
            var isValidateVoice=false;
            var misls=0 //录音时长
            scope.stopRecord = function(dId) {
                misls=parseInt((new Date().getTime()-startTime)/1000);
                if(misls>1){ //大于1S才能发布
                    isValidateVoice=true;
                }else{
                    isValidateVoice=false;
                    Toast.show('多说几个字吧');
                }
                console.log('touch end ......end');
                scope.btnValue = "开始录音";
                dotId = dId;
                setTimeout(function() {
                    shouldStop = true;
                }, 500);
                started = false;
                scope.voiceText="按住 说话";
                scope.inputtext.voiceState="touchend";
                scope.showvoicebox = false;   //隐藏录音提示框
                event.stopPropagation();
                return false;
            }
            scope.moreFun = function() {
                $ionicPopup.alert({
                    title: '更多功能，敬请期待...'
                })
            }
            scope.$watch('inputtext.voiceState', function(newValue, oldValue) {
                console.log(newValue,oldValue)
                scope.voiceText = newValue == 'touch' ? '松开 发送' : '按住 说话';
            })
            /**
             * 打开电信登录页面
             * @return {[type]} [description]
             */
            scope.openLoginPageEvent = function() {
                $rootScope.$broadcast("closeModal",{"data":true})
                $state.go('login');//跳转登录页面
                if (typeof LaunchMode != 'undefined') {
                    LaunchMode.log();
                }
            }
            if(attrs.isfixedbottom=="true"){
                element[0].setAttribute('style','display:block;');
            }else{
                // 监听页面滚动事件,控制页面的显示和隐藏
                var eventname = attrs.elementid;
                scope.$on(eventname,function(e,data){
                    if(data.status){
                      element[0].setAttribute('style','display:block;');
                    }else{
                      element[0].setAttribute('style','display:none;');
                      element[0].querySelector(".commenttext").value = ""
                    }


                })
            }


        }
        return {
            restrict: "EA",
            link: linker,
            replace: true,
            templateUrl: 'templates/voicecomment-item.html'
        };
    });