'use strict';
/**
 * @author Vivian
 * @desc 用于电信登陆接口对接
 * @date 2015/07/09
 **/
rootModule
    .factory('dianxinLogin', function(User, Storage, TV, $location, $ionicLoading, $state, Toast) {
        // var phoneNum = GLOBAL_ASSIGN_PHONE;
        var pwd = 123456;
        var verifyCode = "-1";
        var itVid = GLOBAL_ASSIGN_ITVID;
        var username = 'scdx' + GLOBAL_ASSIGN_ITVID;

        //检测帐号如果不存在立即注册并登录,存在则登陆
        function check() {
            if (itVid != '' && pwd != '') {
                User.signup(username, verifyCode, pwd).$promise.then(function(result) {
                    var user = {
                        username: username,
                        password: pwd
                    }
                    login(user);
                })
            }
        }

        //登陆
        function login(user) {
            User.login(user.username, user.password).$promise.then(function(result) {
                if (result.success) {
                    User.get_user_info().$promise.then(function(data) {
                        if (data.success) {
                            bindingDevice(function(result) {
                                if (data.data.nickname && data.data.nickname != '') {
                                    $state.go('tab.tv');
                                } else {
                                    $state.go('full_info');
                                    return;
                                }
                            })

                        } else {
                            console.log('获取用户信息失败');
                        }
                    });
                } else {
                    console.log('登录失败')
                }
            })
        }

        //绑定设备
        function bindingDevice(_callback) {
            TV.add_device({
                deviceCode: itVid,
                type: 1
            }).$promise.then(function(data) {
                if (data.success) {
                    //return true;
                } else {

                }
                _callback && _callback(data);
            })
        }
        return {
            loginAPP: function() {
                check();
            }
        }





    })

.factory('toupinLogin', function(User, Toast,Storage, TV, InterfaceSide, $location, $ionicLoading, $state,$ionicPopup) {
    var deviceCode;
    return {
        check: function(itvId, verifyCode, pwd,scope) {
            //判断账户是否存在
            if (itvId != null && itvId != 'undefined'&&itvId!='testott1') {
                deviceCode = itvId;
                User.signup("scdx" + itvId, verifyCode, pwd).$promise.then(function(result) {
                    var user = {
                        username: "scdx" + itvId,
                        password: pwd
                    }
                    login(user,scope);
                })
            }else{
                //处理用户未登录情况
                User.logout();
            }
        }
    }

    function login(user,scope) {
        User.login(user.username, user.password).$promise.then(function(result) {
            if (result.success) {
                User.get_user_info().$promise.then(function(data) {
                    if (User.getCurrentUser().nickName == '') {
                        scope.user={}
                        $ionicPopup.show({
                            title: '设置一个昵称吧',
                            template: '<input ng-model="user.nickName" type="text" placeholder="请输入用户昵称">',
                            scope: scope,
                            buttons: [{
                                text: '取消'
                            }, {
                                text: '确定',
                                onTap: function(e) {
                                    $ionicLoading.show();
                                    var user = User.getCurrentUser();
                                    user.nickName = scope.user.nickName;
                                    User.update_user_info(user,function(){
                                        Toast.show('设置成功！');
                                        $ionicLoading.hide()
                                    });
                                }
                            }]
                        });
                    }
                    if (data.success) {
                        bindingDevice(function(result) {
                            console.log("绑定成功");
                        })
                    } else {
                        console.log('获取用户信息失败');
                    }
                });
            } else {
                console.log('登录失败')
            }
        })
    }

    //绑定设备
    function bindingDevice(_callback) {
        InterfaceSide.add_scdx_device(deviceCode).$promise.then(function(data) {
            console.log(data);
            if (data.success) {
                //return true;
            } else {

            }
            _callback && _callback(data);
        })
    }

})