'user strict';
/**
 * @description 数据管理服务
 */
rootModule
    .factory('HttpInterceptor', function($rootScope, $q, $injector, $location, $window, Toast, Storage, NetWork, ENV) {
        return {
            'request': function(config) {
                //这里加入一个默认的参数APPID
                //这里判断API列表内是否
                var addAPPID=false;
                if(ENV.servers){
                    for(var server in ENV.servers){
                        if(config.url.indexOf(ENV.servers[server])>-1&&config.url.indexOf("user/appid")==-1){
                            addAPPID=true;
                            break;
                        }else{
                            //不包含
                        }
                    }
                }
                if (addAPPID) {
                    //第一步判断Method
                    if (config.method == "GET") {
                        if(typeof config.params !="undefined"){
                            config.params.appId=ENV.APPID;
                        }else{
                            config.params={
                                appId:ENV.APPID
                            }
                        }
                    } else if (config.method == "POST") {
                        if (config.data != null) {
                            config.data = config.data + "&appId=" + ENV.APPID;
                        } else {
                            config.data = "appId=" + ENV.APPID
                        }
                    }
                }
                //config.timeout=5000;
                if (!NetWork.isValidateNetWork() && typeof netWorkStateInfo != 'undefined' && netWorkStateInfo.online == "false") {
                    if (config.url.indexOf(".html") > -1) {} else {
                        config = NetWork.httpRequestOrResponseERROR(config);
                        //                        console.log("config_testing",config);
                        //                        return $q.reject("netWorkError");//主动设置拒绝
                    }
                }
                return config;
            },

            'requestError': function(rejection) {
                debugger;
                //                if (rejection === 'injectForMe') {
                // Recover the request
                //                }
                return $q.reject(rejection);
            },
            'response': function(response) {
                window.responseError = "none";
                try {
                    if (response && response.data.code == 41007) {
                        console.log('用户未登录...');
                        
                    }
                } catch (e) {

                }
                return response;
            },

            'responseError': function(rejection) {
                //对URL进行匹配，直接返回本地数据
                //                console.log("responseError", rejection);
                //                $q.defer().notify(rejection);
                try {
                    if (responseError == "none" && rejection.status === 0) {
                        console.log("连接服务器超时");
                        window.responseError = "true";
                        return rejection;
                    } else if (responseError == "none" && rejection.status === 500) {
                        console.log("服务器开小差啦!");
                        Toast.show('服务器开小差啦！');
                        window.responseError = "true";
                        return rejection;
                    }
                } catch (e) {}

                try {
                    if (rejection.data == null) {
                        rejection.data = {
                            Identification: rejection.config.Identification
                        };
                    } else {
                        rejection.data.Identification = rejection.config.Identification;
                    }
                } catch (e) {}
                return rejection;
            }
        };
    })