'use strict';
/**
 * @author SuperK
 * @desc 用于打点信息的相关操作
 * @date 2015/05/15
 **/
rootModule
    .factory('InterfaceDotInfo', function(InterfaceSide, UUID, ENV, Storage, $sce,$rootScope) {
        var sotrage_pref = "videoId_" + ENV.version;
        var Side = InterfaceSide;
        var localDots, shownDots, sideScope; //
        var videoThemeList = [];
        var defaultDot;
        var watchId;
        var anwsers = [];//三边公布的答案


        /**
         * 初始化打点相关方法
         * @param  {[type]}
         * @param  {[type]}
         * @return {[type]}
         */
        function __init(scope, watchType, videoId, startTime, endTime, callback, $rootScope) {
            localDots = [];
            shownDots = [];
            anwsers = [];
            sideScope = scope;
            scope.dots = [];
            watchId = videoId;
            if (!scope.$$phase) {
                scope.$apply();
            }
            defaultDot = {
                uuid: UUID.newuuid(), //唯一的ID，每个主题
                dotId: watchId, //评论ID
                timePoint: 0, //当前时间点
                hasShow: false,
                visible: false, //是否正在显示,
                inputMode: 0,
                handShow: true,
                type: -1,
                isTop: 2,
                /**
                 * 当前的状态 默认'item-nomal'
                 * @type {String} 'item-nomal':常规显示，背景为白色，透明度为1, 默认值
                 *                'item-show' :模块在最前端显示，背景色为白色，带有投影效果，透明度为1
                 *                'item-hide' :模块在最下端显示，背景色为浅灰色，透明度为0.4 无投影效果
                 */
                status: 'item-nomal',
                userStatus: 1, //当前主题的状态，1.默认值，2.高亮
                videoId: watchId
            }
            sideScope.dot = defaultDot;
            localDots.push(defaultDot);
            __getDotInfoList(watchType, watchId, startTime, endTime, callback);
        }
        //控制页面每行显示视频个数
        var filterData = function(data, column) {
                var tempData = [];
                for (var i = 0; i < data.length; i++) {
                    var index = parseInt(i / column);
                    if (i % column == 0) {
                        tempData[index] = [];
                    }
                    var temp = data[i];
                    //做一个转换操作
                    tempData[index].push(temp);
                }
                return tempData;
            }
            /**
             * 获取
             * @param  {[type]}
             * @param  {[type]}
             * @param  {Function}
             * @return {[type]}
             */
        function __getDotInfoList(watchType, watchId, startTime, endTime, callback) {

            // videoThemeList = Storage.get(sotrage_pref + watchId);
            // // if (videoThemeList && videoThemeList != null) {
            //     localDots=videoThemeList;
            //     callback && callback(videoThemeList);
            // } else {
            // Side.select_dot_info(watchType, watchId, startTime, endTime, 0).$promise.then(function(result) {
            var longitude=$rootScope.userlocation.locations.longitude;
            var latitude=$rootScope.userlocation.locations.latitude;
             Side.selectPointInfo(0, watchId,longitude,latitude).$promise.then(function(result) {
                if (result.success) {
                    //解析数据，对数据进行分类
                    if (result.data && result.data.length > 0) {
                        //对数据进行过滤
                        localDots = [];
                        //默认增加一个评论模块
                        localDots.push(defaultDot);
                        // console.log(result.data)
                        angular.forEach(result.data, function(it, index) {
                                it.type = parseInt(it.themeType);
                                if (it.type == 2 || it.type == 5) {//mark
                                    if(it.type==5){
                                        it.choiceType = it.guessing.choiceType;
                                        it.choice = it.guessing?it.guessing.choiceList:[];
                                    }else if(it.type==2){
                                        it.choiceType = it.vote.choiceType;
                                        it.choice = it.vote?it.vote.choiceList:[];
                                        //debugger
                                        it.choice.isTrue = NaN?0:it.choice.isTrue;
                                    }

                                    if (it.choice&&it.choice.length>0) {
                                        for (var i = 0; i < it.choice.length; i++) {
                                            //hasnot表示未投票，own表示自己投的票，others表示单选状态时，另一个选项的颜色
                                            it.choice[i].isTrue=parseInt(it.choice[i].isTrue);
                                            it.choice[i].status = it.choice[i].isrepeation == "1" ? 1 : 0;
                                        }
                                    }


                                }
                                //这里来解析数据
                                //1.解析标题数据，主要处理商品的标题
                                if (it.type == 3) { //商品的标题来源于content
                                    var title = "";
                                    if (it.content && it.content.length > 0) {
                                        var tempItem = it.content[0];
                                        title = getDesc(tempItem, false);
                                    } else {
                                        title = "未定义";
                                    }
                                    it.title = title;
                                } else if (it.type == 10 || it.type == 4 || it.type == 1) { //2.处理所有的content，10，简介,4.知识点
                                    //生成内容
                                    var tempDesc = "";
                                    if (it.content && it.content.length > 0) {
                                        var tempItem = it.content[0];
                                        var t = getDesc(tempItem, false);
                                        tempDesc = t;
                                    } else {
                                        tempDesc = "未定义";
                                    }
                                    it.desc = tempDesc;

                                    var content = createAllContent(it);
                                    it.allContent = content;
                                }
                                var newItem = angular.extend({
                                    uuid: UUID.newuuid(), //唯一的ID，每个主题
                                    dotId: it.motiveId, //主题ID
                                    timePoint: parseInt(it.timePoint), //当前时间点
                                    hasShow: false,
                                    visible: false, //是否正在显示,
                                    // handShow:true,
                                    status: 'item-nomal',
                                    isTop: it.top,
                                    videoId: watchId,
                                    userStatus: it.top == 1 ? 2 : 1
                                }, it);
                                if (newItem.type == 10) { //简介
                                    newItem.visible = true;
                                }
                                //初始化部分页面用到的数据
                                localDots.push(newItem);
                        });
                        //根据时间排序
                        localDots = localDots.sort(function(a, b) {
                            return a.timePoint - b.timePoint;
                        });
                        var dotInfoList = {
                            videoId: watchId,
                            list: localDots
                        }

                        //从dotlist里面提取出微博形式要展示的文字和图片
                        angular.forEach(localDots, function(dot) {
                            if (dot.type == 3) { //商品提取出图片链接
                                var imgList = [];
                                dot.goodsList = dot.commodity;
                                angular.forEach(dot.commodity, function(good) {
                                    imgList.push(good.image)
                                });
                                dot.imgList = filterData(imgList, 3);
                                dot.descContent = dot.title;
                            } else if (dot.type == 10 || dot.type == 1 || dot.type == 4) {
                                var imgList = [];
                                var imgstr = dot.allContent;
                                var descstr = dot.allContent;
                                var deschtml = angular.element(descstr);
                                //根据一定的字数要求提取文本内容
                                if (deschtml.length > 0) {
                                    if (dot.type == 1) { //为话题时候，只有一段
                                        var texta = deschtml[0].innerText;
                                    } else {

                                        //当长度为一

                                            if(deschtml[0].innerText.length>100){
                                                var texta = deschtml[0].innerText;
                                            }else if(deschtml.length>1){
                                                var texta = deschtml[0].innerText + deschtml[1].innerText;
                                            }
                                            else{
                                                var texta = deschtml[0].innerText;
                                            }

                                       // var texta = deschtml[0].innerText;
                                        if (texta.length > 60) {
                                            texta = texta.slice(0,60)
                                        }
                                    }
                                }
                                var imgres = imgstr.match(/(?=[^_]src=("|')http)[^<>]+?\.(jpg|png|gif)(?=("|')[^<>]*>)/gi);
                                angular.forEach(imgres, function(src) {
                                    if (/"/.test(src)) {
                                        imgList.push(src.split('"')[1])
                                    } else if (/'/.test(src)) {
                                        imgList.push(src.split("'")[1])
                                    }

                                })

                                dot.descContent = texta;
                                dot.imgList = filterData(imgList, 3); //没有图片时返回空格数组
                                dot.allimgList = [];
                                angular.forEach(imgList,function(item){
                                    dot.allimgList.push({"url":item});
                                })
                                // console.log(dot.allimgList)
                            } else if (dot.type == 5 || dot.type == 2) {

                                if(dot.choice&&dot.choice.length>0){
                                    if(dot.choiceType==2){
                                        // debugger
                                        var temp = {"type":dot.type,
                                                    "choice":[],
                                                    "title":dot.title,
                                                    "choiceType":dot.choiceType}
                                        angular.forEach(dot.choice,function(item){
                                            if(item.isTrue==1){
                                                temp.choice.push(item.content)
                                            }
                                        })
                                        if(temp.choice.length>0){
                                            anwsers.push(temp)
                                        }
                                    }else{
                                        angular.forEach(dot.choice,function(item){
                                            if(item.isTrue==1){
                                                var temp = {"type":dot.type,
                                                            "choice":[item.content],
                                                            "title":dot.title,
                                                            "choiceType":dot.choiceType}
                                                anwsers.push(temp)
                                            }
                                        })
                                    }

                                }else{

                                        var temp = {"type":dot.type,

                                                    "choice":"暂未公布答案",

                                                    "title":dot.title}
                                        anwsers.push(temp)
                                }


                                dot.descContent = dot.title;
                                dot.imgList = [];
                            }
                        })
                        // console.log(localDots); //mark
                        // debugger
                        // console.log(anwsers); //mark
                        //Storage.set(sotrage_pref + watchId, localDots);
                    }
                } else {
                    console.error('加载打点信息失败');
                }
                callback && callback(localDots);
            });
            // }

        }
        /**
         * 创建详情需要的Content数据
         */
        function createAllContent(it) {
            var content = "";
            if (it.content && it.content.length > 0) {
                angular.forEach(it.content, function(_item) {
                    content += "<span>" + getDesc(_item, true) + "</span>";
                });
            } else {
                content = "未定义";
            }
            return content;
        }

        function getDesc(item, withSce) {
            var title = "";
            item.type = parseInt(item.type);
            switch (item.type) {
                case 0: //文本
                    title = item.data;
                    break;
                case 1: //图片
                    title = "<img src='" + item.data + "'>"
                    break;
                case 2: //未定义
                    title = "未定义";
                    break;
                case 3: //富文本编辑器内容
                    title = contentDecode(item.data, withSce);
                    break;
                default:
                    title = "未定义";
                    break;
            }
            return title;
        }


        function contentDecode(value, withSce) {
            try {
                value = decodeURIComponent(value);
                value = value.replaceAll("\\\"", "\"");
                if (withSce) {
                    value = $sce.trustAsHtml(value);
                }
            } catch (e) {

            }
            return value;
        }

        String.prototype.replaceAll = function(s2, s3) {
            var r = new RegExp(s2.replace(
                /([\(\)\[\]\{\}\^\$\+\-\*\?\.\"\'\|\/\\])/g, "\\$1"), "ig");
            return this.replace(r, s3);
        }

        function extractContent(contentList) {

        }

        //获得choice标志
        // function getchoice(){
        //     va__getDotInfoList(watchType, watchId, callback);
        // }
        /**
         * 根据时间查询打点信息,这里需要注意如果中途时间被拖动过，不需要重新显示，并且，把之前没显示的打点信息直接显示
         * @param  {[type]} time [description]
         * @return {[type]}      [description]
         */
        function __getShownDotsByTime(time) {
            var dots = [];
            if (localDots && localDots.length > 0) {
                angular.forEach(localDots, function(item, index) {
                    //当前$scope里是否已经有了，
                    var hasDump = false;
                    angular.forEach(sideScope.dots, function(scopeDotItem) {
                        if (scopeDotItem.uuid == item.uuid) {
                            hasDump = true;
                            return false;
                        }
                    })
                    if (!hasDump && parseInt(item.timePoint) - time <= 0 && item.videoId == watchId) {
                        dots.push(item);
                    }
                    // if (parseInt(item.timePoint) - time < ENV.timeRange && parseInt(item.timePoint) - time > 0) { //正负三秒内的取出来
                    //     dots.push(item);
                    //     item.hasShow = true;
                    //     return false;
                    // }
                    // //将之前未显示的内容直接显示
                    // if (!item.hasShow && time > item.timePoint) { //表示视频已经播放过了。
                    //     dots.push(item);
                    //     item.hasShow = true;
                    // }
                });
                //将最后一个商品给设置为默认展开
                // if(dots&&dots.length>0){
                //     for(var i=0;i<dots.length;i++){
                //         var item=dots[dots.length-1-i];
                //         if(item.type==3){
                //             item.visible=true;
                //             item.status='item-show';
                //             break;
                //         }
                //     }
                // }
            }
            return dots;
        }

        /**
         * 根据UUID获取打点信息
         * @param  {[type]} dotId [description]
         * @return {[type]}       [description]
         */
        function __getDotByUUID(uuid) {
            var dot;
            angular.forEach(localDots, function(item, index) {
                if (uuid == item.uuid && item.videoId == watchId) {
                    dot = item;
                    return false;
                }
            });
            return dot;
        }

        return {
            init: function(scope, watchType, watchId, startTime, endTime, callback) {
                __init(scope, watchType, watchId, startTime, endTime, callback);
                return this;
            },
            getShownDotsByTime: function(currentTime) {
                return __getShownDotsByTime(currentTime);
            },
            getDotByUUID: function(uuid) {
                return __getDotByUUID(uuid);
            },
            getShownDots: function() {
                return sideScope.dots;
            },

            getLastShownDot: function() {
                var dot = null;
                if (sideScope.dots && sideScope.dots.length > 0) {
                    dot = sideScope.dots[sideScope.dots.length - 1];
                }
                return dot;
            },
            createAllContent:function(dotInfo){
                return createAllContent(dotInfo)
            },
            getActivityAnwsers:function(){
                return anwsers;
            },
            getMovieGoods:function(type, watchId,longitude,latitude,approvedStatus,callback){
                /**查询商品信息**/
                Side.selectPointInfo(type, watchId,longitude,latitude,approvedStatus).$promise.then(function(result) {
                    if (result.success) {
                        //解析数据，对数据进行分类
                        var movieGoods = [];//电影相关商品推荐
                        var title;
                        if (result.data && result.data.length > 0) {

                            angular.forEach(result.data, function(it, index) {
                                if (it.content && it.content.length > 0) {
                                    var tempItem = it.content[0];
                                    title = getDesc(tempItem, false);
                                } else {
                                    title = "未定义";
                                }
                                it.title = title;
                                var imgList = [];
                                it.goodsList = it.commodity;
                                angular.forEach(it.commodity, function(good) {
                                    imgList.push(good.image)
                                });
                                it.imgList = filterData(imgList, 3);
                                it.descContent = it.title;
                                it.type = parseInt(it.themeType);
                                if(it.type == 3){
                                    movieGoods.push(it)
                                }
                            })
                        }
                        callback && callback(movieGoods);return;
                    }
                })
            },
            getDesc:function(item, withSce){
                return getDesc(item, withSce)
            }
        }


    })