'use strict';
/**
 * @author SuperK
 * @desc 用于电影数据处理服务
 * @date 2015/12/30
 **/
rootModule
    .factory('MovieServe', function(Movies,InterfaceDotInfo,Toast,$rootScope) {

        function __getLastSence(type,callback){
            //查询场景列表
            Movies.getSenceList(type,function(result){
              debugger
              if(result.data&&result.data.scenes.length>0){

                var currentD = new Date;
                var c_year = currentD.getFullYear();
                var c_month = currentD.getMonth() + 1;
                var c_day=currentD.getDate();
                var currentT = currentD.getHours()*3600 + currentD.getMinutes()*60 + currentD.getSeconds();


                angular.forEach(result.data.scenes,function(item){
                  item.bigtime = item.realtime.split(" ")[0].split("-");
                  if(item.bigtime[0]-c_year==0 && item.bigtime[1]-c_month==0&&item.bigtime[1]-c_day==0){
                    item.smalltime = item.realtime.split(" ")[1];
                    item.timelist=item.smalltime.split(":");
                    item.showT = parseInt(item.timelist[0])*3600 + parseInt(item.timelist[1])*60 + parseInt(item.timelist[2]);
                  }
                })
              }
              callback && callback(result.data.scenes);
            })

        }
        //将数组搞成二维数组，column子数组的长度
        var filterData = function (data, column) {
            var tempData = [];
            if(data.length>0){
              for (var i = 0; i < data.length; i++) {
                  var index = parseInt(i / column);
                  if (i % column == 0) {
                      tempData[index] = [];
                  }
                  var temp = data[i];
                  // switchDesign(temp);
                  tempData[index].push(temp);
              }
            }
            return tempData;
        }
        //乐配type转换
        var switchDesign = function(temp){
           //做一个转换操作
           switch (temp.recreationType) {
               case "1":
                   temp.recreationTypeText = "video";
                   temp.img = temp.content.videoSplashImg;
                   break;
               case "2":
                   temp.recreationTypeText = "head";
                   temp.img = temp.content.resultImg;
                   break;
               case "3":
                   temp.recreationTypeText = "text";
                   temp.img = temp.content.imgSrc
                   break;
           }
        }
        //转换时间
        function checkTime(i)
        {
        if (i<10)
          {i="0" + i}
          return i
        };
        /**
         * @author SuperK
         * @desc 初始化电影详情页面相关数据
         * @date 2015/12/30
        **/
        function __init(vid, callback) {
          var allDetailList = {"success":false};
          var entertainmentOthervideo = [];
          var threeEntertainments = [];
          var movieDetailResult = [];
          // debugger
          getMovieDetail(vid,function(detailResult){
            if(detailResult!=null){
              movieDetailResult = detailResult;
              var vId = vid;
              Movies.getEntertainmentOthervideo(vId,function(result){ //查询其他影片的娱乐推荐
                  if(result.data && result.data.resultList.length > 0){
                      var resultList=[];
                      angular.forEach(result.data.resultList,function(data,index,array){
                        if(data.content!=""){
                            data.content = JSON.parse(data.content)//地址信息
                        }
                        switchDesign(data) //转换
                        // resultList[index]=data;
                        entertainmentOthervideo.push(data)
                      });
                      Movies.getEntertainmentOther(vId,function(result){ //查询影片的其他娱乐推荐
                          if(result.data && result.data.resultList.length > 0){
                              angular.forEach(result.data.resultList,function(item){
                                item.content = JSON.parse(item.content);
                                switchDesign(item); //转换
                              })
                              // entertainmentOther = result.data.resultList;
                              threeEntertainments   =  getThreeEntertainments(result.data.resultList); //获取三种娱乐成果各一个
                              entertainmentOthervideo = result.data.resultList.concat(entertainmentOthervideo)
                          } else{
                              // Toast.show("没有更多数据了")
                              console.log("没有更多数据了")
                          }
                          entertainmentOthervideo=filterData(entertainmentOthervideo,2);
                          allDetailList = {"detailInfo":movieDetailResult,"entertainmentOthervideo":entertainmentOthervideo,
                          "threeEntertainments":threeEntertainments,"success":true};
                          callback && callback(allDetailList)
                      });
                      // console.log(result)
                  } else{
                      allDetailList = {"detailInfo":detailResult}
                      // Toast.show("没有更多数据了")
                      callback && callback(allDetailList)
                      console.log("没有更多数据了")
                  }

              });
            }else{
              //未查到电影详情的数据
              allDetailList = {"success":false}
              callback && callback(allDetailList)
            }
          })
        }
        /**
        * @author SuperK
        * @desc 查询视频二级显示的详情
        * @date 2015/12/30
        **/
        function getMovieDetail(vid,callback){
          var movieinfo; //电影详情页显示的信息
          Movies.getVideoDetails(vid,function(result){ //查询视频二级显示的详情
              if(result.success){
                  //放置视频信息
                  result.data.topPoster = {"url":result.data.img}
                  result.data.releaseTime = result.data.releaseTime / 60;
                  var regvideo = /\.(mp4)$/i;
                  var allposterlength = result.data.posters.length + result.data.featuresVOs.length;
                  var imglength= 0
                  angular.forEach(result.data.posters,function(item){
                    if(regvideo.test(item.url)){
                      item.posterurl = "http://resource.handsight.com.cn/TVHelp01/img/upload/1449555795291_2145.jpg";
                      item.isImg = false;   //视频
                      item.imgtype = "featureimg"
                    }else{
                      imglength++
                      item.posterurl = item.url
                      item.isImg = true;
                      item.imgtype = "movieimg"
                    }
                  });
                  angular.forEach(result.data.featuresVOs,function(item){
                    item.posterurl = item.coverImgUrl;
                    item.isImg = false;
                    item.imgtype = "featureimg"
                    // $scope.isImg = item.isImg;
                  })
                  result.data.movieFeature = result.data.posters.concat(result.data.featuresVOs);
                  result.data.allmovieFeature = result.data.movieFeature;
                  result.data.movieFeature = filterData(result.data.movieFeature,3)
                  result.data.vediolength = allposterlength - imglength;
                  result.data.imglength = imglength;
                  movieinfo = result.data;
                  callback && callback(movieinfo)
              } else{
                  // Toast.show("没有更多数据了");
                  movieinfo = null
                  console.log("没有更多数据了");
                  callback && callback(movieinfo)
              }

          });
          // callback && callback(movieinfo)
        }
        /**
        * @author SuperK
        * @desc 将时间转化成显示时间
        * @date 2015/12/30
        **/
        function filterPlayTime(item){
          item.startShowDate = new Date(item.starttime.replace(/-/g,"/"));
          item.endShowDate = new Date(item.endtime.replace(/-/g,"/"));
          var hour = checkTime(item.startShowDate.getHours());
          var minute = checkTime(item.startShowDate.getMinutes());
          item.showstarttime = hour + ":" + minute;
        }
        /**
        * @author SuperK
        * @desc 获取一定格式的开始和结束时间相对今天
        * @date 2015/12/30
        **/
        function getNiceTime(adate,type){
          var Smonth = checkTime(parseInt(adate.getMonth() + 1));
          var Sday = checkTime(parseInt(adate.getDate()));
          var year = adate.getFullYear();
          var hour = checkTime(adate.getHours());
          var minute = checkTime(adate.getMinutes());
          var second = checkTime(adate.getSeconds());
          if(type == 0){//0,要年份
            var starttime = year + "-"+Smonth+"-"+Sday+" "+hour+":"+minute+":"+second;//"2015-01-14 13:20:00"
          }else if(type == 1){//0,不要年份
            var starttime = Smonth+"-"+Sday+" "+hour+":"+minute;//"01-14 13:20"
          }else if(type == 2){
            var starttime = (parseInt(adate.getMonth())+1)+"月"+adate.getDate()+"日"+" "+hour+":"+minute;
          }else if(type == 3){//0,不要年份
            var starttime = year + Smonth +Sday;//"20150114"
          }
          return starttime;
        }
        /**
        * @author SuperK
        * @desc 获取一定格式的开始和结束时间相对今天
        * @date 2015/12/30
        **/
        function getAtime(startNo,endNo){
          var currentD = new Date();
          var startDay = new Date();
          var endDay = new Date();
          startDay.setDate(currentD.getDate() - parseInt(startNo));
          endDay.setDate(currentD.getDate() + parseInt(endNo));
          var starttime = getNiceTime(startDay,0);
          var endtime = getNiceTime(endDay,0);//0,要年份
          var time = {"starttime":starttime,"endtime":endtime}
          return time;
        }
        /**
        * @author SuperK
        * @desc 判断时间今天明天后天
        * @date 2015/12/30
        **/
        function filterInDay(list){
          var currentDay = new Date().getDate();
          var currentDate = new Date();
          var yestodayDate = new Date();
          var tomorrowDate = new Date();
          var twodaybeforeDate = new Date();
          var yesterDay = new Date(yestodayDate.setDate(yestodayDate.getDate()-1)).getDate();
          var twodaybeforeDay = new Date(twodaybeforeDate.setDate(twodaybeforeDate.getDate()-2)).getDate();
          var tomorrowDay = new Date(tomorrowDate.setDate(tomorrowDate.getDate()+1)).getDate();

          angular.forEach(list,function(item,index){
            var startDate = new Date(item.programsInDate.replace(/-/g,"/"));
            var startDay = startDate.getDate();
            if(startDay == yesterDay){
              item.status = 1;//昨天
            }else if(startDay == tomorrowDay){
              item.status = 3 //明天
            }else if(startDay == currentDay){
              item.status = 2 //今天
            }else if(startDay == twodaybeforeDay){
              item.status = 0 //前天
            }else{
              item.status = 4 //显示日期
              var month = checkTime(startDate.getMonth()+1);
              item.showDay = month + "月" + checkTime(startDay) + "号"
            }
            item.startDate = startDate
            if(item.tvProgramList.length>0){
              angular.forEach(item.tvProgramList,function(itema,index){
                filterPlayTime(itema);//时间转换
                itema.title = itema.pname;
                if(currentDate>startDate){
                  itema.isPlaying = 2;//结束v
                }else if(currentDate<startDate){
                  itema.isPlaying = 0;//未开始
                }else{
                  itema.isPlaying = 1;//正在播放
                }

                // debugger
              })
              item.tvProgramList.sort(function(a,b){
                return a.startShowDate - b.startShowDate
              })
            }

            // var starday = starday.getDate()
          })
        }
        /**
        * @author SuperK
        * @desc 查询电视台节目
        * @date 2015/12/30
        **/
        function getTvprogramList(tvStationId,callback){

          var time =  getAtime(2,1)//前两天和后一天的时间
          var time1 =  getAtime(30,30)//前两天和后一天的时间
          Movies.getTvprogramList(tvStationId,time.starttime,time.endtime,function(result){
            if(result.success){
              if(result.data.programList &&result.data.programList.length>0){
                filterInDay(result.data.programList);

              }else{
                result.data.programList = [];
              }
              result.data.status = true;

              callback && callback(result.data)
            }else{
              var list = {};
              list.status = false;
              callback && callback(list)
            }

          })
        }
        /**
        * @author SuperK
        * @desc 查询电视台
        * @date 2015/12/30
        **/
        function getTvStationList(callback){
          Movies.getTvstationList(function(result){
            if(result.success && result.data &&result.data.length>0){

              callback && callback(result.data)
            }else{
              var list = []
              callback && callback(list)
            }
          })
        }
        /**
        * @author SuperK
        * @desc 获取三种娱乐成果各一个
        * @date 2015/12/30
        **/
        var getThreeEntertainments = function (array) { //获取三种娱乐成果各一个
            var list = [];
            var fisrtType1 = true;
            var fisrtType2 = true;
            var fisrtType3 = true;
            for (var i = 0; i < array.length; i++) {
                if (array[i].recreationType == 1 && fisrtType1) {
                    list.push(array[i]);
                    fisrtType1 = false;
                } else if (array[i].recreationType == 2 && fisrtType2) {
                    list.push(array[i]);
                    fisrtType2 = false;
                } else if (array[i].recreationType == 3 && fisrtType3) {
                    list.push(array[i]);
                    fisrtType3 = false;
                }

            }
            if (list.length == 3) {
                return list;
            }else if(list.length<3){
                return list;
            }
        }
        var getCinema = function(callback) {
                var senceList = [];
                // 查询附近电影院
                Movies.getAroundCinema(longitude, latitude, 5, function(result) {
                    if (result.data && result.data.length > 0) {
                        senceList = result.data;
                        callback && callback(senceList);
                        return;
                    } else {
                        console.log("没有更多数据了")
                    }
                })
            }
        /*
         *根据地理位置获取附近电影院
         */
        var location = function() {
            locationTime++
            if (locationTime == 7) {
                locationTime = 0;
                Toast.show("未获得地理位置信息");
            } else if (locationTime != 0 && locationTime != 7) {
                setTimeout(function() {
                    if ($rootScope.userlocation && $rootScope.userlocation.isCinema) {
                        //手机测试
                        for (var i = 0; i <= $rootScope.userlocation.locations.length; i++) {
                            if (i == $rootScope.userlocation.locations.length) {
                                currentLocation = $rootScope.userlocation.locations[i - 1];
                                longitude = currentLocation.longitude;
                                latitude = currentLocation.latitude;
                            }
                        }
                        getCinema(function(data) {
                            // console.log(data)
                            if (data.length > 0 && data[0].distance < 5.5) {
                                $rootScope.userlocation.nearciname = true;
                                // Toast.show("获得地理位置信息");
                                locationTime = 0
                                //$scope.isHotNew = true;
                            } else {
                                $rootScope.userlocation.nearciname = false;
                            }
                        });
                    } else {
                        location()
                    }
                }, 2000);
            }
        }
        $rootScope.userlocation = {};
        $rootScope.userlocation.locations = [];
        $rootScope.userlocation.isCinema = false;
        $rootScope.userlocation.nearciname = false;
        $rootScope.netWorkOnline = true;//网络
        var locationTime = 1;
        var longitude;
        var latitude;
        var currentLocation;
        var  __locationInit = function(isFirst){
          Movies.searchLocation(function(result) {
              if (result.latitude && /5e-324/.test(result.latitude)) {
                  $rootScope.userlocation.isCinema = false;
                  $rootScope.userlocation.locations.push(result);
                  return;
              } else {
                  // var data
                  // $scope.broadcast("isLocation",data)
                  $rootScope.userlocation.isCinema = true;
                  $rootScope.userlocation.locations.push(result);
              }
          });
          //第一次设置隔一段时间去获取地理位置
          if(isFirst){
            setInterval(function() {
                Movies.searchLocation(function(result) {
                    if (result.latitude && /5e-324/.test(result.latitude)) {
                        $rootScope.userlocation.isCinema = false;
                        return;
                    }
                    //$rootScope.userlocation.isCinema = true;
                    $rootScope.userlocation.locations.push(result);
                });
            }, 1800000);
          }
          location();
        }
        /**
        * @author SuperK
        * @desc 查询视频二级显示的详情
        * @date 2015/12/30
        **/
        function getMovieDetail(vid,callback){
          var movieinfo; //电影详情页显示的信息
          Movies.getVideoDetails(vid,function(result){ //查询视频二级显示的详情
              if(result.success){
                  //放置视频信息
                  result.data.topPoster = {"url":result.data.img}
                  result.data.releaseTime = result.data.releaseTime / 60;
                  var regvideo = /\.(mp4)$/i;
                  var allposterlength = result.data.posters.length + result.data.featuresVOs.length;
                  var imglength= 0
                  angular.forEach(result.data.posters,function(item){
                    if(regvideo.test(item.url)){
                      item.posterurl = "http://resource.handsight.com.cn/TVHelp01/img/upload/1449555795291_2145.jpg";
                      item.isImg = false;   //视频
                      item.imgtype = "featureimg"
                    }else{
                      imglength++
                      item.posterurl = item.url
                      item.isImg = true;
                      item.imgtype = "movieimg"
                    }
                  });
                  angular.forEach(result.data.featuresVOs,function(item){
                    item.posterurl = item.coverImgUrl;
                    item.isImg = false;
                    item.imgtype = "featureimg"
                    // $scope.isImg = item.isImg;
                  })
                  result.data.movieFeature = result.data.posters.concat(result.data.featuresVOs);
                  result.data.allmovieFeature = result.data.movieFeature;
                  result.data.movieFeature = filterData(result.data.movieFeature,3)
                  result.data.vediolength = allposterlength - imglength;
                  result.data.imglength = imglength;
                  movieinfo = result.data
              } else{
                  // Toast.show("没有更多数据了");
                  movieinfo = null
                  console.log("没有更多数据了")
              }
              callback && callback(movieinfo)
          });
          // callback && callback(movieinfo)
        }
        //判断是不是正在播放
        function fundShowProgram(item,start,end){
          var currentDate = new Date();
          var startDate = new Date(start.replace(/-/g,"/"));
          var endDate = new Date(end.replace(/-/g,"/"));
          item.showDate = getNiceTime(startDate,2);
          item.startDate = startDate;
          item.endDate = endDate;
          if(currentDate>startDate && currentDate<endDate){
            item.showStatus = 1;//正在播放
          }else if(currentDate<startDate){
            item.showStatus = 0;//未开始
          }else if(currentDate>endDate){
            item.showStatus = 2;//结束
          }
        }
        function filterDetail(item){
          item.topPoster = {"url":item.img}
          item.releaseTime = item.releaseTime / 60;
          var regvideo = /\.(mp4)$/i;
          var allposterlength = item.posters.length + item.featuresVOs.length;
          var imglength= 0
          angular.forEach(item.posters,function(item){
            if(regvideo.test(item.url)){
              item.posterurl = "http://resource.handsight.com.cn/TVHelp01/img/upload/1449555795291_2145.jpg";
              item.isImg = false;   //视频
              item.imgtype = "featureimg"
            }else{
              imglength++
              item.posterurl = item.url
              item.isImg = true;
              item.imgtype = "movieimg"
            }
          });
          angular.forEach(item.featuresVOs,function(item){
            item.posterurl = item.coverImgUrl;
            item.isImg = false;
            item.imgtype = "featureimg"
            // $scope.isImg = item.isImg;
          })
          item.movieFeature = item.posters.concat(item.featuresVOs);
          item.allmovieFeature = item.movieFeature;
          item.movieFeature = filterData(item.movieFeature,3)
          item.vediolength = allposterlength - imglength;
          item.imglength = imglength;
          movieinfo = item
        }
        /**
        * @author SuperK
        * @desc 初始化视频元素详情页数据
        * @date 2016/01/13
        **/
        function __videoDetailInfoInit(videoId,callback){

          Movies.getVideoDetailInfo(videoId,function(result){
            if(result.success){
              result.data.videoDetail = result.data;//详情信息
              result.data.videoDetail.topPoster = {"url":result.data.videoDetail.img}
              result.data.videoDetail.releaseTime = result.data.videoDetail.releaseTime / 60;
              if(result.data.videoDetail.posters!=null && result.data.videoDetail.featuresVOs!=null){
                var regvideo = /\.(mp4)$/i;
                var allposterlength = result.data.videoDetail.posters.length + result.data.videoDetail.featuresVOs.length;
                var imglength= 0
                angular.forEach(result.data.videoDetail.posters,function(item){
                  if(regvideo.test(item.url)){
                    item.posterurl = "http://resource.handsight.com.cn/TVHelp01/img/upload/1449555795291_2145.jpg";
                    item.isImg = false;   //视频
                    item.imgtype = "featureimg"
                  }else{
                    imglength++
                    item.posterurl = item.url
                    item.isImg = true;
                    item.imgtype = "movieimg"
                  }
                });
                angular.forEach(result.data.videoDetail.featuresVOs,function(item){
                  item.posterurl = item.coverImgUrl;
                  item.isImg = false;
                  item.imgtype = "featureimg"
                  // $scope.isImg = item.isImg;
                })
                result.data.videoDetail.movieFeature = result.data.videoDetail.posters.concat(result.data.videoDetail.featuresVOs);
                result.data.videoDetail.allmovieFeature = result.data.videoDetail.movieFeature;
                result.data.videoDetail.movieFeature = filterData(result.data.videoDetail.movieFeature,3)
                result.data.videoDetail.vediolength = allposterlength - imglength;
                result.data.videoDetail.imglength = imglength;
              }else{
                result.data.videoDetail.movieFeature = [];
                result.data.videoDetail.allmovieFeature = [];
                result.data.videoDetail.movieFeature = []
                result.data.videoDetail.vediolength = 0;
                result.data.videoDetail.imglength = 0;
              }

              //1娱乐列表

              angular.forEach(result.data.disportResultList,function(data){
                if(data.content!=""){
                    data.content = JSON.parse(data.content)//地址信息
                }
                switchDesign(data) //转换
              });
              result.data.disportResultList = filterData(result.data.disportResultList,2);
              //2一样一个娱乐

              angular.forEach(result.data.oneResultList,function(data){
                if(data.content!=""){
                    data.content = JSON.parse(data.content)//地址信息
                }
                switchDesign(data) //转换
              });

              //3猜你喜欢
              result.data.relatedVideo = []
              angular.forEach(result.data.relatedVideoList,function(item,index){
                if(item.videoId == videoId){
                    result.data.relatedVideoList.splice(index,1)
                }
              })
              var randoms = getRandomNo(result.data.relatedVideoList.length,6)
              if(randoms.length == 0){
                result.data.relatedVideo = result.data.relatedVideoList;
              }else{
                angular.forEach(randoms,function(item){
                  result.data.relatedVideo.push(result.data.relatedVideoList[item]);
                })
              }

              result.data.relatedVideo = filterData(result.data.relatedVideo,3);

              //4电视版本选集
              if(result.typeId!=2){
                angular.forEach(result.data.episodeList,function(item){
                  item.number = item.tvVideoNo;
                })
              }

              result.data.success = true;
              callback && callback(result.data);return;
            }else{
              var resultstatus={};
              resultstatus.success = false;
              callback && callback(resultstatus);return;
            }



            // movieinfo = result.data.videoDetail
            // debugger

            // getMovieDetail(268701619,function(detailresult){
            //   result.data.videoDetail = detailresult;
            //   InterfaceDotInfo.getMovieGoods(3,268701619,31,111,1,function(item){

            //     // $scope.isLoading = false;
            //     result.data.relatedGoodsList = item;
            //     result.data.relatedVideoList = filterData(result.data.relatedVideoList,3);
            //     //脑补按时间排序，小的在前面
            //     result.data.headThemeList.sort(function(a,b){
            //       return parseInt(a.timePoint)-parseInt(b.timePoint)
            //     })
            //     Movies.getEntertainmentOther(268701619,function(disport){ //查询影片的其他娱乐推荐
            //       result.data.disportResultList = disport.data.resultList;
            //       angular.forEach(result.data.disportResultList,function(data,index,array){
            //         if(data.content!=""){
            //             data.content = JSON.parse(data.content)//地址信息
            //         }
            //         switchDesign(data) //转换

            //         // entertainmentOthervideo.push(data)
            //       });
            //       result.data.disportResultList = filterData(result.data.disportResultList,2);
            //       Movies.getEntertainmentOther(268701619,function(itemc){ //查询影片的其他娱乐推荐
            //           if(itemc.data && itemc.data.resultList.length > 0){
            //               angular.forEach(itemc.data.resultList,function(item){
            //                 item.content = JSON.parse(item.content);
            //                 switchDesign(item); //转换
            //               })
            //               // entertainmentOther = result.data.resultList;
            //               result.data.oneResultList = getThreeEntertainments(itemc.data.resultList);//获取三种娱乐成果各一个
            //           }
            //           callback && callback(result.data)

            //       });

            //     });
            //   })
            // })
          });

        }
        /**
        * @author SuperK
        * @desc 初始化首页数据
        * @date 2016/01/13
        **/
        function __homeInfoInit(type,callback){
          // debugger
          // var activityTime = getAtime(30,30); //获取前30天和后30天的时间
          // var starttime = activityTime.starttime;
          // var endtime = activityTime.endtime;
          // var mark = 2; //活动状态（0：所有，1：强推2：首页显示，3：下架，5：已删除）
          // var type = 0; //活动类型(1:大转盘 2：百宝箱 3：其他活动 0:全部 6:抢红包)
          // Movies.getActiveList(mark, starttime, endtime, type, function(result){
          //   debugger
          // })
          Movies.getHomeInfo(type,function(result){

            if(result.success){
              result.data.goingLiveList = []//即将直播的节目
              result.data.headThemeListN = []//脑补列表new
              result.data.headThemeListP = []//脑补列表past
              result.data.headThemeListH = []//脑补列表hot
              result.data.homeVideoListN = []//new
              result.data.homeVideoListP = []//past
              result.data.homeVideoListH = []//hot
              result.data.liveList = []//正在直播的节目
              if(type==1){
                if(result.data.hotLiveprogramList.length>0){
                  angular.forEach(result.data.hotLiveprogramList,function(item,index){
                    fundShowProgram(item,item.starttime,item.endtime);

                    item.title  = item.pname;
                    item.source  = item.mname;
                    item.date  = item.showDate;

                    // item.starttime  = item.title;
                    if(item.showStatus == 1){
                      result.data.liveList.push(item)
                    }else if(item.showStatus == 0){
                      result.data.goingLiveList.push(item)
                    }
                  })
                }
                if(result.data.hotTvstationList.length>0){
                  angular.forEach(result.data.hotTvstationList,function(item,index){
                    if(item.programStarttime!=null&&item.programStarttime!=""){
                      item.startDate = new Date(item.programStarttime.replace(/-/g,"/"));
                      item.showDate = getNiceTime(item.startDate,1); //获得一个页面显示时间
                    }else{
                      item.showDate = "01-24 19:30"
                    }
                    item.title = item.mname;
                    item.program = item.playingProgramName;
                    item.date = item.showDate;
                    item.img = item.mimg;
                  })
                }
                if(result.data.videoList.length>0){
                  angular.forEach(result.data.videoList,function(item,index){
                    if(item.status == "1" || item.status == 1){//new

                      result.data.homeVideoListN.push(item);
                      if(item.headThemeList.length>0){
                        result.data.headThemeListN = result.data.headThemeListN.concat(item.headThemeList);
                      }
                    }else if(item.status == "2" || item.status == 2){//hot
                      result.data.homeVideoListH.push(item);
                      if(item.headThemeList.length>0){
                        result.data.headThemeListH = result.data.headThemeListH.concat(item.headThemeList);
                      }
                    }else{//past
                      result.data.homeVideoListP.push(item);
                      if(item.headThemeList.length>0){
                        result.data.headThemeListP = result.data.headThemeListP.concat(item.headThemeList);
                      }
                    }
                  })
                  result.data.homeVideoListN = filterData(result.data.homeVideoListN,3);
                  result.data.homeVideoListP = filterData(result.data.homeVideoListP,3);
                  result.data.homeVideoListH = filterData(result.data.homeVideoListH,3);
                }
              }else{
                  angular.forEach(result.data,function(item,index){
                    if(item.status == "1" || item.status == 1){//new

                      result.data.homeVideoListN.push(item);
                      if(item.headThemeList.length>0){
                        result.data.headThemeListN = result.data.headThemeListN.concat(item.headThemeList);
                      }
                    }else if(item.status == "2" || item.status == 2){//hot
                      result.data.homeVideoListH.push(item);
                      if(item.headThemeList.length>0){
                        result.data.headThemeListH = result.data.headThemeListH.concat(item.headThemeList);
                      }
                    }else{//past
                      result.data.homeVideoListP.push(item);
                      if(item.headThemeList.length>0){
                        result.data.headThemeListP = result.data.headThemeListP.concat(item.headThemeList);
                      }
                    }
                  })
                  result.data.homeVideoListN = filterData(result.data.homeVideoListN,3);
                  result.data.homeVideoListP = filterData(result.data.homeVideoListP,3);
                  result.data.homeVideoListH = filterData(result.data.homeVideoListH,3);
              }
              result.data.success = true;
              callback && callback(result.data);return;
            }else{
              var result = {};
              result.goingLiveList = []//即将直播的节目
              result.headThemeListN = []//脑补列表new
              result.headThemeListP = []//脑补列表past
              result.headThemeListH = []//脑补列表hot
              result.homeVideoListN = []//new
              result.homeVideoListP = []//past
              result.homeVideoListH = []//hot
              result.liveList = []//正在直播的节目

              result.success = true;
              callback && callback(result);return;
            }

          })
        }
        function __getLeftTime(time){
          var countdown = {};
          var EndTime= time; //截止时间
          EndTime = new Date(EndTime)
          var NowTime = new Date();
          var t =EndTime.getTime() - NowTime.getTime();
          if(t>0){
            var d=Math.floor(t/1000/60/60/24);
            if(d>0){
              var h=Math.floor(t/1000/60/60%24)+24*d;
            }else{
              var h=Math.floor(t/1000/60/60%24);
            }
            var m=Math.floor(t/1000/60%60);
            var s=Math.floor(t/1000%60);
            if(d>0){
              countdown.day = d
            }else{
              countdown.day = 0
            }
            if(h>0){
              countdown.hour = h
            }else{
              countdown.hour = 0
            }
            if(m>0){
              countdown.minute = m
            }else{
              countdown.minute = 0
            }
            if(s>0){
              countdown.second = s
            }else{
              countdown.second = 0
            }
            countdown.isNotShow = true
          }else{
            countdown = {
              "isNotShow":false,
            }
          }
          return countdown;
        }
        function __getMoreList(type,callback){
          Movies.getClassificationList(type,function(result){
            // debugger
            angular.forEach(result.data,function(item,index){
              angular.forEach(item.classificationList,function(itema,index){
                var idname = item.classificationName +"id";
                itema[idname] = itema.labelId;
                itema.classificationName = item.classificationName;
              })
            })
            // result.data.reverse();rever
            callback && callback(result.data);return;
          })
        }
        function getLoadingStatus(type){
          var loadingStatus = {}
          if(type == 1){//初始化
            loadingStatus = {
              "isLoadingAgain":true,
              "isLoading":true,
              "isGoodNet":false
            }
          }else if(type == 2){//加载成功
            loadingStatus = {
              "isLoadingAgain":true,
              "isLoading":false,
              "isGoodNet":true
            }
          }else if(type == 3){//加载失败
            loadingStatus = {
              "isLoadingAgain":false,
              "isLoading":false,
              "isGoodNet":false
            }
          }
          return loadingStatus;
        }
        //电影详情页获取六个随机数
        function getRandomNo(sum,length){

          var items = {};
          if(length > sum){
            return Object.keys(items);
          }else{
            while(Object.keys(items).length < length){
              var item = Math.floor(Math.random() * sum);
              items[item] = item;
            }
            return Object.keys(items);
          }

        }

        // homeInfoInit(1,function(result){
        //   debugger
        // })
        return {
          getRandomNo: function(sum,length) {
              return getRandomNo(sum,length);
          },
          getLoadingStatus: function(type) {
              return getLoadingStatus(type);
          },
          getMoreList: function(type, callback) {
              return __getMoreList(type,callback);
          },
          videoDetailInfoInit: function(videoId, callback) {
              return __videoDetailInfoInit(videoId,callback);
          },
          locationInit: function(isFirst) {
              // __init(vid,callback);
              return __locationInit(isFirst);
          },
          init: function(vid, callback) {
              // __init(vid,callback);
              return __init(vid,callback);
          },
          getLeftTime: function(time) {
              return __getLeftTime(time);
          },
          homeInfoInit: function(type, callback) {
              return __homeInfoInit(type,callback);
          },
          getLastSence:function(type,callback){
              return __getLastSence(type,callback)
          },
          filterInArray:function(data, column){
            return  filterData(data, column);
          },
          getTvprogramList:function(tvStationId, callback){
            return  getTvprogramList(tvStationId, callback)
          },
          getTvStationList:function(callback){
            return  getTvStationList(callback);
          },
          getAtime:function(start,end){
            return  getAtime(start,end);
          },
          getNiceTime:function(adate,type){
            return  getNiceTime(adate,type);
          }

        }


    })


