/**
 * 电影相关的数据服务
 * @param  {[type]} rootModule){  function Play(ENV){ } rootModule.service('Play',Play);} [description]
 * @return {[type]}                        [description]
 */
rootModule
    .factory('Movies', function(ENV,Storage,InterfaceDotInfo, $resource,$timeout,$q,$rootScope) {
        var senceList=[];
        var sceneIds = [];
        var resource = $resource("", null, {
            getMoviesList: {//查询视频列表
                method: "GET",
                url: ENV.api + '/editor/video/get_video_list'
            },
            getVideoList: {//more查询视频列表new3
                method: "GET",
                url: ENV.api + '/editor/video/get_video_list16'
            },
            getHomeMovies: {//查询首页显示视频元素
                method: "GET",
                url: ENV.api + '/editor/video/get_homepage'
            },
            getHeadTheme: {//查询视频二级显示的脑补（查询主题信息接口）
                method: "POST",
                url: ENV.api + '/editor/motive/get'
            },
            getEntertainmentOther: {//查询视频元素的相关成果(查询影片的其他娱乐推荐)
                method: "GET",
                url: ENV.api + '/recreation/get_related_disport'
            },
            getEntertainmentOthervideo: {//查询其他影片的娱乐推荐
                method: "GET",
                url: ENV.api + '/recreation/get_disport_othervideo'
            },
            getRelatedVideo: { //查询相关视频元素
                method:"GET",
                url:ENV.api + '/editor/video/get_related_video'
            },
            getVideoDetails: { //查询视频元素详情
                method:"GET",
                url:ENV.api + "/editor/video/get_video_details"
            },
            getActiveList: { //查询首页活动
                method:"POST",
                url:ENV.api + "/active/getList"
            },
            getAroundCinema: { //查询用户附近电影院
                method:"GET",
                url:ENV.api + '/cinema/get_position'
            },
            getShowMovie: { //查询附近电影院上映的电影信息接口
                method:"GET",
                url:ENV.api + '/cinema/get_movie_cinema'
            },
            getShowSessionId: { //查询附近电影院上映电影场次信息
                method:"GET",
                url:ENV.api + '/cinema/get_showtime'
            },
            getShowSessionInfor: { //根据电影场次id查询附近电影院上映电影场次信息
                method:"GET",
                url:ENV.api + '/cinema/get_showtime'
            },
            getSenceInfor: { //根据电影场景ID查询绑定的电影场次信息
                method:"GET",
                url:ENV.api + '/scene/get_info16'
            },
            getSenceList: { //获取终端电影临时场景列表
                method:"GET",
                url:ENV.api + '/scene/list'
            },
            addAsence: { //绑定一个场景连接
                method:"GET",
                url:ENV.api + '/scene/bind'
            },
            addAsenceNew: { //绑定一个场景连接
                method:"GET",
                url:ENV.api + '/scene/bind16'
            },
            deleteAsence: { //删除一个场景连接
                method:"GET",
                url:ENV.api + '/scene/unwrap'
            },
            addPraise: { //用户点赞功能
                method:"GET",
                url:ENV.api + '/user/add_praise'
            },
            getPraise: { //查询点赞信息
                method:"GET",
                url:ENV.api + '/user/get_praise'
            },
            _getCityList: { //查询点赞信息
                method:"GET",
                url:ENV.api + '/cinema/get_area'
            },
            getCityCinema: { //查询点赞信息
                method:"GET",
                url:ENV.api + '/cinema/get_cinema_area'
            },
            getTvDetail: { //查询场景页面信息
                method:"GET",
                url:ENV.api + '/scene/info_list'
            },
            getDisportDetail: { //查询乐配成果详情页信息
                method:"GET",
                url:ENV.api + '/recreation/get_detail'
            },
            getCommentbyPage: { //分页查询评论列表
                method:"GET",
                url:ENV.api + '/side/select_theme_talk_page'
            },
            getRedPacket: { //查询抢红包活动详情
                method:"POST",
                url:ENV.api + '/active/get_active'
            },
            getRedPacketResult: { //查询抢红包活动结果
                method:"POST",
                url:ENV.api + '/active/get_draw_result'
            },
            sendRedpacketUserInfro: { //将抢红包中奖用户信息发送给服务器
                method:"POST",
                url:ENV.api + '/active/upload_luck'
            },
            getActivetyPlaytime: { //查询抽奖次数
                method:"POST",
                url:ENV.api + '/active/get_draw_count'
            },
            getTvstationList: { //查询电视台列表接口new5
                method:"GET",
                url:ENV.api + '/menu/new_list'
            },
            getTvprogramList: { //查询电视台节目接口new6
                method:"GET",
                url:ENV.api + '/menu/new_programs'
            },
            getHomeInfo:{ //查询首页信息new1
                method:"GET",
                url:ENV.api + '/editor/video/get_homepage16'
            },
            getHeadThemeDetail:{ //查询单个脑补new7
                method:"GET",
                url:ENV.api + '/editor/motive/get_id'
            },
            getVideoDetailInfo:{ //查询电影信息new2
                method:"GET",
                url:ENV.api + '/editor/video/get_video_details16'
            },
            getClassificationList:{ //查询电影信息new4
                method:"GET",
                url:ENV.api + '/scene/get_label'
            },
        });
        function getNiceTime(adate,type){
          var Smonth = checkTime(parseInt(adate.getMonth() + 1));
          var Sday = checkTime(parseInt(adate.getDate()));
          var year = adate.getFullYear();
          var hour = checkTime(adate.getHours());
          var minute = checkTime(adate.getMinutes());
          var second = checkTime(adate.getSeconds());
          if(type == 0){//0,要年份
            var starttime = year + "-"+Smonth+"-"+Sday+" "+hour+":"+minute+":"+second;//"2015-01-14 13:20:00"
          }else if(type == 1){//0,不要年份
            var starttime = Smonth+"-"+Sday+" "+hour+":"+minute;//"01-14 13:20"
          }else if(type == 2){
            var starttime = (parseInt(adate.getMonth())+1)+"月"+adate.getDate()+"日"+" "+hour+":"+minute;
          }else if(type == 3){//0,不要年份
            var starttime = year + Smonth +Sday;//"20150114"
          }else if(type == 4){
            var starttime = hour+":"+minute;//"13:20"
          }
          return starttime;
        }
        //转换时间
        function checkTime(i)
        {
        if (i<10)
          {i="0" + i}
          return i
        };

        return {
            /**
             * 查询抽奖次数
             * @return {[type]}                [description]
             */
            getClassificationList: function(type,callback) {
                var result = {
                                "code": 20001,
                                "data":[{
                                "classificationName":"status",
                                "classificationList":[
                                    {"labelname":"全部","labelId":"0"},
                                    {"labelname":"即将上映","labelId":"1"},
                                    {"labelname":"正在热映","labelId":"2"},
                                    {"labelname":"历史热映","labelId":"3"},
                                ]
                                },
                                {
                                "classificationName":"area",
                                "classificationList":[
                                    {"labelname":"全部","labelId":"0"},
                                    {"labelname":"内地","labelId":"1"},
                                    {"labelname":"港台","labelId":"2"},
                                    {"labelname":"日韩","labelId":"3"},
                                    {"labelname":"欧美","labelId":"4"},
                                    {"labelname":"其他","labelId":"5"}
                                ],
                                },
                                {
                                "classificationName":"type",
                                "classificationList":[
                                  {"labelname":"全部","labelId":"0"},
                                  {"labelname":"爱情","labelId":"1"},
                                  {"labelname":"战争","labelId":"2"},
                                  {"labelname":"喜剧","labelId":"3"},
                                  {"labelname":"科幻","labelId":"4"},
                                  {"labelname":"恐怖","labelId":"5"},
                                  {"labelname":"动画","labelId":"6"}
                                ],
                                },
                                {
                                "classificationName":"year",
                                "classificationList":[
                                    {"labelname":"全部","labelId":"0"},
                                    {"labelname":"2016","labelId":"2016"},
                                    {"labelname":"2015","labelId":"2015"},
                                    {"labelname":"2014","labelId":"2014"},
                                    {"labelname":"2013","labelId":"2013"},
                                    {"labelname":"2012","labelId":"2012"},
                                    {"labelname":"2011","labelId":"2011"},
                                    {"labelname":"2010","labelId":"2010"},
                                ],
                                // },{
                                // "classificationName":"typeId",
                                // "classificationList":[
                                // {"labelname": "全部", "labelId": "0"},
                                // {"labelname": "连续剧", "labelId": "1"},
                                // {"labelname": "电影", "labelId": "2"},
                                // {"labelname": "综艺", "labelId": "3"},
                                // {"labelname": "音乐", "labelId": "4"},
                                // {"labelname": "少儿", "labelId": "5"},
                                // {"labelname": "娱乐", "labelId": "6"},
                                // ],
                                }],
                                "msg": "",
                                "success": true
                            }
                $timeout(function(){
                    callback && callback(result);
                },100);return;

                return resource.getClassificationList({
                    type:type
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询电影信息
             * @return {[type]}                [description]
             */
            getVideoDetailInfo: function(videoId,callback) {
                // var homeList = {
                //             "code": 20001,
                //             "data":{
                //                 "videoId": "1",
                //                 "tvVideoNo": "1",
                //                 "videoType": "2",
                //                 "status": "1",
                //                 "sum": "20",
                //                 "updateNo": "11",
                //                 "headThemeList":[{
                //                     "approvedStatus": "1",
                //                     "approvedUserId": "42",
                //                     "collection": "",
                //                     "commodity": null,
                //                     "createTime": "2016-01-11 16:43:57",
                //                     "guessing": null,
                //                     "isDel": "1",
                //                     "link": "",
                //                     "motiveId": "269753852",
                //                     "positionCol": "3",
                //                     "positionRow": "3",
                //                     "reason": "",
                //                     "showPositionCol": "3",
                //                     "showPositionRow": "3",
                //                     "showTime": "60",
                //                     "themeType": "7",
                //                     "timePoint": "5379",
                //                     "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                     "top": "2",
                //                     "updateTime": "2016-01-11 16:46:03",
                //                     "userId": "42",
                //                     "videoId": "269672763",
                //                     "vote": null,
                //                 }],
                //                 "videoDetail":{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 },
                //                 "episodeList":[{
                //                     "videoId": "1",
                //                     "tvVideoNo": "1",
                //                     "videoType": "1",
                //                     "status": "1",
                //                     "sum": "11",
                //                     "updateNo": "11",
                //                     "videoDetail":{
                //                         "addTime": "2015-10-23 10:10:10",
                //                         "area": "美国",
                //                         "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                         "director": "乔斯·韦登",
                //                         "featuresVOs": null,
                //                         "homePage": 1,
                //                         "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                         "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                         "isDel": "1",
                //                         "language": "英语 / 韩语",
                //                         "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                         "pVid": "",
                //                         "posters": null,
                //                         "releaseTime": "8520",
                //                         "sonVideoCount": null,
                //                         "status": 3,
                //                         "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                         "typeId": "2",
                //                         "typeName": "电影",
                //                         "updateTime": "2016-01-14 09:35:24",
                //                         "videoFirstFrame": null,
                //                         "videoId": "1045",
                //                         "videoType": "2",
                //                         "videoImagePath": "",
                //                         "videoName": "复仇者联盟2",
                //                         "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                         "year": null,
                //                         "headThemeList":[{
                //                             "approvedStatus": "1",
                //                             "approvedUserId": "42",
                //                             "collection": "",
                //                             "commodity": null,
                //                             "createTime": "2016-01-11 16:43:57",
                //                             "guessing": null,
                //                             "isDel": "1",
                //                             "link": "",
                //                             "motiveId": "269753852",
                //                             "positionCol": "3",
                //                             "positionRow": "3",
                //                             "reason": "",
                //                             "showPositionCol": "3",
                //                             "showPositionRow": "3",
                //                             "showTime": "60",
                //                             "themeType": "7",
                //                             "timePoint": "5379",
                //                             "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                             "top": "2",
                //                             "updateTime": "2016-01-11 16:46:03",
                //                             "userId": "42",
                //                             "videoId": "269672763",
                //                             "vote": null,
                //                         }]
                //                     }
                //                 }],
                //                 "oneResultList":[{
                //                     "approvedFirstTime": "2015-12-21 15:14:47",
                //                     "approvedStatus": "4",
                //                     "approvedTime": "2015-12-21 16:38:00",
                //                     "authorHead": "http://resource.handsight.cn/TVHelp01/img/face/default.png",
                //                     "authorId": "16",
                //                     "authorName": "wangxp",
                //                     "content": "{'srcImg':'http://resource.handsight.cn/TVHelp01/img/upload/1450680793357_9357.jpg','resultImg':'http://resource.handsight.cn/TVHelp01/img/alg/face/1450682051031_7726.png','headsIndex':1}",
                //                     "createTime": "2015-12-21 15:14:11",
                //                     "disportDataId": "268702621",
                //                     "disportDataName": "配头像",
                //                     "disportId": "268702701",
                //                     "disportTitle": "贾冰冰",
                //                     "isDel": "1",
                //                     "isRelease": "0",
                //                     "recreationType": "2",
                //                     "releaseTime": "",
                //                     "updateTime": "2015-12-24 22:04:51",
                //                     "usersByApprovedFirstUserId": "16",
                //                     "usersByApprovedUserId": "17",
                //                     "vName": "绝地逃亡",
                //                     "vid": "268701619",
                //                 },{
                //                     "approvedFirstTime": "2015-12-21 16:36:30",
                //                     "approvedStatus": "4",
                //                     "approvedTime": "2015-12-21 16:38:04",
                //                     "authorHead": "http://resource.handsight.cn/TVHelp01/img/face/default.png",
                //                     "authorId": "16",
                //                     "authorName": "wangxp",
                //                     "content": "{'videoSplashImg':'http://resource.handsight.cn/TVHelp01/img/upload/1450686918302_7875.jpg','originalVideoUrl':'http://resource.handsight.cn/TVHelp01/video/1450686895682_4016separated.mp4','userPlayAudio':'http://resource.handsight.cn/TVHelp01/video/1450686989813_1460.m4a','compositeVideo':'http://resource.handsight.cn/TVHelp01/video/1450686895682_4016separatedlast.mp4'}",
                //                     "createTime": "2015-12-21 16:36:30",
                //                     "disportDataId": "268702874",
                //                     "disportDataName": "绝地逃亡乐配音1",
                //                     "disportId": "268702883",
                //                     "disportTitle": "绝地逃亡乐配音1",
                //                     "isDel": "1",
                //                     "isRelease": "0",
                //                     "recreationType": "1",
                //                     "releaseTime": "",
                //                     "updateTime": "2015-12-24 22:04:51",
                //                     "usersByApprovedFirstUserId": "16",
                //                     "usersByApprovedUserId": "17",
                //                     "vName": "绝地逃亡",
                //                     "vid": "268701619",
                //                 },{
                //                     "approvedFirstTime": "2015-12-21 17:16:12",
                //                     "approvedStatus": "4",
                //                     "approvedTime": "2015-12-21 17:16:12",
                //                     "authorHead": "http://resource.handsight.cn/TVHelp01/img/face/default.png",
                //                     "authorId": "16",
                //                     "authorName": "wangxp",
                //                     "content": "{'imgSrc':'http://resource.handsight.cn/TVHelp01/img/upload/1450689328148_9117.jpg','imgMod':'0','originContent':'昨天晚上你跟我老婆去哪里了？！！老实交代！！','en':'Where did you go with my wife last night?!! Honest account!!','jp':','kor':','fontSize':30,'targetLang':'en','resImgSrc':'http://resource.handsight.cn/TVHelp01/img/upload/1450689328148_9117.jpg'}",
                //                     "createTime": "2015-12-21 17:16:12",
                //                     "disportDataId": "268702979",
                //                     "disportDataName": "我老婆",
                //                     "disportId": "268702980",
                //                     "disportTitle": "我老婆",
                //                     "isDel": "1",
                //                     "isRelease": "1",
                //                     "recreationType": "3",
                //                     "releaseTime": "2015-12-21 17:16:12",
                //                     "updateTime": "2015-12-24 22:04:51",
                //                     "usersByApprovedFirstUserId": "16",
                //                     "usersByApprovedUserId": "1",
                //                     "vName": "绝地逃亡",
                //                     "vid": "268701619",
                //                 }],
                //                 "relatedVideoList":[{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                 }],
                //                 "disportResultList":[{
                //                     "approvedFirstTime": "2015-12-21 15:14:47",
                //                     "approvedStatus": "4",
                //                     "approvedTime": "2015-12-21 16:38:00",
                //                     "authorHead": "http://resource.handsight.cn/TVHelp01/img/face/default.png",
                //                     "authorId": "16",
                //                     "authorName": "wangxp",
                //                     "content": "{'srcImg':'http://resource.handsight.cn/TVHelp01/img/upload/1450680793357_9357.jpg','resultImg':'http://resource.handsight.cn/TVHelp01/img/alg/face/1450682051031_7726.png','headsIndex':1}",
                //                     "createTime": "2015-12-21 15:14:11",
                //                     "disportDataId": "268702621",
                //                     "disportDataName": "配头像",
                //                     "disportId": "268702701",
                //                     "disportTitle": "贾冰冰",
                //                     "isDel": "1",
                //                     "isRelease": "0",
                //                     "recreationType": "2",
                //                     "releaseTime": "",
                //                     "updateTime": "2015-12-24 22:04:51",
                //                     "usersByApprovedFirstUserId": "16",
                //                     "usersByApprovedUserId": "17",
                //                     "vName": "绝地逃亡",
                //                     "vid": "268701619",
                //                 },{
                //                     "approvedFirstTime": "2015-12-21 16:36:30",
                //                     "approvedStatus": "4",
                //                     "approvedTime": "2015-12-21 16:38:04",
                //                     "authorHead": "http://resource.handsight.cn/TVHelp01/img/face/default.png",
                //                     "authorId": "16",
                //                     "authorName": "wangxp",
                //                     "content": "{'videoSplashImg':'http://resource.handsight.cn/TVHelp01/img/upload/1450686918302_7875.jpg','originalVideoUrl':'http://resource.handsight.cn/TVHelp01/video/1450686895682_4016separated.mp4','userPlayAudio':'http://resource.handsight.cn/TVHelp01/video/1450686989813_1460.m4a','compositeVideo':'http://resource.handsight.cn/TVHelp01/video/1450686895682_4016separatedlast.mp4'}",
                //                     "createTime": "2015-12-21 16:36:30",
                //                     "disportDataId": "268702874",
                //                     "disportDataName": "绝地逃亡乐配音1",
                //                     "disportId": "268702883",
                //                     "disportTitle": "绝地逃亡乐配音1",
                //                     "isDel": "1",
                //                     "isRelease": "0",
                //                     "recreationType": "1",
                //                     "releaseTime": "",
                //                     "updateTime": "2015-12-24 22:04:51",
                //                     "usersByApprovedFirstUserId": "16",
                //                     "usersByApprovedUserId": "17",
                //                     "vName": "绝地逃亡",
                //                     "vid": "268701619",
                //                 },{
                //                     "approvedFirstTime": "2015-12-21 17:16:12",
                //                     "approvedStatus": "4",
                //                     "approvedTime": "2015-12-21 17:16:12",
                //                     "authorHead": "http://resource.handsight.cn/TVHelp01/img/face/default.png",
                //                     "authorId": "16",
                //                     "authorName": "wangxp",
                //                     "content": "{'imgSrc':'http://resource.handsight.cn/TVHelp01/img/upload/1450689328148_9117.jpg','imgMod':'0','originContent':'昨天晚上你跟我老婆去哪里了？！！老实交代！！','en':'Where did you go with my wife last night?!! Honest account!!','jp':','kor':','fontSize':30,'targetLang':'en','resImgSrc':'http://resource.handsight.cn/TVHelp01/img/upload/1450689328148_9117.jpg'}",
                //                     "createTime": "2015-12-21 17:16:12",
                //                     "disportDataId": "268702979",
                //                     "disportDataName": "我老婆",
                //                     "disportId": "268702980",
                //                     "disportTitle": "我老婆",
                //                     "isDel": "1",
                //                     "isRelease": "1",
                //                     "recreationType": "3",
                //                     "releaseTime": "2015-12-21 17:16:12",
                //                     "updateTime": "2015-12-24 22:04:51",
                //                     "usersByApprovedFirstUserId": "16",
                //                     "usersByApprovedUserId": "1",
                //                     "vName": "绝地逃亡",
                //                     "vid": "268701619",
                //                 }],
                //             },
                //             "msg": "success",
                //             "success": true
                //             }
                //             // InterfaceDotInfo.getMovieGoods(3,268701619,31,111,1,function(result){
                //             //   // $scope.isLoading = false;
                //             //   homeList.data.headThemeList = result.data;

                //             // })
                //         if(videoId == 1){
                //             homeList.data.videoType = "1"
                //         }
                //         $timeout(function(){callback && callback(homeList);},1000);return;

                return resource.getVideoDetailInfo({
                    videoId:videoId
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询单个脑补
             * @param  {[type]} status    视频状态
             * @param  {[type]} homePage  是否首页显示（1true,2false）
             * @return {[type]}           [description]
             */

            getHeadThemeDetail: function(motiveId,callback) {
                    // var result = {
                    //     "data":{
                    //         "approvedStatus": "1",
                    //         "approvedUserId": "42",
                    //         "collection": "",
                    //         "commodity": null,
                    //         "createTime": "2016-01-11 16:43:57",
                    //         "guessing": null,
                    //         "isDel": "1",
                    //         "link": "",
                    //         "motiveId": "269753852",
                    //         "positionCol": "3",
                    //         "positionRow": "3",
                    //         "reason": "",
                    //         "showPositionCol": "3",
                    //         "showPositionRow": "3",
                    //         "showTime": "60",
                    //         "themeType": "7",
                    //         "timePoint": "5379",
                    //         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                    //         "top": "2",
                    //         "updateTime": "2016-01-11 16:46:03",
                    //         "userId": "42",
                    //         "videoId": "269672763",
                    //         "vote": null,
                    //         "content":[{
                    //             "data": "%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cspan%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3A%0AHelvetica%3Bcolor%3A%233E3E3E%22%3E%E5%A6%82%E4%BB%8A%E7%9A%84%E5%BD%B1%E8%A7%86%E5%91%A8%E8%BE%B9%E6%97%A9%E5%B0%B1%E5%91%8A%E5%88%AB%E4%BA%86%3Cspan%20lang%3D%22EN-US%22%3ET%3C%2Fspan%3E%E6%81%A4%E5%85%AC%E4%BB%94%E9%A9%AC%E5%85%8B%E6%9D%AF%E7%9A%84%E6%97%B6%E4%BB%A3%EF%BC%8C%E5%9B%B4%E7%BB%95%E3%80%8A%E6%98%9F%E7%90%83%E5%A4%A7%E6%88%98%E3%80%8B%E8%AE%BE%E8%AE%A1%E5%88%B6%E4%BD%9C%E7%9A%84%E8%AE%B8%E5%A4%9A%E5%91%A8%E8%BE%B9%E4%BA%A7%E5%93%81%EF%BC%8C%E6%9B%B4%E6%98%AF%E5%85%85%E6%BB%A1%E5%A6%99%E8%B6%A3%E7%9A%84%E5%85%B8%E8%8C%83%E3%80%82%3Cspan%20lang%3D%22EN-US%22%3E%0A%20%26nbsp%3B%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fspan%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cstrong%20style%3D%22mso-bidi-font-weight%3Anormal%22%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22font-size%3A9.0pt%3B%0Afont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3AHelvetica%3Bcolor%3Ared%22%3E1%3C%2Fspan%3E%3C%2Fstrong%3E%3Cstrong%20style%3D%22mso-bidi-font-weight%3Anormal%22%3E%3Cspan%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%0A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3AHelvetica%3Bcolor%3Ared%22%3E%E3%80%81%E6%B7%8B%E6%B5%B4%E5%96%B7%E5%A4%B4%3Cspan%20lang%3D%22EN-US%22%3E%0A%20%26nbsp%3B%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fspan%3E%3C%2Fstrong%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22line-height%3A%2017.4pt%3B%20font-size%3A%209pt%3B%20font-family%3A%20%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%2C%20sans-serif%3B%20color%3A%20rgb(62%2C%2062%2C%2062)%3B%22%3E%3Cimg%20width%3D%22397%22%20height%3D%22229%22%20src%3D%22http%3A%2F%2Fresource.handsight.cn%2FTVHelp01%2Fimg%2Fupload%2F1451897641405_7635.jpg%22%20v%3Ashapes%3D%22%E5%9B%BE%E7%89%87_x0020_18%22%2F%3E%0A%20%26nbsp%3B%20%3C%2Fspan%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22line-height%3A%2017.4pt%3B%20font-size%3A%209pt%3B%20font-family%3A%20%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%2C%20sans-serif%3B%20color%3A%20rgb(62%2C%2062%2C%2062)%3B%22%3E%26nbsp%3B%20%26nbsp%3B%3C%2Fspan%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3A%0AHelvetica%3Bcolor%3A%233E3E3E%22%3E%0A%20%26nbsp%3B%3Co%3Ap%3E%26nbsp%3B%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cspan%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3A%0AHelvetica%3Bcolor%3A%233E3E3E%22%3E%E9%BB%91%E6%AD%A6%E5%A3%AB%E5%92%8C%3Cspan%20lang%3D%22EN-US%22%3ER2-D2%3C%2Fspan%3E%E6%9C%BA%E5%99%A8%E4%BA%BA%EF%BC%8C%E3%80%8A%E6%98%9F%E7%90%83%E5%A4%A7%E6%88%98%E3%80%8B%E7%9A%84%E5%91%A8%E8%BE%B9%E4%BA%A7%E5%93%81%E9%87%8C%E6%9C%80%E5%B8%B8%E5%87%BA%E7%8E%B0%E7%9A%84%E4%B8%A4%E4%B8%AA%E5%BD%A2%E8%B1%A1%E3%80%82%E7%8C%9C%E5%BE%97%E5%87%BA%E4%B8%8A%E9%9D%A2%E8%BF%99%E4%B8%A4%E4%B8%AA%E5%B0%8F%E4%B8%9C%E8%A5%BF%E6%98%AF%E5%81%9A%E4%BB%80%E4%B9%88%E7%94%A8%E7%9A%84%E5%90%97%EF%BC%9F%E6%B2%A1%E9%94%99%EF%BC%8C%E5%AE%83%E4%BB%AC%E5%85%B6%E5%AE%9E%E6%98%AF%E7%BE%8E%E5%9B%BD%E7%9A%84%E6%B7%8B%E6%B5%B4%E5%93%81%E7%89%8C%3Cspan%20lang%3D%22EN-US%22%3EOxygenics%3C%2Fspan%3E%E6%8E%A8%E5%87%BA%E7%9A%84%E6%B7%8B%E6%B5%B4%E5%96%B7%E5%A4%B4%E3%80%82%E4%B8%8D%E7%AE%A1%E6%98%AF%E9%BB%91%E6%AD%A6%E5%A3%AB%E8%BF%98%E6%98%AF%3Cspan%20lang%3D%22EN-US%22%3ER2-D2%3C%2Fspan%3E%EF%BC%8C%E9%83%BD%E6%9C%89%E4%B8%89%E7%A7%8D%E6%B0%B4%E6%B5%81%E6%A8%A1%E5%BC%8F%E4%BE%9B%E4%BD%A0%E8%B0%83%E8%8A%82%E3%80%82%E6%83%B3%E6%83%B3%E7%9C%8B%EF%BC%8C%E4%B8%80%E5%BC%80%E6%B0%B4%E9%BE%99%E5%A4%B4%EF%BC%8C%E8%BE%BE%E6%96%AF%3Cspan%20lang%3D%22EN-US%22%3E%E2%80%A2%3C%2Fspan%3E%E7%BB%B4%E8%BE%BE%E4%BB%8E%E7%9C%BC%E7%AA%9D%E9%87%8C%E5%93%97%E5%93%97%E6%9C%9D%E4%BD%A0%E5%96%B7%E6%B0%B4%EF%BC%8C%E8%AE%A9%E4%BD%A0%E6%B2%90%E6%B5%B4%E5%9C%A8%E7%88%B5%E7%88%B7%E5%85%85%E6%BB%A1%E6%82%94%E6%81%A8%E7%9A%84%E7%9C%BC%E6%B3%AA%E7%80%91%E5%B8%83%E4%B9%8B%E4%B8%AD%EF%BC%8C%E6%98%AF%E4%B8%8D%E6%98%AF%E6%9C%89%E4%BA%86%E5%BE%81%E6%9C%8D%E5%85%A8%E5%AE%87%E5%AE%99%E7%9A%84%E6%84%9F%E8%A7%89%EF%BC%9F%3Cspan%20lang%3D%22EN-US%22%3E%0A%20%26nbsp%3B%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C…%26quot%3Bsans-serif%26quot%3B%3Bcolor%3A%234C5969%3B%0Abackground%3Awhite%22%3E%E8%8B%B1%E5%9B%BD%3Cspan%20lang%3D%22EN-US%22%3EIrregular%20Choice%2014%3C%2Fspan%3E%E6%AC%BE%E6%98%9F%E6%88%98%E4%B8%BB%E9%A2%98%E9%AB%98%E8%B7%9F%E9%9E%8B%E6%B7%B7%E5%85%A5%E4%BA%86%E5%90%84%E7%A7%8D%E6%98%9F%E6%88%98%E7%9A%84%E5%85%83%E7%B4%A0%EF%BC%8C%E4%B8%8D%E4%BB%85%E6%83%B3%E7%BB%99%E8%AE%BE%E8%AE%A1%E5%B8%88%E8%84%91%E6%B4%9E%E6%BB%A1%E5%88%86%EF%BC%8C%E5%90%8C%E6%97%B6%E4%B9%9F%E6%83%B3%E7%BB%99%E7%A9%BF%E4%B8%8A%E8%BF%99%E5%8F%8C%E4%BA%9B%E7%9A%84%E5%A5%B3%E7%94%9F%E4%BB%AC%E5%8B%87%E6%B0%94%E6%BB%A1%E5%88%86%EF%BC%81%3C%2Fspan%3E%3Cstrong%20style%3D%22mso-bidi-font-weight%3Anormal%22%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22font-size%3A9.0pt%3B%0Afont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bcolor%3Ablack%3Bbackground%3Awhite%22%3E%0A%20%26nbsp%3B%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fstrong%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3A%0AHelvetica%3Bcolor%3A%233E3E3E%3Bmso-no-proof%3Ayes%22%3E%3Cimg%20width%3D%22554%22%20height%3D%22492%22%20src%3D%22http%3A%2F%2Fresource.handsight.cn%2FTVHelp01%2Fimg%2Fupload%2F1451897641749_6981.jpg%22%20v%3Ashapes%3D%22%E5%9B%BE%E7%89%87_x0020_120%22%2F%3E%0A%20%26nbsp%3B%20%3C!--%5Bendif%5D--%3E%0A%20%26nbsp%3B%20%3C!--%5Bif%20gte%20vml%201%5D%3E%3Cv%3Ashape%0A%20id%3D%22%E5%9B%BE%E7%89%87_x0020_123%22%20o%3Aspid%3D%22_x0000_i1158%22%20type%3D%22%23_x0000_t75%22%20style%3D\'width%3A415.5pt%3B%0A%20height%3A338.25pt%3Bvisibility%3Avisible%3Bmso-wrap-style%3Asquare\'%3E%3Cv%3Aimagedata%20src%3D%221451897633106_1373.files%2Fimage021.png%22%20o%3Atitle%3D%22%22%2F%3E%3C%2Fv%3Ashape%3E%3C!%5Bendif%5D--%3E%0A%20%26nbsp%3B%20%3C!--%5Bif%20!vml%5D--%3E%3Cimg%20width%3D%22554%22%20height%3D%22451%22%20src%3D%22http%3A%2F%2Fresource.handsight.cn%2FTVHelp01%2Fimg%2Fupload%2F1451897641780_5008.jpg%22%20v%3Ashapes%3D%22%E5%9B%BE%E7%89%87_x0020_123%22%2F%3E%0A%20%26nbsp%3B%20%3C!--%5Bendif%5D--%3E%3C%2Fspan%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3A%0AHelvetica%3Bcolor%3A%233E3E3E%22%3E%0A%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cstrong%20style%3D%22mso-bidi-font-weight%3Anormal%22%3E%3Cspan%20lang%3D%22EN-US%22%20style%3D%22font-size%3A9.0pt%3B%0Afont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3AHelvetica%3Bcolor%3Ared%22%3E8%3C%2Fspan%3E%3C%2Fstrong%3E%3Cstrong%20style%3D%22mso-bidi-font-weight%3Anormal%22%3E%3Cspan%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%0A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bmso-bidi-font-family%3AHelvetica%3Bcolor%3Ared%22%3E%E3%80%81%E9%A3%9E%E6%9C%BA%3Cspan%20lang%3D%22EN-US%22%3E%0A%20%26nbsp%3B%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fspan%3E%3C%2Fstrong%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cspan%20style%3D%22font-size%3A9.0pt%3Bfont-family%3A%26quot%3B%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%26quot%3B%2C%26quot%3Bsans-serif%26quot%3B%3Bcolor%3A%234C5969%3B%0Abackground%3Awhite%22%3E%E5%85%A8%E6%97%A5%E7%A9%BA%E8%88%AA%E7%A9%BA%E5%85%AC%E5%8F%B8%3Cspan%20lang%3D%22EN-US%22%3E787-9%3C%2Fspan%3E%E5%AE%A2%E6%9C%BA%3Cspan%20lang%3D%22EN-US%22%3E%2C%3C%2Fspan%3E%E6%95%B4%E4%B8%AA%E6%9C%BA%E8%BA%AB%E9%83%BD%E8%A2%AB%E6%9C%BA%E5%99%A8%E4%BA%BA%3Cspan%20lang%3D%22EN-US%22%3ER2-D2%3C%2Fspan%3E%E5%92%8C%3Cspan%20lang%3D%22EN-US%22%3ESTAR%20WARS%3C%2Fspan%3E%E5%85%83%E7%B4%A0%E6%89%80%E5%8C%85%E5%9B%B4%EF%BC%8C%E7%9C%9F%E5%B8%8C%E6%9C%9B%E5%9D%90%E4%B8%8A%E8%BF%99%E6%9E%B6%E9%A3%9E%E6%9C%BA%E7%9A%84%E6%98%9F%E6%88%98%E7%B2%89%E4%B8%9D%E8%83%BD%E5%9C%A8%E4%B8%87%E7%B1%B3%E9%AB%98%E7%A9%BA%E6%8E%A5%E7%9D%80%E5%97%A8%E3%80%82%3Cspan%20lang%3D%22EN-US%22%3E%0A%20%26nbsp%3B%20%26nbsp%3B%3Co%3Ap%3E%3C%2Fo%3Ap%3E%3C%2Fspan%3E%3C%2Fspan%3E%3C%2Fp%3E%3Cp%20style%3D%22margin%3A0cm%3Bmargin-bottom%3A.0001pt%3Bline-height%3A17.4pt%3Bbackground%3Awhite%22%3E%3Cimg%20width%3D%22554%22%20height%3D%22303%22%20src%3D%22http%3A%2F%2Fresource.handsight.cn%2FTVHelp01%2Fimg%2Fupload%2F1451897641827_5031.jpg%22%20v%3Ashapes%3D%22%E5%9B%BE%E7%89%87_x0020_126%22%20style%3D%22color%3A%20rgb(62%2C%2062%2C%2062)%3B%20font-family%3A%20%E5%BE%AE%E8%BD%AF%E9%9B%85%E9%BB%91%2C%20sans-serif%3B%20font-size%3A%209pt%3B%20line-height%3A%2017.4pt%3B%22%2F%3E%3C%2Fp%3E",
                    //             "type": "3"
                    //         }]
                    //     }
                    // }
                    // $timeout(function(){
                    //     callback && callback(result);
                    // },1000)
                    // return;
                return resource.getHeadThemeDetail({
                    motiveId:motiveId
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询首页信息
             * @return {[type]}                [description]
             */
            getHomeInfo: function(type,callback) {
                // var homeList = {
                //             "code": 20001,
                //             "data":{
                //                 "videoList":[{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 2,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450749451433_5241.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "268701619",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450841507460_9796.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "268651923",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://resource.handsight.cn/TVHelp01/img/upload/1450841507460_9796.jpg",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     },{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 3,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 1,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 1,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },{
                //                     "addTime": "2015-10-23 10:10:10",
                //                     "area": "美国",
                //                     "bianju": "乔斯·韦登 / 斯坦·李 / 杰克·科比",
                //                     "director": "乔斯·韦登",
                //                     "featuresVOs": null,
                //                     "homePage": 1,
                //                     "img": "http://resource.handsight.cn/TVHelp01/img/upload/1450075693508_114.jpg",
                //                     "introduce": "托尼·斯塔克（小罗伯特·唐尼 Robert Downey Jr. 饰）试图重启一个已经废弃的维和项目，不料该项目却成为危机导火索。世上最强大的超级英雄——钢铁侠、美国队长（克里斯·埃文斯 Chris Evans 饰）、雷神（克里斯·海姆斯沃斯 Chris Hemsworth 饰）、绿巨人（马克·鲁弗洛 Mark Ruffalo 饰）、黑寡妇（斯嘉丽·约翰逊 Scarlett Johansson 饰）和鹰眼（杰瑞米·雷纳 Jeremy Renner 饰），不得不接受终极考验，拯救危在旦夕的地球。神秘反派奥创（詹姆斯·斯派德 James Spader 配音）逐渐崛起，超级英雄们必须重新集结，竭力阻止奥创实施人类灭绝计划。战斗中，复仇者联盟成员们还遇到了两个新人物——旺达·马克西莫夫（伊丽莎白·奥尔森 Elizabeth Olsen 饰）和皮特罗·马克西莫...",
                //                     "isDel": "1",
                //                     "language": "英语 / 韩语",
                //                     "leadingActor": "小罗伯特·唐尼 / 克里斯·海姆斯沃斯 / 马克·鲁弗洛 / 克里斯·埃文斯 / 斯嘉丽·约翰逊",
                //                     "pVid": "",
                //                     "posters": null,
                //                     "releaseTime": "8520",
                //                     "sonVideoCount": null,
                //                     "status": 2,
                //                     "tags": "动作 / 科幻 / 奇幻 / 冒险",
                //                     "typeId": "2",
                //                     "typeName": "电影",
                //                     "updateTime": "2016-01-14 09:35:24",
                //                     "videoFirstFrame": null,
                //                     "videoId": "1045",
                //                     "videoType": "2",
                //                     "videoImagePath": "",
                //                     "videoName": "复仇者联盟2",
                //                     "videoUrl": "http://video.handsight.cn/复仇者联盟2.mp4",
                //                     "year": null,
                //                     "headThemeList":[{
                //                         "approvedStatus": "1",
                //                         "approvedUserId": "42",
                //                         "collection": "",
                //                         "commodity": null,
                //                         "createTime": "2016-01-11 16:43:57",
                //                         "guessing": null,
                //                         "isDel": "1",
                //                         "link": "",
                //                         "motiveId": "269753852",
                //                         "positionCol": "3",
                //                         "positionRow": "3",
                //                         "reason": "",
                //                         "showPositionCol": "3",
                //                         "showPositionRow": "3",
                //                         "showTime": "60",
                //                         "themeType": "7",
                //                         "timePoint": "5379",
                //                         "title": "电影号称第七艺术，国内电影木有入门槛审核么？",
                //                         "top": "2",
                //                         "updateTime": "2016-01-11 16:46:03",
                //                         "userId": "42",
                //                         "videoId": "269672763",
                //                         "vote": null,
                //                     }]
                //                 },],
                //                 "hotTvstationList":[{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "playingProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 13:20:00",
                //                     "tvProgramEndtime": "2016-01-21 13:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "playingProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 13:20:00",
                //                     "tvProgramEndtime": "2016-01-21 13:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "playingProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 13:20:00",
                //                     "tvProgramEndtime": "2016-01-21 13:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "playingProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 13:20:00",
                //                     "tvProgramEndtime": "2016-01-21 13:20:00",
                //                 }],
                //                 "hotLiveprogramList":[{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-18 13:20:00",
                //                     "tvProgramEndtime": "2016-01-10 13:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 08:20:00",
                //                     "tvProgramEndtime": "2016-01-21 23:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 21:20:00",
                //                     "tvProgramEndtime": "2016-01-21 23:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 09:20:00",
                //                     "tvProgramEndtime": "2016-01-21 23:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-21 19:20:00",
                //                     "tvProgramEndtime": "2016-01-21 23:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-18 09:20:00",
                //                     "tvProgramEndtime": "2016-01-18 23:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-18 13:20:00",
                //                     "tvProgramEndtime": "2016-01-18 13:20:00",
                //                 },{
                //                     "tvStationId": "11",
                //                     "videoId": "11",
                //                     "mname": "湖南台",
                //                     "mimg":"img/tv01.png" ,
                //                     "tvProgramId": "11",
                //                     "videoId": "11",
                //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                //                     "tvProgramName": "爸爸去哪里了",
                //                     "tvProgramStarttime": "2016-01-18 13:20:00",
                //                     "tvProgramEndtime": "2016-01-18 13:20:00",
                //                 }]
                //             },
                //             "msg": "success",
                //             "success": true
                //             }
                // $timeout(function(){
                //     // homeList.data.hotLiveprogramList = [];
                //     // homeList.data.hotTvstationList = [];
                //     // homeList.data.videoList = [];
                //     callback && callback(homeList);
                // },1000)
                // return;
                return resource.getHomeInfo({
                    type:type
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询电视台列表接口
             * @return {[type]}                [description]
             */
            getTvstationList: function(callback) {
                // var result = {
                //             "code": 20001,
                //             "data":
                //             [{
                //             "typeId": "1",
                //             "typeName": "卫视",
                //             "menuList": [{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             }]
                //             },{
                //             "typeId": "1",
                //             "typeName": "卫视",
                //             "menuList": [{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"img/tv01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             }]
                //             },{
                //             "typeId": "1",
                //             "typeName": "中央电视",
                //             "menuList": [{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"/img/redpacked01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"../img/redpacked01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"../img/redpacked01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             },{
                //             "tvStationId": "11",
                //             "mname": "湖南台",
                //             "mimg":"../img/redpacked01.png" ,
                //             "playingProgramName": "爸爸去哪里了",
                //             }]
                //             }],
                //             "msg": "success",
                //             "success": true
                //             }
                // $timeout(function(){callback && callback(result);},1000)
                // return;
                return resource.getTvstationList(null, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询电视台节目接口
             * @return {[type]}                [description]
             */
            getTvprogramList: function(menuId,startTime,endTime,callback) {
                    // var result = {
                    //             "code": 20001,
                    //             "data":
                    //             {
                    //             "tvStationId": "1",
                    //             "tvStationName ": "湖南台",
                    //             "tvStationLogo":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //             "tvProgramList": [{
                    //                 "programsInDate":"2016-01-22 13:20:00",
                    //                 "programList":[{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-22 13:20:00",
                    //                     "endtime": "2016-01-22 13:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "天天饮食",
                    //                     "starttime": "2016-01-22 13:20:00",
                    //                     "endtime": "2016-01-22 13:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "天天饮食",
                    //                     "starttime": "2016-01-22 13:20:00",
                    //                     "endtime": "2016-01-22 13:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-22 13:20:00",
                    //                     "endtime": "2016-01-22 13:20:00",
                    //                     }]
                    //             },{
                    //                 "programsInDate":"2016-01-21 13:20:00",
                    //                 "programList":[{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "天天饮食",
                    //                     "starttime": "2016-01-21 08:20:00",
                    //                     "endtime": "2016-01-21 14:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-21 17:20:00",
                    //                     "endtime": "2016-01-21 23:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-21 14:20:00",
                    //                     "endtime": "2016-01-21 17:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-21 13:20:00",
                    //                     "endtime": "2016-01-21 13:20:00",
                    //                     }]
                    //             },{
                    //                 "programsInDate":"2016-01-19 13:20:00",
                    //                 "programList":[{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "生活早参考",
                    //                     "starttime": "2016-01-19 10:25:00",
                    //                     "endtime": "2016-01-19 15:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "天天饮食",
                    //                     "starttime": "2016-01-19 10:20:00",
                    //                     "endtime": "2016-01-19 10:25:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-19 07:20:00",
                    //                     "endtime": "2016-01-19 10:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "挑战不可能-6",
                    //                     "starttime": "2016-01-19 23:20:00",
                    //                     "endtime": "2016-01-19 23:20:00",
                    //                     }]
                    //             },{
                    //                 "programsInDate":"2016-01-20 13:20:00",
                    //                 "programList":[{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "生活早参考",
                    //                     "starttime": "2016-01-10 13:20:00",
                    //                     "endtime": "2016-01-10 13:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "天天饮食",
                    //                     "starttime": "2016-01-13 13:20:00",
                    //                     "endtime": "2016-01-11 13:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "爸爸去哪里了",
                    //                     "starttime": "2016-01-11 13:20:00",
                    //                     "endtime": "2016-01-11 13:20:00",
                    //                     },{
                    //                     "tvProgramId": "11",
                    //                     "tvProgramImg":"http://handsight.cn/video/bianxingjinggangsi.jpg" ,
                    //                     "pname": "挑战不可能-6",
                    //                     "starttime": "2016-01-12 13:20:00",
                    //                     "endtime": "2016-01-12 13:20:00",
                    //                     }]
                    //             }]
                    //             }
                    //             ,
                    //             "msg":"success",
                    //             "success":true
                    //             }
                    // $timeout(function(){
                    //     callback && callback(result);
                    // },1000)
                    // return;
                return resource.getTvprogramList({
                    menuId:menuId,
                    startTime:startTime,
                    endTime:endTime,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询首页活动
             * @param  {[type]} status    视频状态
             * @param  {[type]} homePage  是否首页显示（1true,2false）
             * @return {[type]}           [description]
             */

            getActiveList: function(mark,starttime,endtime,type,callback) {
                // if(type==6){
                //     var result = {
                //         "data":[{
                //             activeId:"250"
                //         }]
                //     }
                //     callback && callback(result);
                // }
                return resource.getActiveList(null, param({
                    mark:mark,
                    type:type,
                    starttime:starttime,
                    endtime:endtime
                })).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询抽奖次数
             * @return {[type]}                [description]
             */
            getActivetyPlaytime: function(activeId,callback) {
                // if(activeId=="250"){
                //     var result = {
                //         "data":"1"
                //     }
                //     callback && callback(result);
                // }
                return resource.getActivetyPlaytime(null, param({
                    activeId:activeId
                })).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 将抢红包中奖用户信息发送给服务器
             * @param  {[type]} themeType        哪种主题,主题类型
             * @param  {[type]} rootId           评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
             * @param  {[type]} pageNo           当前页数
             * @param  {[type]} pageSize         每页大小
             * @return {[type]}                [description]
             */
            sendRedpacketUserInfro: function(activeId,serialId,username,tel,mailCode,addr,callback) {
                // var result={"success":true}
                // callback && callback(result);return
                return resource.sendRedpacketUserInfro(null, param({
                    activeId:activeId,
                    serialId:serialId,
                    username:username,
                    tel:tel,
                    mailCode:mailCode,
                    addr:addr
                })).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询抢红包活动结果
             * @param  {[type]} themeType        哪种主题,主题类型
             * @param  {[type]} rootId           评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
             * @param  {[type]} pageNo           当前页数
             * @param  {[type]} pageSize         每页大小
             * @return {[type]}                [description]
             */
            getRedPacketResult: function(activeId,callback) {
                // if(activeId=="250"){
                //     var result = {
                //         "data":{
                //             "rewardId":"2"
                //         }
                //     }
                //     callback && callback(result);return;
                // }
                return resource.getRedPacketResult(null, param({
                    activeId:activeId
                })).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询红包活动详情
             * @return {[type]}                [description]
             */
            getRedPacket: function(activeId,callback) {
                // if(activeId=="250"){
                //     var result = {
                //         "data":{
                //             "rewards":[{
                //                 "rewardId": "0",
                //                 "rewardName": "this is text",
                //                 "rewardImg": "",
                //                 "color": "#ffffff",
                //                 "rewardSum": "2",
                //                 "rewardSlogan": "this is text",
                //                 "probability": "0.5"

                //             },{
                //                 "rewardId": "1",
                //                 "rewardName": "this is text",
                //                 "rewardImg": "",
                //                 "color": "#ffffff",
                //                 "rewardSum": "2",
                //                 "rewardSlogan": "this is text",
                //                 "probability": "0.5"

                //             },{
                //                 "rewardId": "2",
                //                 "rewardName": "五元话费",
                //                 "rewardImg": "",
                //                 "color": "#ffffff",
                //                 "rewardSum": "2",
                //                 "rewardSlogan": "this is text",
                //                 "probability": "0.5"

                //             }],
                //             "remark":"这是一个抢红包的活动，抢完既可以中花费，这是一个抢红包的活动，抢完既可以中花费这是一个抢红包的活动，抢完既可以中花费这是一个抢红包的活动，抢完既可以中花费这是一个抢红包的活动，抢完既可以中花费"
                //         }
                //     }
                //     callback && callback(result);return;
                // }
                return resource.getRedPacket(null, param({
                    activeId:activeId
                })).$promise.then(function(result){
                    callback && callback(result);return;
                })
            },
            // getRedActivetyInfro:function(mark, starttime, endtime, type,callback){
            //     var self = this;
            //     self.getActiveList(mark, starttime, endtime, type, function(result) { //查询抢红包
            //         debugger
            //         if (result.data) {
            //             var activeId =result.data.activeId;//活动id
            //             self.getActivetyPlaytime(activeId,function(resulttime){//查询剩余抽奖次数
            //                 if(resulttime.data!=0){
            //                     self.getRedPacket(activeId,function(detailresult){

            //                     })
            //                 }else{
            //                     console.log("没有抽奖次数了")
            //                 }
            //             })
            //         }else{
            //             console.log("no redactivity")
            //         }
            //     })
            // },
            /**
             * 分页查询评论列表
             * @param  {[type]} themeType        哪种主题,主题类型
             * @param  {[type]} rootId           评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
             * @param  {[type]} pageNo           当前页数
             * @param  {[type]} pageSize         每页大小
             * @return {[type]}                [description]
             */
            getCommentbyPage: function(themeType,rootId,pageNo,pageSize,callback) {
                return resource.getCommentbyPage({
                    themeType:themeType,
                    rootId:rootId,
                    pageNo:pageNo,
                    pageSize:pageSize,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询乐配成果详情页信息
             * @return {[type]}              [description]
             */
            getDisportDetail: function(disportId,callback) {
                return resource.getDisportDetail({
                    disportId:disportId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询场景页面信息
             * @return {[type]}              [description]
             */
            getTvDetail: function(type,callback) {
                return resource.getTvDetail({
                    type:type,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 根据城市查询电影院
             * @param  {[type]} targetId      要点赞的数据Id
             * @param  {[type]} type
             * @return {[type]}              [description]
             */
            getCityCinema: function(areaId,callback) {
                return resource.getCityCinema({
                    areaId:areaId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            selectAcity:function(areaId,callback){
                this.getCityCinema(areaId,function(result){
                    if(result.data&&result.data.length>0){
                        callback && callback({"success":true,"cinemaList":result.data});
                    }else{
                        callback &&callback({"success":false,"msg":result.msg})
                    }
                })
            },
            /**
             * 查询城市列表
             * @param  {[type]} targetId      要点赞的数据Id
             * @param  {[type]} type
             * @return {[type]}              [description]
             */
            _getCityList: function(callback) {
                return resource._getCityList(null, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            getCityList:function(callback){
                if(Storage.get('city_list')==null){
                    this._getCityList(function(result){
                        if(result.data&&result.data.length>0){
                            Storage.set('city_list',{"success":true,"cityList":result.data});
                            callback && callback({"success":true,"cityList":result.data});
                        }else{
                            callback &&callback({"success":false,"msg":result.msg})
                            // console.log(result.msg)
                        }
                    })
                }else{
                    var cityList = Storage.get("city_list");
                    callback && callback(cityList);
                }
            },

            /**
             * 用户点赞
             * @param  {[type]} targetId      要点赞的数据Id
             * @param  {[type]} type          点赞的数据类型(type=1,对评论点赞，targetId是评论ID；type=2，对视频，targetId是视频ID；type=3，对主题，targetId是主题ID)
             * @return {[type]}              [description]
             */
            getPraise: function(targetId,type,callback) {
                return resource.getPraise({
                    targetId:targetId,
                    type:type,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 用户点赞
             * @param  {[type]} targetId      要点赞的数据Id
             * @param  {[type]} type          点赞的数据类型(type=1,对评论点赞，targetId是评论ID；type=2，对视频，targetId是视频ID；type=3，对主题，targetId是主题ID)
             * @return {[type]}              [description]
             */
            addPraise: function(targetId,type,callback) {
                return resource.addPraise({
                    targetId:targetId,
                    type:type,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 删除一个场景连接
             * @param  {[type]} senceId      电影场景的ID
             * @return {[type]}              [description]
             */
            deleteAsence: function(senceId,callback) {
                return resource.deleteAsence({
                    sceneId:senceId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 获取终端电影临时场景列表
             *type        场景类型（0、所有，1、电影院场次，2、机顶盒）
             * @return {[type]}              [description]
             */
            getSenceList: function(type,callback) {
                        return resource.getSenceList({
                            type:type,
                        }, param()).$promise.then(function(result){
                            callback && callback(result);
                        })
            },
            /**
             * 根据电影场景ID查询绑定的电影场次信息
             * @param  {[type]} senceId       电影场景的ID
             * @return {[type]}              [description]
             */
            getSenceInfor: function(sceneId,callback) {
                return resource.getSenceInfor({
                    sceneId:sceneId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            getSenceInforByIds: function(vIds){
                var promises = [];
                angular.forEach(vIds, function(id){
                    var promise = resource.getSenceInfor({
                        sceneId: id
                    }, param()).$promise;
                    promises.push(promise);
                });
                return $q.all(promises);
            },
            //获取场景页面详情

            getSenceInfroList:function(type,callback){
                var senceList=[];
                var sceneIds = [];
                var self = this;
                var getShowTime = function(time){

                  if(time!=""){
                    var temp = time;
                    temp = time.split(" ")[1];
                    if(temp.length>5){
                      temp = temp.slice(0,5);
                      return temp;
                    }else{
                      return time;
                    }
                  }

                }
                self.getTvDetail(type,function(result){
                    if(result.success){
                        if(result.data.movieSenceList.length>0){
                            angular.forEach(result.data.movieSenceList,function(item){
                                var currentD = new Date();
                                item.videoType = 2 //电视
                                if(item.realtime!=null&&item.movieEndTime!=null){
                                    // item.realtime = "2016-01-11 11:13:00";
                                    // item.movieEndTime = "2016-01-11 23:17:00";
                                    item.showStartTime = getShowTime(item.realtime)
                                    item.showEndTime = getShowTime(item.movieEndTime)
                                    var startT = new Date(item.realtime.replace(/-/g,"/"));
                                    var endT = new Date(item.movieEndTime.replace(/-/g,"/"));
                                    if(currentD<startT){
                                        item.buttonName = "精彩预约";
                                        item.showstatus = "1";
                                        item.startT = startT;
                                        item.endT = endT;
                                    }else if(currentD>endT){
                                        item.buttonName = "精彩回顾";
                                         item.showstatus = "2";
                                        item.startT = startT;
                                        item.endT = endT;
                                    }else{
                                        item.buttonName = "精彩互动";
                                         item.showstatus = "3";
                                        item.startT = startT;
                                        item.endT = endT;
                                    }

                                    senceList.unshift(item)
                                }
                            })
                            result.data.movieSenceList = senceList;
                        }
                        if(result.data.programList && result.data.programList.length>0){
                            var currentD = new Date();
                            angular.forEach(result.data.programList,function(item){
                                item.videoType = 1 //节目
                                item.startT = new Date(item.starttime.replace(/-/g,"/"));
                                item.endT = new Date(item.endtime.replace(/-/g,"/"));
                                item.showStartTime = getNiceTime(item.startT,4);
                                item.showEndTime = getNiceTime(item.endT,4);
                                if(currentD<item.startT){
                                    item.buttonName = "精彩预约";
                                    item.showstatus = "1";
                                }else if(currentD>item.endT){
                                    item.buttonName = "精彩回顾";
                                     item.showstatus = "2";

                                }else{
                                    item.buttonName = "精彩互动";
                                     item.showstatus = "3";
                                }

                            })
                        }
                        result.data.success = true;
                    }else{
                        console.log("nodata")
                        // result.data.success = false;
                        var resultstatus = false;
                        callback&&callback(resultstatus);return;
                    }
                    callback&&callback(result.data);return;
                })
            },
            /**
             * 绑定一个场景连接
             * @param  {[type]} showtimeId    电影场次的ID
             * @param  {[type]} type          场景类型（1电影院场次，2机顶盒）
             * @return {[type]}              [description]
             */
            addAsence: function(showtimeId,type,callback) {
                var self = this;
                return resource.addAsence({
                    showtimeId:showtimeId,
                    type:type,
                }, param()).$promise.then(function(result){
                    //这里来绑定临时场景，绑定临时场景的同时，
                    //需要发送一条消息给APP后台的推送服务，仅安卓版使用
                    self.getSenceInfroList(0,function(result){
                        senceList = result.movieSenceList;
                        $rootScope.$broadcast("addnewsence",{"data":senceList})
                        // debugger
                    })
                    // $rootScope.$broadcast("addnewsence",{"data":true})
                    callback && callback(result);
                })
            },
            /**
             * 绑定一个场景连接
             * @param  {[type]} showtimeId    电影场次的ID
             * @param  {[type]} type          场景类型（1电影院场次，2机顶盒）
             * @return {[type]}              [description]
             */
            addAsenceNew: function(showtimeId,type,callback) {
                var self = this;
                return resource.addAsenceNew({
                    showtimeId:showtimeId,
                    type:type,
                }, param()).$promise.then(function(result){
                    //这里来绑定临时场景，绑定临时场景的同时，
                    //需要发送一条消息给APP后台的推送服务，仅安卓版使用
                    self.getSenceInfroList(0,function(result){
                        $rootScope.$broadcast("addnewsence",result)
                    })
                    // $rootScope.$broadcast("addnewsence",{"data":true})
                    callback && callback(result);
                })
            },
            /**
             * 调用百度定位插件
             * @return {[type]} [description]
             */
            searchLocation: function(callback){
                //百度定位插件
                if(typeof(cordova) != "undefined"){
                    cordova.plugins.WHLocal.getCurrentPosition(
                        function(result){
                            //授权成功返回用户信息
                            if(result.latitude || /5e-324/.test(result.latitude)){
                                if(Storage.get('local_storage_position')!=null){
                                    var baidulocation= Storage.get('local_storage_position');
                                }else{
                                    var baidulocation = {
                                        'longitude': 104.06667,
                                        'latitude': 30.66667,
                                        'addr':"成都市",
                                        'city':"成都",
                                    }

                                }
                            }else{
                                var baidulocation = {};
                                baidulocation=JSON.parse(result)
                                Storage.set('local_storage_position',baidulocation);
                            }

                            // userlocation.longitude = baidulocation.longitude;//经度
                            // userlocation.latitude = baidulocation.latitude;//纬度
                            // userlocation.addr = baidulocation.addr;
                            // userlocation.city = baidulocation.city;
                            // userlocation.msg = baidulocation.message;
                            callback&&callback(baidulocation);return;

                        },
                        function(msg){
                            //错误处理
                            if(Storage.get('local_storage_position')!=null){
                                var baidulocation= Storage.get('local_storage_position');
                            }
                        });
                }else{
                    var baidulocation = {
                        'longitude': 104.08188,
                        'latitude': 30.545789,
                        'addr':"成都市武侯区天府软件园d区",
                        'city':"成都",
                    }
                    if(baidulocation==null){
                        if(Storage.get('local_storage_position')!=null){
                            var baidulocation= Storage.get('local_storage_position');
                        }else{
                            var baidulocation = {
                                'longitude': 104.06667,
                                'latitude': 30.66667,
                                'addr':"成都市",
                                'city':"成都",
                            }
                        }
                    }else{
                        Storage.set('local_storage_position',baidulocation);

                        // debugger
                    }

                    // debugger
                    // userlocation.msg = baidulocation.message;
                    // var baidulocation={}
                    $timeout(function(){callback&&callback(baidulocation)},2000);return;
                    // callback&&callback(baidulocation);return;
                }

            },
            /**
             * 查询附近电影院上映的电影信息接口
             * @param  {[type]} showtimeId          电影院的ID
             * @return {[type]}              [description]
             */
            getShowSessionInfor: function(showtimeId,callback) {
                return resource.getShowSessionInfor({
                    showtimeId:showtimeId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询附近电影院上映电影场次信息
             * @param  {[type]} cId          电影院的ID
             * @return {[type]}              [description]
             */


            getShowSessionId: function(cId,mId,date,callback) {
                return resource.getShowSessionId({
                    cinemaId:cId,
                    videoId:mId,
                    date:date
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询附近电影院上映的电影信息接口
             * @param  {[type]} cId          电影院的ID
             * @return {[type]}              [description]
             */
            getShowMovie: function(cId,callback) {
                return resource.getShowMovie({
                    cinemaId:cId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询用户附近电影院
             * @param  {[type]} longitude    百度经度
             * @param  {[type]} latitude     百度纬度
             * @return {[type]}              [description]
             */

            getAroundCinema: function(longitude,latitude,distance,callback) {
                return resource.getAroundCinema({
                    longitude:longitude,
                    latitude:latitude,
                    distance:distance
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询视频视频列表
             * @param  {[type]} disportType    娱乐类型  娱乐类型（0全部 1乐配词 2乐配音）
             * @param  {[type]} area           地区     地区（0全部 1内地 2港台 3日韩 4欧美 5其他）
             * @param  {[type]} type           影片内线  影片内线（0全部 1爱情 2战争 3喜剧 4科幻 5恐怖 6动画）
             * @param  {[type]} year           年份     年份（2010 2011 2012 2013 2014 2015）
             * @param  {[type]} currentPageNo  当前页数
             * @return {[type]}                [description]
             */
            getMoviesList: function(sendParameter,callback) {
                return resource.getMoviesList(sendParameter, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询视频视频列表
             * @param  {[type]} disportType    娱乐类型  娱乐类型（0全部 1乐配词 2乐配音）
             * @param  {[type]} area           地区     地区（0全部 1内地 2港台 3日韩 4欧美 5其他）
             * @param  {[type]} type           影片内线  影片内线（0全部 1爱情 2战争 3喜剧 4科幻 5恐怖 6动画）
             * @param  {[type]} year           年份     年份（2010 2011 2012 2013 2014 2015）
             * @param  {[type]} currentPageNo  当前页数
             * @return {[type]}                [description]
             */
            getVideoList: function(sendParameter,callback) {
                return resource.getVideoList(sendParameter, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询首页显示视频元素
             * @param  {[type]} status    视频状态
             * @param  {[type]} homePage  是否首页显示（1true,2false）
             * @return {[type]}           [description]
             */

            getHomeMovies: function(callback) {
                return resource.getHomeMovies(null,param({})).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询视频二级显示的脑补主题
             * @param  {[type]} type                         主题类型（0:所有的，1:话题；2：投票，3：商品， 4：知识点，5：竞猜，6未分类,7：脑补主题，10：简介)
             * @param  {[type]} videoId                      视频ID
             * @param  {[type]} approvedStatuscallback       审核状态(0:所有，1：通过，2：未通过) 不是必选项目
             * @return {[type]}           [description]
             */

            getHeadTheme: function(type,videoId,callback) {

                return resource.getHeadTheme(null, param({
                    type:type,
                    videoId:videoId
                })).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            getHeadThemeByIds: function(type, vIds){
                var promises = [];
                angular.forEach(vIds, function(id){
                    var promise = resource.getHeadTheme(null, param({
                        type: type,
                        videoId: id
                    })).$promise;
                    promises.push(promise);
                });
                return $q.all(promises);
            },

            /**
             * 查询视频元素的相关成果
             * @param  {[type]} vId            视频ID
             * @param  {[type]} disportDataId  素材ID
             * @return {[type]}                [description]
             */

            getEntertainmentOther: function(vId,callback) {
                return resource.getEntertainmentOther({
                    videoId:vId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询其他影片的娱乐推荐
             * @param  {[type]} vId          视频ID
             * @return {[type]}              [description]
             */

            getEntertainmentOthervideo: function(vId,callback) {

                return resource.getEntertainmentOthervideo({
                    videoId:vId
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询相关视频元素
             * @param  {[type]} vId          视频ID
             */

            getRelatedVideo: function(vId,callback) {

                return resource.getRelatedVideo({
                    videoId:vId,
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            },
            /**
             * 查询视频元素详情
             * @param  {[type]} vId            视频ID
             * @return {[type]}                [description]
             */
            getVideoDetails: function(vId,callback) {

                return resource.getVideoDetails({
                    videoId:vId
                }, param()).$promise.then(function(result){
                    callback && callback(result);
                })
            }
        }
    })