'user strict';
/**
 * @description 数据管理服务
 */
rootModule

    .factory('NetWork', function (ENV, $rootScope, $cordovaNetwork, $q, $injector, Toast) {
        return {
            init: function () {
                if (ENV.api == 'http://service.handsight.com.cn') {
                    $rootScope.isNetwork = '内网测试版，仅在办公室环境使用！';
                }

                document.addEventListener("deviceready", function () {

                    var type = $cordovaNetwork.getNetwork()

                    var isOnline = $cordovaNetwork.isOnline()

                    var isOffline = $cordovaNetwork.isOffline()

                    // listen for Online event

                    $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
                        if ($cordovaNetwork.getNetwork() != "wifi" && netWorkStateInfo.type != "others") {
                            netWorkStateInfo.online = "true";
                            $rootScope.netWorkOnline = true;
                            netWorkStateInfo.type = "others";
                            Toast.show('非WIFI环境下，请注意流量，请设置网络.');
                        } else if(networkState=="wifi"){
                            netWorkStateInfo.online = "true";
                            $rootScope.netWorkOnline = true;
                            netWorkStateInfo.type = "wifi";
                        }
                    })

                    // listen for Offline event
                    $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
                        if (netWorkStateInfo.online == "true") {
                            netWorkStateInfo.online = "false";
                            $rootScope.netWorkOnline = false;
                            netWorkStateInfo.type = "none";
                            Toast.show('世界上最遥远的距离就是没有网络，请检查设置！');
                        }
                    })

                }, false);

            },
            settingShowState: function (isShow, tip, type) {
                Toast.show(tip);
            },
            isValidateNetWork: function () {
                if (ENV.api == 'http://service.handsight.com.cn') {
                    $rootScope.isNetwork = '内网测试版，仅在办公室环境使用！';
                }
                var isOnline = false;
                document.addEventListener("deviceready", function () {

                    var type = $cordovaNetwork.getNetwork()

                    isOnline = $cordovaNetwork.isOnline()

                    var isOffline = $cordovaNetwork.isOffline()

                    // listen for Online event
                    $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {

                        if ($cordovaNetwork.getNetwork() != "wifi" && netWorkStateInfo.type != "others") {
                            netWorkStateInfo.online = "true";
                            $rootScope.netWorkOnline = true;
                            netWorkStateInfo.type = "others";
                            Toast.show('非WIFI环境下，请注意流量，请设置网络.');
                        } else if(networkState=="wifi"){
                            netWorkStateInfo.online = "true";
                            $rootScope.netWorkOnline = true;
                            netWorkStateInfo.type = "wifi";
                        }
                    })

                    // listen for Offline event
                    $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {

                        if (netWorkStateInfo.online == "true") {
                            netWorkStateInfo.online = "false";
                            $rootScope.netWorkOnline = false;
                            netWorkStateInfo.type = "none";
                            Toast.show('世界上最遥远的距离就是没有网络，请检查设置！');
                        }
                    })

                }, false);
                return isOnline;
            }, httpRequestOrResponseERROR: function (_config) {
                _config.Identification = new Date().getTime() + "";
                $rootScope.httpConfigs.push(_config);
                return _config;
            }, repeatHttpRequest: function (IdentificationString, callback) {
                console.log("configs", $rootScope.httpConfigs, IdentificationString);
                angular.forEach($rootScope.httpConfigs, function (config, index) {
                    if (config.Identification == IdentificationString) {
                        var $_http = $injector.get('$http');
                        console.log("进入到判断条件准备重发", config, $_http);

                        $q.defer().notify(IdentificationString);
                        if (config.method == "POST") {
                            $_http.post(config.url, config).then(function (data, status, headers, config) {
                                console.log("callback--success");
                                callback && callback(data, config);
                            }, function (data, status, headers, config) {
                                console.log("callback--error");
                                callback && callback(data, config);
                            });
                        } else if (config.method == "GET") {
                            $_http.get(config.url, config).then(function (data, status, headers, config) {
                                console.log("callback--success");
                                callback && callback(data, config);
                            }, function (data, status, headers, config) {
                                console.log("callback--error");
                                callback && callback(data, config);
                            });
                        }
//                        $_http(config, function (data, status, headers, config) {
//                            callback && callback(data, config);
//                        }, function (data, status, headers, config) {
//                            callback && callback(data, config);
//                        });
                    }
                });
            }
        }
    })