/**
 * 配音相关功能模块
 * @param  {[type]} ){} [description]
 * @return {[type]}       [description]
 */
rootModule
    .factory('PlayVideoSvc', function($timeout, $interval, UploadSvc) {
        var started = false;
        var media;
        var shouldStop = false;
        var stopRecordCallback;
        var src = "";
        var dotId = -1;
        /**
         * 开始录音方法
         * @return {[type]} [description]
         */
        function recordAudio() {
            if (typeof device != 'undefined') {
                var devicePlatform = device.platform;
                console.log(devicePlatform);
                try {
                    if (devicePlatform == 'Android') {
                        src = fullPath+"temprecord" + new Date().getTime() + ".m4a"; // 定义录音文件
                        // src = "audio.amr";
                    } else if (devicePlatform == 'iOS') {
                        src = fullPath+"temprecord" + new Date().getTime() + '.m4a';
                    }
                    media = new Media(src, function() { //初始化录音Media
                        console.log('录音成功!');
                    }, function(err) {
                        console.log('录音失败:' + JSON.stringify(err));
                    });
                    // 开始录音
                    media.startRecord();
                    var intv = $interval(function() {
                        if (shouldStop) {
                            console.log('Stop Record')
                            media.stopRecord();
                            $interval.cancel(intv);
                            media.release();
                            console.log('释放资源...')
                            stopRecordCallback && stopRecordCallback(src);
                        }
                    }, 100);
                } catch (e) {
                    console.log(e);
                }
            }
        }
        /**
         * 上传配音音频
         * @param  {[type]} src 在本地磁盘的文件
         * @return {[type]}     [description]
         */
        function uploadRecordAudio(src, callback,errorCallback,progressEventCallback) {
            UploadSvc.upload(src, {
                type: '2'
            }, function(result) {
                if (typeof result == 'string') { //如果返回的结果为字符串，则将
                    result = JOSN.parse(result);
                }
                callback && callback(result);
            },errorCallback,progressEventCallback);
        }

        return {
            /**
             * 开始录音
             * @return {[type]} [description]
             */
            startRecord: function() {
                shouldStop = false;
                recordAudio();
            },
            stopRecord: function(callback) {
                stopRecordCallback = callback;
                $timeout(function() {
                    shouldStop = true;
                }, 500)
            },
            /**
             * 上传配音
             * @param  {[type]} src [description]
             * @return {[type]}     [description]
             */
            uploadRecordAudio: function(src, callback,errorCallback,progressEventCallback) {
                uploadRecordAudio(src, callback,errorCallback,progressEventCallback);
            }
        }
    })