/**
 * @description  系统服务
 */
rootModule
    .factory('SystemSvc', function($rootScope,$state,$resource,$stateParams,$interval,$ionicPopup,$location, ENV,Storage,UUID,$http,Movies) {
        var resource = $resource(ENV.api + '/', null, {
            //获取直播推荐列表接口
            versionCheckResource: {
                method: "GET",
                url: ENV.api + '/common/version_check'
            }
        });

        var popShowSenceList = [];
        $rootScope.$on("onChangeStatusList",function(e,data){
            popShowSenceList.push(data)
        })
        var goSidePage = function(showMovieList){
            var infroList;
            $rootScope.showMovieList={
                moviesChoice:"",
            };

            if(showMovieList.length>3){
                // infroList = showMovieList.slice(0,3);
                infroList = showMovieList;
                $rootScope.showMovieInfroList=infroList;
            }else{
                infroList = showMovieList;
                $rootScope.showMovieInfroList=infroList;
            }
            $rootScope.showMovieList={
                moviesChoice:$rootScope.showMovieInfroList[0],
            };
            if(showMovieList[0].videoType && showMovieList[0].videoType == 2){
                var promptWords = '节目开始，是否立即参加互动？';
                var template='<ion-list><ion-radio ng-repeat="info in showMovieInfroList" ng-model="showMovieList.moviesChoice" ng-value="info">{{info.tvProgramName}}</ion-radio></ion-list>'
            }else{
                var promptWords = '电影已开始，是否立即参加互动？';
                var template='<ion-list><ion-radio ng-repeat="info in showMovieInfroList" ng-model="showMovieList.moviesChoice" ng-value="info">{{info.movieName+"-"+info.hallName}}</ion-radio></ion-list>'
            }

            var goSidePage = $ionicPopup.show({
              title: promptWords,
              template: template,
              scope: $rootScope,
              buttons: [
                  {
                      text: '前往',
                      type: 'button-positive',
                      onTap: function(){
                        if(showMovieList[0].videoType && showMovieList[0].videoType == 2){

                        }else{
                            $rootScope.$broadcast("onChangeStatus",{"data":true})
                            $rootScope.$broadcast("closeModal",{"data":true})
                            var vId = $rootScope.showMovieList.moviesChoice.videoId;
                            var moviename = $rootScope.showMovieList.moviesChoice.movieName;
                            var startTime = $rootScope.showMovieList.moviesChoice.startT;
                            var movieLength = parseInt(($rootScope.showMovieList.moviesChoice.endT - $rootScope.showMovieList.moviesChoice.startT)/1000);
                            $state.go('platform-side', {
                                videoId:vId,  //跳转传入一个视频ID
                                tvhelper:"tvhelper",
                                startedTime:0,
                                movieLength:movieLength,
                                moviename:encodeURIComponent(moviename),
                                startTime:startTime,

                            });
                        }
                      }
                  },
                  {
                      text: '取消',
                      onTap:function(){
                        $rootScope.$broadcast("onChangeStatus",{"data":true})
                      }
                  }
              ]
            });
        }
        function GetRTime(){
            var isPlatform = /platformside/.test($location.path());
            var isMovieDetail = true;//判断是不是在有倒计时的电影详情页面，true：是，false：不是
            if($stateParams.isSystemCountdown==""||$stateParams.isSystemCountdown==undefined){
                isMovieDetail = false
            }
            if(!isPlatform && !isMovieDetail){
                var currentDate = new Date();
                var showMovieList = [];
                Movies.getSenceInfroList(0,function(result){
                    // debugger
                    if(result.success){
                        // 电影
                        if(result.movieSenceList.length>0){
                            angular.forEach(result.movieSenceList,function(item,index){

                                // var startedTime = startT
                                var startedTime = parseInt((item.startT - currentDate)/1000);
                                if(-60<=startedTime&&startedTime<=0){
                                    showMovieList.push(item);
                                    // popShowSenceList.push.(item)

                                }
                            })
                            if(showMovieList.length>0){
                                //检查有没有重复的场景提示
                                if(popShowSenceList.length>0){
                                    for(i=0;i<popShowSenceList.length;i++){
                                        angular.forEach(showMovieList,function(item,index){
                                            if(popShowSenceList[i].sceneId == item.sceneId){
                                                showMovieList.splice(index,1)
                                            }
                                        })

                                    }
                                }
                                if(showMovieList.length>0){
                                    goSidePage(showMovieList);
                                }
                            }
                        }
                        // 电视
                        // debugger
                        // if(result.tvSenceList && result.tvSenceList.length){
                        //     var showtvList = [];
                        //     angular.forEach(result.tvSenceList,function(item,index){
                        //         var startedTime = parseInt((item.startT - currentDate)/1000);
                        //         if(-60<=startedTime&&startedTime<=0){
                        //             showtvList.push(item);
                        //         }
                        //     })
                        //     if(showtvList.length>0){
                        //         goSidePage(showtvList);
                        //     }
                        // }
                    }

                })
            }

        }
        /**
         * 初始化全局倒计时
         * @param  {[type]} successCallback 成功的回调函数
         * @param  {[type]} errorCallabck   失败的回调函数
         * @return {[type]}                 [description]
         */
        function _initCountDown(){
            var timer = $interval(GetRTime,60000);
        }
        /**
         * 创建系统APPID
         * @param  {[type]} successCallback 成功的回调函数
         * @param  {[type]} errorCallabck   失败的回调函数
         * @return {[type]}                 [description]
         */
        function createAppID(successCallback,errorCallabck) {
            //1.判断本地是否已经存储了一个APPID
            var appId = Storage.get("HANDSIGHTAPPID");
                //创建一个APPID
                if (typeof MacAddress != 'undefined') {
                    MacAddress.getMacAddress(function(mac) {
                        //获取Mac地址成功
                        console.log("get MacAddress success"+mac);
                        requestAPPID(mac,successCallback,errorCallabck);
                    }, function(error) {
                        console.log("get MacAddress err use device.uuid");
                        requestAPPID(device.uuid,successCallback,errorCallabck); //使用UUID来获取
                    })
                }else{
                    //这里处理不是Cordova环境的情况,随机创建一个UUID
                    requestAPPID(UUID.newguid(),successCallback,errorCallabck);
                }
            // }
        }
        /**
         * 向服务器申请APPID
         * @return {[type]} [description]
         */
        function requestAPPID(str,successCallback,errorCallabck) {
            //发送请求，申请APPID
            $http.post(ENV.api + "/user/appid", param({
                mac: str,
            })).success(function(result) {
                //返回的数据
                if (result.success) {
                    Storage.set('HANDSIGHTAPPID', {
                        id: result.data
                    }); //保存到本地
                    ENV.APPID = result.data; //写入到全局配置中去
                    successCallback&&successCallback(); //成功回调函数
                } else {
                    console.log('服务器创建APPID失败', result.msg);
                }
            }, function(err) {
                console.log('申请APPID失败', error)
            });
        }



        return {
        	/**
        	 * 版本检测更新服务
        	 * @param  {[type]} version  版本号
        	 * @param  {[type]} platform 平台
        	 * @return {[type]}          [description]
        	 */
        	checkVersion:function(version,platform,successCallback){
	            resource.versionCheckResource({
	                version: "v" + version,
	                platform: platform
	            }).$promise.then(function(result) {
	            	successCallback&&successCallback(result);
	            }, function(err) {
	                console.log('检测更新失败！')
	            })
        	},
            /**
             * 创建APPID
             * @type {[type]}
             */
            createAppID:createAppID,
            initCountDown:_initCountDown
        }
    });