
rootModule
	.factory('ThirdSystemSvc',function($ionicPlatform,Toast){
		var devicePlatformType=1; //1.Android, 2.IOS 
		//注意：本方法只能在系统初始化完成后（cordova.deviceready）才能进行调用
		function init(){
			//这里需要初始化系统相关资源
			//IOS系统目前用的是第三方开源的组件，Android未使用
			if(typeof device !='undefined'&&device.platform=="iOS"){
				devicePlatformType=2;
			}else{
				devicePlatformType=1;
				//Android系统暂时不需要初始化
			}
		}
		/**
		 * 微博相关资源的访问
		 */
		function HSWeibo(){
			/**
			 * @param  调用成功的回调函数
			 * @param  调用失败的回调函数
			 * @return {[type]}
			 */
			this.login=function(successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					YCWeibo.ssoLogin(successCallback,errorCallback);
				}else if(devicePlatformType==1){ //Android 版本
					window.HSPlugin.execFunc('thirdPartLogin', ['wb'],successCallback,errorCallback);
				}
			}
			/**
			 * @param  分享的参数
			 * @param  分享成功的回调函数
			 * @param  分享失败的回调函数
			 * @return {[type]}
			 */
			this.share=function(options,successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					//解析并设置参数
					var args={};
					args.url = options[0].content.qzLink;
					args.title = options[0].content.title;
					args.description = options[0].content.title;
					args.imageUrl = options[0].content.qzImgUrl;//if you don't have imageUrl,for android http://www.sinaimg.cn/blog/developer/wiki/LOGO_64x64.png will be the defualt one
					args.defaultText = "";
					YCWeibo.shareToWeibo(successCallback,errorCallback, args);
				}else if(devicePlatformType==1){ //Android 版本
					HSPlugin.execFunc("share",options,successCallback,errorCallback);
				}
			}
		}
		/**
		 * QQ相关资源的访问
		 */
		function HSQQ(){
			/**
			 * @param  调用成功的回调函数
			 * @param  调用失败的回调函数
			 * @return {[type]}
			 */
			this.login=function(successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					YCQQ.ssoLogin(successCallback,errorCallback);
				}else if(devicePlatformType==1){ //Android 版本
					window.HSPlugin.execFunc('thirdPartLogin', ['qq'],successCallback,errorCallback);
				}
			}
			/**
			 * 分享给QQ好友
			 * @param  分享的参数
			 * @param  分享成功的回调函数
			 * @param  分享失败的回调函数
			 * @return {[type]}
			 */
			this.shareToQQ=function(options,successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					//解析并设置参数
					var args = {};
					args.url = options[0].content.qzLink;
					args.title = options[0].content.title;
					args.description = options[0].content.description;
					args.imageUrl = options[0].content.qzImgUrl;
					args.appName = "视动无限";
					YCQQ.shareToQQ(successCallback,errorCallback, args);
				}else if(devicePlatformType==1){ //Android 版本
					HSPlugin.execFunc("share",options,successCallback,errorCallback);
				}
			}
			/**
			 * 分享到QQ空间
			 * @param  分享的参数
			 * @param  分享成功的回调函数
			 * @param  分享失败的回调函数
			 * @return {[type]}
			 */
			this.shareToQzone=function(options,successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					//解析并设置参数
					var args = {};
					args.url = options[0].content.qzLink;
					args.title = options[0].content.title;
					args.description = options[0].content.description;
					var imgs =[options[0].content.qzImgUrl];
					args.imageUrl = imgs;


					YCQQ.shareToQzone(successCallback,errorCallback, args);
				}else if(devicePlatformType==1){ //Android 版本
					HSPlugin.execFunc("share",options,successCallback,errorCallback);
				}
			}
		}
		/**
		 * 微信相关资源的访问
		 */
		function HSWeChat(){
			/**
			 * @param  调用成功的回调函数
			 * @param  调用失败的回调函数
			 * @return {[type]}
			 */
			this.login=function(successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					//需要判断是否安装微信
					Wechat.isInstalled(function (installed) {
					    var scope = "snsapi_userinfo";
						Wechat.auth(scope,successCallback,errorCallback);
					}, function (reason) {
					    Toast.show('微信未安装')
					});
				}else if(devicePlatformType==1){ //Android 版本
					window.HSPlugin.execFunc('thirdPartLogin', ['wx'],successCallback,errorCallback);
				}
			}
			/**
			 * 分享给朋友
			 * @param  分享的参数
			 * @param  分享成功的回调函数
			 * @param  分享失败的回调函数
			 * @return {[type]}
			 */
			this.shareToFriend=function(options,successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					//解析并设置参数
					var args = {};
					args.message={
						title: options[0].content.title,
					    description: options[0].content.description,
					    thumb: options[0].content.qzImgUrl,
					    mediaTagName: "T",
					    messageExt: "",
					    messageAction: "",
					    media: {
                			type: Wechat.Type.WEBPAGE,   // webpage
                			webpageUrl:options[0].content.qzLink     // webpage
            			}
					}
					args.scene=Wechat.Scene.SESSION;
					console.log(JSON.stringify(args));
					Wechat.share(args,successCallback,errorCallback);
				}else if(devicePlatformType==1){ //Android 版本
					HSPlugin.execFunc("share",options,successCallback,errorCallback);
				}
			}
			/**
			 * 分享到朋友圈
			 * @param  分享的参数
			 * @param  分享成功的回调函数
			 * @param  分享失败的回调函数
			 * @return {[type]}
			 */
			this.shareToFriendCircle=function(options,successCallback,errorCallback){
				//1.这里需要区分Android还是IOS版本
				if(devicePlatformType==2){ //IOS 版本
					//解析并设置参数
					var args = {};
					args.message={
						title: options[0].content.title,
					    description: options[0].content.description,
					    thumb: options[0].content.qzImgUrl,
					    mediaTagName: "T",
					    messageExt: "",
					    messageAction: "",
					    media: {
                			type: Wechat.Type.WEBPAGE,   // webpage
                			webpageUrl:options[0].content.qzLink     // webpage
            			}
					}
					args.scene=Wechat.Scene.TIMELINE;
					Wechat.share(args,successCallback,errorCallback);
				}else if(devicePlatformType==1){ //Android 版本
					HSPlugin.execFunc("share",options,successCallback,errorCallback);
				}
			}
		}
		var hsweibo=new HSWeibo();
		var hsqq=new HSQQ();
		var hswechat=new HSWeChat();
		return{
			//初始化系统
			init:init,
			hsweibo:hsweibo,
			hsqq:hsqq,
			hswechat:hswechat
		}
	})