'user strict';
/**
 * @author SuperK
 * @date 2015-04-16
 * @description 图片缩略图相关管理
 */
rootModule
    .factory('ThumbImage', function($interval, ENV, Side, $log) {
        var thumbImageData, //存放加载回来的数据
            thumbIndex = 0; // 缩略图数据下标
        return {
            init: function(watchType, id,deviceId) {
                thumbImageData = []; //清空数据
                var $this = this;
                $this.loadThumbInterval(watchType, id,deviceId);
                $interval(function() {
                    $this.loadThumbInterval(watchType, id,deviceId)
                }, ENV.thumbImageLoadTime);
            },
            loadThumbInterval: function(watchType, id,deviceId) {
                Side.get_thumb(watchType, id, 60,deviceId).$promise.then(function(result) {
                    if (result.success) {
                        angular.forEach(result.data, function(item) {
                            item.index = thumbIndex++;
                        }); //增加下标
                        thumbImageData=thumbImageData.concat(result.data);
                    } else {
                        $log.debug('ThumbImageService', '数据加载失败', result);
                    }
                });
            },
            //获取一张当前进度图片
            //根据当前播放的进度
            getThumb: function(time) {
                //组装一个URL节目快照的URL
                


                var thumb;
                angular.forEach(thumbImageData, function(item) {
                    if (item.time - time <2&&item.time-time>0) { //正负三秒内的取出来
                        thumb = item;
                        return false;
                    }
                });
                return thumb;
            },
            /**
             * 获取缩略图大图
             * @param  {[type]} index [description]
             * @return {[type]}       [description]
             */
            getBigThumb: function(index) {
                return thumbImageData[index] && thumbImageData[index].bigImg;
            }
        }
    })