'user strict';
/**
 * @desc 版本升级相关
 */
rootModule
    .factory('UpgradeSvc', function(ENV,$ionicDeploy, $rootScope, $resource, Toast, SystemSvc, $cordovaAppVersion, $ionicActionSheet, $ionicPopup, $ionicLoading, $cordovaFileTransfer, $cordovaFileOpener2, $timeout, $injector) {
        /**
         * 检测版本信息
         * @return {[type]} [description]
         */
        function checkVersion(isShowToast) {
            //1.获取当前系统的版本号
            if (typeof cordova != 'undefined') {
                //获取当前的平台
                var platform = device.platform == 'iOS' ? "1" : "2";
                $cordovaAppVersion.getAppVersion().then(function(version) {
                    //将版本信息存入$rootScope
                    $rootScope.versionCode=version;
                    //初始化设置一些参数
                    var checkURL=ENV.api+"/common/version_check?appId="+ENV.APPID+"&platform="+ENV.platform+"&version="+ENV.version;
                    $ionicDeploy.initialize(checkURL);
                    $ionicDeploy.update(); //调用更新函数
                    //这里去检测更新
                    SystemSvc.checkVersion(version, platform, function(result) {
                        //这里来接收服务器返回的结果
                        extractVersionData(result,isShowToast);
                    });
                });

            } else {
                //当前不是Native环境
            }
        }
        /**
         * 解析服务端返回的版本信息；
         * @param  {[type]} data [description]
         * @return {[type]}      [description]
         */
        function extractVersionData(data,isShowToast) {
            if (data && data.success && data.data) {
                //这里来判断是否需要更新版本
                var versionInfo = data.data;
                //这里根据不同的平台显示不同的内容
                if(versionInfo.platform=="1"){ //IOS 企业版平台，整包更新
                    var confirmPopup = $ionicPopup.confirm({
                        title: '发现新版本',
                        template: versionInfo.appVersion+'<br>'+versionInfo.content, //从服务端获取更新的内容
                        cancelText: '取消',
                        okText: '立即升级'
                    });
                    confirmPopup.then(function(res) {
                        if (res) {
                            window.open("itms-services://?action=download-manifest&url=https://raw.githubusercontent.com/woaiso/woaiso.github.io/master/tvhelper.plist", '_blank', 'location=yes', 'closebuttoncaption=Done');
                        }else{
                            //不下载
                        }
                    })
                }else if(versionInfo.platform=="2"){ //Android平台，下载安装包升级
                    var confirmPopup = $ionicPopup.confirm({
                        title: '发现新版本',
                        template: versionInfo.appVersion+'<br>'+versionInfo.content, //从服务端获取更新的内容
                        cancelText: '取消',
                        okText: '立即升级'
                    });
                    confirmPopup.then(function(res) {
                        if(res){
                            upgradeAndroid(versionInfo); //升级Android
                        }else{
                            //
                        }
                    });
                }else if(versionInfo.platform=="3"){ //IOS自动升级平台
                    //无需点击确定，直接下载
                    if(typeof downloadFramework!="undefined"){
                        downloadFramework(versionInfo.fileUrl);
                    }else{
                        //('调用下载FrameWork失败')
                    }
                }
            } else {
                if(!isShowToast){
                    //不提示信息
                }else{
                    Toast.show(data.msg);
                }
            }
        }
        /**
         * Android版本升级
         * @return {[type]} [description]
         */
        function upgradeAndroid(versionInfo){
                        $ionicLoading.show({
                            template: "已经下载：0%"
                        });
                        var url = versionInfo.fileUrl;
                        var targetPath = "file:///storage/sdcard0/Download/tvhelper.apk"; //APP下载存放的路径，可以使用cordova file插件进行相关配置
                        var trustHosts = true
                        var options = {};
                        $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function(result) {
                            // 打开下载下来的APP
                            $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function() {
                                // 成功
                            }, function(err) {
                                // 错误
                            });
                            $ionicLoading.hide();
                        }, function(err) {
                            console.log(err);
                            alert('下载失败');
                            $ionicLoading.hide();
                        }, function(progress) {
                            //进度，这里使用文字显示下载百分比
                            $timeout(function() {
                                var downloadProgress = (progress.loaded / progress.total) * 100;
                                $ionicLoading.show({
                                    template: "已经下载：" + Math.floor(downloadProgress) + "%"
                                });
                                if (downloadProgress > 99) {
                                    $ionicLoading.hide();
                                }
                            })
                        });
        }

        return {
            checkVersion: checkVersion
        }
    })