'use strict';
/**
 * 图片上传
 * @author  Vivian
 * @date 2015/05/15
 */
rootModule
    .factory('upload', function(ENV, $rootScope, $ionicLoading,Toast) {
        return {
            /**
             * 文件上传功能
             * @param  {[type]} fileURL         文件的地址
             * @param  {[type]} params          参数
             * @param  {[type]} successCallabck 成功的回调函数
             * @param  {[type]} errorCallback   失败的回调函数
             * @return {[type]}                 [description]
             */
            uploadEvent: function(fileURL, params, successCallabck, errorCallback,progressEventCallback) {
                /**
                 * 文件上传成功执行ing的函数
                 * @param  {[type]} r 服务器返回的数据
                 * @return {[type]}   [description]
                 */
                function win(r) {
                    console.log("Code = " + r.responseCode);
                    console.log("Response = " + r.response);
                    console.log("Sent = " + r.bytesSent);
                    var result = JSON.parse(r.response);
                    //$ionicLoading.hide();
                    successCallabck && successCallabck(result);
                }

                function fail(error) {
                    console.log("An error has occurred: Code = " + error.code);
                    console.log("upload error source " + error.source);
                    console.log("upload error target " + error.target);
                    //$ionicLoading.hide();
                    errorCallback && errorCallback(error);
                }
                var uri = encodeURI(ENV.uploadApi + "/common/upload");
                var options = new FileUploadOptions();
                options.fileKey = "filename";
                options.chunkedMode = false;
                options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
                options.params = params;
                if (device && device.platform == 'Android') {
                    if (params.fileType == 'img') {
                        options.mimeType = "audio/x-mpeg";
                    } else if (params.fileType == 'video') {
                        options.mimeType = "audio/x-mpeg";
                    } else if (params.fileType == 'audio') {
                        options.mimeType = "audio/x-mpeg";
                    }
                } else if (device.platform == 'iOS') {
                    if (params.fileType == 'img') {
                        options.mimeType = "audio/x-wav";
                    } else if (params.fileType == 'video') {
                        options.mimeType = "audio/x-mpeg";
                    } else if (params.fileType == 'audio') {
                        options.mimeType = "audio/x-wav";
                    }
                }
                var headers = {};
                options.headers = headers;
                var ft = new FileTransfer();
                /**
                 * 文件上传进度
                 * @param  {[type]} progressEvent [description]
                 * @return {[type]}               [description]
                 */
                ft.onprogress = function(progressEvent) {
                    console.log(progressEvent);
                    if (progressEvent.lengthComputable){
                        var percent=((progressEvent.loaded / progressEvent.total)*100).toFixed(2);
                        progressEventCallback&&progressEventCallback(percent);
                        //$ionicLoading.show({template:"正在处理"+percent+"%",});
                    } else {
                        Toast.show('处理完成');
                    }
                };
                ft.upload(fileURL, uri, win, fail, options);
            },
            uploadVideo: function(fileURL, params) {
                // console.log(userinfo);
                function win(r) {
                    console.log("Code = " + r.responseCode);
                    console.log("Response = " + r.response);
                    console.log("Sent = " + r.bytesSent);
                    var result = JSON.parse(r.response);
                    console.log(result);
                    if (result.success) {
                        //$ionicLoading.hide();
                        if (params) {
                            params.headImg = result.data;
                            $rootScope.$broadcast('reload_userInfo');
                            $rootScope.$broadcast('save_userinfo');
                        }
                    } else {
                        //$ionicLoading.hide();
                        $ionicLoading.show({
                            template: '上传失败',
                            noBackdrop: true,
                            duration: 1000
                        });
                    }
                    // callback && callback(result);
                }


                function fail(error) {
                    //$ionicLoading.hide();
                    $ionicLoading.show({
                        template: '上传失败',
                        noBackdrop: true,
                        duration: 1000
                    });
                    console.log(error);
                    console.log("An error has occurred: Code = " + error.code);
                    console.log("upload error source " + error.source);
                    console.log("upload error target " + error.target);
                }

                var uri = encodeURI(ENV.uploadApi + "/common/upload");

                var options = new FileUploadOptions();
                options.fileKey = "filename";
                options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
                options.mimeType = "video/quicktime";

                var headers = {};
                options.headers = headers;
                options.params = {
                    type: '5',
                    params: params
                }

                var ft = new FileTransfer();
                ft.onprogress = function(progressEvent) {
                    if (progressEvent.lengthComputable) {
                        console.log(progressEvent.loaded / progressEvent.total);
                    } else {
                        console.log('end');
                    }
                };
                $ionicLoading.show();
                ft.upload(fileURL, uri, win, fail, options);
            }
        }
    })
    .service('UploadSvc', function(ENV) {
        return {
            /**
             * [upload description]
             * @param  {[type]}   fileName 本地全路径
             * @param  {[type]}   params   [description]
             * @param  {Function} callback [description]
             * @return {[type]}            [description]
             */
            upload: function(fileName, params, callback, errorCallback, progressEventCallback) {
                // var fileURL2 = '/storage/emulated/0/' + filename;
                var fileURL = fileName;
                // var fileEntry1 = new FileEntry();
                // var fileURL = fileEntry1.toURL();
                // document.addEventListener("deviceready", onDeviceReady, false);
                // // device APIs are available
                // function onDeviceReady() {
                //     var filesys = LocalFileSystem.TEMPORARY;
                //     if (device && device.platform == 'Android') {
                //         filesys = LocalFileSystem.PERSISTENT;
                //     }
                //     window.requestFileSystem(filesys, 0, gotFS, fail);
                // }

                // function gotFS(fileSystem) {
                //     fileSystem.root.getFile(fileName, {
                //         create: true,
                //         exclusive: false
                //     }, gotFileEntry, fail);
                // }

                // function gotFileEntry(fileEntry) {
                // fileURL = encodeURI(fileEntry.toInternalURL());
                // fileURL = fileEntry.nativeURL;
                // console.log(fileURL);
                function win(r) {
                    console.log("Code = " + r.responseCode);
                    console.log("Response = " + r.response);
                    console.log("Sent = " + r.bytesSent);
                    options.chunkedMode = false;
                    var result = JSON.parse(r.response);
                    callback && callback(result);
                }

                function error(error) {
                    console.log("An error has occurred: Code = " + error.code);
                    console.log("upload error source " + error.source);
                    console.log("upload error target " + error.target);
                    errorCallback && errorCallback(error);
                }
                var uri = encodeURI(ENV.uploadApi + "/common/upload");
                var options = new FileUploadOptions();
                options.fileKey = "filename";
                options.chunkedMode = false;
                options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
                if (device && device.platform == 'Android') {
                    options.mimeType = "audio/x-mpeg";
                } else if (device.platform == 'iOS') {
                    options.mimeType = "audio/x-wav";
                }
                var headers = {
                    // Connection: "close"
                };

                options.headers = headers;

                options.params = params;
                var ft = new FileTransfer();
                console.log(ft);
                ft.onprogress = function(progressEvent) {
                    if (progressEvent.lengthComputable) {
                        progressEventCallback && progressEventCallback(progressEvent.loaded / progressEvent.total);
                    } else {
                        console.log('end');
                    }
                };
                ft.upload(fileURL, uri, win, error, options, true);
            }

        }
    })